<?php

require_once 'ArkeiaAction.php';

class ApplianceController extends ArkeiaAction
{

    // method de verification du pass root
    public function jsonCheckPassAction()
    {   
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        // on fait n'importe quelle requete de lecture poyur vérifier que le pass est OK
        $trans = "SYS_NET_LIST";
        $trans_version = 2;
        $vector = array("param0" => 'root', "param1" => $_POST['ROOTPASS']);
        $result = $model->new_trans($trans, $trans_version, 1, $vector, $context);

        if (($result->param0 == '0') && (!empty($_POST['ROOTPASS']))) {
            $session_arkeia = Zend_Registry::get('session_arkeia');
            $session_arkeia->passroot = $_POST['ROOTPASS'];
        }

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetForComboboxAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        // On lit la liste des timezones
        $trans = "SYS_TIME_LIST_TIMEZONES";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot);
        $result = $model->new_trans($trans, $trans_version, 1, $vector, $context);
        $res = (array) $result->param2->item;
        $tList = array();
        foreach ($res as $key => $val) {
            $tList[$res[$key]->NAME] = $res[$key]->NAME;
        }

        $result = Zend_Json::encode($tList);
        $this->getResponse()->appendBody($result);
        return;
    }


////////////////////////////////////////////////////////////////////////
// NETWORK
////////////////////////////////////////////////////////////////////////

    public function networkAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'network';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('network');
        }
    }

    public function jsonGetNetworkAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->loadNetwork($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonModifyNetworkAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeNetwork($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// SMTP
////////////////////////////////////////////////////////////////////////

    public function smtpAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'smtp';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('smtp');
        }
    }

    public function jsonGetSmtpAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->loadSmtp($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonModifySmtpAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeSmtp($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// TIME AND DATE
////////////////////////////////////////////////////////////////////////

    public function timeAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'time';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('time');
        }
    }

    public function jsonGetTimeAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->loadTime($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonModifyTimeAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeTime($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonModifyTimeZoneAction()
    {
       $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeTimeZone($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// SSH
////////////////////////////////////////////////////////////////////////

    public function sshAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'ssh';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('ssh');
        }
    }

    public function jsonGetSshAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->loadSsh($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonModifySshAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeSsh($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// RAID
////////////////////////////////////////////////////////////////////////

    public function raidAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'raid';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('raid');
        }
    }

////////////////////////////////////////////////////////////////////////
// UPDATE
////////////////////////////////////////////////////////////////////////

    public function updateAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'update';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('update');
        }
    }

    public function updateformAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'updateform';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('updateform');
        }
    }

    public function jsonGetMachineInfoAction()
    {        
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $trans = "INFO_STATUS";
        $trans_version = 1;
	$vector = array();
        $result = $model->new_trans($trans, $trans_version, 1, $vector, $context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonInstallGoAction()
    {
        
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $trans = "SYS_UPDATE";
        $trans_version = 2;
        $session_arkeia = Zend_Registry::get('session_arkeia');
        $vector = array("param0" => 'root', "param1" => $session_arkeia->passroot, "param2" => '/tmp/ApplianceUpdate');
        $result = $model->new_trans($trans, $trans_version, 1, $vector, $context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// PASSWORD
////////////////////////////////////////////////////////////////////////

    public function passwordAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'password';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('password');
        }
    }

    public function jsonModifyPassWordAction()
    {
        
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writePassword($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// RESTART
////////////////////////////////////////////////////////////////////////

    public function restartAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'restart';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('restart');
        }
    }

    public function jsonRestartGoAction()
    {
        
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeRestart($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// SHUTDOWN
////////////////////////////////////////////////////////////////////////

    public function shutdownAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'shutdown';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('shutdown');
        }
    }

    public function jsonShutdownGoAction()
    {
        
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->writeShutdown($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// STATUS
////////////////////////////////////////////////////////////////////////

public function jsonsysStatusAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

	//error_log("jsonSysStatusAction");

        $result = $model->sysStatus($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);
	//error_log("jsonSysStatusAction, RESULT:".$result);
        $this->getResponse()->appendBody($result);
        return;
    }

////////////////////////////////////////////////////////////////////////
// HELP
////////////////////////////////////////////////////////////////////////

    public function raidHelp01Action()
    {
        echo $this->view->render('appliance/raid_help.html');
    }

////////////////////////////////////////////////////////////////////////
// VMList
////////////////////////////////////////////////////////////////////////

    public function vmlistAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'vmlist';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('vmlist');
        }
    }

    public function jsonSysVMDiskListAction() {

        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->SysVMDiskList($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);

        $this->getResponse()->appendBody($result);
        return;

    }

    public function jsonSysVMDiskExpandAction() {

        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->SysVMDiskExpand($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);

        $this->getResponse()->appendBody($result);
        return;

    }

////////////////////////////////////////////////////////////////////////
// VTL Expansion
////////////////////////////////////////////////////////////////////////

    public function expanddiskAction()
    {
        $session_arkeia = Zend_Registry::get('session_arkeia');
        if (empty($session_arkeia->passroot)) {
            $this->view->lastview = 'expanddisk';
            $this->displayFromScreenIni('askpass');
        } else {
            $this->displayFromScreenIni('expanddisk');
        }
    }

    public function jsonSysExpDiskListAction() {

        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->SysExpDiskList($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);

        $this->getResponse()->appendBody($result);
        return;

    }

    public function jsonSysExpDiskExpandAction() {

        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $result = $model->SysExpDiskExpand($context);

        $res = $this->_get_result($result, $context);
        $result = Zend_Json::encode($res);

        $this->getResponse()->appendBody($result);
        return;

    }

}
