<?php

require_once 'ArkeiaAction.php';

class D2d2tController extends ArkeiaAction
{

  public function interactiveAction()
    {
      $this->displayFromScreenIni('interactive');
    }

  public function showD2d2tAction()
    {
      $this->displayFromScreenIni('showd2d2t');
    }

    public function jsonShowD2d2tAction()
    {
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';

        //error_log("jsonShowBackupAction POST: ".Zend_Json::encode($this->_request->getPost()));

      if (!$params['PARAM2']) {
          $array_context = $this->view->context;
          list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
          if ($id) {
              list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
          }
      }

        $this->view->showBackup = $params;
        $res = $this->displayFromScreenIni('showd2d2t', FALSE);
        $this->_render_json_view($res);
        return;
    }

  public function jsonStartAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      $params = $this->_request->getPost();
      $val_select = array('BKSID', 'DKID', 'PLID', 'NEW_TAPE', 'INC_I', 'RET_TIME_UNIT', 'DO_EMAIL', 'BASE');
      $params = $this->_clean_select_POST($params, $val_select);

        unset($params['BASE']);
        unset($params['SUBMIT']);

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'd2d2t/interactive'
                ) {

                $params['REP_CLIENT_ID'] = $_COOKIE['base'];

        }

      require_once 'Zend/Json.php';
      //error_log('jsonStartAction, params: '.Zend_Json::encode($params));
      if ($params['BKSID'] == '' ||
          $params['DKID'] == '' ||
          $params['PLID'] == '') {
          $res = $this->_set_error_message($this->lang['d2d2t_start_error_BK_DK_PL_require']);
      } else {
          $data = $model->startD2d2t($params, $this->view->context);
          $res = $this->_get_result($data, $this->view->context);
      }
      //error_log('jsonStartAction, res: '.Zend_Json::encode($res));
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }
  public function jsonCreateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      require_once 'Zend/Json.php';
      $params = $this->_request->getPost();
      
      //error_log("jsonCreateObjectAction POST: ".Zend_Json::encode($params));
      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
      unset($params['APPID_SCHID']);

      if ($params['NAME'] == '' ||
          $params['DKID'] == '' ||
          $params['PLID'] == '') {
          $res = $this->_set_error_message($this->lang['d2d2t_create_error_NAME_DK_PL_require']);
      } else {
          $data = $model->createObject($params, $this->view->context);
          $res = $this->_get_result($data, $this->view->context);
      }

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      require_once 'Zend/Json.php';
      $params = $this->_request->getPost();

      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
      unset($params['APPID_SCHID']);

      $data = $model->modifyObject($params, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

    public function interactiveHelpAction()
    {
        echo $this->view->render('interactived2d2t/help.html');
    }

    public function interactiveHelp01Action()
    {
        echo $this->view->render('interactived2d2t/help01.html');
    }

}

?>
