<?php

require_once 'ArkeiaAction.php';

class IndexController extends ArkeiaAction
{

    private function is_user()
    {
        $id = $this->view->auth->getIdentity(); 
        if ($id && $id['role'] == 'USER') return true;
        return false;
    }

    public function menutreeAction()
    {
        $id = $this->view->auth->getIdentity(); 
        if (null == $id || $this->is_user()) {
            $menutree = @simplexml_load_file('../app/views/menutree_logout.xml');
        } else if ($this->view->context !== null) {
            $menutree = @simplexml_load_file('../app/views/menutree_multisite.xml');
        } else {
            $menutree = @simplexml_load_file('../app/views/menutree.xml');
        }
        $this->view->menutree = $menutree;
        echo $this->render();
    }

    public function summaryieAction()
    {
        $this->displayFromScreenIni('ie');
    }
    public function ieAction()
    {
        $this->view->subaction = "index/summaryie";
        echo $this->view->render('layout.phtml');
    }

    public function homeAction()
    {
        if ($this->is_user()) {
            $options['controller'] = "restoration";
        } else {
            $options['controller'] = "index";
        }

        if($this->view->context) {
            $this->displayFromScreenIni('summary_multisite',true, $options);
        } else {
            $this->displayFromScreenIni('summary',true, $options);
        }
    }

    public function indexAction()
    {
      if (isset($_COOKIE['subaction']) && is_string($_COOKIE['subaction']) && 
	  ((function_exists('mb_strpos') && mb_strpos($_COOKIE['subaction'], '/') != false)
	   || (!function_exists('mb_strpos') && strpos($_COOKIE['subaction'], '/') != false))) {
            $this->view->subaction = $_COOKIE['subaction'];
        } else {
            $this->view->subaction = "index/home";
        }
        echo $this->view->render('layout.phtml');
    }

    public function summaryAction()
    {
        if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
        } else if (null == $this->view->auth->getIdentity()) {
            $this->displayFromScreenIni('summary_logout');
        } else {
            $this->displayFromScreenIni('summary');
        }
    }

    public function loginAction()
    {
        echo $this->view->render('login.phtml');
    }

}
