<?php
/**
 * Generate javascript lang file for dojo
 * 
 * Created on June 1st 2007
 *   
 * PHP version 5
 * 
 * @author    Quentin Labadens <qlabadens@arkeia.com>
 * @copyright 2007, Arkeia Software
 * @version   CVS: $Id: JournalController.php,v 1.21 2009/04/10 22:35:05 fdaniel Exp $
 * 
 **/
 
require_once 'ArkeiaAction.php';

class JournalController extends ArkeiaAction
{

    function jsonJournalListLogAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();

        require_once 'Zend/Json.php';
        $data = $model->journalListLog($array_context);

        $res = array();
        foreach ($data as $obj) {
            $res[$obj->YEAR.'_'.$obj->MONTH] = $this->lang['month_'.$obj->MONTH].' '.$obj->YEAR;
        }
        ksort($res);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    function jsonJournalLoadCompleteLogPrePrintAction()
    {
        if(isset($_SESSION)) {
            $_SESSION['reporthook'] = 'COMPLETE_PREPRINT';
        }
      return $this->jsonJournalLoadAction('COMPLETE_PREPRINT');
    }

    function jsonJournalLoadCompleteLogAction()
    {
      return $this->jsonJournalLoadAction('COMPLETE');
    }

    function jsonJournalLoadDriveLogPrePrintAction()
    {
        if(isset($_SESSION)) {
            $_SESSION['reporthook'] = 'DRIVE_PREPRINT';
        }
      return $this->jsonJournalLoadAction('DRIVE_PREPRINT');
    }

    function jsonJournalLoadDriveLogAction()
    {
      return $this->jsonJournalLoadAction('DRIVE');
    }

    function jsonJournalLoadTapeLogPrePrintAction()
    {
        if(isset($_SESSION)) {
            $_SESSION['reporthook'] = 'TAPE_PREPRINT';
        }
      return $this->jsonJournalLoadAction('TAPE_PREPRINT');
    }

    function jsonJournalLoadTapeLogAction()
    {
      return $this->jsonJournalLoadAction('TAPE');
    }

    function jsonJournalLoadReplicationLogPrePrintAction()
    {
        if(isset($_SESSION)) {
            $_SESSION['reporthook'] = 'REPLICATION_PREPRINT';
        }
      return $this->jsonJournalLoadAction('REPLICATION_PREPRINT');
    }

    function jsonJournalLoadReplicationLogAction()
    {
      return $this->jsonJournalLoadAction('REPLICATION');
    }

    function jsonJournalLoadRestoreLogPrePrintAction()
    {
        if(isset($_SESSION)) {
            $_SESSION['reporthook'] = 'RESTORE_PREPRINT';
        }
      return $this->jsonJournalLoadAction('RESTORE_PREPRINT');
    }

    function jsonJournalLoadBackupLogPrePrintAction()
    {
        if(isset($_SESSION)) {
            $_SESSION['reporthook'] = 'BACKUP_PREPRINT';
        }
      return $this->jsonJournalLoadAction('BACKUP_PREPRINT');
    }

    function jsonJournalLoadAction($type = false)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();
        list($id, $context) = $this->_getIdContext($array_context, "BKSID");

        $current_date = 0;
        if ($this->_request->getPost('DISP_DATE')) {
            $current_date = $this->_request->getPost('DISP_DATE');
        } else if ($this->_request->getPost('DATE')) {
            $current_date = $this->_request->getPost('DATE');
        }

        if ($this->_request->getPost('VERBOSITY')) {
            $verbosity = $this->_request->getPost('VERBOSITY');
        } else {
            $verbosity = 255;
        }

        if ($current_date) {
            list($year, $month) = split('[/_]', $current_date);
        } else {
            $year = date('Y');
            $month = 0;
        }

        if (((int) date('m')) == $month) {
            $month = 0;
        }

	switch ($type)
	  {
	  case 'COMPLETE':
	  case 'COMPLETE_PREPRINT':
	    {
	      $regexp_log = 'A .......... ..:..:.. [^K]...*';
	      break ;
	    }
	  case 'DRIVE':
	  case 'DRIVE_PREPRINT':
	    {
	      $regexp_log = 'A .......... ..:..:.. [^K]........ D.*';
	      break ;
	    }
	  case 'TAPE':
	  case 'TAPE_PREPRINT':
	    {
	      $regexp_log = 'A .......... ..:..:.. [^K]........ T.*';
	      break ;
	    }
	  case 'REPLICATION':
	  case 'REPLICATION_PREPRINT':
	    {
	      $regexp_log = 'A .......... ..:..:.. [^K]........ S.*';
	      break ;
	    }
	  case 'RESTORE_PREPRINT':
	  case 'BACKUP_PREPRINT':
	  default :
	    {
	      if ($id) {/* backup journal */
		$regexp_log = 'A .* .* [^K]....* .'.hexdec($id).'.*';
		//$res = $model->journalLoad($month, $year, 'A .* .* [^K]....* .'.hexdec($id).'.*', $verbosity, $context);
	      } else {/* restore journal */
		$regexp_log = 'A .......... ..:..:.. [^K]........ [RE].*';
		//$res = $model->journalLoad($month, $year, 'A .......... ..:..:.. [^K]........ [RE].*', $verbosity, $context);
	      }
	      break ;
	    }
	  }
	$res = $model->journalLoad($month, $year, $regexp_log, $verbosity, $context);

/* The following code does not work with multisite.
   If we don't get the correct journal, we must modify the transaction
   to get it with whatever month and year we pass.
        if (!isset($res->param2)) {
            $month = $month ? 0 : date('m');
            $res = $model->journalLoad($month, $year, 'A .* .* [^K]....* .'.hexdec($id).'.*', 255, $context);
        }
*/

        $data = $this->_get_result($res,$context);
	switch ($type)
	  {
	  case 'BACKUP_PREPRINT':
	  case 'RESTORE_PREPRINT':
	  case 'COMPLETE_PREPRINT':
	  case 'DRIVE_PREPRINT':
	  case 'TAPE_PREPRINT':
	  case 'REPLICATION_PREPRINT':
	    {
	      foreach ($data as $app => $app_data) {
		  $content = '';
		  $content_raw = '';
		  if (isset($data[$app]['PARAM2'][0]->item)) {
		      if ($data[$app]['PARAM2'][0]->item->NAME)
			  $data[$app]['PARAM2'][0]->item = array($data[$app]['PARAM2'][0]->item);
		      foreach ($data[$app]['PARAM2'][0]->item as $key => $msg) {
			  $content .= /*$data[$app]['PARAM2'][0]->item[$key]->NAME = */
			  preg_replace("/^A (....\/..\/..) (..:..:..) (.).{8} ..{1,10} (.?.*)$/", 
				       '<div><span style="display:none">${1} ${2}</span>'
				       . '<span id="type${3}" name="type${3}" class="type${3}">'
				       . '<span class="datetime">${1} ${2}</span>'
				       . ' <span class="message">${4}</span></span></div>', $msg->NAME);
			  $content_raw .= $msg->NAME."\n";
		      }
		      $data[$app]['PARAM2'][0]->item = array(array('NAME' => $content, 'BRUT' => $content_raw, 'NUM' => "1"));
		  } else {
		    $content_raw .= $this->lang['jrnl_Log_msg_list_empty'];
		    $content .= '<div>'.$this->lang['jrnl_Log_msg_list_empty'].'</div>';
		    $data[$app]['PARAM2'][0] = new stdClass();
		    $data[$app]['PARAM2'][0]->item = array(array('NAME' => $content, 'BRUT' => $content_raw, 'NUM' => "1"));
		  }
	      }

            if(isset($_SESSION) && isset($_SESSION['reporthook'])) {
                $_SESSION['reporthookdata'] = $content_raw;
                $this->writereporthook();
            }

	      break ;
	    }
	  }
	$result = $this->makecolumnjson(Zend_Json::encode($data), true);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonNextJournalLoadAction()
    {
        $context = $this->view->context;
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();
        $sessnum = $this->_request->getPost(SESSNUM);
        $transnum = $this->_request->getPost(TRANSNUM);
        $data = $model->nextJournalload($transnum, $sessnum, $context);
        $data = $this->_get_result($data, $context);

	      foreach ($data as $app => $app_data) {
		  $content = '';
		  $content_raw = '';
		  if (isset($data[$app]['PARAM2'][0]->item)) {
		      if ($data[$app]['PARAM2'][0]->item->NAME)
			  $data[$app]['PARAM2'][0]->item = array($data[$app]['PARAM2'][0]->item);
		      foreach ($data[$app]['PARAM2'][0]->item as $key => $msg) {
			  $content .= /*$data[$app]['PARAM2'][0]->item[$key]->NAME = */
			  preg_replace("/^A (....\/..\/..) (..:..:..) (.).{8} ..{1,10} (.?.*)$/", 
				       '<div><span style="display:none">${1} ${2}</span>'
				       . '<span id="type${3}" name="type${3}" class="type${3}">'
				       . '<span class="datetime">${1} ${2}</span>'
				       . ' <span class="message">${4}</span></span></div>', $msg->NAME);
			
			  $content_raw .= $msg->NAME."\n";
		      }
		      $data[$app]['PARAM2'][0]->item = array(array('NAME' => $content, 'BRUT' => $content_raw, 'NUM' => "1"));
		  } else {
		    $content_raw .= '';
		    $content .= '<div>'.$this->lang['jrnl_Log_msg_list_empty'].'</div>';
		    $data[$app]['PARAM2'][0] = new stdClass();
		    $data[$app]['PARAM2'][0]->item = array(array('NAME' => $content, 'BRUT' => $content_raw, 'NUM' => "1"));
		  }
	      }

        if(isset($_SESSION) && isset($_SESSION['reporthook'])) {
            $_SESSION['reporthookdata'] = $content_raw;
            $this->writereporthook();
        }

        $result = $this->makecolumnjson(Zend_Json::encode($data), true);
        $this->getResponse()->appendBody($result);
        return;
    }

    private function writereporthook() {

        if(isset($_SESSION) && isset($_SESSION['reporthook']) && isset($_SESSION['reporthookdata'])) {

            $tmppath = dirname(__FILE__) . '/../../tmp';
            $path = $tmppath . '/reportlogs';

            if(file_exists($tmppath)) {

                if(!file_exists($path)) {
                    mkdir($path);
                    chmod($path, 0777);
                }

                file_put_contents($path . '/' . $_SESSION['reporthook'], $_SESSION['reporthookdata']);
                chmod($path . '/' . $_SESSION['reporthook'], 0666);

            }

        }

    }

    public function jsonJournalDownLoadAction() {

        if(isset($_SESSION) && isset($_SESSION['reporthook']) && isset($_SESSION['reporthookdata'])) {

            $tmppath = dirname(__FILE__) . '/../../tmp';
             $path = $tmppath . '/reportlogs';
             $file = $path . '/' . $_SESSION['reporthook'];
             $tmp = explode('_', $_SESSION['reporthook']);
             $filename = $tmp[0];

             if(file_exists($tmppath) && file_exists($path) && file_exists($file)) {

                //telechargement
                $taille=filesize("$file");
                header("Content-Type: application/force-download; name=\"$filename.txt\"");
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: $taille");
                header("Content-Disposition: attachment; filename=\"$filename.txt\"");
                header("Expires: 0");
                header("Cache-Control: no-cache, must-revalidate");
                header("Pragma: no-cache");
                readfile("$file");
                exit();

             }

        }

    }

    public function jsonJournalGetStatusAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->_getContext();

        require_once 'Zend/Json.php';
        $data = $model->journalGetStatus($array_context);

        $res = $this->_get_result($data, $array_context);

	//DEBUG error_log('jsonJournalGetStatusAction res :'.Zend_Json::encode($res));

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

}
