<?php

require_once 'ArkeiaAction.php';

class LibraryController extends ArkeiaAction
{

    public function jsonManageSlotsAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('manageslots', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonManageDrivesAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('managedrives', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonMoveTapeAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('movetape', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonListFormFactorAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
	$context = $this->view->context;

        require_once 'Zend/Json.php';
        $data = $model->listFormFactor($context);

        $res = array();
        foreach ($data as $obj) {
            $res[$obj->NAME] = $obj->NAME;
        }
        ksort($res);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonListTypeAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
	$context = $this->view->context;

        require_once 'Zend/Json.php';
        $data = $model->listType($context);

        $res = array();
        foreach ($data as $obj) {
            $res[$obj->NAME] = $obj->NAME;
        }
        ksort($res);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonCreateObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $params = $this->_request->getPost();
		
		$params['ARKLIBNODE'] = $params['ARKLIB_NODE_selected'];
		
		$params = $this->_clean_POST($params);
		$params = $this->_clean_select_POST($params);

		$params['ARKLIB_NODE'] = $params['ARKLIBNODE'];
	  	unset ($params['ARKLIBNODE']);

        if(isset($params['FORM_FACTOR']) && $params['FORM_FACTOR'] == 'FILE') {

            //controls

            switch(true) {

                case ($params['NAME'] == ''):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_name']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

                case ($params['ARKLIB_NODE'] == ''):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_node']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

                case ($params['NB_SLOTS_TOTAL'] == '' || !is_numeric($params['NB_SLOTS_TOTAL'])):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_nb_slots']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

            }

            //cleaning
            unset($params['ARM_DEV']);
            unset($params['NB_DRV_TOTAL']);

            $params['NB_SLOTS'] = $params['NB_SLOTS_TOTAL'];
            unset($params['NB_SLOTS_TOTAL']);

            $params['LIB_TYPE'] = $params['FORM_FACTOR'];
            unset($params['FORM_FACTOR']);

            $parts = explode(':', $params['ARKLIB_NODE']);

            if(count($parts) == 2) {

                if($parts[0] == 'NDMP') {

                    $params['NDMPID'] = $parts[1];
                    unset($params['ARKLIB_NODE']);

                } else {

                    $params['ARKLIB_NODE'] = $parts[1];

                }

            }

        } else {

            //controls

            switch(true) {

                case ($params['NAME'] == ''):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_name']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

                case ($params['ARM_DEV'] == '' || $params['ARKLIB_NODE'] == ''):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_devnode']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

                case ($params['FORM_FACTOR'] == ''):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_form_factor']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

                case (($params['NB_SLOTS_TOTAL'] == '' || !is_numeric($params['NB_SLOTS_TOTAL'])) || ($params['NB_DRV_TOTAL'] == '' || !is_numeric($params['NB_DRV_TOTAL']))):
                    $res = $this->_set_error_message($this->view->lang['lib_form_error_nb_drivesslots']);
                    $result = Zend_Json::encode($res);
                    $this->getResponse()->appendBody($result);
                    return;
                break;

            }

            //cleaning
            $params['LIB_TYPE'] = 'TAPE_AUTOMATION';

            $parts = explode(':', $params['ARKLIB_NODE']);

            if(count($parts) == 2) {

                if($parts[0] == 'NDMP') {

                    $params['NDMPID'] = $parts[1];
                    unset($params['ARKLIB_NODE']);

                } else {

                    $params['ARKLIB_NODE'] = $parts[1];

                }

            }

            $params['SLOT_OFFSET'] = 1;
            $params['DRV_OFFSET'] = 1;

        }

        $context = $this->view->context;
        $data = $model->createObject($params, $context);
        $res = $this->_get_result($data, $context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;

    }

    public function jsonModifyObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);

        $params = $this->_request->getPost();

        $params = $this->_clean_POST($params);
        $params = $this->_clean_select_POST($params);

        if(preg_match('`\(NDMP\)$`', $params['ARKLIB_NODE'])) {

            $params['NDMPID'] = $this->_getIDFromNDMP($params['ARKLIB_NODE']);
            $params['ARKLIB_NODE'] = $params['NODE'];

        }

        unset($params['NODE']);
        unset($params['ARKLIB_NODE']);

        $data = $model->modifyObject($params, $context);

        $res = $this->_get_result($data, $context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonDoOne($action, $extra_params=null)
    {
        $context = $this->view->context;
        $data = $this->_doModelResultOne($action, &$context, $extra_params);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonStartAction()
    {
        $this->jsonDoOne('start');
        return;
    }

    public function jsonStopAction()
    {
        $this->jsonDoOne('stop');
        return;
    }

    public function jsonListDrivesAction()
    {
        $this->jsonDoOne('libListDrive');
        return;
    }

    public function jsonCompTapeAction()
    {
        $this->jsonDoOne('libCompTape');
        return;
    }

    public function jsonCompDriveAction()
    {
        $this->jsonDoOne('libCompDrive');
        return;
    }

    public function jsonPingAction()
    {
        $this->jsonDoOne('libPing');
        return;
    }

    public function jsonComboCompatibleDrivesAction()
    {
        $context = $this->view->context;
        $res = $this->_doModelResultOne('listCompatibleDrives', $context, null);
        if ($context) {
            $res = $res->param3->item;
        } else {
            $res = $res->param2->item;
        }
    	if (!is_array($res)) $res = array($res);
        $tList = array();
        $idname = 'DRVID';
        foreach ($res as $key => $val) {
            if ($res[$key]->LIBID) continue;
		    $tList[$res[$key]->$idname] = $res[$key]->NAME;
        }
        $result = Zend_Json::encode($tList);
        $this->getResponse()->appendBody($result);
        return;
    }


    public function jsonCleanDriveAction()
    {
        $params = $this->_request->getPost();
        $this->jsonDoOne('cleanDrive', $params['DRVID']);
        return;
    }

    public function jsonUnmountDriveAction()
    {
        $params = $this->_request->getPost();
        $this->jsonDoOne('unmountDrive', $params['DRVID']);
        return;
    }

    public function jsonMountDriveViewAction()
    {
        $params = $this->_request->getPost();
        $info = $this->_getOne();
        $info->ATTACHABLE = $params['ATTACHABLE'];
        $info->LIBID = $params['LIBID'];
        $res = $this->displayFromScreenIni('mountDrive', FALSE);
        $this->_render_json_view($res);
    }

    public function jsonMountDriveAction()
    {
        $params = $this->_request->getPost();
        $this->jsonDoOne('mountDrive', $params);
        return;
    }

    public function jsonListCompatibleTapesAction()
    {
        $this->jsonDoOne('listCompatibleTapes');
        return;
    }

    public function jsonManageSlotsViewAction()
	{
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('manageSlots', FALSE);
        $this->_render_json_view($res);
	}
    
    public function jsonComboSlotsAction()
    {
        $context = $this->view->context;
        $res = $this->_doModelResultOne('getResultOne', $context, null);
        $res = $res["list0"];
        if ($context) {
            $res = $res->param3->item;
        } else {
            $res = $res->param2->item;
        }
    	if (!is_array($res)) $res = array($res);
        $tList = array();
        $idname = 'SLOT';
        foreach ($res as $key => $val) {
		    $name = $res[$key]->SLOT;
            if (isset($res[$key]->LABEL)) $name = "{$name} {$res[$key]->LABEL}";
		    $tList[$res[$key]->$idname] = $name;
        }
        natcasesort($tList);
        $result = Zend_Json::encode($tList);
        $this->getResponse()->appendBody($result);
        return;
    }
    
    public function jsonComboCompatibleTapesAction()
    {
        $context = $this->view->context;
        $res = $this->_doModelResultOne('listCompatibleTapes', $context, null);
        if ($context) {
            $res = $res->param3->item;
        } else {
            $res = $res->param2->item;
        }
    	if (!is_array($res)) $res = array($res);
        $tList = array();
        $idname = 'TPID';
        foreach ($res as $key => $val) {
            if ($res[$key]->LIBID) continue;
		    $tList[$res[$key]->$idname] = $res[$key]->NAME;
        }
        natcasesort($tList);
        $result = Zend_Json::encode($tList);
        $this->getResponse()->appendBody($result);
        return;
    }
    
    public function jsonSetTapesAction()
    {
        $params = $this->_request->getPost();

error_log(Zend_Json::encode($params));
        $slots = array();
        $tapes = array();
        foreach ($params as $key => $val) {
            if (preg_match('/^SLOT_(.*)$/', $key, $slot)) {
                array_push($slots, $slot[1]);
            } else if (preg_match('/^TPID_(.*)$/', $key, $tape)) {
                array_push($tapes, $tape[1]);
            }
        }
        $tList = array();
        $i = 0;
        foreach ($slots as $slot) {
            $tape = array_shift($tapes);
            if (!$tape) break;
            $tList["item".$i] = array("SLOT" => $slot, "TPID" => $tape);
            $i++;
        }
        $this->jsonDoOne('setTapes', $tList);
        return;
    }

    public function jsonUnsetTapesAction()
    {
        $params = $this->_request->getPost();
        $tList = array();
        $i = 0;
        foreach ($params as $key => $val) {
            if (preg_match('/^SLOT_([^_]*)_(.*)$/', $key, $slot)) {
                $tList["item".$i++] = array("SLOT" => $slot[1], "TPID" => $slot[2]);
            }
        }
        $this->jsonDoOne('unsetTapes', $tList);
        return;
    }

    public function jsonSetStatusAction()
    {
        $params = $this->_request->getPost();
	$params = $this->_clean_select_POST($params);
        $tList = array();
        $i = 0;
        foreach ($params as $key => $val) {
            if (preg_match('/^SLOT_([^_]*)$/', $key, $slot)) {
                $tList["item".$i++] = array("SLOT" => $slot[1], 'STATUS' => $params['STATUS']);
            }
        }
        $this->jsonDoOne('setStatus', $tList);
        return;
    }

    public function jsonWriteLabelAction()
    {
        $params = $this->_request->getPost();
        $tList = array();
        $i = 0;
        foreach ($params as $key => $val) {
            if (preg_match('/^SLOT_([^_]*)_(.*)$/', $key, $slot)) {
                $tList["item".$i++] = array("SLOT" => $slot[1], "TPID" => $slot[2]);
            }
        }
        $this->jsonDoOne('writeLabel', $tList);
        return;
    }

    public function jsonLoadTapeAction()
    {
	$params = $this->_request->getPost();
	$this->jsonDoOne('loadTape', $params);
	return;
    }
    
    public function jsonUnloadTapeAction()
    {
	$params = $this->_request->getPost();
	$this->jsonDoOne('unloadTape', $params);
	return;
    }

    public function jsonImportTapeAction()
    {
	$params = $this->_request->getPost();
	$this->jsonDoOne('importTape', $params);
	return;
    }
    
    public function jsonExportTapeAction()
    {
	$params = $this->_request->getPost();
	$this->jsonDoOne('exportTape', $params);
	return;
    }
    
    public function manageDriveHelpAction()
    {
    	echo $this->view->render('library/managedrives.html');
    }

    public function manageSlotHelpAction()
    {
    	echo $this->view->render('library/manageslots.html');
    }

    public function moveTapeHelpAction()
    {
    	echo $this->view->render('library/movetapes.html');
    }

    public function jsonGetResultOneAndNDMPAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultOneAndNDMP($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
	//DEBUG error_log('jsonGetOneAction: '.$result);
        return;
    }

    protected function _getResultOneAndNDMP($array_context = null)
    {
        return $this->_doModelResultOne('getResultOneAndNDMP', $array_context);
    }

    public function jsonUpdateAction()
    {
        $info = $this->_getOneAndNDMP();
        $res = $this->displayFromScreenIni('update', FALSE);
        $this->_render_json_view($res);
        return;
    }

    protected function _getOneAndNDMP()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOneAndNDMP($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->$appidname = $this->view->appid_id;
	    if (($idname = $ctrlcfg->id) && !isset($data->$idname))
                $data->$idname = $id;
            $data->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;
        $this->view->$arkobject = $data;
        return $data;
    }

   private function _getIDFromNDMP($name='') {

        $result = '';

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $context = null;
        $appid = null;

        if ($appidraw = $this->_request->getPost('APPID_LIBID')) {
            $tmp = explode('_', $appidraw);
            $appid = $tmp[0];
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }

        $res = $model->_getAllNDMP($context);

        if($context && $appid) {

            foreach($res as $list => $val) {

                if(isset($val->param0) && $val->param0 == $appid) {

                    foreach($val->param3->item as $subval) {

                        if($subval->NAME == $name || preg_match('`^'.$subval->NAME.' \(NDMP\)$`', $name)) {

                            $result = $subval->NDMPID;
                            break;

                        }

                    }

                    break;

                }

            }

        } else {

            if(isset($res->param2) && isset($res->param2->item)) {

                foreach($res->param2->item as $num=>$val) {

                    if($val->NAME == $name || preg_match('`^'.$val->NAME.' \(NDMP\)$`', $name)) {

                        $result = $val->NDMPID;
                        break;

                    }

                }

            }

        }

        return $result;

    }

}
