<?php

require_once 'ArkeiaAction.php';

class LoginController extends ArkeiaAction
{

    public function init()
    {
        $this->view = $this->getInvokeArg('view');
        $this->mvc = $this->getInvokeArg('mvc');
        $this->_auth = $this->getInvokeArg('auth');
        $this->view->title = "Login";
        $this->_redirectUrl = $this->getRequest()->getBaseUrl();
        if (array_key_exists('HTTP_REFERER', $_SERVER)) {
            $this->_redirectUrl = $_SERVER['HTTP_REFERER'];
        }
    }

    public function indexAction() {
        echo $this->render();
    }

    public function layoutAction() {
        $this->view->assign('subaction','login/summary');
        echo $this->view->render('layout.phtml');
    }

    public function summaryAction()
    {
        echo $this->view->render('login.phtml');
    }

    public function doLoginAction()
    {
        // make sure they are not already logged in
        if ($this->_auth->hasIdentity())
        {
            $msg = "You are already logged in.";
            $this->getResponse()->appendBody($msg);
            return;
        }

        $username = $this->_request->getPost('username');
        if ($username == null || $username == "") {
        // make sure they provided both a username and password
            $msg = "You must provide a username and password";
            $this->getResponse()->appendBody($msg);
            return;
        }
        $password = $this->_request->getPost('password');
        if ($password == null) $password = "";
        $admin = $this->_request->getPost('admin');
        if ($admin == null) $admin = 0;
        // check their credentials against their username
        try
        {
            require_once 'Arkeia/Auth/Adapter/Arkws.php';
            Zend_Loader::loadClass("ArkObject");
            $model = new ArkObject($this->mvc, "ArkObject");

            $result = $model->connect($this->_auth,
                                      $username,
                                      $password,
                                      $admin,
                                      0);

            //$authenticator = new Arkeia_Auth_Adapter_Arkws($username, $password,$admin);
            
            /**
             * By default Zend_Auth will auto-store the identity
             * if it is authenticated.
             */
            //$result = $this->_auth->authenticate($authenticator);

            if ($result->isValid()) {
	        $msg = "url:.";
	        $messages = $result->getMessages();
	        foreach ($messages as $message)
		    if ($message == 'NOT_ENOUGH_LICENSE')
		        $msg = "warning:".$this->_auth->lang['login_warning_NOT_ENOUGH_LICENSE'].";url:.";
		    if ($message == 'NO_APPLIANCE_CONFIGURED')
		        $msg = "warning:".$this->_auth->lang['login_warning_NO_APPLIANCE_CONFIGURED'].";url:.";
            } else {
                require_once 'Zend/Json.php';
                $msg = Zend_Json::encode($result->getMessages());
            }

            if(!$admin) {

                $this->getstatus();

            }

        }
        catch (Zend_Auth_Exception $e)
        {
            $msg = "Invalid credentials / " . $e->getMessage();
        }
        catch (Zend_Exception $e)
        {
            die($e->getMessage());
        }
        $this->getResponse()->appendBody($msg);
        return;
    }

    public function autoLoginAction()
    {
	// make sure they are not already logged in
        if ($this->_auth->hasIdentity())
        {
		echo $this->view->render('autologin.phtml');
		return;
        }

        $username = $this->_request->getPost('username');
        if ($username == null || $username == "") {
		// make sure they provided both a username and password
		echo $this->view->render('autologin.phtml');
		return;
        }
        $password = $this->_request->getPost('password');
        if ($password == null) $password = "";
        $admin = 0;

	require_once 'Arkeia/Auth/Adapter/Arkws.php';
	Zend_Loader::loadClass("ArkObject");
	$model = new ArkObject($this->mvc, "ArkObject");

	$result = $model->connect($this->_auth,
				  $username,
				  $password,
				  $admin,
				  0);

    if(!$admin) {

        $this->getstatus();

    }

	echo $this->view->render('autologin.phtml');
        return;
    }

    private function _logout()
    {
        // make sure they are not already logged in
        if (!$this->_auth->hasIdentity())
        {
            $this->view->flashMessenger->addMessage("You must be logged in to logout.");
            return;
        }
        require_once 'Arkeia/Soap.php';
        $acx = Arkeia_Soap::getInstance();
        $acx->logoutAll();
        $this->_auth->clearIdentity();

        Zend_Session::namespaceUnset('arkeia');
        //Zend_Session::forgetMe();
        Zend_Session::writeClose();
    }

    public function logoutAction() {
        $this->_logout();
        $this->_redirect($this->_redirectUrl);
        return;
    }

    public function doLogoutAction() {
        $this->_logout();
        $msg = "url:.";
        $this->getResponse()->appendBody($msg);
        return;
    }

    public function doLogoutrestartNowAction() {
    	$time = 0;
        $this->_logoutshutdown("REBOOT", $time);
        $msg = "url:.";
        $this->getResponse()->appendBody($msg);
        return;
    }

    public function doLogoutrestartAction() {
    	$time = 0;
    	$time = $_POST['RESTART'];
        $this->_logoutshutdown("REBOOT", $time);
        $msg = "url:.";
        $this->getResponse()->appendBody($msg);
        return;
    }

    public function doLogoutpoweroffAction() {
    	$time = 0;
    	$time = $_POST['POWEROFF'];
        $this->_logoutshutdown("POWEROFF", $time);
        $msg = "url:.";
        $this->getResponse()->appendBody($msg);
        return;
    }

    private function _logoutshutdown($action=null, $time=0)
    {
        // make sure they are not already logged in
        if (!$this->_auth->hasIdentity())
        {
            $this->view->flashMessenger->addMessage("You must be logged in to logout.");
            return;
        }
        require_once 'Arkeia/Soap.php';
        $acx = Arkeia_Soap::getInstance();
		$acx->logoutAllShutdown($action, $time);
        $this->_auth->clearIdentity();

        Zend_Session::namespaceUnset('arkeia');
        //Zend_Session::forgetMe();
        Zend_Session::writeClose();
    }

    function successAction() {
        echo 'Congratulations! You are in.';
    }

    private function getstatus() {

        $context = $this->view->context;

        Zend_Loader::loadClass("ArkObject");
        $model = new ArkObject($this->mvc, "ArkObject");

        $data = $model->getstatus($context);

        $res = $this->_get_result($data, $context);

	$status = array();

        foreach((array)$res as $result) {
		if(isset($result['PARAM2']) && isset($result['PARAM2'][0])) {
			if (isset($result['PARAM2'][0]->ISVBA)) {
				$status['vba'] = true;
			}
			if (isset($result['PARAM2'][0]->ISEXPANDABLE)) {
				$status['expandable'] = true;
			}
			if(isset($result['PARAM2'][0]->EDGEFORT_VERSION)) {
				$status['version'] = $result['PARAM2'][0]->EDGEFORT_VERSION;
			}
			if(isset($result['PARAM2'][0]->EDGEFORT_MODEL)) {
				$status['model'] = $result['PARAM2'][0]->EDGEFORT_MODEL;
			}
		}
	}
	$session_arkeia = new Zend_Session_Namespace('arkeia');
	$session_arkeia->status = $status;
    }
}
?>
