<?php

require_once 'ArkeiaAction.php';

class MediaserverController extends ArkeiaAction
{
	public function jsonListMediaserverAction()
    {
		require_once 'Zend/Json.php';
	    $result = $this->_getResultAllNameId();
	    $appid = $this->_request->getParam(APPLIANCE_GUID);
	    if (!$appid) $appid = "local";
	    $res = $result[$appid][PARAM2][0];
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
	}
	
  public function jsonGetListMediaserversAction()
    {
    	$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;
		
	    require_once 'Zend/Json.php';
		$result = $model->getAllMediaservers();
		$res = $this->_get_result($result, $this->view->context);
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
    }
	
	public function jsonGetListNoMediaserversAction()
    {
    	$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;
		
	    require_once 'Zend/Json.php';
		$result = $model->getAllNoMediaservers();
		$res = $this->_get_result($result, $this->view->context);
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
    }
	
	public function jsonUnsetMediaserverAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;
		
		$params = $this->_request->getPost();
	    require_once 'Zend/Json.php';
				
		//error_log("PARAMS:".Zend_Json::encode($params));

		if (!isset($params['ID']) || $params['ID'] == '') {
          	$res = $this->_set_error_message($this->lang['mediaserver_no_id']);
			$result = Zend_Json::encode($res);
	        $this->getResponse()->appendBody($result);      
	        return;
	    }
		if ($params['ID'] == 'N') {
			$res = $this->_set_error_message($this->lang['mediaserver_error_id']);
			$result = Zend_Json::encode($res);
	        $this->getResponse()->appendBody($result);      
	        return;
		}

		$result = $model->unsetMediaserver($params['ID']);
		$res = $this->_get_result($result, $this->view->context);
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
	}
	
	public function jsonSetMediaserverAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;
		
		$params = $this->_request->getPost();
	    require_once 'Zend/Json.php';
				
		if (!isset($params['ID']) || $params['ID'] == '') {
          	$res = $this->_set_error_message($this->lang['mediaserver_no_id']);
			$result = Zend_Json::encode($res);
	        $this->getResponse()->appendBody($result);      
	        return;
	    }
		if ($params['ID'] == 'N') {
			$res = $this->_set_error_message($this->lang['mediaserver_error_id']);
			$result = Zend_Json::encode($res);
	        $this->getResponse()->appendBody($result);      
	        return;
		}

		$result = $model->setMediaserver($params['ID']);
        $res = $this->_get_result($result, $this->view->context);
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
	}

    public function jsonGetAllAndNDMPNameAction() {
		$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;

        $res = $this->getAllAndNDMPNameId('SID');
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function getAllAndNDMPNameId($idname = false) {

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        if ($idname == false)
            $idname = $ctrlcfg->id;

        if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }

        $res = $this->_getResultAllAndNDMP($context);

        if (!is_array($res))
            $res = array($res);

        foreach ($res as $key => $val) {
            if ($context) {
                $data = $res[$key]->param3->item;
            } else {
                $data = $res[$key]->param2->item;
            }
            if ($data) break ; 
        }

        $res = array();

        if ($data) {
            if (is_array($data)) {
                foreach ($data as $obj) {
                    $res[$obj->$idname] = (string) $obj->NAME;
                }
            } else {
                    $res[$data->$idname] = (string) $data->NAME;
            }
        }
        natcasesort($res);

        return $res;
    }

    private function _getResultAllAndNDMP($array_context, $intersect = false, $params = false) {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $appid = $this->_request->getPost(APPLIANCE_GUID);
        $context = null;

        require_once 'Zend/Json.php';

        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
        }

        if ($intersect)
            $result = $model->getResultAllIntersect($context, $params);
        else
            $result = $model->getAllMediaserversAndNDMP(3, $context);

        return $result;
    }

}

?>
