<?php

require_once 'ArkeiaAction.php';

class NdmprestorationController extends ArkeiaAction
{
	static function NDMPsearch_arkndmp($start_search)
	{
		if (stristr($start_search, '!arkndmp') === false) {
			$dash = strpos($start_search, ':');
			if ($dash === false) {
				$start_search .= '!arkndmp:';
			}
			else {
				$split = split(':', $start_search);
				$split[0] .= '!arkndmp';
				$start_search = implode(':', $split);
			}
		}
		else {
			$excl = strpos($start_search, '!');
			$tmp = $start_search;
			$new_tmp = substr($tmp, $excl + 1, 8);
			$new_tmp_lower = strtolower($new_tmp);
			if ($new_tmp_lower == 'arkndmp') {
				$start_search = str_replace($new_tmp, $new_tmp_lower, $start_search);
			}
		}
		return ($start_search);
	}
	
	public function showndmprestorationHelpAction()
    {
        echo $this->view->render('showndmprestoration/help.html');
    }
	
	public function jsonStartAction()
    {
	    $ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
	    $idname = $ctrlcfg->id;
	
	    $params = $this->_request->getPost();
	
	    $listtrees = Zend_Json::decode($params['listtrees']);
	    unset($params['listtrees']);
	
	    $params = $this->_clean_select_POST($params);
	    $params = $this->_clean_POST($params);
	
		unset($params['advparam_name']);
		unset($params['advparam_val']);

		foreach ($params as $key => $val) {
			if (!strncmp($key, 'adv_param_', 10)) {
		  		$cut = substr($key, 10);
		  		$params['var_env_'.$cut] = $val;
				unset($params[$key]);
		  	}
		}

	    /* set tree */
        for ($i = 0; isset($listtrees[$i]); $i++) {
            if(isset($listtrees[$i]['FULLNAME']) && isset($listtrees[$i]['FULLPATH'])) {
                unset($listtrees[$i]['FULLPATH']);
                $listtrees[$i]['FULLNAME'] = $this->navpath_base64_decode($listtrees[$i]['FULLNAME']);
            }
            $params['item'.$i] = $listtrees[$i];
        }
	
	    require_once 'Zend/Json.php';
	    //error_log('jsonStartAction, params: '.Zend_Json::encode($params));
	
	    /* no file select */
	    if (!$i) {
			$res = $this->_set_error_message($this->lang['rst_start_error_no_files_selected']);
	    } 
		else {

		  	$data = $model->startRestoration($params, $this->view->context);
			//error_log('jsonStartAction, data: '.Zend_Json::encode($data));
			//error_log('jsonStartAction, context: '.Zend_Json::encode($this->view->context));
			
			$res = $this->_get_result($data, $this->view->context);
	    }
	    //error_log('jsonStartAction, res: '.Zend_Json::encode($res));
		
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
	}	   

	public function jsonShowRestorationAction()
	{
		$params = $this->_request->getPost();
	    require_once 'Zend/Json.php';
	
		//error_log("jsonShowRestorationAction POST: ".Zend_Json::encode($this->_request->getPost()));
		
		if (!$params['PARAM2']) {
		  $array_context = $this->view->context;
		  list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
		  if ($id) {
		    list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
		  }
		}
	
	    $this->view->showBackup = $params;
	
        $data = $this->displayFromScreenIni('showndmprestoration', FALSE);
	    $this->_render_json_view($data);
	    return;
	}
}

?>