<?php

require_once 'ArkeiaAction.php';

class ReplicationController extends ArkeiaAction
{
	/**	ARKRSYNCD PART    **/

	public function datacenterAction()
	{
		$this->displayFromScreenIni('datacenter');
	}

	public function datacenterHelpAction()
	{
		echo $this->view->render('replication/datacenter_help.html');
	}

	public function datacenteraccountmainHelpAction()
	{
		echo $this->view->render('replication/account_help.html');
	}

	public function datacenteraccountHelpAction()
	{
		echo $this->view->render('replication/account_help01.html');
	}

	public function jsonReplicationActiveAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$data = $model->isInstalled();

		if ($data->param0 == "0") {
			if ($data->param2 == "-1") {
				$data->param2 = array('ACTIVE' => 1, 'PATH' => $data->param3);
			}
			else {
				$data->param2 = array('ACTIVE' => 0, 'PATH' => $data->param3);
			}
			unset($data->param3);
		}
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function installAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$data = $model->isInstalled();

		if ($data->param0 == "0" && $data->param2 == "-1") {
			$this->displayFromScreenIni('remove');
		}
		else {
			$this->displayFromScreenIni('install');
		}
	}

	public function accountAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$data = $model->isInstalled();

		if ($data->param0 == "0" && $data->param2 == "-1") {
			$this->displayFromScreenIni('account');
		}
		else {
			$this->displayFromScreenIni('datacenter');
		}
	}

	public function hostinfoAction()
	{
		$info = $this->_getOne();
		$res = $this->displayFromScreenIni('hostinfo', FALSE);
		$this->_render_json_view($res);
		return ;
	}

	public function modifyAction()
	{
		$info = $this->_getOneModify();
		$res = $this->displayFromScreenIni('modify', FALSE);
		$this->_render_json_view($res);
		return ;
	}

	public function accountpasswordAction()
	{
		$info = $this->_getOneModify();
		$res = $this->displayFromScreenIni('accountpassword', FALSE);
		$this->_render_json_view($res);
		return ;
	}

	protected function _getOneModify()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context);
		$data = $model->getOneModify($id, $context);
		if ($appidname = $this->view->appidname) {
			$data->$appidname = $this->view->appid_id;
			if (($idname = $ctrlcfg->id) && !isset($data->$idname))
				$data->$idname = $id;
			$data->APPID = $this->view->appid;
		}
		$arkobject = $ctrlcfg->object;
		if (isset($data->QUOTA)) {
			$data->QUOTA /= 1073741824;
		}
		$this->view->$arkobject = $data;
		return $data;
	}

	public function jsonInstallAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();
		//error_log('jsonInstallAction post:'.Zend_Json::encode($params));

		if ($params['PATH'] == '') {
			$res = $this->_set_error_message($this->lang['replication_path_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		$data = $model->arkrsyncdInstall($params['PATH']);
		$model->arkrsyncdStart();
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonRemoveAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$model->arkrsyncdStop();
		$data = $model->arkrsyncdRemove();
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonStartAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$data = $model->arkrsyncdStart();
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonStopAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$data = $model->arkrsyncdStop();
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonGetConfigAllAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context);

		$data = $model->arkrsyncdgetconfig($id);
		$res = $this->_get_result($data, null);
		if ($id != null) {
			if (isset($res["local"]["PARAM2"][0]->ACTIVE)) {
				if (isset($res["local"]["PARAM2"][0]->AUTH_ID) &&
				    !$res["local"]["PARAM2"][0]->ACTIVE) {
					$res["local"]["PARAM2"][0]->ACTIVE =
						$this->lang['replication_in_progress'];
				}
				else {
					$res["local"]["PARAM2"][0]->ACTIVE =
						$res["local"]["PARAM2"][0]->ACTIVE ?
						$this->lang['replication_yes'] :
						$this->lang['replication_no'];
				}
			}
			else {
				$res["local"]["PARAM2"][0]->ACTIVE =
					$this->lang['replication_no'];
			}
			if (isset($res["local"]["PARAM2"][0]->ENABLE)) {
				$res["local"]["PARAM2"][0]->ENABLE =
					$res["local"]["PARAM2"][0]->ENABLE ?
					$this->lang['replication_yes'] :
					$this->lang['replication_no'];
			}
			else {
				$res["local"]["PARAM2"][0]->ENABLE =
					$this->lang['replication_no'];
			}
			if (isset($res["local"]["PARAM2"][0]->SHARE)) {
				$res["local"]["PARAM2"][0]->SHARE =
					$res["local"]["PARAM2"][0]->SHARE ?
					$this->lang['replication_yes'] :
					$this->lang['replication_no'];
			}
			else {
				$res["local"]["PARAM2"][0]->SHARE =
					$this->lang['replication_no'];
			}
			if (isset($res["local"]["PARAM2"][0]->QUOTA)) {
				$res["local"]["PARAM2"][0]->QUOTA /= 1073741824;
			}
		}

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonGetVolumesAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$data = $model->getVolumes();
		$res = $this->_get_result($data, null);

		/* Parse FREE_SIZE value to set it in the good format */
		if (is_array($res["local"]["PARAM2"])) {
			foreach ($res["local"]["PARAM2"] as $search) {
				if (gettype($search) == "object") {
					$param2 = $search->item;
					break ;
				}
			}
		}
		else {
			$param2 = &$res["local"]["PARAM2"]->item;
		}
		if (is_array($param2)) {
			for ($i = 0; isset($param2[$i]); $i++) {
				foreach ($param2[$i] as $key => $val) {
					if ($key == 'FREE_SIZE') {
						$param2[$i]->$key = $this->_convert_size($val / 1024);
					}
				}
			}
		}
		else {
			$param2->FREE_SIZE = $this->_convert_size($param2->FREE_SIZE / 1024);
		}

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	private function _convert_size($val) {
		if ($val > 1073741824) {
		    $val = round($val / 1073741824, 2) . ' TB';
		} else if ($val > 1048576) {
		    $val = round($val / 1048576, 2) . ' GB';
		} else if ($val > 1024) {
		    $val = round($val / 1024, 2) . ' MB';
		} else {
		    $val = round($val, 2) . ' KB';
		}
		return ($val);
	}

	public function jsonAddModuleAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();

		if ($params['NAME'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_name_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['PASSWD'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_passwd_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if (isset($params['PASSWD_confirm']) && $params['PASSWD'] != $params['PASSWD_confirm']) {
			$res = $this->_set_error_message($this->lang['replication_account_passwd_confirm_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['CHK_PATH'] == '1' && $params['PATH'] == '') {
			$res = $this->_set_error_message($this->lang['replication_path_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['CHK_PATH'] != '1') {
			unset($params['PATH']);
		}
		unset($params['CHK_PATH']);

		unset($params['ADD']);

		if ($params['CHK_QUOTA'] == '1' && $params['QUOTA'] == '') {
			$res = $this->_set_error_message($this->lang['replication_info_account_quota_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['CHK_QUOTA'] == '1' && $params['QUOTA'] != '') {
			/* translate Gb to Octets */
			$params['QUOTA'] = $params['QUOTA'] * 1073741824;
		}
		else {
			unset($params['QUOTA']);
		}
		unset($params['CHK_QUOTA']);
		
		if(isset($params['PASSWD_confirm'])) {
			unset($params['PASSWD_confirm']);
		}

		$data = $model->createModule($params);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonRemoveModuleAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context);

		$data = $model->RemoveModule($id);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonGetHostConfigAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context);

		$data = $model->arkrsyncdgethostconfig($id);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonModifyModuleAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context);

		$idname = $ctrlcfg->id;
		$params = $this->_request->getPost();

		unset($params['MODIFY']);
		unset($params['ACTIVE']);
		unset($params['NAME']);
		$array_params = array();

		if (isset($params['NEW_PASSWD']) && $params['NEW_PASSWD'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_newpasswd_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		} else {
			if (isset($params['NEW_PASSWD_confirm']) && $params['NEW_PASSWD'] != $params['NEW_PASSWD_confirm']) {
				$res = $this->_set_error_message($this->lang['replication_account_newpasswd_confirm_require']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return ;
			}
			$array_params['PASSWD'] = $params['NEW_PASSWD'];
		}

		if (isset($params['ENABLE'])) {
			$array_params['ENABLE'] = $params['ENABLE'];
		}
		else {
			$array_params['ENABLE'] = "0";
		}
		if (isset($params['SHARE'])) {
			$array_params['SHARE'] = $params['SHARE'];
		}
		else {
			$array_params['SHARE'] = "0";
		}
		if ($array_params['SHARE'] == "1") {
			if ($params['PASSWD_SHARE'] == '') {
				$res = $this->_set_error_message($this->lang['replication_account_passwd_share_require']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return ;
			}
			else {
				$array_params['PASSWD_SHARE'] = $params['PASSWD_SHARE'];
			}

			if (isset($params['PASSWD_SHARE_confirm']) && $params['PASSWD_SHARE'] != $params['PASSWD_SHARE_confirm']) {
				$res = $this->_set_error_message($this->lang['replication_account_passwd_confirm_share_require']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return ;
			}

		}
		if ($params['CHK_QUOTA'] == '1' && $params['QUOTA'] == '') {
			$res = $this->_set_error_message($this->lang['replication_info_account_quota_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['CHK_QUOTA'] == "1") {
			$array_params['QUOTA'] = $params['QUOTA'] * 1073741824;
		}
		else {
			$array_params['QUOTA'] = '';
		}
		$data = $model->modifyModule($array_params, $params['MODULE_ID'], $context);
		$res = $this->_get_result($data, $context);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);

		return ;
	}


	/**	ARKRSYNC PART    **/

	public function dcconnectionmainHelpAction()
	{
		echo $this->view->render('replication/dcconnection_help.html');
	}

	public function datacenterclientAction()
	{
		$this->displayFromScreenIni('datacenterclient');
	}

	public function dcperiodicmainHelpAction()
	{
		echo $this->view->render('replication/dcperiodic_help.html');
	}


	public function dcconnectionAction()
	{
		$this->displayFromScreenIni('dcconnection');
	}

	public function dcperiodicAction()
	{
		$this->displayFromScreenIni('dcperiodic');
	}

	public function dcperiodicwizardAction()
	{
		$this->displayFromScreenIni('dcperiodicwizard');
	}

	public function getAllNameDCId($idname = false)
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		if ($idname == false)
			$idname = $ctrlcfg->id;

		if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
			$context = $this->_get_filtered_context($appid, $this->view->context);
		} else {
			$context = $this->view->context;
		}

		$res = $model->arkrsyncgetconfig(null, $context);
		if (!is_array($res)) $res = array($res);
		foreach ($res as $key => $val) {
			if ($context) {
				$data = $res[$key]->param3->item;
			} else {
				$data = $res[$key]->param2->item;
			}
			if ($data) break ;
		}
		$res = array();
		if ($data) {
			if (is_array($data)) {
				foreach ($data as $obj) {
					if ($obj->SHARE == "0") {
						$res[$obj->$idname] = (string) $obj->NAME;
					}
				}
			} else {
				if ($data->SHARE == "0") {
					$res[$data->$idname] = (string) $data->NAME;
				}
			}
		}
		natcasesort($res);

		return $res;
	}

	public function jsonGetAllNameDCIdAction()
	{
		$res = $this->getAllNameDCId("DCID");
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function _getResultAllNameDCIntersect($combobox = true)
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$idname = 'NAME';
		$array_context = $this->view->context;
		$appid = $this->_request->getParam(APPLIANCE_GUID);
		if (!$appid) $appid = "local";
		if ($appid != "local") {
			$context = $this->_get_filtered_context($appid, $array_context);
		} else $context = $array_context;
		$res = $model->arkrsyncgetconfig(null, $context);
		if (is_array($res->param2->item)) {
			foreach ($res->param2->item as $obj) {
				if ($combobox)
					$newres[$obj->$idname] = $obj->NAME;
				else
					$newres[] = array($idname => $obj->NAME);
			}
		} else if ($res->param2->item){
			if ($combobox)
				$newres[$res->param2->item->$idname] = $res->param2->item->NAME;
			else
				$newres[] = array($idname => $res->param2->item->NAME);
		}
		return $newres;
	}

	public function jsonGetResultAllNameIntersectAction()
	{
		$res = $this->_getResultAllNameDCIntersect();
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function jsonGetDcConfigAllAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
			$context = $this->_get_filtered_context($appid, $this->view->context);
		} else {
			$context = $this->view->context;
		}

		$data = $model->arkrsyncgetconfig(null, $context);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonGetDcConfigOneAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "DCID");

		$data = $model->arkrsyncgetconfig($id, $context);
		$res = $this->_get_result($data, null);

		if ($this->view->appid != "") {
			$list = $res[$this->view->appid]['PARAM2'][0];
		}
		else {
			$list = $res['local']['PARAM2'][0];
		}
		if (isset($list->AUTH_ID) && $list->AUTH_ID == "share") {
			$list->GUEST = $this->lang['replication_yes'];
		}
		else {
			$list->GUEST = $this->lang['replication_no'];;
		}

		$result = Zend_Json::encode($res);

		//error_log("RES:".$result);

		$this->getResponse()->appendBody($result);
		return ;
	}

	public function dcaddAction()
	{
		$this->displayFromScreenIni('dcadd');
		return ;
	}

	public function dcaddguestAction()
	{
		$this->displayFromScreenIni('dcaddguest');
		return ;
	}

	public function dcmodifyAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "DCID");

		$info = $model->arkrsyncgetconfigModify($id, $context);
		if ($appidname = $this->view->appidname) {
			$info->$appidname = $this->view->appid_id;
			if (($idname = $ctrlcfg->id) && !isset($info->$idname))
				$info->$idname = $id;
			$info->APPID = $this->view->appid;
		}
		$arkobject = $ctrlcfg->object;
		$this->view->$arkobject = $info;

		$res = $this->displayFromScreenIni('dcmodify', FALSE);
		$this->_render_json_view($res);
		return ;
	}

	public function dcmodifyipAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "DCID");

		$info = $model->arkrsyncgetconfigModify($id, $context);
		if ($appidname = $this->view->appidname) {
			$info->$appidname = $this->view->appid_id;
			if (($idname = $ctrlcfg->id) && !isset($info->$idname))
				$info->$idname = $id;
			$info->APPID = $this->view->appid;
		}
		$arkobject = $ctrlcfg->object;
		$this->view->$arkobject = $info;

		$res = $this->displayFromScreenIni('dcmodifyip', FALSE);
		$this->_render_json_view($res);
		return ;
	}
	
	public function dctestconnectAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "DCID");

		if ($id == '') {
			$res = $this->_set_error_message($this->lang['replication_datacenter_test_connect_not_selected']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}

		$info = $model->arkrsyncgetconfigModify($id, $context);
		if ($appidname = $this->view->appidname) {
			$info->$appidname = $this->view->appid_id;
			if (($idname = $ctrlcfg->id) && !isset($info->$idname))
				$info->$idname = $id;
			$info->APPID = $this->view->appid;
		}
		$data = $model->testconnect($info, $context);
		
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonAddDcAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();

		if ($params['NAME'] == '') {
			$res = $this->_set_error_message($this->lang['replication_datacenter_name_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['ADDRESS'] == '') {
			$res = $this->_set_error_message($this->lang['replication_datacenter_address_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['MODULE'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_name_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['PASSWORD'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_passwd_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}

		unset($params['ADD']);

		$data = $model->declareDc($params);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonAddGuestDcAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();

		if ($params['NAME'] == '') {
			$res = $this->_set_error_message($this->lang['replication_datacenter_name_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['ADDRESS'] == '') {
			$res = $this->_set_error_message($this->lang['replication_datacenter_address_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['MODULE'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_name_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if ($params['PASSWORD'] == '') {
			$res = $this->_set_error_message($this->lang['replication_account_passwd_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}

		unset($params['ADDGUEST']);

		$data = $model->declareGuestDc($params);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonModifyDcAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();

		if ($params['NEW_PASSWORD'] == '') {
			$res = $this->_set_error_message($this->lang['replication_module_change_passwd_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		if (isset($params['NEW_PASSWORD_confirm']) && $params['NEW_PASSWORD'] != $params['NEW_PASSWORD_confirm']) {
			$res = $this->_set_error_message($this->lang['replication_account_newpasswd_confirm_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		
		unset($params['MODIFY']);
		$params['PASSWORD'] = $params['NEW_PASSWORD'];
		unset($params['NEW_PASSWORD']);
		unset($params['NEW_PASSWORD_confirm']);

		$data = $model->modifyDc($params);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonModifyDcIpAction() {
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$params = $this->_request->getPost();

		if ($params['ADDRESS'] == '') {
			$res = $this->_set_error_message($this->lang['replication_module_change_ip_require']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return ;
		}
		unset($params['MODIFY']);
		
		$data = $model->modifyDc($params);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonRemoveDcAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "DCID");

		$data = $model->RemoveDc($id);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonSchRepListAllAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$data = $model->schreplistall();
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonGetAllNameSchIdAction()
	{
		$res = $this->getAllNameSchId("SCHID");
		require_once 'Zend/Json.php';
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return;
	}

	public function getAllNameSchId($idname = false)
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		if ($idname == false)
			$idname = $ctrlcfg->id;

		if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
			$context = $this->_get_filtered_context($appid, $this->view->context);
		} else {
			$context = $this->view->context;
		}

		$res = $model->schrepchainlistall($context);
		if (!is_array($res)) $res = array($res);
		
		foreach ($res as $key => $val) {
			if ($context) {
				$data = $res[$key]->param3->item;
			} else {
				$data = $res[$key]->param2->item;
			}
			if ($data) break ;
		}
		
		$res = array(); 
		if ($data) { 	 
			if (is_array($data)) { 	 
				foreach ($data as $obj) { 	 
					$res[$obj->$idname] = (string) $obj->DCNAME; 	 
				} 	 
			} else { 	 
				$res[$data->$idname] = (string) $data->DCNAME; 	 
			} 	 
		} 	 
		natcasesort($res);
		
		return $res;
	}

	public function jsonSchRepListOneAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "SCHID");

		$data = $model->schreplistone($id);
		if (isset($data->param2->RET_TIME) &&
		    $data->param2->RET_TIME != '') {
			$data->param2->REP_SCH_RETENTION = 'on';
		}
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		//DEBUG error_log('jsonSchRepListOneAction result:' . $result);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonSchRepRemoveAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "SCHID");

		$data = $model->RemoveSchRep($id);
		$res = $this->_get_result($data, null);

		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	public function jsonCreateRepWizardObjectAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);
		$idname = $ctrlcfg->id;

		$res = false;

		$post_params = $this->_request->getPost();
		$post_params = $this->_clean_select_POST($post_params);

		require_once 'Zend/Json.php';
		//DEBUG error_log('jsonCreateRepWizardObjectAction, post: '.Zend_Json::encode($post_params));

		if ($post_params['VTLID'] == '') {
			$res = $this->_set_error_message($this->lang['replication_sch_wizard_error_value_require_VTL']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}

		if ($post_params['REPLICATE_WHOLE_VTL'] != 1) {
		    if (!isset($post_params['spkidlist']) || $post_params['spkidlist'] == '') {
			$res = $this->_set_error_message($this->lang['replication_sch_wizard_error_value_require_SPK']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		    }
		    $spkidlist = split(',', $post_params['spkidlist']);
		}

		if ($post_params['DCID'] == '') {
			$res = $this->_set_error_message($this->lang['replication_sch_wizard_error_value_require_DC']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}

		$list1 = array();
		$list2 = array();

		$rep_policy = $post_params['REPPOLICY'];

		if (isset($post_params[$rep_policy.'_REP_SCH_RETENTION']) && 
		    $post_params[$rep_policy.'_REP_SCH_RETENTION'] == 'on' &&
		    ($post_params[$rep_policy.'_RET_TIME'] == '' || 
		     $post_params[$rep_policy.'_RET_TIME_UNIT'] == '')) {
			$res = $this->_set_error_message($this->lang['replication_error_value_require_RET_TIME']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}

		if (isset($post_params[$rep_policy.'_FORM_DATE'])) {
			list($year, $mouth, $day) = split('[-]', $post_params[$rep_policy.'_FORM_DATE']);
			$start_date = $year.$mouth.$day;
		} else {
			$start_date = date('Ymd');
		}

		list($heure, $minute, $seconde) = split('[:+]', $post_params[$rep_policy.'_FORM_TIME']);
		$list1['START_DATE'] = $start_date.'T'.$heure.$minute.$seconde;
		$list1['REP_ACTIVE'] = (isset($post_params['REP_ACTIVE']) && $post_params['REP_ACTIVE']) ? '1' : '0';
		
		if ($post_params['DO_EMAIL'] == '1') {
			$list2['DO_EMAIL'] = '1';
		} else {
			$list2['DO_EMAIL'] = '0';
		}

		$rrule_evr = isset($post_params[$rep_policy.'_RRULE_EVR']) ? $post_params[$rep_policy.'_RRULE_EVR'] : '1';

		$list1['RRULE'] = '';
		switch ($rep_policy) {
		case 'D':
			$list1['RRULE'] .= 'D'.$rrule_evr;
			break ;
		case 'W':
			$list1['RRULE'] .= 'W'.$rrule_evr;
			$days = array('MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU');
			foreach ($days as $day)
				if (isset($post_params[$rep_policy.'_RRULE_JRS'.$day]))
					$list1['RRULE'] .= ' '.$day;
			break ;
		case 'M':
			switch($post_params['M_RRULE_M_MORE']) {
			default:
			case '0':
				$list1['RRULE'] .= 'MD'.$rrule_evr.' '.$post_params['M_RRULE_M_FSTR'];
				break;
			case '1':
				$list1['RRULE'] .= 'MD'.$rrule_evr.' -'.$post_params['M_RRULE_M_FEND'];
				break;
			case '2':
				$list1['RRULE'] .= 'MP'.$rrule_evr.' '.$post_params['M_RRULE_M_NUMWEEK'].' '.$post_params['M_RRULE_M_JRSWEEK'];
				break;
			}
			break ;
		}

		switch ($post_params[$rep_policy.'_LAST_MORE']) {
		default:
		case '':
		case 2:
			$list1['RRULE'] .= ' *0';
			break ;
		case 1:
			$list1['RRULE'] .= ' *'.$post_params[$rep_policy.'_LAST_NBREP'];
			break ;
		case 0:
			list($year, $mouth, $day) = split('[-]', $post_params[$rep_policy.'_LAST_DATE']);
				$list1['RRULE'] .= ' '.$year.$mouth.$day.'T000000';
				break ;
		}

		$schid = false;
		$list1['NAME'] = $post_params['NAME'];
		$list1['OWNER'] = $post_params['OWNER'];
		$list1['COMMENT'] = $post_params['COMMENT'];
		if (isset($post_params[$rep_policy.'_REP_SCH_RETENTION']) && 
		    $post_params[$rep_policy.'_REP_SCH_RETENTION'] == 'on') {
			$list2['RET_TIME'] = $post_params[$rep_policy.'_RET_TIME'];
			$list2['RET_TIME_UNIT'] = $post_params[$rep_policy.'_RET_TIME_UNIT'];
		}
		if ($list1['REP_ACTIVE'] == '1') {
			$list1['DO_SCHED_NEXT'] = "1";
		}
		else {
			$list1['DO_SCHED_NEXT'] = "0";
		}

		$list2['VTLID'] = $post_params['VTLID'];
		$list2['DCID'] = $post_params['DCID'];

		if ($post_params['REPLICATE_WHOLE_VTL'] != 1) {
		    $spkidlist = split(',', $post_params['spkidlist']);
		    $i = 0;
		    foreach ($spkidlist as $spkid) {
		      if ($spkid != '')
			$list2['item'.$i++] = array('SPKID' => $spkid);
		    }
		}

		$data = $model->CreateSchRep($list1, $list2, $this->view->context);

 		$res = $this->_get_result($data, $this->view->context);

		foreach ($res as $appid => $data) {
			foreach ($data['STATUS'] as $status) {
				if ($status) {
					$res[$appid]['FORCE_ALERT'] = 1;
					$result = Zend_Json::encode($res);

					$this->getResponse()->appendBody($result);
					return;
				}
			}
		}
		$result = Zend_Json::encode($res);

		$this->getResponse()->appendBody($result);
		return;
	}

	public function putPost(&$data, $search, $dest = '')
	{
		if (empty($dest)) $dest = $search;
		if (isset($_POST[$dest]))
			$data->$search = $_POST[$dest];
	}

	public function jsonSchModifyAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$array_context = $this->view->context;
		list($id, $context) = $this->_getIdContext($array_context, "SCHID");

		$result = $model->schreplistone($id);
		$res = $this->_get_result($result, $context);

		if ($this->view->appid != "") {
			$list1 = $res[$this->view->appid]['PARAM2'][0];
		}
		else {
			$list1 = $res['local']['PARAM2'][0];
		}

        $list2 = new stdclass;

		if (isset($_POST['DCID_selected'])) {
			if (empty($_POST['DCID'])) {
				$res = $this->_set_error_message($this->lang['replication_sch_wizard_error_value_require_DC']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return;
			}
			$this->putPost($list2, 'DCID', 'DCID_selected');
		}
		else {
			$list2->DCID = $list1->DCID;
		}

		if (isset($_POST['schedulerform3_inputs'])) {

			if (empty($_POST['VTLID'])) {
				$res = $this->_set_error_message($this->lang['replication_sch_wizard_error_value_require_VTL']);
				$result = Zend_Json::encode($res);
				$this->getResponse()->appendBody($result);
				return;
			}
			$this->putPost($list2, 'VTLID', 'VTLID_selected');

            if(!isset($_POST['REPLICATE_WHOLE_VTL'])) {
                $spkidlist = split(',', $_POST['spkidlist']);
                $i = 0;
                foreach ($spkidlist as $spkid) {
                    if ($spkid != '') {
                        $list2->{'item'.$i++} = array('SPKID' => $spkid);
                    }
                }
            }

            unset($list1->item);

		} else {

            $list2->VTLID = $list1->VTLID;

            if(isset($list1->item)) {
                if(!is_array($list1->item)) {
                    $list1->item = array($list1->item);
                }
                foreach($list1->item as $key=>$val) {
                    $list2->{'item'.$key} = array('SPKID' => $val->SPKID);
                }
                unset($list1->item);
            }

        }

		if (isset($_POST['REP_SCH_RETENTION']) && 
		    $_POST['REP_SCH_RETENTION'] == 'on' &&
		    ($_POST['RET_TIME'] == '' || 
		     $_POST['RET_TIME_UNIT'] == '')) {
			$res = $this->_set_error_message($this->lang['replication_error_value_require_RET_TIME']);
			$result = Zend_Json::encode($res);
			$this->getResponse()->appendBody($result);
			return;
		}

		if (isset($_POST['OWNER'])) {
			$this->putPost($list1, 'OWNER', 'OWNER_selected');
		}
		
		if (isset($_POST['schedulerform3_inputs'])) {
            $list1->REP_ACTIVE = (isset($_POST['REP_ACTIVE']))?'1':'0';
		}

        $list1->DO_SCHED_NEXT = $list1->REP_ACTIVE;

		if (isset($_POST['schedulerform3_inputs'])) {
            unset($list1->DO_EMAIL);
			$list2->DO_EMAIL = (isset($_POST['DO_EMAIL']))?'1':'0';
		} else {
            if(isset($list1->DO_EMAIL)) {
                $list2->DO_EMAIL = $list1->DO_EMAIL;
                unset($list1->DO_EMAIL);
            }
        }

		$this->putPost($list1, 'SCHID');

		$this->putPost($list1, 'RRULE_PER');
		$this->putPost($list1, 'RRULE_EVR');
		$this->putPost($list1, 'RRULE_JRSMO');
		$this->putPost($list1, 'RRULE_JRSTU');
		$this->putPost($list1, 'RRULE_JRSWE');
		$this->putPost($list1, 'RRULE_JRSTH');
		$this->putPost($list1, 'RRULE_JRSFR');
		$this->putPost($list1, 'RRULE_JRSSA');
		$this->putPost($list1, 'RRULE_JRSSU');
		$this->putPost($list1, 'RRULE_M_MORE');
		$this->putPost($list1, 'RRULE_M_FSTR');
		$this->putPost($list1, 'RRULE_M_FEND');
		$this->putPost($list1, 'RRULE_Y_MORE');
		$this->putPost($list1, 'RRULE_Y_FSTR');
		$this->putPost($list1, 'RRULE_Y_FEND');
		$this->putPost($list1, 'LAST_MORE');
		$this->putPost($list1, 'LAST_DATE');
		$this->putPost($list1, 'LAST_NBREP');
		$this->putPost($list1, 'FORM_DATE');
		$this->putPost($list1, 'FORM_TIME');

		$this->putPost($list1, 'RRULE_M_NUMWEEK', 'RRULE_M_NUMWEEK_selected');
		$this->putPost($list1, 'RRULE_M_JRSWEEK', 'RRULE_M_JRSWEEK_selected');
		$this->putPost($list1, 'RRULE_Y_NUMMONTH', 'RRULE_Y_NUMMONTH_selected');
		$this->putPost($list1, 'RRULE_Y_NUMDAY', 'RRULE_Y_NUMDAY_selected');

        if(isset($_POST['schedulerform3_inputs'])) {
            if (isset($_POST['REP_SCH_RETENTION'])) {
                $this->putPost($list2, 'RET_TIME');
                $this->putPost($list2, 'RET_TIME_UNIT', 'RET_TIME_UNIT_selected');
            }
            unset($list1->RET_TIME);
            unset($list1->RET_TIME_UNIT);
		} else {
            if(isset($list1->RET_TIME) && isset($list1->RET_TIME_UNIT)) {
                $list2->RET_TIME = $list1->RET_TIME;
                $list2->RET_TIME_UNIT = $list1->RET_TIME_UNIT;
            }
			unset($list1->RET_TIME);
			unset($list1->RET_TIME_UNIT);
		}

        if(isset($_POST['COMMENT'])) {
            $this->putPost($list1, 'COMMENT');
        }

        if(isset($_POST['TEXCEPTION'])) {
            $this->putPost($list1, 'TEXCEPTION');
        } else {
            $_POST['TEXCEPTION'] = $list1->TEXCEPTION; //this is needed because implodeSchInfo reworks the data in $_POST
        }

		$list1 = $model->implodeSchInfo($list1);

		$data = $model->modifySchRep($list1, $list2, $context);
		$res = $this->_get_result($data, $context);
		$result = Zend_Json::encode($res);
		$this->getResponse()->appendBody($result);
		return ;
	}

	/** LISTING STUFF **/

	public function connectionlistingAction()
	{
		$this->displayFromScreenIni('connectionlisting');
	}

	public function connectionlistingHelpAction()
	{
		echo $this->view->render('replication/connectionlisting_help.html');
	}

	public function accountlistingAction()
	{
		$ctrlcfg = $this->_getCtrlCfg();
		$model = $this->_getModel($ctrlcfg);

		$data = $model->isInstalled();

		if ($data->param0 == "0" && $data->param2 == "-1") {
			$this->displayFromScreenIni('accountlisting');
		}
		else {
			$this->displayFromScreenIni('datacenter');
		}
	}

	public function accountlistingHelpAction()
	{
		echo $this->view->render('replication/accountlisting_help.html');
	}

	public function jsonGetResultAllAccountAction() {

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $context = $this->view->context;

        $data = $model->getResultAllAccount($context);

        if(!is_array($data)) $res = array($data);
        $res = $this->_get_result($data, $context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;

    }

	public function jsonGetResultAllConnectionAction() {

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $context = $this->view->context;

        $data = $model->getResultAllConnection($context);

        if(!is_array($data)) $res = array($data);
        $res = $this->_get_result($data, $context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;

    }

    private function _parseReplist($res, $context) {

        $langid = ($_COOKIE['lang'])?$_COOKIE['lang']:'en';
        $dateformat = ($langid == 'en')?'Y/m/d H:i':'d/m/Y H:i';

        $tmp = array();
        $firstmatch = '';

        //merging lists
        foreach((array)$res as $key=>$val) {

            if(preg_match('`^param`', $key) && isset($val->VTLID)) {

                array_push($tmp, $val);

                if(empty($firstmatch)) {

                    $firstmatch = $key;

                } else {

                    unset($res->{$key});

                }

            }

        }

        if(!empty($firstmatch) && isset($res->{$firstmatch})) {

            $res->{$firstmatch} = $tmp;

        } else {

            return $res;

        }

        //searching for max size in struct and fixing broken properties
        $maxsize = 0;

        foreach($res->{$firstmatch} as $key=>$val) {

            if(!isset($res->{$firstmatch}[$key]->CAPACITY)) {

                $val->CAPACITY = $res->{$firstmatch}[$key]->CAPACITY = 0;

            }

            if(!isset($res->{$firstmatch}[$key]->SIZE)) {

                $val->SIZE = $res->{$firstmatch}[$key]->SIZE = 0;

            }

            if(!isset($res->{$firstmatch}[$key]->SIZE_REP)) {

                $val->SIZE_REP = $res->{$firstmatch}[$key]->SIZE_REP = 0;

            }

            if(!isset($res->{$firstmatch}[$key]->SIZE_REC)) {

                $val->SIZE_REC = $res->{$firstmatch}[$key]->SIZE_REC = 0;

            }

            if($val->CAPACITY > $maxsize) {

                $maxsize = $val->CAPACITY;

            }

            if($val->SIZE_REP > $maxsize) {

                $maxsize = $val->SIZE_REP;

            }

            if($val->SIZE_REC > $maxsize) {

                $maxsize = $val->SIZE_REC;

            }

            if(isset($val->item)) {

                if(is_object($val->item)) {

                    if(!isset($res->{$firstmatch}[$key]->item->SIZE)) {

                        $res->{$firstmatch}[$key]->item->SIZE = 0;

                    }

                    if(!isset($res->{$firstmatch}[$key]->item->SIZE_REP)) {

                        $res->{$firstmatch}[$key]->item->SIZE_REP = 0;

                    }

                    if(isset($val->item->NAME) && $val->item->NAME == '.ARK_VTL.lst') {

                        $res->{$firstmatch}[$key]->SIZE -= $val->item->SIZE;
                        $res->{$firstmatch}[$key]->SIZE_REP -= $val->item->SIZE_REP;

                    }

                } else {

                    foreach($res->{$firstmatch}[$key]->item as $subkey=>$subval) {

                        if(!isset($res->{$firstmatch}[$key]->item[$subkey]->SIZE)) {

                           $res->{$firstmatch}[$key]->item[$subkey]->SIZE = 0;

                        }

                        if(!isset($res->{$firstmatch}[$key]->item[$subkey]->SIZE_REP)) {

                            $res->{$firstmatch}[$key]->item[$subkey]->SIZE_REP = 0;

                        }

                        if(isset($subval->item->NAME) && $subval->item->NAME == '.ARK_VTL.lst') {

                            $res->{$firstmatch}[$key]->SIZE -= $subval->SIZE;
                            $res->{$firstmatch}[$key]->SIZE_REP -= $subval->SIZE_REP;

                        }

                    }

                }

            }

        }

        //making size percents
        foreach($res->{$firstmatch} as $key=>$val) {

            if($res->{$firstmatch}[$key]->CAPACITY > 0) {
                $res->{$firstmatch}[$key]->CAPACITY_P = ($res->{$firstmatch}[$key]->CAPACITY * 100) / $maxsize;
            } else {
                $res->{$firstmatch}[$key]->CAPACITY_P = 0;
            }

            if($res->{$firstmatch}[$key]->SIZE > 0) {
                $res->{$firstmatch}[$key]->SIZE_P = ($res->{$firstmatch}[$key]->SIZE * 100) / $maxsize;
            } else {
                $res->{$firstmatch}[$key]->SIZE_P = 0;
            }

            if($res->{$firstmatch}[$key]->SIZE_REP > 0) {
                $res->{$firstmatch}[$key]->SIZE_REP_P = ($res->{$firstmatch}[$key]->SIZE_REP * 100) / $maxsize;
            } else {
                $res->{$firstmatch}[$key]->SIZE_REP_P = 0;
            }

            if($res->{$firstmatch}[$key]->SIZE_REC > 0) {
                $res->{$firstmatch}[$key]->SIZE_REC_P = ($res->{$firstmatch}[$key]->SIZE_REC * 100) / $maxsize;
            } else {
                $res->{$firstmatch}[$key]->SIZE_REC_P = 0;
            }

            if(isset($val->item)) {

                if(is_object($val->item)) {

                    if(isset($val->item->BKSID)) {

                        if($res->{$firstmatch}[$key]->item->SIZE > 0) {
                            $res->{$firstmatch}[$key]->item->SIZE_P = ($res->{$firstmatch}[$key]->item->SIZE * 100) / $maxsize;
                        } else {
                            $res->{$firstmatch}[$key]->item->SIZE_P = 0;
                        }

                        if($res->{$firstmatch}[$key]->item->SIZE_REP > 0) {
                            $res->{$firstmatch}[$key]->item->SIZE_REP_P = ($res->{$firstmatch}[$key]->item->SIZE_REP * 100) / $maxsize;
                        } else {
                            $res->{$firstmatch}[$key]->item->SIZE_REP_P = 0;
                        }

                        //creating name
                        if(isset($res->{$firstmatch}[$key]->item->BACKUP_SK_NAME)) {

                            $res->{$firstmatch}[$key]->item->BACKUP_NAME = $this->lang['replication_listing_replication_backup']. ': ' . $res->{$firstmatch}[$key]->item->BACKUP_SK_NAME . ' (' . date($dateformat, $res->{$firstmatch}[$key]->item->BACKUP_DATE) . ')';

                        } else {

                            if(isset($res->{$firstmatch}[$key]->item->BACKUP_DATE)) {

                                $res->{$firstmatch}[$key]->item->BACKUP_NAME = $this->lang['replication_listing_replication_backup_unknown'] . ' (' . date($dateformat, $res->{$firstmatch}[$key]->item->BACKUP_DATE) . ')';

                            } else {

                                $res->{$firstmatch}[$key]->item->BACKUP_NAME = $this->lang['replication_listing_replication_backup_unknown'];

                            }

                        }

                    }

                } else {

                    foreach($res->{$firstmatch}[$key]->item as $subkey=>$subval) {

                        if(isset($subval->BKSID)) {

                            if($res->{$firstmatch}[$key]->item[$subkey]->SIZE > 0) {
                                $res->{$firstmatch}[$key]->item[$subkey]->SIZE_P = ($res->{$firstmatch}[$key]->item[$subkey]->SIZE * 100) / $maxsize;
                            } else {
                                $res->{$firstmatch}[$key]->item[$subkey]->SIZE_P = 0;
                            }

                            if($res->{$firstmatch}[$key]->item[$subkey]->SIZE_REP > 0) {
                                $res->{$firstmatch}[$key]->item[$subkey]->SIZE_REP_P = ($res->{$firstmatch}[$key]->item[$subkey]->SIZE_REP * 100) / $maxsize;
                            } else {
                                $res->{$firstmatch}[$key]->item[$subkey]->SIZE_REP_P = 0;
                            }

                            //creating name
                            if(isset($res->{$firstmatch}[$key]->item[$subkey]->BACKUP_SK_NAME)) {

                                $res->{$firstmatch}[$key]->item[$subkey]->BACKUP_NAME = $this->lang['replication_listing_replication_backup'] . ': ' . $res->{$firstmatch}[$key]->item[$subkey]->BACKUP_SK_NAME . ' (' . date($dateformat, $res->{$firstmatch}[$key]->item[$subkey]->BACKUP_DATE) . ')';

                            } else {

                                if(isset($res->{$firstmatch}[$key]->item[$subkey]->BACKUP_DATE)) {

                                    $res->{$firstmatch}[$key]->item[$subkey]->BACKUP_NAME = $this->lang['replication_listing_replication_backup_unknown'] . ' (' . date($dateformat, $res->{$firstmatch}[$key]->item[$subkey]->BACKUP_DATE) . ')';

                                } else {

                                    $res->{$firstmatch}[$key]->item[$subkey]->BACKUP_NAME = $this->lang['replication_listing_replication_backup_unknown'];

                                }

                            }

                        }

                    }

                }

            }

        }

        return $res;

    }

    public function jsonGetNextResultAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $res = $this->_getNext($context);

        if(is_object($res)) {
        
            if(($res->param0 == 12 && ($res->param1 == 2 || $res->param1 == 3)) || ($res->param0 != 12 && $res->last == 0)) {
                //getNext
            } else {

                $res = $this->_parseReplist($res, $context);

            }

        } else {

            if(isset($res['list0'])) {

                foreach($res as $key=>$list) {

                    if(isset($list->param2)) {

                        $res[$key] = $this->_parseReplist($res[$key], $context);

                    }

                }

            }

        }

        $res = $this->_get_result($res, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

	public function jsonGetResultOneAccountAction() {

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $context = $this->view->context;

        $res = $model->getResultOneAccount($_GET['MODULE_ID'], $context);

        if(is_object($res)) {
        
            if(($res->param0 == 12 && ($res->param1 == 2 || $res->param1 == 3)) || ($res->param0 != 12 && $res->last == 0)) {
                //getNext
            } else {

                $res = $this->_parseReplist($res, $context);

            }

        } else {

            if(isset($res['list0'])) {

                foreach($res as $key=>$list) {

                    if(isset($list->param2)) {

                        $res[$key] = $this->_parseReplist($res[$key], $context);

                    }

                }

            }

        }

        $res = $this->_get_result($res, $context);
        $result = Zend_Json::encode($res);

        $this->getResponse()->appendBody($result);
        return;

    }

	public function jsonGetResultOneConnectionAction() {

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $context = $this->view->context;

        $res = $model->getResultOneConnection($_GET['DCID'], $context);

        if(is_object($res)) {

            if(($res->param0 == 12 && ($res->param1 == 2 || $res->param1 == 3)) || ($res->param0 != 12 && $res->last == 0)) {
                //getNext
            } else {

                $res = $this->_parseReplist($res, $context);

            }

        } else {

            if(isset($res['list0'])) {

                foreach($res as $key=>$list) {

                    if(isset($list->param2)) {

                        $res[$key] = $this->_parseReplist($res[$key], $context);

                    }

                }

            }

        }

        $res = $this->_get_result($res, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;

    }

    public function jsonLaunchReplicationAction() {

        if(isset($_GET['DCID']) && isset($_GET['VTLID'])) {

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = $ctrlcfg->id;

            $context = $this->view->context;

            $params = array();

            $params['DCID'] = $_GET['DCID'];
            $params['VTLID'] = $_GET['VTLID'];

	    if (isset($_GET['RET_TIME']) &&
		isset($_GET['RET_TIME_UNIT'])) {
		    $params['RET_TIME'] = $_GET['RET_TIME'];
		    $params['RET_TIME_UNIT'] = $_GET['RET_TIME_UNIT'];
	    }

            if(isset($_GET['DO_EMAIL'])) {

                $params['DO_EMAIL'] = 1;

            }

            if(isset($_GET['BKSID'])) {

                $params['ITEM'] = array('BKSID'=>$_GET['BKSID']);

            }

            $res = $model->startReplication($params, $context);

            $res = $this->_get_result($res, $context);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);

        }

        return;

    }

    public function jsonLaunchRecoverAction() {

        if(isset($_GET['DCID']) && isset($_GET['VTLID'])) {

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = $ctrlcfg->id;

            $context = $this->view->context;

            $params = array();

            $params['DCID'] = $_GET['DCID'];
            $params['VTLID'] = $_GET['VTLID'];

            if(isset($_GET['DO_EMAIL'])) {

                $params['DO_EMAIL'] = 1;

            }

            if(isset($_GET['BKSID'])) {

                $params['ITEM'] = array('BKSID'=>$_GET['BKSID']);

            }

            $res = $model->startRecover($params, $context);

            $res = $this->_get_result($res, $context);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);

        }

        return;

    }

    public function jsonLaunchIntegrationAction() {

        if(isset($_GET['VTLID'])) {

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = $ctrlcfg->id;

            $context = $this->view->context;

            $params = array();

            if(isset($_GET['IS_REINDEXED']) || isset($_GET['CT'])) {

                $params['SRC_VTLID'] = $_GET['VTLID'];

                if(isset($_GET['DO_EMAIL'])) {

                    $params['DO_EMAIL'] = 1;

                }

            } else {

                $params['VTLID'] = $_GET['VTLID'];
                $params['VTLNAME'] = $_GET['VTLNAME'];

                if(isset($_GET['MODULE_ID'])) {

                    $params['MODULE_ID'] = $_GET['MODULE_ID'];

                }

                if(isset($_GET['SRC_VTL_NAME'])) {

                    $params['SRC_VTL_NAME'] = $_GET['SRC_VTL_NAME'];

                }

                $params['SRC_VTL_CAPACITY'] = 20;

                if(isset($_GET['DO_EMAIL'])) {

                    $params['DO_EMAIL'] = 1;

                }

            }

            $res = $model->startIntegration($params, $context);

            $res = $this->_get_result($res, $context);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);

        }

        return;

    }

    public function jsonLaunchRemoveAction() {

        if(isset($_GET['VTLID'])) {

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = $ctrlcfg->id;

            $context = $this->view->context;

            $params = array();

            $params['VTLID'] = $_GET['VTLID'];

            if(isset($_GET['MODULE_ID'])) {

                $params['MODULE_ID'] = $_GET['MODULE_ID'];

            }

            if(isset($_GET['BKSID'])) {

                $params['BKSID'] = $_GET['BKSID'];

            }

            $res = $model->startRemove($params, $context);

            $res = $this->_get_result($res, $context);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);

        }

        return;

    }

    public function jsonLaunchVtlCreationAction() {

        if  (
                isset($_GET['REMOTE_REPNAME']) &&
                isset($_GET['NAME']) &&
                isset($_GET['CAPACITY']) &&
                    (
                        (
                            isset($_GET['SHARED']) &&
                            isset($_GET['REMOTE_REPVTLID']) &&
                            isset($_GET['DCID'])
                        ) || (
                            !isset($_GET['SHARED']) &&
                            isset($_GET['VTLID'])
                        )
                    ) &&
                isset($_GET['MEDIA_SERVER']) &&
                isset($_GET['PATH'])

            ) {

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = $ctrlcfg->id;

            $context = $this->view->context;

            $params = array();

            $params['REMOTE_REPNAME'] = $_GET['REMOTE_REPNAME'];
            $params['NAME'] = $_GET['NAME'];
            $params['CAPACITY'] = $_GET['CAPACITY'];

            if(isset($_GET['SHARED'])) {

                $params['SHARED'] = 1;
                $params['REMOTE_REPVTLID'] = $_GET['REMOTE_REPVTLID'];
                $params['DCID'] = $_GET['DCID'];

            } else {

                $params['VTLID'] = $_GET['VTLID'];

            }

            $params['MEDIA_SERVER'] = $_GET['MEDIA_SERVER'];

            $params['PATH'] = $_GET['PATH'];

            $res = $model->startVtlCreate($params, $context);

            $res = $this->_get_result($res, $context);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);

        }

        return;

    }

    public function jsonStatAction() {

        if(isset($_GET['ID']) && isset($_GET['PORT'])) {

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = "ID_PORT";

            require_once 'Zend/Json.php';

            $ctrlcfg = $this->_getCtrlCfg();
            $model = $this->_getModel($ctrlcfg);
            $idname = $ctrlcfg->id;

            $context = $this->view->context;

            $params = array();

            $params['ID'] = $_GET['ID'];
            $params['PORT'] = $_GET['PORT'];

            $res = $model->getStat($params, $context);

            if(isset($res->param1) && preg_match('`^\d{4}/\d{2}/\d{2}\s\d{2}:\d{2}:\d{2}\s\w{1}\d{8}\s.*$`', $res->param1)) {

                $res->param1 = preg_replace('`^(\d{4}/\d{2}/\d{2}\s\d{2}:\d{2}:\d{2}\s)(\w{1})(\d{8}\s.*)$`', '\\1H\\3', $res->param1);

            }

            if ($res == null) {
                error_log("get Stat is null");
                return null;
            }

            $res = $this->_get_result($res, $context);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);
            return;
        }

    }

    public function jsonShowReplicationAction()
    {
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';

	//error_log("jsonShowBackupAction POST: ".Zend_Json::encode($this->_request->getPost()));
    
        if (!$params['PARAM2']) {
            $array_context = $this->view->context;
            list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
            if ($id) {
                list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
            }
	    //error_log("jsonShowBackupAction context: ".Zend_Json::encode($context));
	    if ($context)
	      list($params[APPLIANCE_GUID]) = $context[0]->APPLIANCE_GUID;
        }

        $this->view->showBackup = $params;

	$options = false;
	$screen = 'showreplication';
	if (isset($params['TYPE'])) {
	    if ($params['TYPE'] == 'RST') {
	        $options = array('controller' => 'restoration');
		$screen = 'showrestoration';
	    } else if ($params['TYPE'] == 'D2T') {
	        $options = array('controller' => 'd2d2t');
		$screen = 'showd2d2t';
	    }
	}
        $res = $this->displayFromScreenIni($screen, FALSE, $options);
        $this->_render_json_view($res);
        return;
    }

    public function showreplicationHelpAction()
    {
        echo $this->view->render('showreplication/help.html');
    }

}

?>
