<?php

require_once 'ArkeiaAction.php';

class SavepackController extends ArkeiaAction
{
    public function summaryAction()
	{
	    if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
		} else {
            $this->displayFromScreenIni('summary');
		}
    }

  public function updatetreeAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('updatetree', FALSE);
        $this->_render_json_view($res);
        return;
    }

  public function managetreeAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('managetree', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function managetreeHelpAction()
    {
        echo $this->view->render('managetree/help.html');
    }

  public function updateonetreeAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('updateonetree', FALSE);
        $this->_render_json_view($res);
        return;
    }

  public function addonetreeAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('addonetree', FALSE);
        $this->_render_json_view($res);
        return;
    }

  public function jsonCreateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);

      $params = $this->_request->getPost();
	  
	  $params['MEDIASERVER'] = $params['MEDIA_SERVER'];
	  
      $params = $this->_clean_select_POST($params);
      $params = $this->_clean_POST($params);

	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);

        if($params['MEDIA_SERVER'] == '') {
            unset($params['MEDIA_SERVER']);
        }

      if ($params['NAME'] == '') {
          $res = $this->_set_error_message($this->lang['spk_create_error_name_require']);
      } else {
          $context = $this->view->context;
          $data = $model->createObject($params, $context);
          $res = $this->_get_result($data, $context);
      }

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonAddTreeAction()
    {
      require_once 'Zend/Json.php';
      
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $params = $this->_request->getPost();
	  	  
      $info_spk = $this->_getOne();
      $info_spk = Zend_Json::decode(Zend_Json::encode($info_spk), Zend_Json::TYPE_ARRAY); 

      if ($params['FULLNAME'] == '') {
        $res = $this->_set_error_message($this->lang['spk_create_tree_error_fullname_require']);
      } else {
	$i = 0;
	if (isset($info_spk['item'])) {
	  $info = $info_spk['item'];
	  for ($i = 0; isset($info[$i]); $i++)
	    $info_spk["item".$i] = array('FULLNAME' => $this->navpath_base64_decode($info[$i]['FULLNAME']));
	  if ($i == 0)
	    $info_spk["item".$i++] = $info_spk['item'];
	  unset($info_spk['item']);
	}
	$info_spk["item".$i] = array('FULLNAME' => $params['FULLNAME']);

	$data = $model->modifyObject($info_spk, $context);

	$res = $this->_get_result($data, $context);
      }

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonUpdateTreeAction()
    {
      require_once 'Zend/Json.php';
      //error_log('jsonUpdateTreeAction');
      
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $info_spk = $this->_getOne();
      $params = $this->_request->getPost();
      $params = $this->_clean_POST($params);

      $info_spk = Zend_Json::decode(Zend_Json::encode($info_spk), Zend_Json::TYPE_ARRAY); 

      unset($info_spk["item"]);
      for ($i = 0; isset($info_spk["item".$i]); $i++)
	unset($info_spk["item".$i]);
      $listtree = Zend_Json::decode($params['listtrees'], Zend_Json::TYPE_ARRAY);
      //error_log('listtree:'.$params['listtrees']);

      for ($i = 0; isset($listtree[$i]); $i++){
        unset($listtree[$i]['FULLPATH']);
        $listtree[$i]['FULLNAME'] = $this->navpath_base64_decode($listtree[$i]['FULLNAME']);
        $info_spk["item".$i] = $listtree[$i];
    }

      $data = $model->modifyObject($info_spk, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonRemoveTreeObjectAction()
    {
      $this->jsonModifyObjectAction('DEL_ONE_TREE');
    }

  public function jsonAddTreeObjectAction()
    {
      $params = $this->_request->getPost();
      //DEBUG error_log('jsonAddTreeObjectAction: '.Zend_Json::encode($params));
      if ($params['TYPE'] == 'SAVEPACK') {
	if (!isset($params['SKID_INC']) || $params['SKID_INC'] == '') {
	  $res = $this->_set_error_message($this->lang['spk_create_tree_error_include_savepack_require']);
	  $result = Zend_Json::encode($res);
	  $this->getResponse()->appendBody($result);
	  return;
	}
      } else {
	if ($params['FULLNAME'] == '') {
	  $res = $this->_set_error_message($this->lang['spk_create_tree_error_fullname_require']);
	  $result = Zend_Json::encode($res);
	  $this->getResponse()->appendBody($result);
	  return;
	} else {
        //filter simple case: string cannot begin with :, / or ! and respect the mask "(something that isn't :,/ or !)[!][(something that isn't :,/ or !)]"
        $exp1 = '^[^:/!][^:/!]*!?[^:/!]*$';
        //filter more complex case: string cannot begin with :, / or ! and respects the mask "(something that isn't :,/ or !)[!][(something that isn't :,/ or !)]:[(something that isn't / or !)][/][(something that isn't : or !)]"
        $exp2 = '^[^:/!][^:/!]*!?[^:/!]*:[^/!]*/?[^:!]*$';
        if  (
                !(
                    preg_match('`'.$exp1.'`', $params['FULLNAME']) ||
                    preg_match('`'.$exp2.'`', $params['FULLNAME'])
                )
            ) {
          $res = $this->_set_error_message($this->lang['spk_create_tree_error_syntax_fullname_require']);
          $result = Zend_Json::encode($res);
          $this->getResponse()->appendBody($result);
          return;
        }
    }
      }

      $this->jsonModifyObjectAction('ADD_ONE_TREE');
    }

  public function jsonModifyObjectAction($modify_type = FALSE)
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $info_spk = $this->_getOne();

      require_once 'Zend/Json.php';
      $info_spk = Zend_Json::decode(Zend_Json::encode($info_spk), Zend_Json::TYPE_ARRAY); 

      $val_select = array('s_cryp', 's_cpres', 's_allowedfs', 'u_posixacl', 'u_xattr', 'u_ratim', 'FOLLOWFS', 's_folln', 'MEDIA_SERVER', 'TYPE', 'MAX_RETRY');
      
      $params = $this->_request->getPost();
	  
      $params['MEDIASERVER'] = $params['MEDIA_SERVER'];
	  
      foreach ($val_select as $val)
	{
	  if (isset($params[$val.'_selected']))
	    {
	      $params[$val] = $params[$val.'_selected'];
	      unset($params[$val.'_selected']);
	    }
	}

      $params = $this->_clean_POST($params);

      $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
      unset ($params['MEDIASERVER']);

        if($params['MEDIA_SERVER'] == '') {
            unset($params['MEDIA_SERVER']);
        }

      if (isset($params['MODIFY_TYPE']))
	$type = $params['MODIFY_TYPE'];
      else if ($modify_type)
	$type = $modify_type;
      else $type = '';

      switch ($type)
	{
	case 'ADD_ONE_TREE':
	case 'DEL_ONE_TREE':
	case 'MODIFY_ONE_TREE':
	  {
	    unset($params["APPID_SKID"]);
	    unset($params["SKID"]);
	    if (($type == 'MODIFY_ONE_TREE' || $type == 'ADD_ONE_TREE') && $params["TYPE"] == 'SAVEPACK') {
	      $params['FULLNAME'] = $params['SKID_INC'];
	      $params['SKID'] = $params['SKID_INC_selected'];
	    } else {
	      unset($params["SKID_INC"]);
	    }
	    unset($params['SKID_INC_selected']);

	    foreach ($val_select as $val) {
	      if (isset($params[$val]) && $params[$val] == 'SPKOPT')
		unset($params[$val]);
	    }

	    if (isset($info_spk['item']['FULLNAME']))
	      $info = array($info_spk['item']);
	    else
	      $info = $info_spk['item'];
 
            if ($type == 'MODIFY_ONE_TREE') 
	      {
		for ($i = 0; isset($info[$i]); $i++) {
		  if ($info[$i]['FULLNAME'] == $params['FULLNAME']) {
		    $info[$i] = $params;
            }
            }
	      }
	    else if ($type == 'ADD_ONE_TREE')
	      {
		
		$info[] = $params;
	      }
	    else if ($type == 'DEL_ONE_TREE')
	      {
		for ($i = 0; isset($info[$i]); $i++) {
		  if ($info[$i]['FULLNAME'] == $params['FULLNAME'])
		    {
		      array_splice($info, $i, 1);
		      break ;
		    }
		}
	      }
	    for ($i = 0; isset($info[$i]); $i++) {
            if  (
                    isset($info[$i]['FULLNAME']) && 
                    isset($info[$i]['FULLPATH']) && 
                    (
                        (isset($info[$i]['MODIFY_TYPE']) && $info[$i]['MODIFY_TYPE'] != 'ADD_ONE_TREE') || 
                        !isset($info[$i]['MODIFY_TYPE'])
                    )
                ) {
                unset($info[$i]['FULLPATH']);
                $info[$i]['FULLNAME'] = $this->navpath_base64_decode($info[$i]['FULLNAME']);
            }
	      $info_spk["item".$i] = $info[$i];
        }
	    unset($info_spk["item"]);
	    $params = $info_spk;
	    break ;
	  }
	default :
	  {
	    $i = 0;
	    if (isset($info_spk['item'])) {
	      $info = $info_spk['item'];
        for ($i = 0; isset($info[$i]); $i++) {
            if(isset($info[$i]['FULLNAME']) && isset($info[$i]['FULLPATH'])) {
                unset($info[$i]['FULLPATH']);
                $info[$i]['FULLNAME'] = $this->navpath_base64_decode($info[$i]['FULLNAME']);
            }
            $params["item".$i] = $info[$i];
        }
	      if ($i == 0) {
            if(isset($info_spk['item']['FULLNAME']) && isset($info_spk['item']['FULLPATH'])) {
                unset($info_spk['item']['FULLPATH']);
                $info_spk['item']['FULLNAME'] = $this->navpath_base64_decode($info_spk['item']['FULLNAME']);
            }
		$params["item".$i++] = $info_spk['item'];
        }
	    }
	    break ;
	  }
	}

      //DEBUG error_log('jsonModifyObjectAction: params:'.Zend_Json::encode($params));

      $data = $model->modifyObject($params, $context);

      $res = $this->_get_result($data, $context);
      //DEBUG error_log('jsonModifyObjectAction: data:'.Zend_Json::encode($data));

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

    public function jsonGetResultOneAction() {

        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultOne($context);
        $res = $this->_get_result($data, $context);

        foreach($res as $key=>$val) {

            if(isset($res[$key]['PARAM3']) && isset($res[$key]['PARAM3'][0]) && is_object($res[$key]['PARAM3'][0]) && isset($res[$key]['PARAM3'][0]->item)) {

                if(!is_array($res[$key]['PARAM3'][0]->item)) {

                    $tmp = $this->navpathlist_fix(array($res[$key]['PARAM3'][0]->item));
                    $res[$key]['PARAM3'][0]->item = $tmp[0];

                } else {

                    $res[$key]['PARAM3'][0]->item = $this->navpathlist_fix($res[$key]['PARAM3'][0]->item);

                }

            } else {

                if(isset($res[$key]['PARAM2']) && isset($res[$key]['PARAM2'][0]) && is_object($res[$key]['PARAM2'][0]) && isset($res[$key]['PARAM2'][0]->item)) {

                    if(!is_array($res[$key]['PARAM2'][0]->item)) {

                        $tmp = $this->navpathlist_fix(array($res[$key]['PARAM2'][0]->item));
                        $res[$key]['PARAM2'][0]->item = $tmp[0];

                    } else {

                        $res[$key]['PARAM2'][0]->item = $this->navpathlist_fix($res[$key]['PARAM2'][0]->item);

                    }

                }

            }

        }

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);

        return;
    }

    protected function _getOne()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOne($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->$appidname = $this->view->appid_id;
	    if (($idname = $ctrlcfg->id) && !isset($data->$idname))
                $data->$idname = $id;
            $data->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;

        if(!is_array($data->item)) {
            $tmp = $this->navpathlist_fix(array($data->item));
            $data->item = $tmp[0];
        } else {
            $data->item = $this->navpathlist_fix($data->item);
        }

        $this->view->$arkobject = $data;
        return $data;
    }

}

?>
