<?php

require_once 'ArkeiaAction.php';

class SchedulerController extends ArkeiaAction
{
    public function calendarAction() {
        $this->displayFromScreenIni('calendar');
    }

    public function jsonListCalendarAction() {
        require_once 'Zend/Json.php';
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $params = $this->_request->getPost();

        if(!isset($params['month'])) {
            $params['month'] = date('Ym');
        }

        $year = substr($params['month'], 0, 4);
        $month = substr($params['month'], 4);

        $prev = date('Ym', mktime(0, 0, 0, ((int)$month)-1, 1, (int)$year));
        $next = date('Ym', mktime(0, 0, 0, ((int)$month)+1, 1, (int)$year));

        $context = $this->view->context;
        $data = $model->listcalendar($prev . ' ' . $params['month'] . ' ' . $next, $context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function loadPaneAction()
    {
        $ctrl = $this->getRequest()->getControllerName();
        $appid_id = $this->_request->getParam('param');
        $context = null;
        if ($appid_id) {
            list($appid, $id, $level) = split("_", $appid_id, 3);
            if ($appid != "local") {
                $context = $this->_get_filtered_context($appid, $array_context);
            }
        } else {
            $tmpid = $this->_request->getPost($idname);
            list($id, $level) = split("_", $tmpid, 2);
        }
//        $this->view->screen = new Zend_Config_Ini($this->viewdir . '/'.$ctrl.'/screen.ini', 'summary');
        $this->view->toto = $id;
        if ($level == "0")
            echo $this->view->render($ctrl . '/periodic.phtml');
        else
            echo $this->view->render($ctrl . '/level.phtml');
    }

    public function jsonGetResultOneAction() {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultOne($context);
        $res = $this->_get_result($data, $context);

        list($id, $context) = $this->_getIdContext($array_context);
        list($id, $appid, $level) = split("@", $id, 3);
        if((int)$level > 0) {
            foreach ($res as $appid => &$data) {
                if(isset($data['PARAM3']) && isset($data['PARAM3'][0])) {
                    if(!isset($res[$appid]['PARAM3'][0]->IS_BKP_TO_DISK)) {
                        if(!isset($res[$appid]['PARAM3'][0]->IS_BKP_TO_DISK)) {
                            $res[$appid]['PARAM3'][0]->IS_BKP_TO_DISK = '0';
                        }
                    }
                } else {
                    if(!isset($res[$appid]['PARAM2'][0]->IS_BKP_TO_DISK)) {
                        if(!isset($res[$appid]['PARAM2'][0]->IS_BKP_TO_DISK)) {
                            $res[$appid]['PARAM2'][0]->IS_BKP_TO_DISK = '0';
                        }
                    }
                }
            }
        }
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _getOne()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOne($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->$appidname = $this->view->appid_id;
            $data->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;
        $this->view->$arkobject = $data;

        return $data;
    }

    public function jsonCreateObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $params = $this->_request->getPost();
        $val_select = array('LSPK', 'LDEVPACK', 'LPOOL', 'LTYPE');
        $params = $this->_clean_select_POST($params, $val_select);

        unset($params['advparam_name']);
        unset($params['advparam_val']);
        unset($params['advparam_submit']);
        unset($params['OWNER_selected']);
        unset($params['SUBMIT']);
        require_once 'Zend/Json.php';

        $params['LVAL_UNITS'] = 'DAYS';
        $params['LVAL_NBU'] = '30';
        $params['NB_FLOWS'] = '0';
        $params['LNEW_TP'] = 'COMPLETE_EXIST';
        $params['L_BASE_NAME'] = '';
        $params['LTYPE'] = 'TOTAL';
        $params['START_DATE'] = date('Ymd\THis', mktime());
        $params['RRULE'] = 'D1 *0';
        $params['BKP_ACTIVE'] = 'ACTIVE';
        $params['DO_EMAIL'] = '1';
        $params['LEVEL'] = '1';
        $params['NB_LEVEL'] = '1';

        require_once 'Zend/Json.php';

        if ($params['NAME'] == '' ||
            $params['OWNER'] == '' ||
            $params['LSPK'] == '' ||
            $params['LDEVPACK'] == '') {
            $res = $this->_set_error_message($this->lang['pr_create_error_name_type_require']);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);
            return;
        }

        if ($params['LDEVPACKTYPE'] == 'tape' && $params['LPOOL'] == '') {
            $res = $this->_set_error_message($this->lang['pr_create_error_name_type_require']);
            $result = Zend_Json::encode($res);
            $this->getResponse()->appendBody($result);
            return;
        } 

        unset($params['LDEVPACKTYPE']);

        $data = $model->createObject($params, $this->view->context);
        $res = $this->_get_result($data, $this->view->context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _addlevelObject($array_context = null)
    {
        return $this->_doModelResultOne('addlevelObject', $array_context);
    }

    public function jsonAddLevelAction()
    {
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $this->_addlevelObject($context);
	$res = $this->_get_result($data, $context);

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

// Surcharge de cette fonction affin de créer toutes les lignes de level liées au scheduler.
    public function jsonGetResultAllAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $data = $this->_getResultAll($context);
        $res = $this->_get_result($data, $context);

        $appids = array();
        if ($context) {
            foreach ($res as $key => $data)
                $appids[] = $key;
        } else {
            $appids[] = 'local';
        }

        foreach ($appids as $appid) {
            $tItem = $res[$appid]['PARAM2'][0]->item;
            if ($tItem) {
                if (!is_array($tItem))
                    $tItem = array($tItem);
                $tDestItem = Array();
                for ($s = 0 ; $s < count($tItem) ; $s++) {
                    $oDst = new StdClass();
		    $oDst->LEVEL = '0';
                    $oDst->NB_LEVEL = $tItem[$s]->NB_LEVEL;
                    $oDst->NAME = $tItem[$s]->NAME;
                    $oDst->OKEY = $tItem[$s]->NAME.'@'.$appid.'@0';
                    $oDst->PRID = $tItem[$s]->PRID.'@'.$appid.'@0';
                    $oDst->APPID_PRID = $appid.'_'.$tItem[$s]->PRID;
                    $tDestItem[] = $oDst;

                    for($l = 0 ; $l < $tItem[$s]->NB_LEVEL ; $l++) {
                        $n = $l + 1;
                        $oDst = new StdClass();
		        $oDst->LEVEL = ''.$n;
                        $oDst->NB_LEVEL = $tItem[$s]->NB_LEVEL;
                        $oDst->NAME = '-  Level ' . $n;
                        $oDst->OKEY = $tItem[$s]->NAME.'@'.$appid.'@'.$n;
                        $oDst->PRID = $tItem[$s]->PRID.'@'.$appid.'@'.$n;
                        $oDst->APPID_PRID = $appid.'_'.$tItem[$s]->PRID;
                        $tDestItem[] = $oDst;
                    }

                }
                $res[$appid]['PARAM2'][0]->item = $tDestItem;
            }
        }
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        //error_log('jsonGetResultAllAction Sch res: '.$result);
        return;
    }

    public function jsonGetForComboboxAction()
    {
// USR_LIST_ALL ne retourne par de USERID
// on va donc utiliser le NAME qui est forcément une clé !!!
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = 'NAME';
        require_once 'Zend/Json.php';
        $context = $this->view->context;
        $res = $this->_getResultAll($context);
        $res = $res->param2->item;
        if (!is_array($res)) $res = array($res);
        $tList = array();
        foreach ($res as $key => $val)
            $tList[$res[$key]->$idname] = $res[$key]->NAME;
        $result = Zend_Json::encode($tList);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonModifyObjectAction()
    {
        require_once 'Zend/Json.php';

        //error_log('jsonModifyObjectAction POST: '. Zend_Json::encode($_POST));

        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        //$context = $this->view->context;
        $result = $this->_getResultOne($context);
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $res = $this->_get_result($result, $context);
        //error_log('res: '. Zend_Json::encode($res));
        $params = $res[$this->view->appid]['PARAM2'][0];
	//error_log('AVANT: '. Zend_Json::encode($params));

        $tPRID = explode('@', $params->PRID);
        $params->PRID = $tPRID[0];
        $appid = (int)$tPRID[1];
        $level = (int)$tPRID[2];

        if ($level == 0) {
            $params->BKP_ACTIVE = ($_POST['BKP_ACTIVE'] == 'on')?'ACTIVE':'INACTIVE';
            $this->putPost($params, 'OWNER', 'OWNER_selected');
            $params->DO_EMAIL = ($_POST['DO_EMAIL'] == 'on')?'1':'0';
            $this->putPost($params, 'EMAIL_VERBO');
            $this->putPost($params, 'EMAIL_SEND');
        } else {
            $this->putPost($params, 'RRULE_PER');
            $this->putPost($params, 'RRULE_EVR');
            $this->putPost($params, 'DO_EMAIL');
            $this->putPost($params, 'RRULE_JRSMO');
            $this->putPost($params, 'RRULE_JRSTU');
            $this->putPost($params, 'RRULE_JRSWE');
            $this->putPost($params, 'RRULE_JRSTH');
            $this->putPost($params, 'RRULE_JRSFR');
            $this->putPost($params, 'RRULE_JRSSA');
            $this->putPost($params, 'RRULE_JRSSU');
            $this->putPost($params, 'RRULE_M_MORE');
            $this->putPost($params, 'RRULE_M_FSTR');
            $this->putPost($params, 'RRULE_M_FEND');
            $this->putPost($params, 'RRULE_Y_MORE');
            $this->putPost($params, 'RRULE_Y_FSTR');
            $this->putPost($params, 'RRULE_Y_FEND');
            $this->putPost($params, 'LAST_MORE');
            $this->putPost($params, 'LAST_DATE');
            $this->putPost($params, 'LAST_NBBKP');
            $this->putPost($params, 'FORM_DATE');
            $this->putPost($params, 'FORM_TIME');
            $this->putPost($params, 'TADVPARAM');
            $this->putPost($params, 'LTYPE');
            $this->putPost($params, 'LVAL_NBU');

            $this->putPost($params, 'CMDAFT');
            $this->putPost($params, 'CRUISE');
            $params->EXEC_FAIL = (isset($_POST['EXEC_FAIL']) ? 'YES' : 'NO');
            $this->putPost($params, 'CMDBEF');
            $this->putPost($params, 'SYSCMD');

            $this->putPost($params, 'OWNER', 'OWNER_selected');
            $this->putPost($params, 'RRULE_M_NUMWEEK', 'RRULE_M_NUMWEEK_selected');
            $this->putPost($params, 'RRULE_M_JRSWEEK', 'RRULE_M_JRSWEEK_selected');
            $this->putPost($params, 'RRULE_Y_NUMMONTH', 'RRULE_Y_NUMMONTH_selected');
            $this->putPost($params, 'RRULE_Y_NUMDAY', 'RRULE_Y_NUMDAY_selected');
            $this->putPost($params, 'LSPK', 'LSPK_selected');
            $this->putPost($params, 'LDEVPACK', 'LDEVPACK_selected');
            $this->putPost($params, 'LPOOL', 'LPOOL_selected');

            if ($params->LSPK == '' || $params->LDEVPACK == '') {
                $res = $this->_set_error_message($this->lang['pr_create_error_name_type_require']);
			    $result = Zend_Json::encode($res);
			    $this->getResponse()->appendBody($result);
			    return ;
            }

            if (isset($_POST['LDEVPACKTYPE']) && ($_POST['LDEVPACKTYPE'] == 'tape' || $_POST['LDEVPACKTYPE'] == 'both') && $params->LPOOL == '') {
                $res = $this->_set_error_message($this->lang['pr_create_error_name_type_require']);
			    $result = Zend_Json::encode($res);
			    $this->getResponse()->appendBody($result);
			    return ;
            }

            if (isset($_POST['LDEVPACKTYPE']) && $_POST['LDEVPACKTYPE'] == 'vtl') {
                $params->LPOOL = '26';
            }

            if(isset($_POST['HAS_RET_TIME'])) {

                if(isset($_POST['REP_SCH_RETENTION']) && $_POST['REP_SCH_RETENTION'] == 'on') {

                    $this->putPost($params, 'CHAIN_RET_TIME');
                    $this->putPost($params, 'CHAIN_RET_TIME_UNIT', 'CHAIN_RET_TIME_UNIT_selected');

                } else {

                    unset($params->CHAIN_RET_TIME);
                    unset($params->CHAIN_RET_TIME_UNIT);

                }

            } else {

                $this->putPost($params, 'CHAIN_RET_TIME');
                $this->putPost($params, 'CHAIN_RET_TIME_UNIT', 'CHAIN_RET_TIME_UNIT_selected');

            }

	    if ($params->LTYPE == 'INCREMENTAL' || $params->LTYPE == 'DIFFERENTIAL')
	        $this->putPost($params, 'L_BASE_NAME', 'L_BASE_NAME_selected');
	    else 
	        $params->L_BASE_NAME = '';
            $this->putPost($params, 'LVAL_UNITS', 'LVAL_UNITS_selected');
            $this->putPost($params, 'LNEW_TP', 'LNEW_TP_selected');
            $this->putPost($params, 'NB_FLOWS', 'NB_FLOWS_selected');

            $this->putPost($params, 'CHAIN_DELAY');
	    if (isset($_POST['CHAIN_FLAG']) && $_POST['CHAIN_FLAG'] == 'CHAIN') {
		    if (!isset($_POST['radio_chained'])) {
			    $res = $this->_set_error_message($this->lang['pr_levform_error_radio_chained']);
			    $result = Zend_Json::encode($res);
			    $this->getResponse()->appendBody($result);
			    return ;
		    }
		    if (isset($_POST['radio_chained']) && $_POST['radio_chained'] == "0" &&
			isset($_POST['CHAIN_D2T_SCHID_selected'])) {
			    if ($_POST['CHAIN_D2T_SCHID_selected'] == '') {
				    $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_SCHID']);
				    $result = Zend_Json::encode($res);
				    $this->getResponse()->appendBody($result);
				    return ;
			    }
			    $params->CHAIN_SCHID = $_POST['CHAIN_D2T_SCHID_selected'];
		    }
		    if (isset($_POST['radio_chained']) && $_POST['radio_chained'] == "1" &&
			isset($_POST['CHAIN_REP_SCHID_selected'])) {
			    if ($_POST['CHAIN_REP_SCHID_selected'] == '') {
				    $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_REP_SCHID']);
				    $result = Zend_Json::encode($res);
				    $this->getResponse()->appendBody($result);
				    return ;
			    }
			    $params->CHAIN_SCHID = $_POST['CHAIN_REP_SCHID_selected'];

			    if (isset($_POST['REP_SCH_RETENTION']) && $_POST['REP_SCH_RETENTION'] == 'on' &&
				isset($_POST['CHAIN_RET_TIME']) && isset($_POST['CHAIN_RET_TIME_UNIT'])) {
				    if ($_POST['CHAIN_RET_TIME'] == '' || $_POST['CHAIN_RET_TIME_UNIT'] == '') {
					    $res = $this->_set_error_message($this->lang['replication_error_value_require_RET_TIME']);
					    $result = Zend_Json::encode($res);
					    $this->getResponse()->appendBody($result);
					    return;
				    }
			    }

		    }
	    }
            
            $this->putPost($params, 'CHAIN_FLAG');

            $this->putPost($params, 'TEXCEPTION');

	    $this->putPost($params, 'IGNORE_LAST_DAY');
	    if ($params->IGNORE_LAST_DAY == '') {
	        unset($params->IGNORE_LAST_DAY);
	    }

	    if (isset($params->IS_BKP_TO_DISK)) {
	        unset($params->IS_BKP_TO_DISK);
	    }

        if(isset($params->LDEVPACKTYPE)) {
            unset($params->LDEVPACKTYPE);
        }

	    $ASK_REINIT_DATE = false;
	    if (isset($params->RAN_TODAY) && (!isset($params->IGNORE_LAST_DAY) || $params->IGNORE_LAST_DAY != 1)) {
	        $ASK_REINIT_DATE = $params->LAST_DAY;
	    }

            $params = $model->implodeInfo($params, $level);
        }

        //error_log('APRES: '. Zend_Json::encode($params));

        $data = $model->modifyObject($params, $context);
        $res = $this->_get_result($data, $context);
	if ($ASK_REINIT_DATE) {
	  $res = $this->_set_ask_user_message($this->lang['sch_bkp_ask_reinit_scheduler'], 'REINIT');
	}
        $result = Zend_Json::encode($res);
	//error_log('result Modifyobject: '. $result);
        $this->getResponse()->appendBody($result);
    }

    public function putPost(&$data, $search, $dest = '')
    {
        if (empty($dest)) $dest = $search;
        if (isset($_POST[$dest]))
            $data->$search = $_POST[$dest];
    }

    public function wizardAction()
    {
        $this->displayFromScreenIni('wizard');
    }

    public function jsonCreateWizardObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $res = false;

        $post_params = $this->_request->getPost();
        $post_params = $this->_clean_select_POST($post_params);

        require_once 'Zend/Json.php';
        //error_log('jsonCreateWizardObjectAction, post: '.Zend_Json::encode($post_params));

        $params = array();

        $bkp_policy = $post_params['BKPPOLICY'];

        $list_level = array();
        $elms = split('_', $bkp_policy); /* MT_WT_DI */
        $level_num = 1;
        foreach ($elms as $elm) {
            $level = $elm{0};
            $type = $elm{1};
            $level_info = array();

            $level_info['LEVEL'] = $level_num++;
            $level_info['NB_LEVEL'] = $level_info['LEVEL'];

            $level_info['LVAL_UNITS'] = $post_params[$level.'_LVAL_UNITS'];
            $level_info['LVAL_NBU'] = $post_params[$level.'_LVAL_NBU'];

            $level_info['NB_FLOWS'] = '0';
            $level_info['LNEW_TP'] = 'COMPLETE_EXIST';

            if (isset($post_params[$level.'_EXEC_FAIL']) && $post_params[$level.'_EXEC_FAIL'])
                $level_info['EXEC_FAIL'] = 'YES';

            foreach (array('CRUISE', 'CMDAFT', 'CMDBEF', 'SYSCMD', 'LNEW_TP', 'NB_FLOWS') as $elm)
                if (isset($post_params[$level.'_'.$elm]) && $post_params[$level.'_'.$elm] != '')
                    $level_info[$elm] = $post_params[$level.'_'.$elm];

            if (isset($post_params[$level.'_FORM_DATE'])) {
                list($year, $mouth, $day) = split('[-]', $post_params[$level.'_FORM_DATE']);
                $start_date = $year.$mouth.$day;
            } else
                $start_date = date('Ymd');
            list($heure, $minute, $seconde) = split('[:+]', $post_params[$level.'_FORM_TIME']);
            $level_info['START_DATE'] = $start_date.'T'.$heure.$minute.$seconde;

            foreach ($post_params as $key => $val) {
                if (preg_match('/^'.$level.'_(adv_param_.*)/', $key, $match))
                    $level_info[$match[1]] = $val;
            }

            $level_info['BKP_ACTIVE'] = (isset($post_params['BKP_ACTIVE']) && $post_params['BKP_ACTIVE']) ? 'ACTIVE' : 'INACTIVE';

            if ($post_params['DO_EMAIL'] == '1') {
                $level_info['DO_EMAIL'] = '1';
                $level_info['EMAIL_SEND'] = $post_params['EMAIL_SEND'] == '' ? '0' : $post_params['EMAIL_SEND'];
                $level_info['EMAIL_VERBO'] = $post_params['EMAIL_VERBO'] == '' ? '0' : $post_params['EMAIL_VERBO'];
            } else
                $level_info['DO_EMAIL'] = '0';

            $level_info['L_BASE_NAME'] = '';
            if ($type == 'I')
                $level_info['L_BASE_NAME'] = $post_params['NAME'];
            $ltype = array('T' => 'TOTAL', 'I' => 'INCREMENTAL', 'A' => 'ARCHIVE', 'D' => 'DIFFERENTIAL');
            $level_info['LTYPE'] = $ltype[$type];
            $level_info['CHAIN_FLAG'] = $post_params['CHAIN_FLAG'] != 'CHAIN' ? 'NOCHAIN' : 'CHAIN';
            if ($level_info['CHAIN_FLAG'] == 'CHAIN') {
		    if ($post_params['radio_chained'] == "0") {
			    if (!ctype_digit($post_params['CHAIN_D2T_DELAY']) || $post_params['CHAIN_D2T_DELAY'] == '')
				    $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_DELAY']);
			    else
				    if ($post_params['CHAIN_D2T_SCHID'] == '')
					    $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_SCHID']);
				    else
					    array_push($level_info, array('DELAY' => (string)$post_params['CHAIN_D2T_DELAY'],
									  'SCHID' => (string)$post_params['CHAIN_D2T_SCHID'],
									  'CMDAFT' => ''));
		    }
		    if ($post_params['radio_chained'] == "1" && $post_params['LDEVPACKTYPE'] == 'vtl') {
			    if (!ctype_digit($post_params['CHAIN_REP_DELAY']) || $post_params['CHAIN_REP_DELAY'] == '')
				    $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_REP_DELAY']);
			    else
				    if ($post_params['CHAIN_REP_SCHID'] == '') {
					    $res = $this->_set_error_message($this->lang['pr_wizard_error_CHAIN_REP_SCHID']);
				    }
				    else {
					    if ($post_params['REP_SCH_RETENTION'] == 'on' &&
						($post_params['RET_TIME'] == '' || 
						 $post_params['RET_TIME_UNIT'] == '')) {
						    $res = $this->_set_error_message($this->lang['replication_error_value_require_RET_TIME']);
					    }
					    else {
						    if ($post_params['REP_SCH_RETENTION'] == 'on') {
							    array_push($level_info, array('DELAY' => (string)$post_params['CHAIN_REP_DELAY'],
											  'SCHID' => (string)$post_params['CHAIN_REP_SCHID'],
											  'CMDAFT' => '',
											  'RET_TIME' => (string)$post_params['RET_TIME'],
											  'RET_TIME_UNIT' => (string)$post_params['RET_TIME_UNIT']));
						    }
						    else {
							    array_push($level_info, array('DELAY' => (string)$post_params['CHAIN_REP_DELAY'],
											  'SCHID' => (string)$post_params['CHAIN_REP_SCHID'],
											  'CMDAFT' => ''));
						    }
					    }
				    }
		    }
	    }

            $rrule_evr = isset($post_params[$level.'_RRULE_EVR']) ? $post_params[$level.'_RRULE_EVR'] : '1';

            $level_info['RRULE'] = '';
            switch ($level) {
            case 'D':
                $level_info['RRULE'] .= 'D'.$rrule_evr;
                break ;

            case 'W':
                $level_info['RRULE'] .= 'W'.$rrule_evr;
                $days = array('MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU');
                foreach ($days as $day)
                    if (isset($post_params[$level.'_RRULE_JRS'.$day]))
                        $level_info['RRULE'] .= ' '.$day;
                break ;

            case 'M':
                switch($post_params['M_RRULE_M_MORE']) {
                default:
                case '0':
                    $level_info['RRULE'] .= 'MD'.$rrule_evr.' '.$post_params['M_RRULE_M_FSTR'];
                    break;
                case '1':
                    $level_info['RRULE'] .= 'MD'.$rrule_evr.' -'.$post_params['M_RRULE_M_FEND'];
                    break;
                case '2':
                    $level_info['RRULE'] .= 'MP'.$rrule_evr.' '.$post_params['M_RRULE_M_NUMWEEK'].' '.$post_params['M_RRULE_M_JRSWEEK'];
                    break;
                }
                break ;
            }

            switch ($post_params[$level.'_LAST_MORE']) {
            default:
            case '':
            case 2:
                $level_info['RRULE'] .= ' *0';
                break ;
            case 1:
                $level_info['RRULE'] .= ' *'.$post_params[$level.'_LAST_NBBKP'];
                break ;
            case 0:
                list($year, $mouth, $day) = split('[-]', $post_params[$level.'_LAST_DATE']);
                $level_info['RRULE'] .= ' '.$year.$mouth.$day.'T000000';
                break ;
            }

            array_push($list_level, $level_info);
        }

        if($post_params['LDEVPACKTYPE'] == 'vtl') {
            $post_params['LPOOL'] = '26';
        }

        require_once 'Zend/Json.php';
        //error_log(Zend_Json::encode($list_level));
        if (!$res) {
            if ($post_params['NAME'] == '' ||
                $post_params['OWNER'] == '' ||
                $post_params['LSPK'] == '' ||
                $post_params['LDEVPACK'] == '' ||
                $post_params['LPOOL'] == '')
            {
                $res = $this->_set_error_message($this->lang['pr_wizard_error_value_require_SPK_PL_DRV']);
            } else {
                $prid = false;
                $level1 = $level2 = $level3 = false;
                for ($i = 0; $i < sizeof($list_level); $i++) {
                    $list_level[$i]['NB_LEVEL'] = sizeof($list_level);

                    $list_level[$i]['NAME'] = $post_params['NAME'];
                    $list_level[$i]['OWNER'] = $post_params['OWNER'];
                    $list_level[$i]['LSPK'] = $post_params['LSPK'];
                    $list_level[$i]['LDEVPACK'] = $post_params['LDEVPACK'];
                    $list_level[$i]['LPOOL'] = $post_params['LPOOL'];
                    $varname = "level".($i+1);
                    $$varname = $list_level[$i];
                }

                $data = $model->createFullObject($level1, $level2, $level3, $this->view->context);

                $res = $this->_get_result($data, $this->view->context);

                foreach ($res as $appid => $data) {
                    foreach ($data['STATUS'] as $status) {
                        if ($status) {
                            $res[$appid]['FORCE_ALERT'] = 1;
                            $result = Zend_Json::encode($res);

                            $this->getResponse()->appendBody($result);
                            return;
                        }
                    }
                }
            }
        }
        $result = Zend_Json::encode($res);

        $this->getResponse()->appendBody($result);
        return;
    }

    public function calendarHelpAction()
    {
        echo $this->view->render('scheduler/calendar_help.html');
    }
}
?>
