<?php

require_once 'ArkeiaAction.php';

class TapeController extends ArkeiaAction
{
  public function summaryAction()
    {
      if ($this->view->context) {
	$this->displayFromScreenIni('summary_multisite');
      } else {
	$this->displayFromScreenIni('summary');
      }
    }

  public function tapeStatusAction()
    {
      $this->displayFromScreenIni('tape_status');
    }

  public function tapeUsageAction()
    {
      $this->displayFromScreenIni('tape_usage');
    }

  public function cleanTapeUsageAction()
    {
      $this->displayFromScreenIni('clean_tape_usage');
    }

  public function jsonMultiUpdateAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $arkobject = $ctrlcfg->object;
      $this->view->$arkobject = $this->_request->getPost();
      $res = $this->displayFromScreenIni('multiupdate', FALSE);
      $this->_render_json_view($res);
      return;
    }

  public function jsonListTypeAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;
      
      require_once 'Zend/Json.php';
      $data = $model->listType($this->view->context);

      $res = array();
      foreach ($data as $obj) {
        $res[$obj->NAME] = $obj->NAME;
      }
      ksort($res);
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonCreateObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      $params = $this->_request->getPost();

	  $params['MEDIASERVER'] = $params['MEDIA_SERVER'];

      $params = $this->_clean_POST($params);
      $params = $this->_clean_select_POST($params);
      
	  $params['MEDIA_SERVER'] = $params['MEDIASERVER'];
	  unset ($params['MEDIASERVER']);
	  
      $firstnum = (integer) $params['firstnum'];
      unset($params['firstnum']);
      $lastnum = (integer) $params['lastnum'];
      unset($params['lastnum']);

      if ($params['TP_TYPE'] == 'FILE') {
          $params['VOLTAG'] = $params['PATH'];
      } else {
          unset($params['MEDIA_SERVER']);
          unset($params['CAPACITY']);
      }
      unset($params['PATH']);

      if ($params['BKPORCLEAN']) /* it's clean tape */
      {
          $params['ST_DENY'] = 15;
          unset($params['PLID']);
      }
      else /* it's backup tape */
      {
          unset($params['MAX_NB_USE']);
          unset($params['NB_USE']);
          $params['ST_DENY'] = 16;
      }
	
      require_once 'Zend/Json.php';

      if ($params['NAME'] == '' || $params['TP_TYPE'] == '') {
          $res = $this->_set_error_message($this->lang['tp_create_error_name_type_require']);
      } else if ($params['TP_TYPE'] == 'FILE' && $params['VOLTAG'] == '') {
          $res = $this->_set_error_message($this->lang['tp_create_error_path_require']);
      } else if ($params['TP_TYPE'] == 'FILE' && $params['MEDIA_SERVER'] == '') {
          $res = $this->_set_error_message($this->lang['tp_create_error_media_server_require']);
      } else {

 	  //error_log('Create tape context : '.Zend_Json::encode($this->view->context)); 
 	  if ($params['VOLTAG'] == '')
	    unset($params['VOLTAG']);
          $data = $model->createObject($params, $firstnum, $lastnum, $this->view->context);
	  //error_log('Create tape data : '.Zend_Json::encode($data)); 
           $res = $this->_get_result($data, $this->view->context);
	  //error_log('Create tape res : '.Zend_Json::encode($res)); 
      }

      //$res = $this->_set_error_message($this->lang['tp_create_error_media_server_require']);

      $result = Zend_Json::encode($res);

      $this->getResponse()->appendBody($result);
      return;
    }

  private function get_right(&$params)
    {
      $list_key = array('ST_DENY_READ', 'ST_DENY_DELETE', 'ST_DENY_WRITE', 'ST_DENY_RECYCLE');
      $right = 31;
      foreach ($list_key as $key)
	if (isset($params[$key]))
	  {
	    $right -= $params[$key];
	    unset($params[$key]);
	  }
      return ($right);
    }

  public function jsonMultiModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $context = $this->view->context;

      require_once 'Zend/Json.php';
      //DEBUG error_log('jsonMultiModifyObjectAction POST : '.Zend_Json::encode($this->_request->getPost()));
      //DEBUG error_log('jsonMultiModifyObjectAction context : '.Zend_Json::encode($context));
      //DEBUG error_log('jsonMultiModifyObjectAction id : '.Zend_Json::encode($id));

      $params = $this->_request->getPost();
      $params = $this->_clean_select_POST($params);

      $params1 = array();
      foreach ($params as $key => $val)
	{
	  if (preg_match('/^(.*)_on/', $key, $match) && (isset($params[$match[1]]) || $match[1] == 'ST_DENY'))
	    {
	      if ($match[1] == 'ST_DENY')
		$params1[$match[1]] = $this->get_right($params);
	      else
		$params1[$match[1]] = $params[$match[1]];
	    }
	}
     
      //DEBUG error_log('jsonMultiModifyObjectAction params1: '.Zend_Json::encode($params1));

      $list_id = Zend_Json::decode($params['APPID_TPID']);
      $params2 = array();
      foreach ($list_id as $id)
	{
	  if ($context)
	    array_push($params2, array('APPID_ID' => $id));
	  else
	    {
	      list($appid, $id) = split('_', $id);
	      array_push($params2, array('TPID' => $id));
	    }
	}

      //DEBUG error_log('jsonMultiModifyObjectAction params2: '.Zend_Json::encode($params2));

      $data = $model->modifyObject($params1, $params2, $context);

      $res = $this->_get_result($data, $context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonModifyObjectAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      require_once 'Zend/Json.php';
      //error_log('jsonModifyObjectAction POST : '.Zend_Json::encode($this->_request->getPost()));
      //error_log('jsonModifyObjectAction array_context: '.Zend_Json::encode($array_context));
      //error_log('jsonModifyObjectAction context: '.Zend_Json::encode($context));
      //error_log('jsonModifyObjectAction id : '.Zend_Json::encode($id));

      $idname = $ctrlcfg->id;
      $params2 = array();
      if ($context)
	array_push($params2, array('APPID_ID' => $this->_request->getPost('APPID_'.$idname)));
      else
	array_push($params2, array('TPID' => $id));

      $params1 = $this->_request->getPost();

      unset($params1['TPID']);
      unset($params1['APPID_TPID']);
      unset($params1['PLID']);
      if (isset($params1['BKPTAPE']))
      {
	      $params1['ST_DENY'] = $this->get_right($params1);
	      foreach (array('PLID', 'RECYCLE_MODE', 'RECYCLE_IN', 'ST_ACCESS') as $val)
	          if (isset($params1[$val.'_selected']))
	          {
                  $params1[$val] = $params1[$val.'_selected'];
                  unset($params1[$val.'_selected']);
	          }
          unset($params1['BKPTAPE']);
      }
      else
          unset($params1['CLEANINGTAPE']);
      require_once 'Zend/Json.php';

      $data = $model->modifyObject($params1, $params2, $context);

      $res = $this->_get_result($data, $context);
      
      //error_log('jsonModifyObjectAction res: '.Zend_Json::encode($res));
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonRecycleOneAction()
    {
      $data = $this->_doModelResultOne('recycleOne', $this->view->context);
      $res = $this->_get_result($data, $this->view->context);

      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

  public function jsonGetAllAction()
    {
        require_once 'Zend/Json.php';
        $data = $this->_getAll();
        //$res = $this->_get_message($data);
        $result = Zend_Json::encode($data);
        $this->getResponse()->appendBody($result);
        return;
    }


  public function writelabelAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('writelabel', FALSE);
        $this->_render_json_view($res);
        return;
    }

  public function jsonGetAllTpCompDriveNameIdAction()
    {
      $ctrlcfg = $this->_getCtrlCfg();
      $model = $this->_getModel($ctrlcfg);
      $idname = $ctrlcfg->id;

      //error_log('jsonGetAllTpCompDriveNameIdAction Param:'.Zend_Json::encode($this->_request->getParams()));

      $array_context = $this->view->context;
      list($id, $context) = $this->_getIdContext($array_context);

      $data = $model->compDrive($id, $context);

      //error_log('jsonGetAllTpCompDriveNameIdAction data:'.Zend_Json::encode($data));

      $result = $this->_get_result($data, $context);
      //error_log('jsonGetAllTpCompDriveNameIdAction _get_result :'.Zend_Json::encode($result));

      $result = array_shift($result);
      //error_log('jsonGetAllTpCompDriveNameIdAction array_pop :'.Zend_Json::encode($result));
      $data = $result['PARAM2'][0]; 
      $list = $data->item; 
      $status = ($result['STATUS'][0]); 
      $sessnum = ($result['sessnum'][0]); 
      $transnum = ($result['transnum'][0]);
      if (!($result['LAST'][0]))
	$model->abortTrans($transnum, $sessnum, $context);

      //error_log('jsonGetAllTpCompDriveNameIdAction status: '.$status.' list:'.Zend_Json::encode($list));

      $res = array();
      if ($status)
	{
	  $res['error'] = $this->lang['tp_get_drv_compatible_error_cant_load_drv_list'];
	}
      else
	if (!$list)
	  {
	    $res['error'] = $this->lang['tp_get_drv_compatible_error_no_drv_compatible'];
	  }
	else
	  {
	    $data = $list;
	    if (!is_array($data))
	      $data = array($data);
	    foreach ($data as $obj) {
	      $res[$obj->DRVID] = $obj->NAME;
	    }
	    ksort($res);
	  }
      $result = Zend_Json::encode($res);
      $this->getResponse()->appendBody($result);
      return;
    }

    public function jsonGetResultTapeStatusAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $data = $model->getResultAllStatus($context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultBackupTapeWithoutNullAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $data = $model->getResultAllWithoutNull(0, $context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetResultCleaningTapeWithoutNullAction()
    {
        require_once 'Zend/Json.php';
        $context = $this->view->context;

        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        $data = $model->getResultAllWithoutNull(1, $context);
        $res = $this->_get_result($data, $context);
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function tapestatushelpAction() {

        echo $this->view->render('tapestatus/help.html');

    }

    public function tapeusagehelpAction() {

        echo $this->view->render('tapeusage/help.html');

    }

    public function cleantapeusagehelpAction() {

        echo $this->view->render('cleantapeusage/help.html');

    }

}

?>
