<?php
require_once 'ArkeiaAction.php';

class TapeduplicationController extends ArkeiaAction
{
	public function jsonDupStartAction()
    {
    	$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;

      	$params = $this->_request->getPost();
		$val_select = array('DST_LIBID', 'DST_DRVID', 'SRC_DRVID', 'SRC_TPID', 'DO_EMAIL', 'FORCE', 'DST_SLOT');
	    $params = $this->_clean_select_POST($params, $val_select);
		unset($params['SUBMIT']);
		
		if ($params['DST_DRVID'] == '' || $params['SRC_DRVID'] == '' ||
          $params['SRC_TPID'] == '') {
          $res = $this->_set_error_message($this->lang['tape_duplication_start_error_DRV_TP_require']);
		  $result = Zend_Json::encode($res);
  	      $this->getResponse()->appendBody($result);
	      return;
	    }
		if (isset($params['USE_LIB']) && ($params['DST_LIBID'] == '' || 
			$params['DST_SLOT'] == '')) {
          $res = $this->_set_error_message($this->lang['tape_duplication_start_error_LIB_SLOT_require']);
		  $result = Zend_Json::encode($res);
  	      $this->getResponse()->appendBody($result);
	      return;
	    }
		if (!isset($params['USE_LIB'])) {
			unset($params['DST_SLOT']);
			unset($params['DST_LIBID']);
		}
		unset($params['USE_LIB']);

        $data = $model->startDup($params, $this->view->context);
        $res = $this->_get_result($data, $this->view->context);

	    //error_log('jsonStartAction, res: '.Zend_Json::encode($res));
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
    }
	
	public function jsonShowDupAction()
    {
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';

		//error_log("jsonShowBackupAction POST: ".Zend_Json::encode($this->_request->getPost()));
    
        if (!$params['PARAM2']) {
            $array_context = $this->view->context;
            list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
            if ($id) {
                list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
            }
	    //error_log("jsonShowBackupAction context: ".Zend_Json::encode($context));
	    if ($context)
	      list($params[APPLIANCE_GUID]) = $context[0]->APPLIANCE_GUID;
        }

        $this->view->showBackup = $params;

		$options = false;
		$screen = 'showbackup';
		
        $res = $this->displayFromScreenIni($screen, FALSE, $options);
        $this->_render_json_view($res);
        return;
    }
	
	public function TapeDuplicationHelpAction()
    {
        echo $this->view->render('tapeduplication/help01.html');
    }
	
	public function getAllNameId($idname = false, $trans_all, $trans_one, $type)
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }

        $res = $model->getResultAll($context, $trans_all);
        if (!is_array($res)) $res = array($res);
        foreach ($res as $key => $val) {
            if ($context) {
                $data = $res[$key]->param3->item;
            } else {
                $data = $res[$key]->param2->item;
            }
            if ($data) break ; 
        }
        $res = array();
        if ($data) {
            if (!is_array($data)) {
	        $data = array($data);
	    }
	    foreach ($data as $obj) {
	        if ($type == 'TP_TYPE' || ($type == 'DRV_TYPE' && $obj->$type != 'NULL' && $obj->$type != 'FILE'))
		  $res[$obj->$idname] = (string) $obj->NAME;
	    }
        }
        natcasesort($res);
        return $res;
    }
	
	public function jsonGetAllNameIdTapeWithoutFileNullAction()
    {
        $res = $this->getAllNameId("TPID", "TP_LIST_ALL", "TP_LIST_ONE", "TP_TYPE");
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }
	
	public function jsonGetAllNameIdDriveWithoutFileNullAction()
    {
        $res = $this->getAllNameId("DRVID", "DRV_LIST_ALL", "DRV_LIST_ONE", "DRV_TYPE");
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }
}
