<?php
require_once 'ArkeiaAction.php';

class TapereindexController extends ArkeiaAction
{
	public function jsonReindexStartAction()
    {
    	$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;

      	$params = $this->_request->getPost();
		$val_select = array('SRC_DRVID', 'SRC_TPID', 'DO_EMAIL', 'UNLOAD', 'FROM_LAST_SEG', 'SRC_LIBID', 'SRC_SLOT', 'DEST_PLID', 'SRC_TPTYPE', 'CAPACITY');
	    $params = $this->_clean_select_POST($params, $val_select);
		unset($params['SUBMIT']);

		if (isset($params['KNOWN_TAPE'])) {
			unset($params['SRC_SLOT']);
			unset($params['SRC_LIBID']);
			unset($params['CAPACITY']);
			unset($params['DEST_PLID']);
			$params['SRC_TPTYPE'] = 'Montype';
		}
		else {
			unset($params['SRC_TPID']);
		}

		if (isset($params['KNOWN_TAPE']) && ($params['SRC_DRVID'] == '' || $params['SRC_TPID'] == '')) {
          $res = $this->_set_error_message($this->lang['tape_verification_start_error_DRV_TP_require']);
		  $result = Zend_Json::encode($res);
  	      $this->getResponse()->appendBody($result);
	      return;
	    }
		if (!isset($params['KNOWN_TAPE']) && ($params['SRC_DRVID'] == '' ||
			$params['DEST_PLID'] == '' || $params['SRC_TPTYPE'] == '')) {
			$res = $this->_set_error_message($this->lang['tape_reindex_start_error_tptype_plid_require']);
		  	$result = Zend_Json::encode($res);
  	      	$this->getResponse()->appendBody($result);
	      	return;
		}
		if ($params['SRC_TPTYPE'] == 'FILE' && $params['CAPACITY'] == '') {
			$res = $this->_set_error_message($this->lang['tape_reindex_start_error_capacity_require']);
		  	$result = Zend_Json::encode($res);
  	      	$this->getResponse()->appendBody($result);
	      	return;
		}
		if (isset($params['USE_LIB'])  && ($params['SRC_LIBID'] == '' || $params['SRC_SLOT'] == '')) {
			$res = $this->_set_error_message($this->lang['tape_reindex_start_error_libid_slot_require']);
		  	$result = Zend_Json::encode($res);
  	      	$this->getResponse()->appendBody($result);
	      	return;
		}
		
		if (!isset($params['KNOWN_TAPE']) && !isset($params['USE_LIB'])) {
			unset($params['SRC_LIBID']);
			unset($params['SRC_SLOT']);
		}
		
		unset($params['KNOWN_TAPE']);
		unset($params['USE_LIB']);

		//error_log("PARAMS:".Zend_Json::encode($params));

        $data = $model->startReindex($params, $this->view->context);
        error_log('jsonStartAction, data: '.Zend_Json::encode($data));
        $res = $this->_get_result($data, $this->view->context);

	    //error_log('jsonStartAction, res: '.Zend_Json::encode($res));
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
    }
	
	public function jsonShowreindexAction()
    {
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';

		//error_log("jsonShowReindexAction POST: ".Zend_Json::encode($this->_request->getPost()));
    
        if (!$params['PARAM2']) {
            $array_context = $this->view->context;
            list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
            if ($id) {
                list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
            }
	    //error_log("jsonShowReindexAction context: ".Zend_Json::encode($context));
	    if ($context)
	      list($params[APPLIANCE_GUID]) = $context[0]->APPLIANCE_GUID;
        }

        $this->view->showBackup = $params;

		$options = false;
		$screen = 'showreindex';
        $res = $this->displayFromScreenIni($screen, FALSE, $options);
        $this->_render_json_view($res);
        return;
    }
	
	public function TapeReindexHelpAction()
    {
        echo $this->view->render('tapereindex/help01.html');
    }
}
