<?php
require_once 'ArkeiaAction.php';

class TapeverificationController extends ArkeiaAction
{
	public function getCompNameId()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);

        if ($appid = $this->_request->getParam(APPLIANCE_GUID)) {
            $context = $this->_get_filtered_context($appid, $this->view->context);
        } else {
            $context = $this->view->context;
        }
		$tpid = $this->_request->getParam(TPID);
		if ($tpid == '') return null;
        $res = $model->gettpcomp($tpid, $context);
        if (!is_array($res)) $res = array($res);
        foreach ($res as $key => $val) {
            if ($context) {
                $data = $res[$key]->param3->item;
            } else {
                $data = $res[$key]->param2->item;
            }
            if ($data) break ; 
        }
        $res = array();
        if ($data) {
            if (is_array($data)) {
                foreach ($data as $obj) {
                    $res[$obj->DRVID] = (string) $obj->NAME;
                }
            } else {
                    $res[$data->DRVID] = (string) $data->NAME;
            }
        }
        natcasesort($res);
        return $res;
    }
	
	public function jsonGetCompAction()
    {
   	 	$res = $this->getCompNameId();
        require_once 'Zend/Json.php';
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }
	
	public function jsonVerifStartAction()
    {
    	$ctrlcfg = $this->_getCtrlCfg();
	    $model = $this->_getModel($ctrlcfg);
      	$idname = $ctrlcfg->id;

      	$params = $this->_request->getPost();
		$val_select = array('SRC_DRVID', 'SRC_TPID', 'DO_EMAIL', 'UNLOAD', 'FROM_LAST_SEG');
	    $params = $this->_clean_select_POST($params, $val_select);
		unset($params['SUBMIT']);
		
		if ($params['SRC_DRVID'] == '' || $params['SRC_TPID'] == '') {
          $res = $this->_set_error_message($this->lang['tape_verification_start_error_DRV_TP_require']);
		  $result = Zend_Json::encode($res);
  	      $this->getResponse()->appendBody($result);
	      return;
	    }

        $data = $model->startVerif($params, $this->view->context);
        //error_log('jsonStartAction, data: '.Zend_Json::encode($data));
        $res = $this->_get_result($data, $this->view->context);

	    //error_log('jsonStartAction, res: '.Zend_Json::encode($res));
	    $result = Zend_Json::encode($res);
	    $this->getResponse()->appendBody($result);
	    return;
    }
	
	public function jsonShowverificationAction()
    {
        $params = $this->_request->getPost();
        require_once 'Zend/Json.php';

		//error_log("jsonShowVerificationAction POST: ".Zend_Json::encode($this->_request->getPost()));
    
        if (!$params['PARAM2']) {
            $array_context = $this->view->context;
            list($id, $context) = $this->_getIdContext($array_context, 'ID_PORT');
            if ($id) {
                list($params['PARAM2'], $params['PARAM3']) = split("_", $id, 2);
            }
	    //error_log("jsonShowVerificationAction context: ".Zend_Json::encode($context));
	    if ($context)
	      list($params[APPLIANCE_GUID]) = $context[0]->APPLIANCE_GUID;
        }

        $this->view->showBackup = $params;

		$options = false;
		$screen = 'showverification';
        $res = $this->displayFromScreenIni($screen, FALSE, $options);
        $this->_render_json_view($res);
        return;
    }
	
	public function TapeVerificationHelpAction()
    {
        echo $this->view->render('tapeverification/help01.html');
    }
}
