<?php

require_once 'ArkeiaAction.php';

class UserController extends ArkeiaAction
{
    public function summaryAction()
	{
	    if ($this->view->context) {
            $this->displayFromScreenIni('summary_multisite');
		} else {
            $this->displayFromScreenIni('summary');
		}
    }

    public function addAction()
    {
        $this->displayFromScreenIni('add');
    }

    public function updatepassAction()
    {
        $info = $this->_getOne();
        $res = $this->displayFromScreenIni('updatepass', FALSE);
        $this->_render_json_view($res);
        return;
    }

    public function jsonModifyObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);

        $params = $this->_request->getPost();

        $info_user = $model->getOne($params[$idname])->item;

        require_once 'Zend/Json.php';
        if (isset($params['NEW_PASSWORD']) && $params['NEW_PASSWORD'] != $params['COMFIRM_PASSWORD']) {
            $res = $this->_set_error_message($this->lang['user_create_error_password_no_match']);
        } else if (isset($params['NEW_PASSWORD']) 
            && !($info_user->PASSWORD == '' && $params['OLD_PASSWORD'] == '') 
            && $info_user->PASSWORD != crypt($params['OLD_PASSWORD'], substr($info_user->PASSWORD, 0, 2))) {
            $res = $this->_set_error_message($this->lang['user_modify_error_invalid_old_password']);
        } else { 
            if (isset($params['NEW_PASSWORD'])) {
                if (is_array($info_user->NODE))
                    $info_user->NODE = implode(" ", array_unique($info_user->NODE));
                if ($params['NEW_PASSWORD'] != '') {
                    $info_user->PASSWORD = crypt($params['NEW_PASSWORD'], "n3"); 
                } else {
                    $info_user->PASSWORD = $params['NEW_PASSWORD'];
                }
                $params = $info_user;
            } else {
                $params['NODE'] = $this->_get_NODE($params);
            }
            //error_log('modify user params : '. Zend_Json::encode($params));
            $data = $model->modifyObject($params, $context);

            $res = $this->_get_result($data, $context);
        }
      
        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    private function _get_NODE($params)
    {
        $NODE = array();
        foreach ($params as $key => $val)
            if (preg_match('/^NODE\_/', $key))
                $NODE[] = $val;
        $NODE = implode(" ", array_unique($NODE));
        return ($NODE);
    }

    public function jsonCreateObjectAction()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = $ctrlcfg->id;

        $params = $this->_request->getPost();

        require_once 'Zend/Json.php';
        //error_log('create user params : '. Zend_Json::encode($params) .' NAME "'.$params['NAME'].'"' );

        if (!isset($params['NAME']) || $params['NAME'] == '') {
            $res = $this->_set_error_message($this->lang['user_create_error_name_require']);
        } else if (!isset($params['PASSWORD'])/* || $params['PASSWORD'] == ''*/) {
            $res = $this->_set_error_message($this->lang['user_create_error_password_require']);
        } else if ($params['PASSWORD'] != $params['PASSWORD_COMFIRM']) {
            $res = $this->_set_error_message($this->lang['user_create_error_password_no_match']);
        } else {
            if ($params['PASSWORD'] != '')
                $params['PASSWORD'] = crypt($params['PASSWORD'], "n3"); 
            $params['NODE'] = $this->_get_NODE($params);
            //error_log('create user params : '. Zend_Json::encode($params));
            $data = $model->createObject($params, $this->view->context);
            //error_log('create user data : '. Zend_Json::encode($data));
            $res = $this->_get_result($data, $this->view->context);
        }

        $result = Zend_Json::encode($res);
        $this->getResponse()->appendBody($result);
        return;
    }

    public function jsonGetForComboboxAction()
    {
// USR_LIST_ALL ne retourne par de USERID
// on va donc utiliser le NAME qui est forcément une clé !!!
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $idname = 'NAME';

        $array_context = $this->view->context;

        $appid = $this->_request->getParam(APPLIANCE_GUID);
        $context = null;

        if ($appid && ($appid != "local")) {
            $context = $this->_get_filtered_context($appid, $array_context);
        } else if (!$appid){
            $context = $array_context;
	        $appid = "local";
        }

        $data = $this->_getResultAll($context);
        $res = $this->_get_result($data, $context);

	    $data = $res[$appid][PARAM2];
        $newres = array();
        if ($data) {
	        foreach ($data as $param) {
	            if (is_array($param->item)) {
	                foreach ($param->item as $obj) {
		                $newres[$obj->$idname] = $obj->NAME;
	                }
	            } else if ($param->item){
	                $newres[$param->item->$idname] = $param->item->NAME;
	            }
	        }
        }
	    $result = Zend_Json::encode($newres);
        $this->getResponse()->appendBody($result);
        return;
    }

    protected function _getOne()
    {
        $ctrlcfg = $this->_getCtrlCfg();
        $model = $this->_getModel($ctrlcfg);
        $array_context = $this->view->context;
        list($id, $context) = $this->_getIdContext($array_context);
        $data = $model->getOne($id, $context);
        if ($appidname = $this->view->appidname) {
            $data->item->$appidname = $this->view->appid_id;
            $data->item->APPID = $this->view->appid;
        }
        $arkobject = $ctrlcfg->object;
        $this->view->$arkobject = $data;
        return $data;
    }


}

?>
