<?php
/*
 * Created on July 11th 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkClient extends ArkObject {

    public function createObject($list=null, $context=null) {
	$trans = "ADMIN_ADD_CLIENT";
	$trans_version = 1;
	if (!$list) return null;
	$config = Zend_Registry::get('config');

	$vector = array(
	            "param0" => $list['NOM'],
	            "param1" => $list['CLIENTCNX'],
	            "param2" => $config->arkws->remote_port,
                "param3" => $list['PORT'],
                "param4" => $list['INETADDR'],
                "param5" => $list['VNAME'],
                "param6" => ''
                );

	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	return ($result);
    }

    public function modifyObject($list=null, $context=null) {
	$trans = "ADMIN_ADD_CLIENT";
	$trans_version = 1;
	if (!$list) return null;
	$config = Zend_Registry::get('config');

	$vector = array(
	            "param0" => $list['NOM'],
	            "param1" => 0,
	            "param2" => $config->arkws->remote_port,
                "param3" => $list['PORT'],
                "param4" => $list['INETADDR'],
                "param5" => $list['VNAME'],
                "param6" => $list['ID']
                );
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	return ($result);
    }

    public function getClientInfo($client, $context=null) {
	$trans = "ADMIN_GET_CLIENT_INFO";
	$trans_version = 1;
        $vector = array("param0" => $client);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function setClientInfo($client, $list, $context=null) {
	$trans = "ADMIN_SET_CLIENT_INFO";
	$trans_version = 1;
        $vector = array("param0" => $client, "param1" => $this->list2soap($list));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function getClientConfig($client, $context=null) {
	$trans = "ADMIN_GET_CLIENT_CONFIG";
	$trans_version = 1;
        $vector = array("param0" => $client);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function setClientConf($client, $list, $context=null) {
	$trans = "ADMIN_SET_CLIENT_CONFIG";
	$trans_version = 1;
        $vector = array("param0" => $client, "param1" => $this->list2soap($list));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function getPluginList($client, $context=null) {
	$trans = "ADMIN_GET_PLUGINLIST";
	$trans_version = 1;
        $vector = array("param0" => $client, "param1" => 1);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('getPluginList: '.Zend_Json::encode($result));
	return ($result);
    }

    public function getPluginConfig($client, $plugin, $context=null) {
	$trans = "ADMIN_GET_PLUGIN_CONFIG";
	$trans_version = 1;
        $vector = array("param0" => $client, "param1" => $plugin);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function setPluginConf($client, $plugin, $list, $context=null) {
	$trans = "ADMIN_SET_PLUGIN_CONFIG";
	$trans_version = 1;
        $vector = array("param0" => $client, "param1" => $plugin, "param2" => $this->list2soap($list));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function getWmiList($client, $num, $context=null) {
	$trans = "ADMIN_WMI_GET";
	$trans_version = 1;
        if ($num >= 0)
	  $vector = array("param0" => $client, "param1" => $num);
	else
	  $vector = array("param0" => $client);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('getWmiList: '.Zend_Json::encode($result));
	return ($result);
    }

    public function getNoBackupInfo($client, $reload, $context=null) {
	$trans = "ADMIN_GET_NOBACKUP_INFO";
	$trans_version = 1;
        if ($reload)
	  $vector = array("param0" => $client, "param1" => "1");
	else
	  $vector = array("param0" => $client);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('getNoBackupInfo: '.Zend_Json::encode($result));
	return ($result);
    }

    public function restartArkeiad($client, $context=null) {
        $trans = "ADMIN_RESTART_ARKEIAD";
	$trans_version = 1;
        $vector = array("param0" => $client);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('restartArkeiad: '.Zend_Json::encode($result));
	return ($result);
    }

    public function getClientCryptTree($client, $context=null) {
	$trans = "ADMIN_CRYPT_GET_CRYPTREE";
	$trans_version = 1;
        $vector = array("param0" => $client);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('getClientCryptTree: '.Zend_Json::encode($result));
	return ($result);
    }

    public function getClientCryptKeys($client, $cryptfilename, $context=null) {
	$trans = "ADMIN_CRYPT_VIEW_KEYS";
	$trans_version = 1;
        $vector = array("param0" => $client, "param1" => $cryptfilename);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('getClientViewCryptKeys: '.Zend_Json::encode($result));
	return ($result);
    }

    public function getOneClientCryptKeys($client, $cryptfilename, $context=null)
    {
        $result = $this->getClientCryptKeys($client, $cryptfilename, $context);
        if ($result == null) return null;
        if (is_array($result)) {
            foreach ($result as $key => $val) {
                if ($key == "local") continue;
                if ($context && $result[$key]->param0 == "0") continue;
                if ($context) {
                    $data = $result[$key]->param3;
                } else {
                    $data = $result[$key]->param2;
                }
                return $data;
            }
        } else {
            if ($context) {
                $data = $result->param3;
            } else {
                $data = $result->param2;
            }
            return $data;
        }
        return null;
    }

    public function addClientCryptKey($client, $list, $context=null) {
        $trans = "ADMIN_CRYPT_ADD";
        $trans_version = 1;
        $vector = array("param0" => $client, "param1" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('addClientCryptKey: '.Zend_Json::encode($result));
        return ($result);
    }

    public function updateClientCryptKey($client, $list, $context=null) {
        $trans = "ADMIN_CRYPT_MODIFY";
        $trans_version = 1;
        $vector = array("param0" => $client, "param1" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('updateClientCryptKey: '.Zend_Json::encode($result));
        return ($result);
    }

    public function removeClientCryptInfo($client, $list, $context=null) {
        $trans = "ADMIN_CRYPT_REMOVE";
        $trans_version = 1;
        $vector = array("param0" => $client, "param1" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('removeClientCryptInfo: '.Zend_Json::encode($result));
        return ($result);
    }

    public function delArkNoBackup($client, $list, $context=null) {
        $trans = "ADMIN_DEL_ARK_NOBACKUP";
	$trans_version = 1;
        $list_snd = array();
        foreach ($list as $name) {
	    array_push($list_snd, array('NAME' => $name));
	}
        $vector = array("param0" => $client, "param1" => $this->list2soap($list_snd));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('delArkNoBackup: '.Zend_Json::encode($result));
	return ($result);
    }

    public function delAbsoluteExclusion($client, $list, $context=null) {
        $trans = "ADMIN_REMOVE_ABSOLUTE_EXCLUSION";
        $trans_version = 1;
        $list_snd = array();
        foreach ($list as $name) {
	  array_push($list_snd, array('NAME' => $name));
	}
	$vector = array("param0" => $client, "param1" => $this->list2soap($list_snd));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	//DEBUG error_log('delAbsoluteExclusion: '.Zend_Json::encode($result));
	return ($result);
    }

    public function addArkNoBackup($client, $path, $context=null) {
        $trans = "ADMIN_CREATE_ARK_NOBACKUP";
        $trans_version = 1;
        $vector = array("param0" => $client, "param1" => $path);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('addArkNoBackup: '.Zend_Json::encode($result));
        return ($result);
    }

    public function addAbsoluteExclusion($client, $path, $context=null) {
        $trans = "ADMIN_CREATE_ABSOLUTE_EXCLUSION";
        $trans_version = 1;
        $vector = array("param0" => $client, "param1" => $path);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('addAbsoluteExclusion: '.Zend_Json::encode($result));
        return ($result);
    }

}
?>
