<?php
/*
 * Created on 10 Mar. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

function set_item_default($model, $data)
{  
	if (is_array($data->item)) {
		for ($i = 0; isset($data->item[$i]); $i++) {
			if (isset($data->item[$i]->DEFAULT)) {
				$data->item[$i]->DEFAULT = $model->lang['Yes'];
			}
		}
	}
	else {
		if (isset($data->item->DEFAULT)) {
			$data->item->DEFAULT = $model->lang['Yes'];
		}
	}
}

class ArkDrive extends ArkObject {

    public function createObject($list=null, $context=null) {
	$trans = "DRV_CREATE";
	$trans_version = 2;
	if (!$list) $vector = array();
	else $vector = array("param0" => $this->list2soap($list));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function listType($type=null, $context) {
	$trans = "DRV_LIST_TYPE";
	$trans_version = 2;
	if (!$type) $vector = array();
	else $vector = array("param0" => $type);

	/* Multi-site: use first appliance  */
	if (sizeof($context) > 1)
	  $context = array($context[0]);

	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	if ($result == null) return null;
	if ($context)
	  {
	    if (is_array($result))
	      {
		foreach ($result as $val)
		  {
		    $data = $val->param3->item;
		    if ($data)
		      break ;
		  }
	      }
	    else
	      $data = $result->param3->item;
	  }
	else
	  $data = $result->param2->item;

        if (!$data) return array();
        if (!is_array($data)) return array($data);
        return $data;
    }

    public function hasCart($id, $context) {
	$trans = "DRV_HASCART";
	$trans_version = 2;
	$vector = array("param0" => $id, "param1" => 1);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function readDrive($id, $context=null) {
	$trans = "DRV_READ";
	$trans_version = 2;
	$vector = array("param0" => $id, "param1" => 1);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function writeLabel($drvid, $tpid, $context=null) {
	$trans = "DRV_WRITE";
	$trans_version = 2;
	$vector = array("param0" => $drvid, "param1" => $tpid, "param2" => 1);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	return ($result);
    }

    public function removeObject($ids, $context=null) {
        if (!is_array($ids))
	  if ($context)
	    $ids = array($context[0][APPLIANCE_GUID].'_'.$ids);
	  else
	    $ids = array($ids);
	
	$list = array();
	foreach ($ids as $id)
	  if ($context)
	    array_push($list, array("APPID_ID" => $id));
	  else
	    array_push($list, array("DRVID" => $id));
	
	return $this->removeObjects($list, $context);
    }

    public function getResultOneWithDefault($id, $context=null)
    {
        $result = $this->getResultOneAndNDMP($id, $context);
        if ($result == null) return null;
        $this->lang = Zend_Registry::get('arkwui_lang');
        return $this->_transform_globals($result, $context, 'set_item_default');
    }

    public function autoDetect($id, $context=null)
    {
      $trans = "DRV_AUTODETECT";
      $trans_version = 1;
      $vector = array("param0" => $id, "param1" => 1);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
      return ($result);
    }

    public function getDrvLibAll($context=null)
    {
      $trans = "DRV_LIB_LIST_ALL";
      $trans_version = 2;
      $vector = array("param0" => 0);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
      return ($result);
    }

    public function is_ndmp($data) {

        $result = false;

        foreach($data as $val) {

            if(isset($val->NDMPID)) {

                $result = true;
                break;

            }

        }

        return $result;

    }

    public function getResultOneAndNDMP($id, $context=null) {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->getOne;
        $trans_version = $this->_mvc->model->{$this->_model}->getOneVersion;

        if (!$trans_version) $trans_version = 1;
        $vector = array("param0" => $id);
        $trans = $this->new_trans($trans, $trans_version, 1, $vector,$context);

        if($context) {

            if(!is_array($trans)) {

                if(is_object($trans) && !$trans->last) {

                    if  (
                            isset($trans->param2) && 
                            (
                                isset($trans->param2->NDMPID) || 
                                (is_array($trans->param2) && $this->is_ndmp($trans->param2))
                            )
                        ) {

                        if(isset($trans->param2->NDMPID)) {

                            $vector = array("param0" => $trans->param2->NDMPID);
                            $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                            $trans->param2->NDMPNAME = $subtrans->param2->NAME . ' (NDMP)';
                            $trans->param2->MEDIA_SERVER = $subtrans->param2->NAME . ' (NDMP)';

                        } else {

                            foreach($trans->param2 as $num=>$val) {

                                $vector = array("param0" => $trans->param2[$num]->NDMPID);
                                $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                                $trans->param2[$num]->NDMPNAME = $subtrans->param2[$num]->NAME . ' (NDMP)';
                                $trans->param2[$num]->MEDIA_SERVER = $subtrans->param2[$num]->NAME . ' (NDMP)';

                            }

                        }

                    } else {

                        if  (
                                isset($trans->param3) && 
                                (
                                    isset($trans->param3->NDMPID) || 
                                    (is_array($trans->param3) && $this->is_ndmp($trans->param3))
                                )
                            ) {

                            if(isset($trans->param3->NDMPID)) {

                                $vector = array("param0" => $trans->param3->NDMPID);
                                $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                                $trans->param3->NDMPNAME = $subtrans->param3->NAME . ' (NDMP)';
                                $trans->param3->MEDIA_SERVER = $subtrans->param3->NAME . ' (NDMP)';

                            } else {

                                foreach($trans->param3 as $num=>$val) {

                                    $vector = array("param0" => $trans->param3[$num]->NDMPID);
                                    $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                                    $trans->param3[$num]->NDMPNAME = $subtrans->param3[$num]->NAME . ' (NDMP)';
                                    $trans->param3[$num]->MEDIA_SERVER = $subtrans->param3[$num]->NAME . ' (NDMP)';

                                }

                            }

                        }

                    }

                }

                //echo 'BUG: ' . gettype($trans);
                //print_r($trans);

            } else {

                if(isset($trans['list1']) && isset($trans['list1']->param3->item->NDMPID)) {

                    $vector = array("param0" => $trans['list1']->param3->item->NDMPID);
                    $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                    $trans['list1']->param3->item->NDMPNAME = $subtrans['list1']->param3->NAME . ' (NDMP)';
                    $trans['list1']->param3->item->MEDIA_SERVER = $subtrans['list1']->param3->NAME . ' (NDMP)';

                } else {

                if(isset($trans['list1']) && is_array($trans['list1']->param3->item)) {

                        $default = (object)array();

                        foreach($trans['list1']->param3->item as $num=>$value) {

                            if(isset($value->NDMPID)) {

                                $vector = array("param0" => $trans['list1']->param3->item[$num]->NDMPID);
                                $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                                $trans['list1']->param3->item[$num]->NDMPNAME = $subtrans['list1']->param3->NAME . ' (NDMP)';
                                $trans['list1']->param3->item[$num]->MEDIA_SERVER = $subtrans['list1']->param3->NAME . ' (NDMP)';

                            }

                            if(isset($value->DEFAULT)) {

                                $default = $trans['list1']->param3->item[$num];

                            }

                        }

                    }

                }

            }

        } else {

            if(isset($trans->param2->item->NDMPID)) {

                $vector = array("param0" => $trans->param2->item->NDMPID);
                $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                $trans->param2->item->NDMPNAME = $subtrans->param2->NAME . ' (NDMP)';
                $trans->param2->item->MEDIA_SERVER = $subtrans->param2->NAME . ' (NDMP)';

            } else {

                if(is_array($trans->param2->item)) {

                    $default = (object)array();

                    foreach($trans->param2->item as $num=>$value) {

                        if(isset($value->NDMPID)) {

                            $vector = array("param0" => $trans->param2->item[$num]->NDMPID);
                            $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                            $trans->param2->item[$num]->NDMPNAME = $subtrans->param2->NAME . ' (NDMP)';
                            $trans->param2->item[$num]->MEDIA_SERVER = $subtrans->param2->NAME . ' (NDMP)';

                        }

                        if(isset($value->DEFAULT)) {

                            $default = $trans->param2->item[$num];

                        }

                    }

                }

            }

        }

        return $trans;
    }

	public function _getAllMediaserversAndNDMP($param0=3, $context=null) {

        if($context && count($context) > 1) {

            return NULL;

        }

        $trans = "ADMIN_GET_HOSTLIST";
        $trans_version = 1;
        $vector = array("param0" => $param0);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        $trans = "NDMP_LIST_ALL";
        $trans_version = 2;
        $vector = array("param0" => $param0);
        $resultbis = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        if($context) {

            $ctparam = 'param3';
            $list = 'list1';

            //on a du ndmp!
            if(count($resultbis[$list]->{$ctparam}->item) > 0) {

                //on a du media server!
                if(isset($result[$list]) && count($result[$list]->{$ctparam}->item) > 0) {

                    //un seul ndmp pas très pratique ce bug...
                    if(isset($resultbis[$list]->{$ctparam}->item->NAME)) {

                        //et un seul media server, vraiment pas pratique
                        if(isset($result[$list]->{$ctparam}->item->NAME)) {

                            $tmp = $result[$list]->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result[$list]->{$ctparam}->item = array();
                            array_push($result[$list]->{$ctparam}->item, $tmp);
                            $resultbis[$list]->{$ctparam}->item->SID = 'NDMP:'.$resultbis[$list]->{$ctparam}->item->NDMPID;
                            unset($resultbis[$list]->{$ctparam}->item->NDMPID);
                            $resultbis[$list]->{$ctparam}->item->NAME .= ' (NDMP)';
                            array_push($result[$list]->{$ctparam}->item, $resultbis[$list]->{$ctparam}->item);

                        } else {

                            foreach($result[$list]->{$ctparam}->item as $num=>$var) {
                                $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;
                            }

                            $resultbis[$list]->{$ctparam}->item->SID = 'NDMP:'.$resultbis[$list]->{$ctparam}->item->NDMPID;
                            unset($resultbis[$list]->{$ctparam}->item->NDMPID);
                            $resultbis[$list]->{$ctparam}->item->NAME .= ' (NDMP)';

                            array_push($result[$list]->{$ctparam}->item, $resultbis[$list]->{$ctparam}->item);

                        }

                    } else {

                        //plusieurs ndmp et un seul media server, étrange mais pourquoi pas
                        if(isset($result[$list]->{$ctparam}->item->NAME)) {

                            $tmp = $result[$list]->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result[$list]->{$ctparam}->item = array();
                            array_push($result[$list]->{$ctparam}->item, $tmp);
                                
                            foreach($result[$list]->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result[$list]->{$ctparam}->item, $var);

                            }

                        } else {

                            foreach($result[$list]->{$ctparam}->item as $num=>$var) {

                                $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;

                            }

                            foreach($resultbis[$list]->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result[$list]->{$ctparam}->item, $var);

                            }

                        }

                    }

                } else {

                    //pas de media server et vu qu'on a un ndmp autant remplacer le résultat
                    $result[$list] = $resultbis->{$numlist};

                    //un seul
                    if(isset($result[$list]->{$ctparam}->item->NAME)) {

                        $result[$list]->{$ctparam}->item->SID = 'NDMP'.$result[$list]->{$ctparam}->item->NDMPID;
                        unset($result[$list]->{$ctparam}->item->NDMPID);
                        $result[$list]->{$ctparam}->item->NAME .= ' (NDMP)';

                    } else {

                        //plusieurs
                        foreach($result[$list]->{$ctparam}->item as $num=>$var) {

                            $result[$list]->{$ctparam}->item[$num]->SID = 'NDMP:'.$result[$list]->{$ctparam}->item[$num]->NDMPID;
                            unset($result[$list]->{$ctparam}->item[$num]->NDMPID);
                            $result[$list]->{$ctparam}->item[$num]->NAME .= ' (NDMP)';

                        }

                    }

                }

            }

        } else {
        
            $ctparam = 'param2';

            //on a du ndmp!
            if(count($resultbis->{$ctparam}->item) > 0) {

                //on a du media server!
                if(count($result->{$ctparam}->item) > 0) {

                    //un seul ndmp pas très pratique ce bug...
                    if(isset($resultbis->{$ctparam}->item->NAME)) {

                        //et un seul media server, vraiment pas pratique
                        if(isset($result->{$ctparam}->item->NAME)) {

                            $tmp = $result->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result->{$ctparam}->item = array();
                            array_push($result->{$ctparam}->item, $tmp);
                            $resultbis->{$ctparam}->item->SID = 'NDMP:'.$resultbis->{$ctparam}->item->NDMPID;
                            unset($resultbis->{$ctparam}->item->NDMPID);
                            $resultbis->{$ctparam}->item->NAME .= ' (NDMP)';
                            array_push($result->{$ctparam}->item, $resultbis->{$ctparam}->item);

                        } else {

                            foreach($result->{$ctparam}->item as $num=>$var) {
                                $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;
                            }

                            $resultbis->{$ctparam}->item->SID = 'NDMP:'.$resultbis->{$ctparam}->item->NDMPID;
                            unset($resultbis->{$ctparam}->item->NDMPID);
                            $resultbis->{$ctparam}->item->NAME .= ' (NDMP)';

                            array_push($result->{$ctparam}->item, $resultbis->{$ctparam}->item);

                        }

                    } else {

                        //plusieurs ndmp et un seul media server, étrange mais pourquoi pas
                        if(isset($result->{$ctparam}->item->NAME)) {

                            $tmp = $result->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result->{$ctparam}->item = array();
                            array_push($result->{$ctparam}->item, $tmp);
                            
                            foreach($resultbis->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result->{$ctparam}->item, $var);

                            }

                        } else {

                            foreach($result->{$ctparam}->item as $num=>$var) {

                                $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;

                            }

                            foreach($resultbis->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result->{$ctparam}->item, $var);

                            }

                        }

                    }

                } else {

                    //pas de media server et vu qu'on a un ndmp autant remplacer le résultat
                    $result = $resultbis;

                    //un seul
                    if(isset($result->{$ctparam}->item->NAME)) {

                        $result->{$ctparam}->item->SID = 'NDMP'.$result->{$ctparam}->item->NDMPID;
                        unset($result->{$ctparam}->item->NDMPID);
                        $result->{$ctparam}->item->NAME .= ' (NDMP)';

                    } else {


                        //plusieurs
                        foreach($result->{$ctparam}->item as $num=>$var) {

                            $result->{$ctparam}->item[$num]->SID = 'NDMP:'.$result->{$ctparam}->item[$num]->NDMPID;
                            unset($result->{$ctparam}->item[$num]->NDMPID);
                            $result->{$ctparam}->item[$num]->NAME .= ' (NDMP)';

                        }

                    }

                }

            }

        }

		return $result;
    }

    public function _getAllNDMP($context) {

        $trans = "NDMP_LIST_ALL";
        $trans_version = 2;
        $vector = array("param0" => $param0);
        return $this->new_trans($trans, $trans_version, 1, $vector, $context);

    }

    public function getOneAndNDMP($id, $context=null)
    {
        $result = $this->getResultOneAndNDMP($id, $context);
        if ($result == null) return null;
        if (is_array($result)) {
            foreach ($result as $key => $val) {
                if ($key == "local") continue;
                if ($context && $result[$key]->param0 == "0") continue;
                if ($context) {
                    $data = $result[$key]->param3;
                } else {
                    $data = $result[$key]->param2;
                }
                return $data;
            }
        } else {
            if ($context) {
                $data = $result->param3;
            } else {
                $data = $result->param2;
            }
            return $data;
        }
        return null;
    }

}
?>
