<?php
/*
 * Created on 25 Apr. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkLdap extends ArkObject {

    public function search($param0, $context=null) {
        if (!$param0) {
	    $dn= "";
	    $filter = "*";
	} else {
	    $dn = $param0["dn"];
	    $filter = $param0["filter"];
	}

	$trans = "LDAP_SEARCH";
	$trans_version = 1;
	$vector = array("param0" => $dn, "param1" => $filter);
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if ($result == null) return null;
        $data = $result->param2;
	if (!$data) return array();
        if (!is_array($data)) return array($data);
	return $data;
    }

    public function multiplelist2soap($orig_list) {
        $mylist = array();
        if ($orig_list) {
            foreach ($orig_list as $key => $val) {
                if (is_array($val)) {
                    $i = 0;
		    foreach ($val as $a_key => $a_val) {
			$mylist[$key][$i++] = $a_val;
		   }
                } else {
                    $mylist[$key] =  $val;
                }
            }
        }
        return new SoapVar($mylist, SOAP_ENC_OBJECT, "xsd:list");
    }


	public function addappliance($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}
		require_once 'Zend/Json.php';
		$list = Zend_Json::decode($param0["params"]);
		$soaplist = $this->multiplelist2soap($list);
		$trans = "LDAP_ADD_APPLIANCE";
		$trans_version = 1;
		$vector = array("param0" => $dn, "param1" => $soaplist);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		return ($result);
	}
	
	public function deleteappliance($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}

		$trans = "LDAP_DELETE_APPLIANCE";
		$trans_version = 1;
		$vector = array("param0" => $dn);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		return ($result);
	}
	
	public function adduser($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}
		require_once 'Zend/Json.php';
		$list = Zend_Json::decode($param0["params"]);
		$soaplist = $this->multiplelist2soap($list);
		$trans = "LDAP_ADD_USER";
		$trans_version = 1;
		$vector = array("param0" => $dn, "param1" => $soaplist);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		return ($result);
	}
	
	public function modifyattributes($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}
		require_once 'Zend/Json.php';
		$list = Zend_Json::decode($param0["params"]);
		$soaplist = $this->multiplelist2soap($list);
		$trans = "LDAP_MODIFY_ATTRIBUTES";
		$trans_version = 1;
		$vector = array("param0" => $dn, "param1" => $soaplist);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		return ($result);
	}
	
	public function deleteuser($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}

		$trans = "LDAP_DELETE_USER";
		$trans_version = 1;
		$vector = array("param0" => $dn);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		return ($result);
	}
	
	public function getattributes($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}

		$trans = "LDAP_GET_ATTRIBUTES";
		$trans_version = 1;
		$vector = array("param0" => $dn);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		$data = $result->param2;
		return $data;
	}
	
	public function setcontext($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $base_dn = $param0["base_dn"];
		    $filter = $param0["filter"];
		    $scope = $param0["scope"];
		}

		$trans = "LDAP_GET_CONTEXT_LIST";
		$trans_version = 1;
		$vector = array("param0" => $base_dn, "param1" => $filter, "param2" => (int)$scope);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return $result;
	}

	public function connectappliance($param0, $context=null) {
		if (!$param0) {
		    return null;
		} else {
		    $dn = $param0["dn"];
		}
		$trans = "LDAP_GET_APPLIANCE_INFO";
		$trans_version = 1;
		$vector = array("param0" => $dn);
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		if ($result == null) return null;
		return ($result);
	}
}
?>
