<?php
/*
 * Created on 12 Oct. 2007
 *
 * @author Quentin Labadens
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkLibrary extends ArkObject {
  
    public function setTapes($id, $list, $context=null) {
      $trans = "LIB_SET_TAPE";
      $trans_version = 2;
      $list['LIBID'] = $id;
      $vector = array("param0" => $this->list2soap($list));
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('setTapes: '.Zend_Json::encode($result));

      return ($result);
    }

    public function cleanDrive($id, $drvid, $context=null) {
      $trans = "DRV_CLEAN_DRIVE";
      $trans_version = 1;
      $vector = array("param0" => $id, "param1" => $drvid);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('cleanDrive: '.Zend_Json::encode($result));

      return ($result);
    }

    public function unmountDrive($id, $drvid, $context=null) {
      $trans = "LIB_UNMOUNT_DRIVE";
      $trans_version = 2;
      $vector = array("param0" => $drvid, "param1" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('unmountDrive: '.Zend_Json::encode($result));

      return ($result);
    }

    public function mountDrive($id, $list, $context=null) {
      $trans = "LIB_MOUNT_DRIVE";
      $trans_version = 2;
      $vector = array("param0" => $list['DRVID'], "param1" => $list['DRV_NUM'], "param2" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('mountDrive: '.Zend_Json::encode($result));

      return ($result);
    }

    public function loadTape($id, $list, $context=null) {
      $trans = "LIB_LOAD";
      $trans_version = 1;
      $vector = array("param0" => (int) hexdec($id), "param1" => (int) $list['DRV_NUM'], "param2" => (int) $list['SLOT']);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('loadTape: '.Zend_Json::encode($result));

      return ($result);
    }

    public function unloadTape($id, $list, $context=null) {
      $trans = "LIB_UNLOAD";
      $trans_version = 1;
      $vector = array("param0" => (int) hexdec($id), "param1" => (int) $list['DRV_NUM'], "param2" => (int) $list['SLOT']);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('unloadTape: '.Zend_Json::encode($result));

      return ($result);
    }

    public function exportTape($id, $list, $context=null) {
      $trans = "LIB_EXPORT";
      $trans_version = 1;
      $vector = array("param0" => (int) hexdec($id), "param1" => (int) $list['IOE_NUM'], "param2" => (int) $list['SLOT']);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('exportTape: '.Zend_Json::encode($result));

      return ($result);
    }

    public function importTape($id, $list, $context=null) {
      $trans = "LIB_IMPORT";
      $trans_version = 1;
      $vector = array("param0" => (int) hexdec($id), "param1" => (int) $list['IOE_NUM'], "param2" => (int) $list['SLOT']);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('importTape: '.Zend_Json::encode($result));

      return ($result);
    }

    public function unsetTapes($id, $list, $context=null) {
      $trans = "LIB_UNSET_TAPE";
      $trans_version = 2;
      $list['LIBID'] = $id;
      $vector = array("param0" => $this->list2soap($list));
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('unsetTapes: '.Zend_Json::encode($result));

      return ($result);
    }

    public function setStatus($id, $list, $context=null) {
      $trans = "LIB_MODIFY";
      $trans_version = 2;
      $list['LIBID'] = $id;
      $vector = array("param0" => $this->list2soap($list));
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
      return ($result);
    }

    public function writeLabel($id, $list, $context=null) {
      $trans = "LIB_WRITE_LABEL";
      $trans_version = 2;
      $list['LIBID'] = $id;
      $vector = array("param0" => $this->list2soap($list));
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('writeLabel: '.Zend_Json::encode($result));

      return ($result);
    }

    public function libListDrive($id, $context=null) {
      $trans = "LIB_LIST_DRIVE";
      $trans_version = 2;
      $vector = array("param0" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('libListDrive: '.Zend_Json::encode($result));

      return ($result);
    }

    public function libCompTape($id, $context=null) {
      $trans = "LIB_COMP_TAPE";
      $trans_version = 2;
      $vector = array("param0" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('libCompTape: '.Zend_Json::encode($result));

      return ($result);
    }

    public function libCompDrive($id, $context=null) {
      $trans = "LIB_COMP_DRV";
      $trans_version = 2;
      $vector = array("param0" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	
      error_log('libCompDrive: '.Zend_Json::encode($result));

      return ($result);
    }

    public function libPing($id, $context=null) {
      $trans = "LIB_PING";
      $trans_version = 2;
      $vector = array("param0" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

      error_log('libPing: '.Zend_Json::encode($result));

      return ($result);
    }

    public function start($id, $context=null) {
      $trans = "LIB_START";
      $trans_version = 2;
      $vector = array("param0" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

      error_log('libStart: '.Zend_Json::encode($result));

      return ($result);
    }

    public function stop($id, $context=null) {
      $trans = "LIB_STOP";
      $trans_version = 2;
      $vector = array("param0" => $id);
      $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

      error_log('libStop: '.Zend_Json::encode($result));

      return ($result);
    }

    public function listFormFactor($context) {
        $trans = "DRV_LIST_FORM_FACTORS";
        $trans_version = 2;
        $vector = array();

	require_once 'Zend/Json.php';
	//error_log('listType context: '.Zend_Json::encode($context));

	/* Multi-site: use first appliance  */
	if (sizeof($context) > 1)
	  $context = array($context[0]);

	//error_log('listType context: '.Zend_Json::encode($context));

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	//error_log('listType result: '.Zend_Json::encode($result));
 
        if ($result == null) return null;
	if ($context)
	  {
	    if (is_array($result))
	      {
		foreach ($result as $val)
		  {
		    $data = $val->param3->item;
		    if ($data)
		      break ;
		  }
	      }
	    else
	      $data = $result->param3->item;
	  }
	else
	  $data = $result->param2->item;

	//error_log('listType data: '.Zend_Json::encode($data));

        if (!$data) return array();
        if (!is_array($data)) return array($data);

        return $data;
    }

    public function listType($context) {
        $trans = "LIB_LIST_TYPE";
        $trans_version = 2;
        $vector = array();

	require_once 'Zend/Json.php';
	//error_log('listType context: '.Zend_Json::encode($context));

	/* Multi-site: use first appliance  */
	if (sizeof($context) > 1)
	  $context = array($context[0]);

	//error_log('listType context: '.Zend_Json::encode($context));

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	//error_log('listType result: '.Zend_Json::encode($result));
 
        if ($result == null) return null;
	if ($context)
	  {
	    if (is_array($result))
	      {
		foreach ($result as $val)
		  {
		    $data = $val->param3->item;
		    if ($data)
		      break ;
		  }
	      }
	    else
	      $data = $result->param3->item;
	  }
	else
	  $data = $result->param2->item;

	//error_log('listType data: '.Zend_Json::encode($data));

        if (!$data) return array();
        if (!is_array($data)) return array($data);

        return $data;
    }

    public function createObject($list, $context=null) {
        $trans = "LIB_CREATE";
        $trans_version = 2;
	$vector = array("param0" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function modifyObject($list, $context=null) {
        $trans = "LIB_MODIFY";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function removeObject($id, $context=null) {
        $trans = "LIB_REMOVE";
        $trans_version = 2;
        $vector = array("param0" => $id);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
    }

    public function getResultOneAndNDMP($id, $context=null)
    {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->getOne;
        $trans_version = $this->_mvc->model->{$this->_model}->getOneVersion;

        if (!$trans_version) $trans_version = 1;
        $vector = array("param0" => $id);
        $trans = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        if(is_array($trans)) {

            foreach($trans as $num=>$val) {

                if ($num == "local") continue;
                if ($context && $trans[$num]->param0 == "0") continue;
                if ($context) {
                    if(isset($trans[$num]->param3->NDMPID)) {
                        $vector = array("param0" => $trans[$num]->param3->NDMPID);
                        $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                        $trans[$num]->param3->ARKLIB_NODE = $subtrans[$num]->param3->NAME . ' (NDMP)';
                    }
                } else {
                    if(isset($trans[$num]->param2->NDMPID)) {
                        $vector = array("param0" => $trans[$num]->param2->NDMPID);
                        $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                        $trans[$num]->param2->ARKLIB_NODE = $subtrans->param2->NAME . ' (NDMP)';
                    }
                }

            }

        } else {

            if($context) {
                if(isset($trans->param3->NDMPID)) {
                    $vector = array("param0" => $trans->param3->NDMPID);
                    $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                    $trans->param3->ARKLIB_NODE = $subtrans->param3->NAME . ' (NDMP)';
                }
            } else {
                if(isset($trans->param2->NDMPID)) {
                    $vector = array("param0" => $trans->param2->NDMPID);
                    $subtrans = $this->new_trans('NDMP_LIST_ONE', 2, 1, $vector, $context);
                    $trans->param2->ARKLIB_NODE = $subtrans->param2->NAME . ' (NDMP)';
                }
            }

        }

        return $trans;
    }

    public function getOneAndNDMP($id, $context=null)
    {
        $result = $this->getResultOneAndNDMP($id, $context);
        if ($result == null) return null;
        if (is_array($result)) {
            foreach ($result as $key => $val) {
                if ($key == "local") continue;
                if ($context && $result[$key]->param0 == "0") continue;
                if ($context) {
                    if(isset($result[$key]->param3)) {
                        $data = $result[$key]->param3;
                    }
                } else {
                    if(isset($result[$key]->param2)) {
                        $data = $result[$key]->param2;
                    }
                }
                if(isset($data)) {
                    return $data;
                }
            }
        } else {
            if ($context) {
                $data = $result->param3;
            } else {
                $data = $result->param2;
            }
            return $data;
        }
        return null;
    }

	public function _getAllMediaserversAndNDMP($param0=3, $context=null) {

        if($context && count($context) > 1) {

            return NULL;

        }

        $trans = "ADMIN_GET_HOSTLIST";
        $trans_version = 1;
        $vector = array("param0" => $param0);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        $trans = "NDMP_LIST_ALL";
        $trans_version = 2;
        $vector = array("param0" => $param0);
        $resultbis = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        if($context) {

            $ctparam = 'param3';
            $list = 'list1';

            //on a du ndmp!
            if(count($resultbis[$list]->{$ctparam}->item) > 0) {

                //on a du media server!
                if(isset($result[$list]) && count($result[$list]->{$ctparam}->item) > 0) {

                    //un seul ndmp pas très pratique ce bug...
                    if(isset($resultbis[$list]->{$ctparam}->item->NAME)) {

                        //et un seul media server, vraiment pas pratique
                        if(isset($result[$list]->{$ctparam}->item->NAME)) {

                            $tmp = $result[$list]->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result[$list]->{$ctparam}->item = array();
                            array_push($result[$list]->{$ctparam}->item, $tmp);
                            $resultbis[$list]->{$ctparam}->item->SID = 'NDMP:'.$resultbis[$list]->{$ctparam}->item->NDMPID;
                            unset($resultbis[$list]->{$ctparam}->item->NDMPID);
                            $resultbis[$list]->{$ctparam}->item->NAME .= ' (NDMP)';
                            array_push($result[$list]->{$ctparam}->item, $resultbis[$list]->{$ctparam}->item);

                        } else {

                            foreach($result[$list]->{$ctparam}->item as $num=>$var) {
                                $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;
                            }

                            $resultbis[$list]->{$ctparam}->item->SID = 'NDMP:'.$resultbis[$list]->{$ctparam}->item->NDMPID;
                            unset($resultbis[$list]->{$ctparam}->item->NDMPID);
                            $resultbis[$list]->{$ctparam}->item->NAME .= ' (NDMP)';

                            array_push($result[$list]->{$ctparam}->item, $resultbis[$list]->{$ctparam}->item);

                        }

                    } else {

                        //plusieurs ndmp et un seul media server, étrange mais pourquoi pas
                        if(isset($result[$list]->{$ctparam}->item->NAME)) {

                            $tmp = $result[$list]->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result[$list]->{$ctparam}->item = array();
                            array_push($result[$list]->{$ctparam}->item, $tmp);
                                
                            foreach($result[$list]->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result[$list]->{$ctparam}->item, $var);

                            }

                        } else {

                            foreach($result[$list]->{$ctparam}->item as $num=>$var) {

                                $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;

                            }

                            foreach($resultbis[$list]->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result[$list]->{$ctparam}->item, $var);

                            }

                        }

                    }

                } else {

                    //pas de media server et vu qu'on a un ndmp autant remplacer le résultat
                    $result[$list] = $resultbis->{$numlist};

                    //un seul
                    if(isset($result[$list]->{$ctparam}->item->NAME)) {

                        $result[$list]->{$ctparam}->item->SID = 'NDMP'.$result[$list]->{$ctparam}->item->NDMPID;
                        unset($result[$list]->{$ctparam}->item->NDMPID);
                        $result[$list]->{$ctparam}->item->NAME .= ' (NDMP)';

                    } else {

                        //plusieurs
                        foreach($result[$list]->{$ctparam}->item as $num=>$var) {

                            $result[$list]->{$ctparam}->item[$num]->SID = 'NDMP:'.$result[$list]->{$ctparam}->item[$num]->NDMPID;
                            unset($result[$list]->{$ctparam}->item[$num]->NDMPID);
                            $result[$list]->{$ctparam}->item[$num]->NAME .= ' (NDMP)';

                        }

                    }

                }

            }

        } else {
        
            $ctparam = 'param2';

            //on a du ndmp!
            if(count($resultbis->{$ctparam}->item) > 0) {

                //on a du media server!
                if(count($result->{$ctparam}->item) > 0) {

                    //un seul ndmp pas très pratique ce bug...
                    if(isset($resultbis->{$ctparam}->item->NAME)) {

                        //et un seul media server, vraiment pas pratique
                        if(isset($result->{$ctparam}->item->NAME)) {

                            $tmp = $result->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result->{$ctparam}->item = array();
                            array_push($result->{$ctparam}->item, $tmp);
                            $resultbis->{$ctparam}->item->SID = 'NDMP:'.$resultbis->{$ctparam}->item->NDMPID;
                            unset($resultbis->{$ctparam}->item->NDMPID);
                            $resultbis->{$ctparam}->item->NAME .= ' (NDMP)';
                            array_push($result->{$ctparam}->item, $resultbis->{$ctparam}->item);

                        } else {

                            foreach($result->{$ctparam}->item as $num=>$var) {
                                $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;
                            }

                            $resultbis->{$ctparam}->item->SID = 'NDMP:'.$resultbis->{$ctparam}->item->NDMPID;
                            unset($resultbis->{$ctparam}->item->NDMPID);
                            $resultbis->{$ctparam}->item->NAME .= ' (NDMP)';

                            array_push($result->{$ctparam}->item, $resultbis->{$ctparam}->item);

                        }

                    } else {

                        //plusieurs ndmp et un seul media server, étrange mais pourquoi pas
                        if(isset($result->{$ctparam}->item->NAME)) {

                            $tmp = $result->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result->{$ctparam}->item = array();
                            array_push($result->{$ctparam}->item, $tmp);
                            
                            foreach($resultbis->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result->{$ctparam}->item, $var);

                            }

                        } else {

                            foreach($result->{$ctparam}->item as $num=>$var) {

                                $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;

                            }

                            foreach($resultbis->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result->{$ctparam}->item, $var);

                            }

                        }

                    }

                } else {

                    //pas de media server et vu qu'on a un ndmp autant remplacer le résultat
                    $result = $resultbis;

                    //un seul
                    if(isset($result->{$ctparam}->item->NAME)) {

                        $result->{$ctparam}->item->SID = 'NDMP'.$result->{$ctparam}->item->NDMPID;
                        unset($result->{$ctparam}->item->NDMPID);
                        $result->{$ctparam}->item->NAME .= ' (NDMP)';

                    } else {


                        //plusieurs
                        foreach($result->{$ctparam}->item as $num=>$var) {

                            $result->{$ctparam}->item[$num]->SID = 'NDMP:'.$result->{$ctparam}->item[$num]->NDMPID;
                            unset($result->{$ctparam}->item[$num]->NDMPID);
                            $result->{$ctparam}->item[$num]->NAME .= ' (NDMP)';

                        }

                    }

                }

            }

        }

		return $result;
    }

    public function _getAllNDMP($context) {

        $trans = "NDMP_LIST_ALL";
        $trans_version = 2;
        $vector = array("param0" => $param0);
        return $this->new_trans($trans, $trans_version, 1, $vector, $context);

    }

}

?>
