<?php
/*
 * Created on 29 Apr. 2007
 *
 * @author Quentin Labadens
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

function set_lic_disp_info($model, $list)
{
    $list->LICENSE_ORGANISATION = $list->LICENSE.'@'.$list->ORGANISATION;
    if (!isset($list->APPID_LICENSE))
        $list->APPID_LICENSE_ORGANISATION = 'local_'.$list->LICENSE_ORGANISATION;
    else 
        $list->APPID_LICENSE_ORGANISATION = $list->APPID_LICENSE.'@'.$list->ORGANISATION;
    if (!empty($list->EXPIRY)) {
        $list->DISP_EXPIRY = date("Y/m/d",$list->EXPIRY);
    } else {
        $list->DISP_EXPIRY = $model->lang['lic_expiry_never'];
    }
    if (!empty($list->INST_DATE)) {
        $list->DISP_INST_DATE = date("Y/m/d",$list->INST_DATE);
    }
    if (preg_match("/^ARK[0-9][0-9]$/", $list->LICENSE) ||
        preg_match("/^ARKEDGEFORT[0-9]$/", $list->LICENSE)) {
        $list->DISP_FLOW1 = $list->FLOW1;
        $list->DISP_FLOW2 = $list->FLOW2;
        $list->DISP_FLOW3 = $list->FLOW3;
        $list->DISP_FLOW4 = $list->FLOW4;
        $list->DISP_DRIVE = $list->DRIVE;
        if (!empty($list->OPTION)) {
            $option = (int)$list->OPTION;
            $list->DISP_COMPRESSION = 
                (1 & $option)?$model->lang['Yes']:$model->lang['No'];
            $list->DISP_ENCRYPTION = 
                (2 & $option)?$model->lang['Yes']:$model->lang['No'];
            $list->DISP_MULTIFLOW = 
                (4 & $option)?$model->lang['Yes']:$model->lang['No'];
            $list->DISP_PERIODIC = 
                (16 & $option)?$model->lang['Yes']:$model->lang['No'];

        }
    } else if ("ARK_VTL" == $list->LICENSE) {
	switch((int)$list->FLOW3) {
	case 1:
	    $list->DISP_SIZE = $list->FLOW1*1024+$list->FLOW2." KB";
	    break;
	case 2:
	    $list->DISP_SIZE = $list->FLOW1*1024+$list->FLOW2." MB";
	    break;
	case 3:
	    $list->DISP_SIZE = $list->FLOW1*1024+$list->FLOW2." GB";
	    break;
	case 4:
	    $list->DISP_SIZE = $list->FLOW1*1024+$list->FLOW2." TB";
	    break;
	case 5:
	    $list->DISP_SIZE = $list->FLOW1*1024+$list->FLOW2." PB";
	    break;
	default:
	    $list->DISP_SIZE = "$list->FLOW1 KB";
	    break;
	}
    } else {
        if (!empty($list->OPTION) && (64 & (int)$list->OPTION)) {
            if ("ARKDR" == $list->LICENSE) {
                $list->DISP_RECO_CLI = $list->FLOW1;
                $list->DISP_RECO_SERV = $list->FLOW2;
            } else {
                $list->DISP_FLOW1 = $list->FLOW1;
                $list->DISP_FLOW2 = $list->FLOW2;
                $list->DISP_FLOW3 = $list->FLOW3;
            }
        } else {
            $list->DISP_NUMBER = $list->FLOW1;
        }
    }
	return $list;
}

class ArkLicense extends ArkObject {

    public function getResultOne($id, $context=null) {
	  if (!$this->_mvc || !$this->_model) return null;
	  $trans = $this->_mvc->model->{$this->_model}->getOne;
	  $trans_version = $this->_mvc->model->{$this->_model}->getOneVersion;
	  list($LICENSE, $ORGANISATION) = split('@', $id, 2);
	  if (!$trans_version) $trans_version = 1;
	  $vector = array("param0" => $LICENSE, "param1" => $ORGANISATION);
	  $result =  $this->new_trans($trans, $trans_version, 1, $vector,$context);
	  if ($result == null) return null;
	  $this->lang = Zend_Registry::get('arkwui_lang');
	  return $this->_transform_globals($result, $context, 'set_lic_disp_info');
    }

    public function modifyObject($list=null, $context=null) {
        return ($this->createObject($list, $context));
    }

    public function createObject($list=null, $context=null) {
	$trans = "LICENSE_PUT";
	$trans_version = 1;
	if (!$list) $vector = array();
	else $vector = array("param0" => $this->list2soap($list));
	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	return ($result);
    }

    public function removeObject($id, $context=null)
    {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->removeObject;
        $trans_version = $this->_mvc->model->{$this->_model}->removeObjectVersion;
	list($LICENSE, $ORGANISATION) = split('@', $id, 2);
        if (!$trans_version) $trans_version= 1;
        $vector = array("param0" => $LICENSE, "param1" => $ORGANISATION);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
    }

}
?>
