<?php
/*
 * Created on 27 Apr. 2007
 *
 * @author Quentin Labadens
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

function set_item_no_mediaservers($model, &$data)
{
    if (empty($data->item)) {
        return ;
    }
	if (!is_array($data->item)) {
		$data->item = array($data->item);
    }
	for ($i = 0; isset($data->item[$i]); $i++) {
		if (isset($data->item[$i]->IS_MEDIA_SERVER)) {
			array_splice($data->item, $i, 1);
			$i--;
		}
	}
}

class ArkMediaserver extends ArkObject {

	public function getResultAll($context=null) {
		return $this->getAllMediaservers(3, $context);
	}

	public function getAllMediaservers($param0=3, $context=null) {
        $trans = "ADMIN_GET_HOSTLIST";
        $trans_version = 1;
        $vector = array("param0" => $param0);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return $result;
    }

	public function getAllMediaserversAndNDMP($param0=3, $context=null) {

        if($context && count($context) > 1) {

            return NULL;

        }

        $trans = "ADMIN_GET_HOSTLIST";
        $trans_version = 1;
        $vector = array("param0" => $param0);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        $trans = "NDMP_LIST_ALL";
        $trans_version = 2;
        $vector = array("param0" => $param0);
        $resultbis = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        if($context) {

            $ctparam = 'param3';
            $list = 'list1';

            //on a du ndmp!
            if(count($resultbis[$list]->{$ctparam}->item) > 0) {

                //on a du media server!
                if(isset($result[$list]) && count($result[$list]->{$ctparam}->item) > 0) {

                    //un seul ndmp pas très pratique ce bug...
                    if(isset($resultbis[$list]->{$ctparam}->item->NAME)) {

                        //et un seul media server, vraiment pas pratique
                        if(isset($result[$list]->{$ctparam}->item->NAME)) {

                            $tmp = $result[$list]->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result[$list]->{$ctparam}->item = array();
                            array_push($result[$list]->{$ctparam}->item, $tmp);
                            $resultbis[$list]->{$ctparam}->item->SID = 'NDMP:'.$resultbis[$list]->{$ctparam}->item->NDMPID;
                            unset($resultbis[$list]->{$ctparam}->item->NDMPID);
                            $resultbis[$list]->{$ctparam}->item->NAME .= ' (NDMP)';
                            array_push($result[$list]->{$ctparam}->item, $resultbis[$list]->{$ctparam}->item);

                        } else {

                            foreach($result[$list]->{$ctparam}->item as $num=>$var) {
                                $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;
                            }

                            $resultbis[$list]->{$ctparam}->item->SID = 'NDMP:'.$resultbis[$list]->{$ctparam}->item->NDMPID;
                            unset($resultbis[$list]->{$ctparam}->item->NDMPID);
                            $resultbis[$list]->{$ctparam}->item->NAME .= ' (NDMP)';

                            array_push($result[$list]->{$ctparam}->item, $resultbis[$list]->{$ctparam}->item);

                        }

                    } else {

                        //plusieurs ndmp et un seul media server, étrange mais pourquoi pas
                        if(isset($result[$list]->{$ctparam}->item->NAME)) {

                            $tmp = $result[$list]->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result[$list]->{$ctparam}->item = array();
                            array_push($result[$list]->{$ctparam}->item, $tmp);
                                
                            foreach($result[$list]->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result[$list]->{$ctparam}->item, $var);

                            }

                        } else {

                            foreach($result[$list]->{$ctparam}->item as $num=>$var) {

                                $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;

                            }

                            foreach($resultbis[$list]->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result[$list]->{$ctparam}->item, $var);

                            }

                        }

                    }

                } else {

                    //pas de media server et vu qu'on a un ndmp autant remplacer le résultat
                    $result[$list] = $resultbis->{$numlist};

                    //un seul
                    if(isset($result[$list]->{$ctparam}->item->NAME)) {

                        $result[$list]->{$ctparam}->item->SID = 'NDMP'.$result[$list]->{$ctparam}->item->NDMPID;
                        unset($result[$list]->{$ctparam}->item->NDMPID);
                        $result[$list]->{$ctparam}->item->NAME .= ' (NDMP)';

                    } else {

                        //plusieurs
                        foreach($result[$list]->{$ctparam}->item as $num=>$var) {

                            $result[$list]->{$ctparam}->item[$num]->SID = 'NDMP:'.$result[$list]->{$ctparam}->item[$num]->NDMPID;
                            unset($result[$list]->{$ctparam}->item[$num]->NDMPID);
                            $result[$list]->{$ctparam}->item[$num]->NAME .= ' (NDMP)';

                        }

                    }

                }

            } else {

                //on a du media server!
                if(isset($result[$list]) && count($result[$list]->{$ctparam}->item) > 0) {

                    //un seul media server, vraiment pas pratique
                    if(isset($result[$list]->{$ctparam}->item->NAME)) {

                        $result[$list]->{$ctparam}->item->SID = 'MS:'.$result[$list]->{$ctparam}->item->NAME;

                    } else {

                        foreach($result[$list]->{$ctparam}->item as $num=>$var) {
                            $result[$list]->{$ctparam}->item[$num]->SID = 'MS:'.$result[$list]->{$ctparam}->item[$num]->NAME;
                        }

                    }

                }

            }

        } else {
        
            $ctparam = 'param2';

            //on a du ndmp!
            if(count($resultbis->{$ctparam}->item) > 0) {

                //on a du media server!
                if(count($result->{$ctparam}->item) > 0) {

                    //un seul ndmp pas très pratique ce bug...
                    if(isset($resultbis->{$ctparam}->item->NAME)) {

                        //et un seul media server, vraiment pas pratique
                        if(isset($result->{$ctparam}->item->NAME)) {

                            $tmp = $result->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result->{$ctparam}->item = array();
                            array_push($result->{$ctparam}->item, $tmp);
                            $resultbis->{$ctparam}->item->SID = 'NDMP:'.$resultbis->{$ctparam}->item->NDMPID;
                            unset($resultbis->{$ctparam}->item->NDMPID);
                            $resultbis->{$ctparam}->item->NAME .= ' (NDMP)';
                            array_push($result->{$ctparam}->item, $resultbis->{$ctparam}->item);

                        } else {

                            foreach($result->{$ctparam}->item as $num=>$var) {
                                $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;
                            }

                            $resultbis->{$ctparam}->item->SID = 'NDMP:'.$resultbis->{$ctparam}->item->NDMPID;
                            unset($resultbis->{$ctparam}->item->NDMPID);
                            $resultbis->{$ctparam}->item->NAME .= ' (NDMP)';

                            array_push($result->{$ctparam}->item, $resultbis->{$ctparam}->item);

                        }

                    } else {

                        //plusieurs ndmp et un seul media server, étrange mais pourquoi pas
                        if(isset($result->{$ctparam}->item->NAME)) {

                            $tmp = $result->{$ctparam}->item;
                            $tmp->SID = 'MS:'.$tmp->NAME;
                            $result->{$ctparam}->item = array();
                            array_push($result->{$ctparam}->item, $tmp);
                            
                            foreach($resultbis->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result->{$ctparam}->item, $var);

                            }

                        } else {

                            foreach($result->{$ctparam}->item as $num=>$var) {

                                $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;

                            }

                            foreach($resultbis->{$ctparam}->item as $var) {

                                $var->SID = 'NDMP:'.$var->NDMPID;
                                unset($var->NDMPID);
                                $var->NAME .= ' (NDMP)';
                                array_push($result->{$ctparam}->item, $var);

                            }

                        }

                    }

                } else {

                    //pas de media server et vu qu'on a un ndmp autant remplacer le résultat
                    $result = $resultbis;

                    //un seul
                    if(isset($result->{$ctparam}->item->NAME)) {

                        $result->{$ctparam}->item->SID = 'NDMP'.$result->{$ctparam}->item->NDMPID;
                        unset($result->{$ctparam}->item->NDMPID);
                        $result->{$ctparam}->item->NAME .= ' (NDMP)';

                    } else {


                        //plusieurs
                        foreach($result->{$ctparam}->item as $num=>$var) {

                            $result->{$ctparam}->item[$num]->SID = 'NDMP:'.$result->{$ctparam}->item[$num]->NDMPID;
                            unset($result->{$ctparam}->item[$num]->NDMPID);
                            $result->{$ctparam}->item[$num]->NAME .= ' (NDMP)';

                        }

                    }

                }

            } else {

                //on a du media server!
                if(count($result->{$ctparam}->item) > 0) {

                    //et un seul media server, vraiment pas pratique
                    if(isset($result->{$ctparam}->item->NAME)) {

                        $result->{$ctparam}->item->SID = 'MS:'.$result->{$ctparam}->item->NAME;

                    } else {

                        foreach($result->{$ctparam}->item as $num=>$var) {
                            $result->{$ctparam}->item[$num]->SID = 'MS:'.$result->{$ctparam}->item[$num]->NAME;
                        }

                    }

                }

            }

        }

		return $result;
    }

	public function getAllNoMediaservers($context=null) {
        $result = $this->getAllMediaservers(0);
		return $this->_transform_globals($result, $context, 'set_item_no_mediaservers');
    }
	
	public function setMediaserver($id) {
        $trans = "ADMIN_SET_MEDIA_SERVER";
        $trans_version = 1;
        $vector = array("param0" => $id);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return $result;
    }
	
	public function unsetMediaserver($id) {
        $trans = "ADMIN_UNSET_MEDIA_SERVER";
        $trans_version = 1;
        $vector = array("param0" => $id);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return $result;
    }
}
?>
