<?php
/*
 * Created on 07 May 2007
 *
 * @author Quentin Labadens
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkNavigator extends ArkObject {

    public function listBase($context=null) {

        $trans = "LIST_REP_DATABASES";
        $trans_version = 2;
        $vector = array();
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        return $result;

    }

    public function listRegexp($reg, $start_path, $list, $context = null) {
        $trans = "NAV_LIST_REGEXP";
	$trans_version = 2;
	$vector = array("param0" => $reg, "param1" => $start_path, "param2" => $this->list2soap($list));

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param3'] = $_COOKIE['base'];

        }

	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	//$result = $this->getNext($transnum = $result['local']->transnum, $sessnum = $result['local']->sessnum);
	return $result;
    }

    public function listOne($path, $list, $context = null) {
        $trans = "CPT_LIST_ONE";
	$trans_version = 2;
	$vector = array("param0" => $path, "param1" => $this->list2soap($list));

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param2'] = $_COOKIE['base'];

        }

	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        //DEBUG error_log('Nav listOne result: '.Zend_Json::encode($result));
	return $result;
    }

    public function listDir($type, $pathname, $plist, $exclude, $context = null) {
        $trans = "ARKNAV_LIST";
	$trans_version = 1;
        if ($exclude == 'excludedir')
	  $vector = array("param0" => (integer) $type, "param1" => $pathname, "param2" => $this->list2soap($plist), 'param3' => '1');
	else
	  $vector = array("param0" => (integer) $type, "param1" => $pathname, "param2" => $this->list2soap($plist));

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param'.(count($vector)+1)] = $_COOKIE['base'];

        }

	$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	require_once 'Zend/Json.php';
	/* for success start navigator message */
	if (isset($result->last) && !$result->last)
	  {
	    sleep(1);
	    $result = $this->getNext($result->transnum, $result->sessnum, $context);
	  }
	while ($result->param0 == '12' && $result->param1 == '2')
	  {
	    sleep(1);
	    $result = $this->getNext($result->transnum, $result->sessnum, $context);
	  }
	//DEBUG error_log('listDir : '.Zend_json::encode($result));
        return ($result);
    }

    public function refresh_tree($type, $list, $plist, $context = null) {

        $trans = "ARKNAV_WUI_REFRESH_TREE";
        $trans_version = 2;
        $vector = array("param0" => (integer) $type, "param1" => $this->list2soap($list), "param2" => $this->list2soap($plist));

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param'.(count($vector)+1)] = $_COOKIE['base'];

        }

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        return $result;

    }

}
?>
