<?php

require_once 'ArkObject.php'; 

function set_item_display_noindex($model, $data)
{
    if (isset($data->NOINDEX) && $data->NOINDEX == '1') {
	$data->DISPLAY_NOINDEX = $model->lang['ndmp_info_direct_access_disable'];
    }
    else {
	$data->DISPLAY_NOINDEX = $model->lang['ndmp_info_direct_access_allow'];
    }
    
    if (empty($data->item)) {
        $data->item = array();
    } elseif (!is_array($data->item)) {
	$data->item = array($data->item);
    }
   
	if (is_array($data->item)) {
		for ($i = 0; isset($data->item[$i]); $i++) {
			if (isset($data->item[$i]->NOINDEX) && $data->item[$i]->NOINDEX == '1') {
				$data->item[$i]->DISPLAY_NOINDEX = $model->lang['ndmp_info_direct_access_disable'];
				unset($data->item[$i]->NOINDEX);
			}
			else {
				$data->item[$i]->DISPLAY_NOINDEX = $model->lang['ndmp_info_direct_access_allow'];
			}
		}
	}
	else {
		if (isset($data->item->NOINDEX) && $data->item->NOINDEX == '1') {
			$data->item->DISPLAY_NOINDEX = $model->lang['ndmp_info_direct_access_disable'];
			unset($data->item->NOINDEX);
		}
		else {
			$data->item->DISPLAY_NOINDEX = $model->lang['ndmp_info_direct_access_allow'];
		}
	}
   
	foreach ($data as $key => $val){
		if (!strncmp($key, 'var_env_', 8)) {
			$tmpElem = new stdClass;
			$tmpElem->NAME = substr($key, 8);
			$tmpElem->VALUE = $val;
			unset($data->$key);
			$data->item[] = $tmpElem;
		}
	}
}

class ArkNdmpSavepack extends ArkObject 
{
    public function getResultOne($id, $context=null)
    {
        $result = parent::getResultOne($id, $context);
        if ($result == null) return null;
        $this->lang = Zend_Registry::get('arkwui_lang');
        return $this->_transform_globals($result, $context, 'set_item_display_noindex');
    }
	
	public function getResultTrees($id, $context=null)
    {
        $result = parent::getResultOne($id, $context);
        return $result;
    }
	
	public function addObject($param, $context=null) {
		$trans = "NDMP_SK_CREATE";
		$trans_version = 2;
		$vector = array("param0" => $this->list2soap($param));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}
	
	public function removeObject($id, $context=null) {
		$trans = "NDMP_SK_REMOVE";
		$trans_version = 2;
		$tmpElem = new stdClass;
		$tmpElem->item = array();
		$tmpElem->item['NDMPSKID'] = $id;
		$vector = array("param0" => $this->list2soap($tmpElem));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}
	
	public function modifyObject($param, $context=null) {
		$trans = "NDMP_SK_MODIFY";
		$trans_version = 2;
		$vector = array("param0" => $this->list2soap($param));
		$result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
		return ($result);
	}
}
?>