<?php
/*
 * Created on 14 Jun. 2007
 *
 * @author Quentin Labadens
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkRestoration extends ArkObject {

    public function startRestore($list, $context=null)
    {
        $trans = 'ARKRST_START';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($list));

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param1'] = $_COOKIE['base'];

        }

error_log('ARKRST_START vector: '.Zend_Json::encode($vector));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
error_log('ARKRST_START result: '.Zend_Json::encode($result));
        return $result;
    }

    public function analyze($list, $context=null)
    {
        $trans = 'ARKRST_ANALYZE';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($list));

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param1'] = $_COOKIE['base'];

        }

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
    }

    public function listFiles($list, $context=null)
    {
        $trans = 'ARKRST_LIST_FILES';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($list),
                        "param1" => 1);
        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param2'] = $_COOKIE['base'];

        }
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if ($result == null) return null;
        if (is_array($result)) {
            foreach ($result as $key => $val) {
                if ($key == "local") continue;
                if ($context) {
                    $result[$key]->param3 = $result[$key]->param4;
                    unset($result[$key]->param4);
                } else {
                    $result[$key]->param2 = $result[$key]->param3;
                    unset($result[$key]->param3);
                }
            }
        } else {
            if ($context) {
                $result->param3 = $result->param4;
            } else {
                $result->param2 = $result->param3;
            }
        }
        return $result;
    }


    public function startVerify($list, $typeVerif, $context=null)
    {
        $trans = 'ARKRST_START_VERIFY';
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($list), "param1" => $typeVerif);

        if      (
                        isset($_COOKIE['base']) && $_COOKIE['base'] != 'thisisafake' &&
                        isset($_COOKIE['subaction']) && $_COOKIE['subaction'] == 'restoration/summary'
                ) {

                $vector['param2'] = $_COOKIE['base'];

        }

        error_log('ARKRST_START_VERIFY vector: '.Zend_Json::encode($vector));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        error_log('ARKRST_START_VERIFY result: '.Zend_Json::encode($result));
        return $result;
    }
}
?>
