<?php
/*
 * Created on 10 Mar. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkScheduler extends ArkObject {

    public function getResultAll($context=null)
    {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->getAll;
        $trans_version = $this->_mvc->model->{$this->_model}->getAllVersion;
        if (!$trans_version) $trans_version= 1;
        $snd_all = 1;

        $vector = array("param0" => $snd_all);
        $result = $this->new_trans($trans, $trans_version, 2, $vector, $context);

        /* wait data, because data received was change by controller */
        while ($result->param0 == '12' && $result->param1 == '2') {
            sleep(1);
            $result = $this->getNext($result->transnum, $result->sessnum, $context);
        }

        return $result;
    }

    public function listcalendar($month, $context=null) {
       $trans = 'PER_SCHEDULE';
        $trans_version = 1;
        $vector = array('param0' => 'ALL', 'param1'=>$month);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function createFullObject($level1, $level2, $level3, $context=null) 
    {
       $trans = "PER_CREATE_FULL";
        $trans_version = 1;
        $vector = array("param0" => $this->list2soap($level1));
        if ($level2)
            $vector["param1"] = $this->list2soap($level2);
        if ($level3)
            $vector["param2"] = $this->list2soap($level3);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function createObject($list, $context=null) 
    {
        $trans = "PER_CREATE";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function modifyObject($list1, $context=null) 
    {
        $trans = "PER_MODIFY";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($list1));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function removeObjects($id, $context=null, $level) 
    {
        $trans_version = 2;
        if ($level == 0) {
            $trans = "PER_REMOVE";
            $vector = array("param0" => $id);
        } else {
            $trans = "PER_REMOVE_LEVEL";
            $vector = array("param0" => $id, "param1" => $level);
        }
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
      }

    public function removeObject($id, $context=null)
    {
        list($id, $appid, $level) = split("@", $id, 3);
        //$list = array("item"=>array("PRID" => $id));
        return $this->removeObjects($id, $context, $level);
    }

    public function addlevelObject($id, $context=null)
    {
        list($idx, $appid, $level) = split("@", $id, 3);
        $id = "$idx@$appid@0";
        $result = $this->getResultOne($id, $context, false);
        if ($context) {
            if ($result->param3) {
                $tParamsData = &$result->param3;
            } else {
                foreach ($result as $key => $val)
                if ($result[$key]->param3)
                    $tParamsData = &$result[$key]->param3;
            }
        } else {
            $tParamsData = &$result->param2;
        }

        $numlevel = $tParamsData->NB_LEVEL;
        $oNewLevel = new StdClass();
    
        $oNewLevel->LVAL_UNITS = "DAYS";
        $oNewLevel->LVAL_NBU = "30";
        $oNewLevel->NB_FLOWS = "0";
        $oNewLevel->LNEW_TP = "COMPLETE_EXIST";
        $oNewLevel->L_BASE_NAME = "";
        $oNewLevel->LTYPE = "TOTAL";
        $oNewLevel->START_DATE = date('Ymd\THis', mktime());
        $oNewLevel->RRULE = "D1 *0";
        $oNewLevel->NB_LEVEL = $numlevel + 1;
        $oNewLevel->LEVEL = $numlevel + 1;
        $oNewLevel->NAME = $tParamsData->NAME;
        $oNewLevel->PRID = $idx;

        $trans = "PER_MODIFY";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($oNewLevel));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function getResultOne($id, $context=null, $needExplode=true) 
    {
        if (!$this->_mvc || !$this->_model) return null;
        $trans = $this->_mvc->model->{$this->_model}->getOne;
        $trans_version = $this->_mvc->model->{$this->_model}->getOneVersion;

        if (!$trans_version) $trans_version= 1;
        list($id, $appid, $level) = split("@", $id, 3);
        $vector = array("param0" => $id, "param1" => $level);
// c'est parti on execture la transaction
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        if ($context) {
            if ($result->param3) {
                $tParamsData = &$result->param3;
            } else {
                foreach ($result as $key => $val)
                    if ($result[$key]->param3)
                        $tParamsData = &$result[$key]->param3;
            }
        } else
            $tParamsData = &$result->param2;

        $tParamsData->PRID = $tParamsData->PRID . '@' . $appid . '@' . (int)$tParamsData->LEVEL;
        $tParamsData->APPID_PRID = $appid.'_'.$tParamsData->PRID;
// On explose les resultat car certaine variable contiennent plusieurs données !!!
// hum.
        if ($needExplode)
            $tParamsData = $this->explodeInfo($tParamsData, $level);
        return $result;
    }

    public function cnvDate($date)
    {
        return (str_replace('-', '', $date));
    }

    public function cnvTime($time)
    {
        return (substr(str_replace(':', '', $time), 0, 6));
    }
   
    public function explodeInfo($params, $level)
    {
// SUBNAME est utilisé pour le menuaction
        $params->SUBNAME = $params->NAME;
        $ilevel = (int)$level;
        if ($ilevel > 0) {
            $params->SUBNAME = $params->NAME . '/Level ' . $ilevel;
            $params->RRULE_JRSMO = '0';
            $params->RRULE_JRSTU = '0';
            $params->RRULE_JRSWE = '0';
            $params->RRULE_JRSTH = '0';
            $params->RRULE_JRSFR = '0';
            $params->RRULE_JRSSA = '0';
            $params->RRULE_JRSSU = '0';
            $params->RRULE_M_MORE = '0';
            $params->RRULE_M_FSTR = 10;
            $params->RRULE_M_FEND = 10;
            $params->RRULE_M_NUMWEEK = 3;
            $params->RRULE_M_JRSWEEK = 'WE';
            $params->RRULE_Y_MORE = '0';
            $params->RRULE_Y_FSTR = 10;
            $params->RRULE_Y_FEND = 10;
            $params->RRULE_Y_NUMMONTH = 5;
            $params->RRULE_Y_NUMDAY = 15;

            $tmp = $params->RRULE;
            $pattern = '/([A-Z]*)(\d*) (?:([^\*].*) )?((\*)(\d*)|((\d\d\d\d)(\d\d)(\d\d)T(\d\d)(\d\d)(\d\d)))/i';
            if (preg_match($pattern, $tmp, $matches)) {

                error_log(Zend_Json::encode($matches));

                switch($matches[1]) {
                case 'D':
                    $params->RRULE_PER = 'D';
                    $params->RRULE_EVR = $matches[2];
                    $params->RRULE_JRSWE = '1';
                    break;

                case 'W':
                    $params->RRULE_PER = 'W';
                    $params->RRULE_EVR = $matches[2];
                    $tJrs = explode(' ', trim($matches[3]));
                    for ($w = 0 ; $w < count($tJrs) ; $w++) {
                        $jvar = "RRULE_JRS" . $tJrs[$w];
                        $params->$jvar = '1';
                    }
                    break;

                case 'MD':
                    $params->RRULE_PER = 'M';
                    $params->RRULE_EVR = $matches[2];
                    if ($matches[3] > 0) {
                        $params->RRULE_M_MORE = '0';
                        $params->RRULE_M_FSTR = $matches[3];
                    } else {
                        $params->RRULE_M_MORE = '1';
                        $params->RRULE_M_FEND = -$matches[3];
                    }
                    $params->RRULE_JRSWE = '1';
                    break;

                case 'MP':
                    $params->RRULE_M_MORE = '2';
                    $params->RRULE_PER = 'M';
                    $params->RRULE_EVR = $matches[2];
                    $tInfo = explode(' ', trim($matches[3]));
                    $params->RRULE_M_NUMWEEK = $tInfo[0];
                    $params->RRULE_M_JRSWEEK = $tInfo[1];
                    $params->RRULE_JRSWE = '1';
                    break;

                case 'YD':
                    $params->RRULE_PER = 'Y';
                    $params->RRULE_EVR = $matches[2];
                    if ($matches[3] > 0) {
                        $params->RRULE_Y_MORE = '0';
                        $params->RRULE_Y_FSTR = $matches[3];
                        $params->RRULE_Y_FEND = 10;
                    } else {
                        $params->RRULE_Y_MORE = '1';
                        $params->RRULE_Y_FSTR = 10;
                        $params->RRULE_Y_FEND = -$matches[3];
                    }
                    $params->RRULE_JRSWE = '1';
                    break;

                case 'YM':
                    $params->RRULE_Y_MORE = '2';
                    $params->RRULE_PER = 'Y';
                    $params->RRULE_EVR = $matches[2];
                    $tInfo = explode(' ', trim($matches[3]));
                    $params->RRULE_Y_NUMMONTH = $tInfo[0];
                    $params->RRULE_Y_NUMDAY = $tInfo[1];
                    $params->RRULE_JRSWE = '1';
                    break;
                }
        
                if ($matches[5] == '*') {
                    if ($matches[6] == '0') {
                        $params->LAST_NBBKP = '1';
                        $params->LAST_MORE = '2';
                        $params->LAST_DATE = date('Y-m-d',  mktime());
                    } else {
                        $params->LAST_NBBKP = $matches[6];
                        $params->LAST_MORE = '1';
                        $params->LAST_DATE = date('Y-m-d',  mktime());
                    }
                } else {
                    $params->LAST_MORE = '0';
                    $params->LAST_NBBKP = '0';
                    $params->LAST_DATE = $matches[8] . '-' . $matches[9] . '-' . $matches[10];
                }
        
            }

            $tmp = $params->START_DATE;
            // 20070523T151000
            $pattern = '/(\d\d\d\d)(\d\d)(\d\d)T(\d\d)(\d\d).*/i';
            if (preg_match($pattern, $tmp, $matches)) {
                $params->FORM_TIME = $matches[4] . ':' . $matches[5];
                $params->FORM_DATE = $matches[1] . '-' . $matches[2] . '-' . $matches[3];
            }
        
            // Recherche des adv_param_
            $params->TADVPARAM = array();
            foreach($params AS $key => $value) {
                if (substr($key, 0, 10) == "adv_param_")
                    $params->TADVPARAM[substr($key, 10, 1024)] = $value;
            }
        
            $params->CHAIN_FLAG = 'NOCHAIN';
            $tException = array();
            if (!is_array($params->item))
                $params->item = array($params->item);
            for($e = 0 ; $e < count($params->item) ; $e++) {
                if (isset($params->item[$e]->CMDAFT)) {
                    // On a un Chain disk-to-tape
                    $params->CHAIN_DELAY = $params->item[$e]->DELAY;
                    $params->CHAIN_SCHID = $params->item[$e]->SCHID;
                    $params->CHAIN_CMDAFT = $params->item[$e]->CMDAFT;
                    $params->CHAIN_FLAG = 'CHAIN';
		    if (isset($params->item[$e]->RET_TIME) &&
			isset($params->item[$e]->RET_TIME_UNIT)) {
			    $params->REP_SCH_RETENTION = 'on';
			    $params->CHAIN_RET_TIME = $params->item[$e]->RET_TIME;
			    $params->CHAIN_RET_TIME_UNIT = $params->item[$e]->RET_TIME_UNIT;
		    }
                } else if (isset($params->item[$e]->NAME)) {
                    // Sinon il s'agit d'une exception
                    $edate = $params->item[$e]->NAME;
                    $edate = substr($edate, 0, 4) . '-' . substr($edate, 4, 2) . '-' . substr($edate, 6, 2);
                    $tException[] = $edate;
                }
            }
            $params->TEXCEPTION = implode(',', $tException);
        }
        return ($params);
    }
    
    public function implodeInfo($params, $level)
    {
        switch($params->RRULE_PER) {
        case 'D':
            $part1 = 'D' . $params->RRULE_EVR;
            break;

        case 'W':
            $tJ = array();
            if ($params->RRULE_JRSMO == 'on') $tJ[] = 'MO';
            if ($params->RRULE_JRSTU == 'on') $tJ[] = 'TU';
            if ($params->RRULE_JRSWE == 'on') $tJ[] = 'WE';
            if ($params->RRULE_JRSTH == 'on') $tJ[] = 'TH';
            if ($params->RRULE_JRSFR == 'on') $tJ[] = 'FR';
            if ($params->RRULE_JRSSA == 'on') $tJ[] = 'SA';
            if ($params->RRULE_JRSSU == 'on') $tJ[] = 'SU';
            $part1 = trim('W' . $params->RRULE_EVR . ' ' . implode(' ', $tJ));
            break;

        case 'M':
            switch($params->RRULE_M_MORE) {
            case '0':
                $part1 = 'MD' . $params->RRULE_EVR . ' ' . $params->RRULE_M_FSTR;
                break;
            case '1':
                $part1 = 'MD' . $params->RRULE_EVR . ' -' . $params->RRULE_M_FEND;
                break;
            case '2':
                $part1 = 'MP' . $params->RRULE_EVR . ' ' . $params->RRULE_M_NUMWEEK . ' ' . $params->RRULE_M_JRSWEEK;
                break;
            }
            break;

        case 'Y':
            switch($params->RRULE_Y_MORE) {
            case '0':
                $part1 = 'YD' . $params->RRULE_EVR . ' ' . $params->RRULE_Y_FSTR;
                break;
            case '1':
                $part1 = 'YD' . $params->RRULE_EVR . ' -' . $params->RRULE_Y_FEND;
                break;
            case '2':
                $part1 = 'YM' . $params->RRULE_EVR . ' ' . $params->RRULE_Y_NUMMONTH . ' ' . $params->RRULE_Y_NUMDAY;
                break;
            }
            break;
        }

        switch($params->LAST_MORE) {
        case '0':
            $part2 = $this->cnvDate($params->LAST_DATE) . 'T000000';
            break;
        case '1':
            $part2 = '*' . $params->LAST_NBBKP;
            break;
        case '2':
            $part2 = '*0';
            break;
        }
        $params->RRULE = trim($part1) . ' ' . trim($part2);
        $params->START_DATE = $this->cnvDate($params->FORM_DATE) . 'T' . $this->cnvTime($params->FORM_TIME);

        // on supprime les adv params actuels
        foreach($params AS $key => $value) {
            if (substr($key, 0, 10) == "adv_param_")
                unset($params->$key);
        }
        // on recherche dans le post les nouveau adv params
        foreach($_POST as $key => $value) {
            if (substr($key, 0, 10) == "adv_param_")
                $params->$key = $value;
        }
    
        unset($params->SUBNAME);
        unset($params->TADVPARAM);
        unset($params->item);
        unset($params->RRULE_PER);
        unset($params->RRULE_EVR);
        unset($params->RRULE_JRSMO);
        unset($params->RRULE_JRSTU);
        unset($params->RRULE_JRSWE);
        unset($params->RRULE_JRSTH);
        unset($params->RRULE_JRSFR);
        unset($params->RRULE_JRSSA);
        unset($params->RRULE_JRSSU);
        unset($params->RRULE_M_MORE);
        unset($params->RRULE_M_FSTR);
        unset($params->RRULE_M_FEND);
        unset($params->RRULE_M_NUMWEEK);
        unset($params->RRULE_M_JRSWEEK);
        unset($params->RRULE_Y_MORE);
        unset($params->RRULE_Y_FSTR);
        unset($params->RRULE_Y_FEND);
        unset($params->RRULE_Y_NUMMONTH);
        unset($params->RRULE_Y_NUMDAY);
        unset($params->LAST_MORE);
        unset($params->LAST_DATE);
        unset($params->LAST_NBBKP);
        unset($params->FORM_TIME);
        unset($params->FORM_DATE);
        unset($params->TEXCEPTION);

        $params = (array)$params;
        if (isset($_POST['TEXCEPTION'])) {
            $exceptionList = $_POST['TEXCEPTION'];
            $tException = explode(',', $exceptionList);
            for ($e = 0 ; $e < count($tException) ; $e++) {
                $edate = $this->cnvDate($tException[$e]);
                if (!empty($edate))
                    array_push($params, array('NAME' => $edate));
            }
        }
    
        if ($params['CHAIN_FLAG'] == 'CHAIN') {
		if (isset($params['CHAIN_RET_TIME']) &&
		    isset($params['CHAIN_RET_TIME_UNIT'])) {
			$tChain = array(
				'DELAY' => (string)$params['CHAIN_DELAY'], 
				'SCHID' => (string)$params['CHAIN_SCHID'], 
				'CMDAFT' => (string)$params['CHAIN_CMDAFT'],
				'RET_TIME' => (string)$params['CHAIN_RET_TIME'],
				'RET_TIME_UNIT' => (string)$params['CHAIN_RET_TIME_UNIT']
				);
			array_push($params, $tChain);
		}
		else {
			$tChain = array(
				'DELAY' => (string)$params['CHAIN_DELAY'], 
				'SCHID' => (string)$params['CHAIN_SCHID'], 
				'CMDAFT' => (string)$params['CHAIN_CMDAFT']
				);
			array_push($params, $tChain);
		}
        }
    
        unset($params['CHAIN_DELAY']);
        unset($params['CHAIN_SCHID']);
        unset($params['CHAIN_CMDAFT']);
	unset($params['REP_SCH_RETENTION']);
	unset($params['CHAIN_RET_TIME']);
	unset($params['CHAIN_RET_TIME_UNIT']);
 
        return ($params);
    }
}
?>
