<?php
/*
 * Created on 10 Mar. 2007
 *
 * @author Arnaud Spicht
 * @copyright 2007 Arkeia Software
 */

require_once 'ArkObject.php'; 

class ArkTape extends ArkObject {

    public function createObject($list, $first=null, $last=null, $context=null) {
        $trans = "TP_CREATE";
        $trans_version = 2;
        if (!$first) $first=0;
        if (!$last) $last=0;
        if ($first == $last)
          $vector = array("param0" => $this->list2soap($list));
        else
          $vector = array("param0" => $this->list2soap($list), "param1" => $first, "param2" => $last);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function modifyObject($list1, $list2, $context=null) {
        $trans = "TP_MODIFY";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($list1), "param1" => $this->list2soap($list2));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return ($result);
    }

    public function removeObjects($list, $context=null) {
        $trans = "TP_REMOVE";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($list));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
    }

    public function removeObject($ids, $context=null) {
 	if (!is_array($ids))
	  if ($context)
	    $ids = array($context[0][APPLIANCE_GUID].'_'.$ids);
	  else
	    $ids = array($ids);

	$list = array();
	foreach ($ids as $id)
	  if ($context)
	    array_push($list, array("APPID_ID" => $id));
	  else
	    array_push($list, array("TPID" => $id));

        return $this->removeObjects($list, $context);
    }

    public function listType($context) {
        $trans = "TP_LIST_TYPE";
        $trans_version = 2;
        $vector = array();

	require_once 'Zend/Json.php';
	//error_log('listType context: '.Zend_Json::encode($context));

	/* Multi-site: use first appliance  */
	if (sizeof($context) > 1)
	  $context = array($context[0]);

	//error_log('listType context: '.Zend_Json::encode($context));

        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

	//error_log('listType result: '.Zend_Json::encode($result));
 
        if ($result == null) return null;
	if ($context)
	  {
	    if (is_array($result))
	      {
		foreach ($result as $val)
		  {
		    $data = $val->param3->item;
		    if ($data)
		      break ;
		  }
	      }
	    else
	      $data = $result->param3->item;
	  }
	else
	  $data = $result->param2->item;

	//error_log('listType data: '.Zend_Json::encode($data));

        if (!$data) return array();
        if (!is_array($data)) return array($data);

        return $data;
    }

    public function recycleTapes($tplist, $context=null) 
    {
        $trans = "TP_RECYCLE";
        $trans_version = 2;
        $vector = array("param0" => $this->list2soap($tplist));
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
    }

    public function recycleOne($ids, $context=null) 
    {
 	if (!is_array($ids))
	  if ($context)
	    $ids = array($context[0][APPLIANCE_GUID].'_'.$ids);
	  else
	    $ids = array($ids);

	$list = array();
	foreach ($ids as $id)
	  if ($context)
	    array_push($list, array("APPID_ID" => $id));
	  else
	    array_push($list, array("TPID" => $id));
	return ($this->recycleTapes($list, $context));
    }

    public function resultListByPool($plid, $context = null) {
        $trans = "TP_LIST_BY_POOL";
        $trans_version = 2;
        $vector = array("param0" => 0, "param1" => $plid);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
	//error_log('resultListByPool : '.Zend_Json::encode($result));
        return $result;
    }

    public function listByPool($plid, $context = null) {
        $result = $this->resultListByPool($plid, $context);
        if ($result == null) return null;
        $data = $result->param2->item;
        if (!$data) return array();
        if (!is_array($data)) return array($data);
        return $data;
    }

    public function compDrive($tpid, $context=null) {
        $trans = "TP_COMP_DRIVE";
        $trans_version = 2;
        $vector = array("param0" => $tpid);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
        return $result;
    }

    public function getResultAllStatus($context=null) {

            $trans = "TP_GET_STATUS";
            $trans_version = 2;
            $vector = array();
            $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);
            return $result;
    }

    public function getResultAllWithoutNull($tapetype=0, $context=null) {
        $trans = "TP_GET_USAGE";
        $trans_version = 2;
        $vector = array('param0' => $tapetype);
        $result = $this->new_trans($trans, $trans_version, 1, $vector, $context);

        $_SESSION['tmplist'] = (array)$result->param2;

            if  (
                    isset($_SESSION['tmplist']['item']) &&
                    isset($_SESSION['tmplist']['item']->NAME)
                ) {

                $_SESSION['tmplist']['item'] = array($_SESSION['tmplist']['item']);

            }

        if  (   
                isset($_SESSION['tmplist']['item']) && 
                count((array)$_SESSION['tmplist']['item']) > 0
            ) {

            $total = count($_SESSION['tmplist']['item']);

            foreach($_SESSION['tmplist']['item'] as $k=>$v) {

                $a = '';

                if(($k+1) < 10) {

                    if($total > 9 && $total < 100) {

                        $a = '0';

                    }

                    if($total > 9 && $total > 99) {

                        $a = '00';

                    }

                } else {

                    if(($k+1) < 100) {

                        if($total > 99) {

                            $a = '0';

                        }

                    }

                }

                $_SESSION['tmplist']['item'][$k]->NAME = '('.$a.($k+1).') '.$_SESSION['tmplist']['item'][$k]->NAME;

            }

        }

        return ($result);
    }

}
?>
