<?php

require_once 'init.php';

$cats = array('space', 'cleaning_cycles');

if(count($_GET) == 0 || !isset($_GET['cat']) || !in_array($_GET['cat'], $cats) || !isset($_GET['tpids'])) {

    die();

}

$data = array();

switch($_GET['cat']) {

    case 'space':

        $angle = 0;
        $title = utf8_decode($arkwui_lang['tp_stinfo_bkp_title2']);

        foreach($_SESSION['tmplist']['item'] as $key=>$val) {

            if(in_array($val->TPID, $_GET['tpids'])) {

                $val->FULL = 0;

                if($val->USED_SPACE == $val->TOT_SPACE) {

                    $val->FULL = 1;

                }

                $data[preg_replace('`^\((\d+)\)\s.*`', '\\1', $val->NAME)] = array($val->TOT_SPACE, $val->USED_SPACE, $val->FULL, $val->WORN_OUT);

            }

        }

    break;

    case 'cleaning_cycles':

        $angle = 0;
        $title = utf8_decode($arkwui_lang['tp_stinfo_clean_title2']);

        foreach($_SESSION['tmplist']['item'] as $key=>$val) {

            if(in_array($val->TPID, $_GET['tpids'])) {

                $val->FULL = 0;

                if($val->NB_USE == $val->MAX_NB_USE) {

                    $val->FULL = 1;

                }

                $data[preg_replace('`^\((\d+)\)\s.*`', '\\1', $val->NAME)] = array($val->MAX_NB_USE, $val->NB_USE, $val->FULL, $val->WORN_OUT);

            }

        }

    break;

}

require_once "Artichow/BarPlot.class.php";
require_once "Artichow/Pie.class.php";

$white = new White();
$free = new awColor(196, 212, 236);
$black = new Black();
$in_use = new awColor(89, 132, 215);
$full = new awColor(255, 90, 90);
$worn_out = new awColor(160, 140, 215);

$graph = new Graph(350, 340);
$graph->shadow->setSize(0);
$graph->border->hide();
$graph->setBackground($white);
$graph->setAntiAliasing(true);

$group = new PlotGroup();
$group->setBackgroundColor($white);

$maxval = 0;

foreach($data as $key=>$value) {

    if($value[0] > $maxval) {

        $maxval = $value[0];

    }

}

$i = 0;

while ($maxval > 1024) {

    $maxval /= 1024;
    $i++;

}

if($i > 0) {

    foreach($data as $key=>$value) {

        $data[$key][0] /= (1024 * $i);
        $data[$key][1] /= (1024 * $i);

    }

}

$i = 0;

foreach($data as $key=>$value) {

    $tmpkey = array();
    $tmpcol1 = array();
    $tmpcol2 = array();
    $tmpbor1 = array();
    $tmpbor2 = array();
    $tmpval1 = array();
    $tmpval2 = array();

    for($k=0;$k<count($data);$k++) {

        if($k != $i) {

            $tmpkey[$k] = '';
            $tmpcol1[$k] = $white;
            $tmpcol2[$k] = $white;
            $tmpbor1[$k] = $white;
            $tmpbor2[$k] = $white;
            $tmpval1[$k] = 0;
            $tmpval2[$k] = 0;

        } else {

            if(strlen($key) > 5) {

                $key = substr($key, 0, 5) . '...';

            }

            $tmpkey[$k] = $key;
            $tmpcol1[$k] = $free;

            if($value[2] == 1) {

                $tmpcol2[$k] = $full;

            } else {

                $tmpcol2[$k] = $in_use;

            }

            if($value[3] == 1) {

                $tmpbor1[$k] = $worn_out;
                $tmpbor2[$k] = $worn_out;

            } else {

                $tmpbor1[$k] = $black;
                $tmpbor2[$k] = $black;

            }

            $tmpval1[$k] = $value[0];
            $tmpval2[$k] = $value[1];

            break;

        }

    }

    $plot = new BarPlot($tmpval1, 1, 1);
    $plot->label = new Label($tmpkey, new PHPFont(2));
    $plot->label->setAngle($angle);
    $plot->label->setPadding(null, null, null, 15);
    $plot->setBarColor($tmpcol1[$i]);
    $plot->barBorder = new Border($tmpbor1[$i]);
    $group->add($plot);

    $plot = new BarPlot($tmpval2, 1, 1);
    $plot->setBarColor($tmpcol2[$i]);
    $plot->barBorder = new Border($tmpbor2[$i]);
    $group->add($plot);

    $i++;

}

$graph->title->set($title);
$graph->title->setFont(new PHPFont(2));

$graph->add($group);

$graph->draw();
