<?php

require_once 'init.php';
require_once 'Artichow/colorconvert.class.php';

$cats = array('vtl', 'bkp', 'vm');

if(count($_GET) == 0 || !isset($_GET['cat']) || !in_array($_GET['cat'], $cats)) {

    die();

}

$colors = array (
                    'clearest_blue'=>'#c4d4ec',
                    'clearer_blue'=>'#83bed7',
                    'clear_blue'=>'#83a0d7',
                    'blue'=>'#325baa',
                    'purple'=>'#a08cd7',
                    'red'=>'#ff0000',
                    'orange'=>'#C66B29',
                    'green'=>'#33b107'
                );

$colorconvert = new colorconvert();

$data = array();

function barcmp($a, $b) {

    if ($a['num'] == $b['num']) {
        return 0;
    }

    return ($a['num'] < $b['num']) ? 1 : -1;

}

switch($_GET['cat']) {

    case 'vtl':

        $data = array   (
                            array('num'=>(isset($_GET['cap']))?$_GET['cap']:0, 'color'=>$colors['clearest_blue']),
                            array('num'=>(isset($_GET['sizerec']))?$_GET['sizerec']:0, 'color'=>$colors['green'], 'left'=>(isset($_GET['size']))?$_GET['size']:0, 'background'=>false, 'inline'=>true),
                            array('num'=>(isset($_GET['size']))?$_GET['size']:0, 'color'=>$colors['clear_blue']),
                            array('num'=>(isset($_GET['sizerep']))?$_GET['sizerep']:0, 'color'=>$colors['red'], 'height'=>1, 'border'=>false, 'marker'=>true, 'markersize'=>10)
                        );

        //usort($data, 'barcmp');

    break;

    case 'bkp':

        $data = array   (
                            array('num'=>(isset($_GET['size']))?$_GET['size']:0, 'color'=>$colors['clear_blue']),
                            array('num'=>(isset($_GET['sizerep']))?$_GET['sizerep']:0, 'color'=>$colors['red'], 'height'=>1, 'border'=>false, 'marker'=>true, 'markersize'=>10)
                        );

        //usort($data, 'barcmp');

    break;

    case 'vm':

        $data = array   (
                            array('num'=>(isset($_GET['total']))?$_GET['total']:0, 'color'=>$colors['clearest_blue']),
                            array('num'=>(isset($_GET['used']))?$_GET['used']:0, 'color'=>$colors['clear_blue'])
                        );

    break;

}

function getgradcolor($color, $index, $dist) {

    $hsv = $GLOBALS['colorconvert']->hex2hsv($color);

    if($index > 0) {

        return $GLOBALS['colorconvert']->hsv2rgb($hsv['h'], (($index * ($hsv['s'] + ($hsv['s'] * 0.5))) / $dist), $hsv['v']);

    } else {

        return $GLOBALS['colorconvert']->hsv2rgb($hsv['h'], $hsv['s'], $hsv['v']);

    }

}

function imagecolorallocatehexa($imo, $color) {

    if(substr($color,0,1) == '#') $color = substr_replace($color, '', 0, 1);

    $rgb = $GLOBALS['colorconvert']->hex2rgb($color);

    return imagecolorallocate($imo, $rgb['r'], $rgb['g'], $rgb['b']);

}

function createbar($percent, $color, $left, $border, $background, $inline, $lift, $height, $marker, $markersize) {

    if($percent > 0) {

        $padding = 2;

        $x1 = $padding;
        $y1 = ($padding + (($GLOBALS['liftmargins']) - $lift));
        $x2 = $GLOBALS['imw'] - ($padding + 1);
        $y2 = ($GLOBALS['imh'] + (($GLOBALS['liftmargins']) - $lift)) - ($padding + 1);
        $middle = ($y2/2) + ($padding / 2);
        $avail_width = ($x2 - $x1) - 1;

        if($height != null) {

            $y1 = $middle - ($height / 2);
            $y2 = $middle + ($height / 2);

        }

        if($percent < 100) {

            $x2 = ($avail_width * $percent) / 100;

        }

        if($left > 0) {

            $fixedleft = ($avail_width * $left) / 100;

            $x1+= $fixedleft;
            $x2+= $fixedleft;

        }

        if($border === true) {

            $hsv = $GLOBALS['colorconvert']->hex2hsv($color);
            $rgb = $GLOBALS['colorconvert']->hsv2rgb($hsv['h'], $hsv['s'], $hsv['v'] - ($hsv['v'] * 0.8));

            if(!$background) {

                imagerectangle($GLOBALS['imo'], ($x1 + 1), ($y1 + 3), ($x2 - 1), ($y2 - 3), imagecolorallocate($GLOBALS['imo'], $rgb['r'], $rgb['g'], $rgb['b']));

            } else {

                imagefilledrectangle($GLOBALS['imo'], $x1, $y1, ($x2 + 1), ($y2 + 1), imagecolorallocate($GLOBALS['imo'], $rgb['r'], $rgb['g'], $rgb['b']));

            }

        }

        if(($x2 - $x1) < 2) {

            $x2 = $x1 + 2;

        }

        if(!$background) {

            if($inline) {

                imagerectangle($GLOBALS['imo'], ($x1 + 2), ($y1 + 4), ($x2 - 2), ($y2 - 4), imagecolorallocatehexa($GLOBALS['imo'], $color));

            } else {

                imagerectangle($GLOBALS['imo'], $x1-1, $y1-1, $x2+1, $y2+1, imagecolorallocatehexa($GLOBALS['imo'], $color));

            }

        } else {

            imagefilledrectangle($GLOBALS['imo'], $x1, $y1, $x2, $y2, imagecolorallocatehexa($GLOBALS['imo'], $color));

            for($i=0; $i<(($y2-$y1)/2); $i++) {

                $gradcolor = getgradcolor($color, $i, (($y2-$y1)/2));

                imagefilledrectangle($GLOBALS['imo'], $x1, $y1+$i, $x2, $y1+$i, imagecolorallocate($GLOBALS['imo'], $gradcolor['r'], $gradcolor['g'], $gradcolor['b']));
                imagefilledrectangle($GLOBALS['imo'], $x1, $y2-$i, $x2, $y2-$i, imagecolorallocate($GLOBALS['imo'], $gradcolor['r'], $gradcolor['g'], $gradcolor['b']));

            }

            if($marker != null) {

                if($markersize == null) {

                    $markersize = 5;

                }

                if(($x1 + 1) < ($x2 - 1) - 2) {

                    imagefilledrectangle($GLOBALS['imo'], $x1, ($middle - ($markersize / 2)), ($x1 + 1), ($middle + ($markersize / 2)), imagecolorallocatehexa($GLOBALS['imo'], $color));
                    imagefilledrectangle($GLOBALS['imo'], ($x2 - 1), ($middle - ($markersize / 2)), $x2, ($middle + ($markersize / 2)), imagecolorallocatehexa($GLOBALS['imo'], $color));

                } else {

                    imagefilledrectangle($GLOBALS['imo'], $x1, ($middle - ($markersize / 2)), ($x1 + 1), ($middle + ($markersize / 2)), imagecolorallocatehexa($GLOBALS['imo'], $color));

                }

            }

        }

    }

}

header("Content-type: image/png");

if(isset($_GET['modal']) && $_GET['modal'] == 1) {

    $imw = 400;

} else {

    $imw = 500;

}

$liftmargins = 0;
$imh = 30;
$imo = imagecreatetruecolor($imw, ($imh + $liftmargins));

imagefill($imo, 0, 0, imagecolorallocatehexa($imo, '#ffffff'));

foreach($data as $num=>$val) {

    createbar($val['num'], $val['color'], (isset($val['left']))?$val['left']:0, (isset($val['border']))?$val['border']:true, (isset($val['background']))?$val['background']:true, (isset($val['inline']))?$val['inline']:false, (isset($val['lift']))?$val['lift']:0, (isset($val['height']))?$val['height']:null, (isset($val['marker']))?$val['marker']:null, (isset($val['markersize']))?$val['markersize']:null);

}

imagepng($imo);

imagedestroy($imo);

?>