<?php

require_once 'init.php';
require_once 'Artichow/colorconvert.class.php';

function getgradcolor($color, $index, $dist) {

    $hsv = $GLOBALS['colorconvert']->hex2hsv($color);

    if($index > 0) {

        return $GLOBALS['colorconvert']->hsv2rgb($hsv['h'], (($index * ($hsv['s'] + ($hsv['s'] * 0.5))) / $dist), $hsv['v']);

    } else {

        return $GLOBALS['colorconvert']->hsv2rgb($hsv['h'], $hsv['s'], $hsv['v']);

    }

}

function imagecolorallocatehexa($imo, $color) {

    if(substr($color,0,1) == '#') $color = substr_replace($color, '', 0, 1);

    $rgb = $GLOBALS['colorconvert']->hex2rgb($color);

    return imagecolorallocate($imo, $rgb['r'], $rgb['g'], $rgb['b']);

}

function createellipse($data, $centerx, $centery) {

    imagefilledellipse($GLOBALS['imo'], $centerx, $centery, $GLOBALS['itemsize'], $GLOBALS['itemsize'], imagecolorallocatehexa($GLOBALS['imo'], $GLOBALS['colors'][$data['bgcolor']]));
    for ($i = ($GLOBALS['itemsize']-1); $i > 0; $i--) {
        $gradcolor = getgradcolor($GLOBALS['colors'][$data['color']], ($GLOBALS['itemsize']-1)-$i, ($GLOBALS['itemsize']-1));
        imagefilledellipse($GLOBALS['imo'], $centerx, $centery, $i, $i, imagecolorallocate($GLOBALS['imo'], $gradcolor['r'], $gradcolor['g'], $gradcolor['b']));
    }

}

$cats = array('d', 'w', 'm');

if(count($_GET) == 0 || !isset($_GET['cat']) || !in_array($_GET['cat'], $cats)) {
    die();
}

$colors = array (
                    1=>'#c4d4ec',
                    2=>'#c4d4ec',
                    3=>'#83a0d7',
                    4=>'#325baa'
                );

$colorconvert = new colorconvert();

$data = array();

switch($_GET['cat']) {

    case 'd':
        if(isset($_GET['item'])) {
            array_push($data, array('color'=>$_GET['item'][0], 'bgcolor'=>4));
        }
    break;

    case 'w';
        if(isset($_GET['item'])) {
            array_push($data, array('color'=>$_GET['item'][0], 'bgcolor'=>4));
        }
    break;

    case 'm';
        if(isset($_GET['item'])) {
            $ct = count($_GET['item']);
            for($i=0; $i<$ct;$i++) {
                array_push($data, array('color'=>$_GET['item'][$i], 'bgcolor'=>4));
            }
        }
    break;

}

$columnmax = 7;

$itemsize = 16;
$widthdivider = 2;
$heightdivider = 1.5;
$width = $itemsize;
$height = $itemsize;

$x = 0;
$y = 0;
foreach($data as $num=>$val) {
    if($x>=($columnmax)) {
        $y++;
        $x = 0;
        $height += ($itemsize/$heightdivider) ;
    }
    if($y==0 && $x > 0) {
        $width += ($itemsize/$widthdivider);
    }
    $x++;
}

$imo = imagecreatetruecolor(($width+1), ($height+1));
imageantialias($imo, true);
$white = imagecolorallocatehexa($imo, '#ffffff');
imagecolortransparent($imo, $white);
imagefill($imo, 0, 0, $white);

$width = $itemsize;
$height = $itemsize;

$x = 0;
$y = 0;
foreach($data as $num=>$val) {
    if($x>=($columnmax)) {
        $y++;
        $x = 0;
        $height += ($itemsize/$heightdivider) ;
        $width = $itemsize;
    }
    if($x > 0) {
        $width += ($itemsize/$widthdivider);
    }
    createellipse($val, ($width - ($itemsize / 2)), ($height - ($itemsize / 2)));
    $x++;
}
header("Content-type: image/gif");
imagegif($imo);
imagedestroy($imo);

?>
