<?php
define('ARKEIA_VERSION', '8.0.11');
define('DOJO1', false);

set_include_path(
    '.' . PATH_SEPARATOR .
    '../lib' . PATH_SEPARATOR .
    '../app/models' . PATH_SEPARATOR .
    '../htdocs/scripts/arkeia/lang'
);

require_once 'Zend/Loader.php';
require_once 'Zend/Registry.php';

// Initialise configuration / environment
require_once 'Zend/Config/Ini.php';
$config = new Zend_Config_Ini('../app/config/config.ini', 'default');
Zend_Registry::set('config', $config);

$mvc = new Zend_Config_Ini('../app/config/mvc.ini', 'default');

$session_config = new Zend_Config_Ini('../app/config/session.ini', 'live');
require_once 'Zend/Session.php';
Zend_Session::setOptions($session_config->toArray());
require_once 'Zend/Session/Namespace.php';
$session_arkeia = new Zend_Session_Namespace('arkeia');
Zend_Registry::set('session_arkeia', $session_arkeia);

// The arkwui_lang 
$LanguagesEnabled = array('en', 'fr');
if (isset($_POST['lang']) && in_array($_POST['lang'], $LanguagesEnabled) && file_exists('../htdocs/scripts/arkeia/lang/lang_' . $_POST['lang'] . '.php')) {
    $_COOKIE['lang'] = $_REQUEST['lang'] = $_POST['lang'];
    $lang_id = $_POST['lang'];
    setcookie('lang', $lang_id, time()+60*60*24*1000, $baseurl.'/');
} else {
    if (!isset($_REQUEST['lang']))
        $lang_id = 'en'; /* default en */
    else 
        $lang_id = $_REQUEST['lang'];
}
require_once 'lang_'.$lang_id.'.php'; // content $arkwui_lang

if($lang_id == 'en') {
    $lang_longid = 'en-us';
    $lang_displayDateFormat = 'MM/dd/yyyy';
} else {
    $lang_longid = 'fr-fr';
    $lang_displayDateFormat = 'dd/MM/yyyy';
}

// Auth
require_once 'Zend/Auth.php';
$auth = Zend_Auth::getInstance();
$auth->lang = $arkwui_lang;

// Acl
Zend_Loader::loadClass('Arkeia_Acl');
$acl = new Arkeia_Acl();

// Session
//Zend_Session::start();

// The baseurl
$baseurl = substr($_SERVER['PHP_SELF'], 0, 
	strpos($_SERVER['PHP_SELF'], '/index.php'));

Zend_Loader::loadClass('FlashMessenger');
$flash = new FlashMessenger();
Zend_Registry::set('flashMessenger', $flash);

// The Front Controller
require_once 'Zend/Controller/Front.php';
$front = Zend_Controller_Front::getInstance();
$front->setBaseUrl($baseurl);
$front->setControllerDirectory('../app/controllers');

require_once 'Zend/View.php';

$view = new Zend_View();
$viewdir = '../app/views/scripts';

$view->lang_id = $lang_id;
Zend_Registry::set('arkwui_lang', $arkwui_lang);
$view->lang = $arkwui_lang;
$view->lang_longid = $lang_longid;
$view->lang_displayDateFormat = $lang_displayDateFormat;
$view->setEncoding('utf-8');
$view->setScriptPath($viewdir);
$view->addScriptPath('../app/views/docs/'.$view->lang_id);
$view->addHelperPath('../app/views/helpers','Arkeia_View_Helper');
$view->buildVersion = $config->lynx->version;
$view->display = $config->display;
$view->flashMessenger = $flash;
$view->baseurl = $baseurl;
$view->auth = $auth;

Zend_Loader::loadClass('Arkeia_Plugin_Auth');
$front->registerPlugin(new Arkeia_Plugin_Auth($auth, $acl));
$front->setParam('auth', $auth);
$front->setParam('mvc', $mvc);
$front->setParam('view', $view);
$front->setParam('lang', $arkwui_lang);
$front->setParam('viewdir', $viewdir);
$front->setParam('noViewRenderer', true);

$front->returnResponse(true);

$response = $front->dispatch();
$response->renderExceptions(true);
$response->sendResponse();
