dojo.provide('arkeia.compactForm');

arkeia.compactForm = {_name: '[arkeia.compactForm]'};

arkeia.compactForm.initOverLabels = function () {
    var labels = [];
    var id = '';
    var field = {};
    var i = 0;
    // Set focus and blur handlers to hide and show 
    // labels with 'overlabel' class names.
    labels = dojo.doc().getElementsByTagName('label');
    for (i; i < labels.length; i += 1) {
        if (labels[i].className === 'overlabel') {
            // Skip labels that do not have a named association
            // with another field.
            id = labels[i].htmlFor || dojo.attr(labels[i], 'for');
            if (!id) {
                continue;
            }
            field = dojo.byId(id);
            if (!field) {
                continue;
            }
            // Change the applied class to hover the label 
            // over the form field.
            labels[i].className = 'overlabel-apply';
            // Hide any fields having an initial value.
            if (field.value !== '') {
                arkeia.compactForm.hideLabel(dojo.attr(field, 'id'), true);
            }
            // Set handlers to show and hide labels.
            field.onfocus = function () {
                arkeia.compactForm.hideLabel(dojo.attr(this, 'id'), true);
            };
            field.onblur = function () {
                if (this.value === '') {
                    arkeia.compactForm.hideLabel(dojo.attr(this, 'id'), false);
                }
            };
            // Handle clicks to label elements (for Safari).
            labels[i].onclick = function () {
                var id = '';
                var field = {};
                id = dojo.attr(this, 'for');
                if (id) {
                    field = dojo.byId(id);
                    if (field) {
                        field.focus();
                    }
                }
            };
        }
    }
}


arkeia.compactForm.hideLabel = function (field_id, hide) {
    var field_for = '';
    var i = 0;
    var labels = dojo.doc().getElementsByTagName('label');
    for (i; i < labels.length; i += 1) {
        field_for = labels[i].htmlFor || dojo.attr(labels[i], 'for');
        if (field_for === field_id) {
            dojo.style(labels[i], 'textIndent', (hide ? '-5000px' : '0px'));
            return true;
        }
    }
}


dojo.addOnLoad = function () {
    setTimeout(arkeia.compactForm.initOverLabels, 50);
}
console.info('arkeia.compactForm created : ', arkeia.compactForm, arkeia);