dojo.provide("arkeia.widget.ActionMenu");

dojo.require("dojo.widget.Menu2"); 
dojo.require("arkeia.widget.ArkeiaListener");

dojo.require("arkeia.widget.ArkeiaDataProvider");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ActionMenu",

    // renderer
    "html",

    // superclass
    dojo.widget.MenuBar2,

    // init function
    function(){
    },

    // properties and methods
    {
        templateString: '<div class="action-menu">' +
            '<div class="action-menu-content" dojoAttachPoint="containerNode"></div>'+
            '</div>' ,


        processKey: function(/*Event*/ evt){
            if(evt.ctrlKey || evt.altKey){ 
                return false; 
            }
            var rval = false;
            switch(evt.key){
            case evt.KEY_DOWN_ARROW :
                return this._moveToNext(evt);
            case evt.KEY_UP_ARROW :
                return this._moveToPrevious(evt);
            case evt.KEY_RIGHT_ARROW :
                return this._moveToParentMenu(evt);
            case evt.KEY_LEFT_ARROW :
                return this._moveToChildMenu(evt);
            default:
                return arkeia.widget.ActionMenu.superclass.processKey.apply(this, arguments);
            }
            //return rval;
        }
    }
);


dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ActionMenuItem",
    [dojo.widget.MenuItem2, arkeia.widget.ArkeiaListener],
    {
        // widgets parameters
        listened: "",
        valueField: "",
        valueAddInfoFieldName1: "",
        valueAddInfoFieldWidgetId1: "",
        valueAddInfoFieldMethod1: "",
        valueAddInfoFieldName2: "",
        valueAddInfoFieldWidgetId2: "",
        valueAddInfoFieldMethod2: "",
        valueAddInfoFieldName3: "",
        valueAddInfoFieldWidgetId3: "",
        valueAddInfoFieldMethod3: "",
	displayConditionVarName1: "",
	displayConditionWidgetId1: "",
	displayConditionMethod1: "",
	displayConditionValue1: "",
	displayConditionValues1: "",
	displayConditionOperator1: "",
	displayConditionVarName2: "",
	displayConditionWidgetId2: "",
	displayConditionMethod2: "",
	displayConditionValue2: "",
	displayConditionValues2: "",
	displayConditionOperator2: "",
	displayConditionVarName3: "",
	displayConditionWidgetId3: "",
	displayConditionMethod3: "",
	displayConditionValue3: "",
	displayConditionValues3: "",
	displayConditionOperator3: "",
        displayField: "NAME",
        itemName: "",
        defaultDisplay: "",
        action: "",
        confirmMsg: '', 
        newconfirmMsg: '', 
        controller: "",
        baseUrl: "",
        dataUrl: "",
        nextUrl: "",
        nextAction: '',
        nextActionController: '',
        nextActionParams: [],
        multipleId: false,
        multipleDatas: [],
        isHelp: false,
        reloadwidget: "",
        cleanCache: "",
	useDataSender: false,

        // private variables
        templateString:
                 '<li dojoAttachEvent="onMouseOver: onHover; onMouseOut: onUnhover; onClick: _onClick; onKey:onKey;" '
                +'tabIndex="-1"><a dojoAttachPoint="innercaption">${this.caption}</a></li>',
        listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaListSelect"],
        value: "",
        display: "",
        dataSender: null,

        initialize: function() {
            this.listenedArkeiaParents = [];
            if (this.dataUrl == "") {
                if (this.action != "" && this.controller != "") {
                    this.dataUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
                }
            }
            if (this.nextUrl == "" && this.controller != "") {
                this.nextUrl = this.controller + ((this.valueField == '') ? ("/" + this.action) : '/summary');
            }
            this.getNext = this.baseUrl + "/" + this.controller + "/jsonGetNext";
            this.nextActionController = (this.nextActionController == '') ? this.controller : this.nextActionController;
            if (this.nextAction != '' && this.nextAction != 'nothing') {
                this.nextAction = this.baseUrl + "/" + this.nextActionController +"/" + this.nextAction;
            }
        },

        postCreate: function(args, frag) {
            var source = this.getFragNodeRef(frag);
            var DataProvider = arkeia.widget.ArkeiaDataProvider;
            if (this.listened) {
                var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                this.listenArkeiaParent(t);
            }
            //this.setNewCaption(this.defaultDisplay, true);
            if (this.valueField != "") {
                if (!source.dataUrl) {
                    source.dataUrl = this.dataUrl;
                }
                if (!source.getNext) {
                    source.getNext = this.getNext;
                }
                if (this.nextAction != '' && this.nextAction != 'nothing') {
                    source.nextAction = this.nextAction;
                }
                source.abortUrl = this.baseUrl + "/" + this.controller + "/jsonAbortTrans";
                this.dataSender = new DataProvider(source);
                dojo.debug(this + 'set visibility to collapse');
                //this.domNode.style.visibility = "collapse";
                //this.domNode.style.visibility = "hidden";
                this.domNode.style.display = "none";
            } else {
		if (this.useDataSender && this.dataUrl != '') {
                    if (!source.dataUrl) {
			source.dataUrl = this.dataUrl;
                    }
                    if (!source.getNext)
			source.getNext = this.getNext;
                    if (this.nextAction != '' && this.nextAction != 'nothing')
			source.nextAction = this.nextAction;
                    source.abortUrl = this.baseUrl + "/" + this.controller +"/jsonAbortTrans";
                    var dpClass = arkeia.widget.ArkeiaDataProvider;
                    this.dataSender = new dpClass(source);
		}
	    }
        },

        destroy: function(){
            dojo.debug(this + " destroy");
            if (this.dataSender) {
                this.dataSender.destroy();
            }
            return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },

        onArkeiaInfoData: function(message) {
            dojo.debug(this + ' onArkeiaInfoData message:' + dojo.json.serialize(message) + ' this.valueField ' + this.valueField);
            if (!this.multipleId) {
                if (this.valueField && this.valueField != '' && message.data) {
                    if (this.itemName != '') {
                        this.value = message.data[this.itemName][this.valueField];
                    } else {
                        this.value = message.data[this.valueField];
                    } 
                    if (message.appid) {
                        this.compositeValue = message.appid + "_" + this.value;
                        this.compositeField = "APPID_" + this.valueField;
                    } else {
                        this.compositeValue = this.value;
                        this.compositeField = this.valueField;
                    }
                }
                for (i = 1; this['valueAddInfoFieldName' + i] != undefined && this['valueAddInfoFieldName' + i] != ''; i++) {
                    addinfowidget = dojo.widget.byId(this['valueAddInfoFieldWidgetId' + i]);
                    addinfodata = addinfowidget[this['valueAddInfoFieldMethod' + i]]();
                    if (addinfodata == undefined || addinfodata[this['valueAddInfoFieldName' + i]] == undefined) {
                        this.collapse();
                        return ;
                    }
                    dojo.debug(this + ' add compositeAddInfoValue '+addinfodata[this['valueAddInfoFieldName'+i]]);
                }
            } else {
                if (this.valueField && message.idlist) {
                    this.value = dojo.json.serialize(message.idlist["APPID_" + this.valueField]);
                    dojo.debug(this + ' onArkeiaInfoData this.value ' + this.value); 
                    this.compositeValue = this.value;
                    this.compositeField = "APPID_" + this.valueField;
                    this.multipleDatas = message.datas;
                }
            }
            if (this.displayField && message.data) {
                if (this.itemName != '') {
                    this.display = message.data[this.itemName][this.displayField];
                } else {
                    this.display = message.data[this.displayField];
                }
		
		if (this.displayConditionVarName1 != '') {
		    cond = 1;
                    for (i = 1; this['displayConditionVarName' + i] != undefined && this['displayConditionVarName' + i] != ''; i++) {
			condwidget = dojo.widget.byId(this['displayConditionWidgetId' + i]);
			conddata = condwidget[this['displayConditionMethod'+i]]();
			if (this['displayConditionValues' + i] != '')
			    values = dojo.json.evalJson(this['displayConditionValues' + i]);
			else
			    values = [this['displayConditionValue' + i]];
			for (j in values) {
			    switch (this['displayConditionOperator'+ i ])
			    {
				default:
				case 'eq':
			            test = (conddata[this['displayConditionVarName'+ i ]] == values[j]);
			            break ;
			        case 'ne':
    			            test = (conddata[this['displayConditionVarName'+ i ]] != values[j]);
			            break ;
			        case 'ge':
			            test = (conddata[this['displayConditionVarName'+ i ]] >= values[j]);
			            break ;
			        case 'le':
			            test = (conddata[this['displayConditionVarName'+ i ]] <= values[j]);
			            break ;
			        case 'gt':
			            test = (conddata[this['displayConditionVarName'+ i ]] > values[j]);
			            break ;
			        case 'lt':
			            test = (conddata[this['displayConditionVarName'+ i ]] < values[j]);
			            break ;
			    }
			    if (!test)
				cond *= 0;
			    dojo.debug(this + test + ' add conddisplay '+ conddata[this['displayConditionVarName' + i]] + ' ' + this['displayConditionOperator'+ i ] + ' ' + values[j]);
			}
                    }
		    if (!cond)
			this.display = undefined;
		}

                if (!this.multipleId && this.display != undefined) {
                    this.setNewCaption(this.display, true);
                } else {
                    this.collapse();
                }
            }
            /* for multiselection */
            if (this.valueField && message.idlist) {
                if (this.multipleId && message.idlist["APPID_" + this.valueField]) {
                    this.setNewCaption('', true);
                } else {
                    //this.domNode.style.visibility = "collapse";
                    //this.domNode.style.visibility = "hidden";
                    this.domNode.style.display = "none";
                }
            }
        },

        onArkeiaListSelect: function(message) {
            //DEBUG dojo.debug(this + ' onArkeiaListSelect message:' + dojo.json.serialize(message) + ' this.valueField ' + this.valueField);
            if (this.multipleId) {
                message.idlist = {};
                message.idlist["APPID_" + this.valueField] = message.id;
            }
            return this.onArkeiaInfoData(message);
        },

        collapse: function() {
            //this.domNode.style.visibility = "collapse";
            //this.domNode.style.visibility = "hidden";
            this.domNode.style.display = "none";
        },

        expand: function() {
            //this.domNode.style.visibility = "visible";
            this.domNode.style.display = "block";
        },

	getArkeiaListSelection: function() {
	    var res = '';
	    dojo.debug(this + ' getArkeiaListSelection multipleDatas: ' + dojo.json.serialize(this.multipleDatas));

	    for (i in this.multipleDatas) {
		res += '\n    '+this.multipleDatas[i]['NAME'];
		if (this.multipleDatas[i]['APPLIANCE_NAME'] != undefined && this.multipleDatas[i]['APPLIANCE_NAME'] != 'local')
		    res += ' ('+this.multipleDatas[i]['APPLIANCE_NAME']+')';
	    }

	    return (res);
	},

        setNewCaption: function(display, render) {
            dojo.debug(this + ' setNewCaption ' + this.caption + ' with ' + display + 'render : ' + render);
            this.newCaption = this.caption.replace(/\$\[NAME\]/, display);
            //this.newCaption = this.caption + display;
            if (this.confirmMsg != '') {
                this.newconfirmMsg = this.confirmMsg.replace(/\$\[NAME\]/,display);
                this.newconfirmMsg = this.newconfirmMsg.replace(/\$\[NAMES\]/, this.getArkeiaListSelection());
            }
            if (render) {
                this.innercaption.innerHTML = this.newCaption;
                //this.domNode.style.visibility = "visible";
                //this.domNode.visibility = "visible";
                this.domNode.style.display = "block";
                dojo.debug(this + 'visibility :' + this.domNode.style.visibility + ' caption :' + this.innercaption.innerHTML);
            }
        },

        onClick: function () {
            if (this.newconfirmMsg == '' || confirm(this.newconfirmMsg)) {
                dojo.debug(this + " onClick");

		if (this.cleanCache != '') {
		    globalCache.cleanCacheForControler(this.cleanCache);
		}

                if (!this.dataSender) {
                    if (this.nextUrl != 'nothing') {
                        dojo.debug(this + " display_result");
                        if (this.nextUrl) display_result(this.nextUrl);
                    } else {
                        dojo.debug(this + " reloadwidget " + this.reloadwidget);
                        if (dojo.lang.isString(this.reloadwidget)) {
                            var reg = new RegExp("[;]+", "g");
                            var widgetList = this.reloadwidget.split(reg);
                            for (i in widgetList) {
                                dojo.debug(this + ' reloaddata for ' + widgetList[i]);
                                var t = dojo.widget.byId(widgetList[i]);
				if (t != undefined)
                                    t.reloaddata(t);
                            }
                        } else {
                            var t = _this.reloadwidget;
			    if (t != undefined)
				t.reloaddata();
                        }
                    }
                } else {
                    var params = {};
                    if (this.compositeField) {
                        dojo.debug(this + " compositeField = " + this.compositeField);
                        dojo.debug(this + " compositeValue = " + this.compositeValue);
                        if (!this.multipleId) {
                            params[this.compositeField] = this.compositeValue;
                        } else {
                            params[this.compositeField+'_datatype'] = 'json_array';
                            params[this.compositeField] = this.compositeValue;
                            params['DATA_datatype'] = 'json_array';
                            params['DATA'] = dojo.json.serialize(this.multipleDatas);
                        }
                    } else {
                        dojo.debug(this + " valueField = " + this.valueField);
                        dojo.debug(this + " value = " + this.value);
			if (this.valueField != '')
                            params[this.valueField] = this.value;
                    }
                    for (i = 1; this['valueAddInfoFieldName'+i] != undefined && this['valueAddInfoFieldName'+i] != ''; i++) {
                        addinfowidget = dojo.widget.byId(this['valueAddInfoFieldWidgetId'+i]);
                        addinfodata = addinfowidget[this['valueAddInfoFieldMethod'+i]]();
                        this['compositeAddInfoValue'+i] = addinfodata[this['valueAddInfoFieldName'+i]];
                        this['compositeAddInfoFieldName'+i] = this['valueAddInfoFieldName'+i];
                        dojo.debug(this + ' add compositeAddInfoValue '+this['compositeAddInfoFieldName'+i] + '=' + this['compositeAddInfoValue'+i]);
                    }
                    for (i = 1; this['compositeAddInfoFieldName'+i] != undefined && this['compositeAddInfoFieldName'+i] != ''; i++) {
                        params[this['compositeAddInfoFieldName'+i]] = this['compositeAddInfoValue'+i]
                    }
                    this.nextActionParams = params;
                    this.dataSender.loadMultipleResult(this,this.newResult, params);
                    //this.dataSender.loadRemoteData(this, this.returnRequest, params);

                        dojo.debug(this + " reloadwidget " + this.reloadwidget);
                        if (dojo.lang.isString(this.reloadwidget)) {
                            var reg = new RegExp("[;]+", "g");
                            var widgetList = this.reloadwidget.split(reg);
                            for (i in widgetList) {
                                dojo.debug(this + ' reloaddata for ' + widgetList[i]);
                                var t = dojo.widget.byId(widgetList[i]);
				if (t != undefined)
                                    t.reloaddata(t);
                            }
                        } else {
                            var t = _this.reloadwidget;
			    if (t != undefined)
				t.reloaddata();
                        }



                }
            }
        },

        newResult: function(_this, message) {
            if (message.VIEW) {
                if (this.nextUrl != 'nothing')
                    display_result(_this.nextUrl, '', message.VIEW);
                return;
            }
            if (message.last) {
                if (_this.nextAction != '') {
                    dojo.debug(_this + " nextAction = " + _this.nextAction);
                    if (_this.nextAction != 'nothing') {
                        dojo.debug(_this + " nextAction: " + _this.nextAction);
                        _this.dataSender.nextAction(_this, _this.newResult, _this.nextActionParams);
                    } else {
                        dojo.debug(_this + " nothing for nextAction");
                    }
                } else if (_this.reloadwidget != '') {
                    var w = dojo.lang.isString(_this.reloadwidget) ? dojo.widget.byId(_this.reloadwidget) : _this.reloadwidget;
		    if (w != undefined)
			w.reloaddata();
                } else {
                    if (_this.nextUrl != 'nothing') {
                         dojo.debug(_this + " nextUrl: " + _this.nextUrl);
                        display_result(_this.nextUrl);
                    }
                }
            }
        },

        returnRequest: function(_this, data){
            dojo.debug(_this + " returnRequest ...");
            dojo.debug(_this + " data : " + dojo.json.serialize(data)); 
            if (data['STATUS'] != '0') { /* error */
                if (data['STATUS'] == undefined){
                    if (this.nextUrl != 'nothing')
                        display_result(_this.nextUrl, '', data);
                } else  if ((data['STATUS'] == '12') && (data['MESSAGE'] == '2')) {
                    dojo.debug(_this + " returnRequest getNext...");
                    _this.dataSender.getNext(_this, _this.returnRequest, data);
                } else {
                    alert(arkwui_lang_get_msg('js_alert_start_error_msg')+clean_DSP_MSG(data['MESSAGE']));
                }
            } else {
                if (data['FORCE_ALERT']) {
                    alert(arkwui_lang_get_msg('js_alert_start_info_msg')+clean_DSP_MSG(data['MESSAGE']));
                }
                if (_this.nextAction != '') {
                    dojo.debug(_this + " nextAction = " + _this.nextAction);
                    if (_this.nextAction != 'nothing') {
                        dojo.debug(_this + " nextAction: " + _this.nextAction + " data: " + dojo.json.serialize(data));
                        _this.dataSender.nextAction(_this, _this.returnRequest, _this.nextActionParams);
                    } else {
                        dojo.debug(_this + " nothing for nextAction");
                        alert(arkwui_lang_get_msg('js_alert_start_info_msg')+clean_DSP_MSG(data['MESSAGE']));
                    }
                } else {
                    dojo.debug(_this + " nextUrl: " + _this.nextUrl);
                    if (this.nextUrl != 'nothing') {
                        if (data['VIEW']) {
                            display_result(_this.nextUrl, '', data['VIEW']);
                        } else {
                            display_result(_this.nextUrl);
                        }
                    }
                }
            }
        }

    }
);


dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ActionMenuHelpItem",
    dojo.widget.MenuItem2,
    {
        templateString:
                 '<div class="action-menu-help" dojoAttachEvent="onMouseOver: onHover; onMouseOut: onUnhover; onClick: _onClick; onKey:onKey;" '
                +'tabIndex="-1" dojoAttachPoint="caption"><a>${this.caption}</a></div>'
    }
);

