dojo.provide("arkeia.widget.ArkeiaButton");
dojo.require("dojo.widget.Button");
dojo.require("arkeia.widget.ArkeiaDataProvider");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaButton",

    // superclass
    [arkeia.widget.ArkeiaListener, dojo.widget.Button],
             
    // member variables/functions
    {
       
        caption: "",
        action: "",
        reloadwidget: "",
        controller: "",
        baseUrl: "",
        myformid: "nodefined",
        sendUrl: "",
        nextUrl: "",
        nextAction: "", /* if nextAction == 'nothing' do nothing :) */
        nextActionController: "",
        nextActionSendResult: false,
	confirmMsg: '',
        getNext: "",
        listeners: [],
	subForms: '',
        tips: "",
	status: '0',
	askUserAfterTransaction: false,
    warnUser: false,
    warnUserMsg: '',
    resetOnData: false,

        eventNamesDefault: {
            arkeiaAddData: "arkeiaAddData",
            arkeiaInfoData: "arkeiaInfoData",
            beforeLoad: "beforeLoad",
            afterLoad: "afterLoad"
        },

        listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaListSelect"],

        initialize: function() {
            dojo.debug(this + " Initialize"+this.myformid);
	    if (this.caption == "")
		this.setCaption(arkwui_lang_get_msg('validate'));
            this.params = new Array();
	    if (this.controller) {
		if (this.sendUrl == "")
		    if (this.action != "" && this.controller != "")
			this.sendUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
		dojo.debug(this + " Initialize sendUrl: " + this.sendUrl);
		if (this.nextUrl == "")
                    this.nextUrl = this.controller +"/summary";
		this.nextActionController = (this.nextActionController == '' ? this.controller : this.nextActionController);
		if (this.nextAction != '' && this.nextAction != 'nothing')
                    this.nextAction = this.baseUrl + "/" + this.nextActionController +"/" + this.nextAction;
		dojo.debug(this + " Initialize nextUrl: " + this.nextUrl);
		dojo.debug(this + " Initialize nextAction: " + this.nextAction);
        if(this.getNext == '')
            this.getNext = this.baseUrl + "/" + this.controller +"/jsonGetNext";
		dojo.debug(this + " Initialize getNext: " + this.getNext);
	    }
            this.eventNames={};
            for(var name in this.eventNamesDefault) {
                if (dojo.lang.isUndefined(this.eventNames[name])) {
                    this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
                    dojo.debug(this + "event: " + this.eventNames[name]);
                }
            }
            this.domNode.setAttribute("title", this.tips);
        },

        postCreate: function(args, frag) {
            dojo.debug(this + " postCreate ...");

            var source = this.getFragNodeRef(frag);
             if (!source.dataUrl) 
                 source.dataUrl = this.sendUrl;
             if (!source.getNext) 
                 source.getNext = this.getNext;
             if (this.nextAction != '' && this.nextAction != 'nothing')
                 source.nextAction = this.nextAction;
             var dpClass = arkeia.widget.ArkeiaDataProvider;
             this.dataSender = new dpClass(source);

            if (this.listened) {
                t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                this.listenArkeiaParent(t);
            }

             var _this = this;
             dojo.lang.forEach(this.listeners,
                function(elem){
                    dojo.debug(_this + " got one listener: " + elem);
		    if (elem != '') {
			var t = dojo.lang.isString(elem) ? dojo.widget.byId(elem) : elem;
			t.listenArkeiaParent(_this)
		    }
                }
             );
        },

        /**
         * publish destruction event so that any listeners should stop listening
         */
        destroy: function(){
                dojo.debug(this + " destroy");
                dojo.event.topic.publish(this.widgetId + "/arkeiaParentDestroy", { source: this } );
                return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },

		onArkeiaInfoData: function(message) {
            if(this.resetOnData) {
               this.setDisabled(true);
                if (message.data) {
                    this.setDisabled(false);
                }
            }
		},

	callWhenReload: function(){
	},

	callWhenNewResult: function(){
	},

        newResult: function(_this, message) 
        {
	    if (message.VIEW) {
		display_result(_this.nextUrl, '', message.VIEW);
		return;
	    }
	    dojo.debug(_this + " newResult message: " + dojo.json.serialize(message));
	    if (message.status != null && message.status != '0' && message.status != '12')
		_this.status = message.status;
	    if (message.last) {
		
		//dojo.event.topic.publish(_this.eventNames.afterLoad, {});
		if (_this.status != '0' || (message.status!= undefined && message.status != '0' && message.status != '12')) { /* error */
		    _this.setDisabled(false);
		    return;
		} 
		_this.callWhenNewResult();

        if(_this.warnUser) {
            alert(_this.warnUserMsg);
        }
		if (_this.nextAction != '') {
		    dojo.debug(_this + " nextAction = " + _this.nextAction);
		    if (_this.nextAction != 'nothing') {
			dojo.debug(_this + " nextAction: " + _this.nextAction + " data: " + dojo.json.serialize(message.data));
			if (_this.nextActionSendResult) {
			    var msg = {};
			    msg['PARAM2'] = message.data;
			    if (message.data2) msg['PARAM3'] = message.data2;
				_this.dataSender.nextAction(_this, _this.newResult, msg);
			} else {
			    _this.dataSender.nextAction(_this, _this.newResult, _this.obj);
			}
		    } else {
			var eventName = _this.eventNames.arkeiaInfoData;
			dojo.event.topic.publish(eventName, { data: message.data, appid: message.appid });
			dojo.debug(_this + " published " + eventName);
			_this.setDisabled(false);
		    }
		} else if (_this.reloadwidget != '') {
 		    if (dojo.lang.isString(_this.reloadwidget)) {
			var reg = new RegExp("[;]+", "g");
			var widgetList = _this.reloadwidget.split(reg);
			for (i in widgetList) {
			    dojo.debug(_this + ' reloaddata for ' + widgetList[i]);
			    var t = dojo.widget.byId(widgetList[i]);
			    t.reloaddata(t);
			}
		    } else {
			var t = _this.reloadwidget;
			t.reloaddata();
		    }
		    _this.callWhenReload();
		    _this.setDisabled(false);
		    if (_this.askUserAfterTransaction) {
			dojo.debug(_this + ' askUser');
			_this.askUser();
			_this.askUserAfterTransaction = false;
		    }
		} else {
		    if (_this.nextUrl != 'nothing') {
			dojo.debug(_this + " nextUrl: " + _this.nextUrl);
			setTimeout("display_result('"+_this.nextUrl+"')", 2000);
		    }
		}
	    }
        },

	askUser: function() {
            dojo.debug(this + ' askUser');
        },

        returnRequest: function(_this, data)
        {
            dojo.debug(_this + " returnRequest ...");
            //DEBUG dojo.debug(_this + " data : " + dojo.json.serialize(data));
            if (data['local'] != undefined) {
                data = data['local'];
                //DEBUG dojo.debug(_this + " new local data : " + dojo.json.serialize(data));
            }
            if (data['STATUS'] == undefined) {
                display_result(_this.nextUrl, '', data);
            }

            if (data['STATUS'] != '0') { /* error */
                if ((data['STATUS'] == '12') && (data['MESSAGE'] == '2')) {
                    dojo.debug(_this + " returnRequest getNext...");
                    _this.dataSender.getNext(_this, _this.returnRequest, data);
                } else {
                    _this.setDisabled(false);
                    display_message(data['MESSAGE']);
                }
            } else {
                var eventName = _this.eventNames.arkeiaAddData;
                var msgs = new Array();
                for(var msg in data["MESSAGE"]) {
                    dojo.debug(_this + " msg: " + dojo.json.serialize(msg) 
                                + " data: " + data["MESSAGE"][msg]);
                    var message = data["MESSAGE"][msg];
                    var item = {};
                    item["NAME"] = message;
                    msgs.push(item);
                    dojo.event.topic.publish(eventName, { data: msgs[msg] });
                }
		if (data['ASK_USER']) {
		    _this.askUserAfterTransaction = true;
		}
                dojo.debug(_this + " msgs: " + msgs);
                if (data['FORCE_ALERT']) {
		    alert(arkwui_lang_get_msg('js_alert_start_info_msg')+clean_DSP_MSG(data['MESSAGE']));
		} else {
                    if (data['LAST'] == 0) {
                        _this.dataSender.getNext(_this, _this.returnRequest, data);
                    } else {
                        if (_this.nextAction != '') {
                            dojo.debug(_this + " nextAction = " + _this.nextAction);
                            if (_this.nextAction != 'nothing') {
                                dojo.debug(_this + " nextAction: " + _this.nextAction + " data: " + dojo.json.serialize(data));
                                if (_this.nextActionSendResult) {
                                    _this.dataSender.nextAction(_this, _this.returnRequest, data);
                                } else {
                                    _this.dataSender.nextAction(_this, _this.returnRequest, _this.obj);
                                }
                            } else {
                                dojo.debug(_this + " nothing for nextAction");
                                display_message(data['MESSAGE']);
                                _this.setDisabled(false);
                            }
                        } else {
                            dojo.debug(_this + " nextUrl: " + _this.nextUrl);
                            setTimeout("display_result('"+_this.nextUrl+"')", 2000);
                        }
                    }
                }
            }
        },

	checkValue: function() {
	    dojo.debug(this + ' checkValue');
	    return (true);
	},

	addParams: function () {
	    dojo.debug(this + ' addParams');
	    return (false);
	},

        onClick: function () {
            dojo.debug(this + " onClick");
            dojo.debug(this + " myformid:" + this.myformid + " subForms: "+this.subForms);

            if (this.confirmMsg == '' || confirm(this.confirmMsg)) {
		this.obj = dojo.widget.byId(this.myformid).getValues();

		dojo.debug(this + " Object is: " + dojo.json.serialize(this.obj));

		if (this.subForms != '')
		    {
			Forms = this.subForms.split(',');
			for (var i in Forms)
			    {
				if (dojo.widget.byId(Forms[i])) {
				    values = dojo.widget.byId(Forms[i]).getValues();
				    for (var key in values)
					this.obj[key] = values[key];
				} else {
				    dojo.debug(this + ' onClick subForums: cant find form : '+Forms[i]);
				}
			    }
		    }
		if ((addvalues = this.addParams()))
		    {
			for (var key in addvalues)
                            this.obj[key] = addvalues[key];
		    }
        if(addvalues == 'Error') {
            return ;
        }
		dojo.debug(this + " Object is: " + dojo.json.serialize(this.obj));
		
		if (!this.checkValue(this.obj)) {
		    dojo.debug(this + ' onClick checkValue failed');
		    return ;
		}
		this.params = this.obj;
		dojo.event.topic.publish(this.eventNames.beforeLoad, {});
		if (this.controller != '') {
		    this.status = '0';
		    this.dataSender.loadMultipleResult(this,this.newResult, this.params);
                    //this.dataSender.sendData(this, this.returnRequest, this.params);
                    /* disable button */
		    this.setDisabled(true);
		}
	    }
        }
    }
);
