dojo.provide("arkeia.widget.ArkeiaCheckbox");
dojo.require("dojo.widget.Checkbox");
dojo.require("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
	// class
	"arkeia.widget.ArkeiaCheckbox",

	// superclass
	[arkeia.widget.ArkeiaListener, dojo.widget.Checkbox],
			
	// member variables/functions
	{
		valueField: "",
//		disabled: false,
		trueValue: '',
		listenArkeiaParentEvents: ["arkeiaInfoData"],
        hideOnTrue: '[]',
        showOnTrue: '[]',

		initialize: function() {
			// dojo.debug(this + " Initialize");
			this.listenedArkeiaParents=[];
//			if (this.disabled)
//				this.disable();
			// dojo.debug(this + " Initialized");
		},

		postCreate: function(args, frag) {
			var notcon = true;
			this.id = this.id !="" ? this.id : this.widgetId;
			if(this.id != ""){
				var labels = document.getElementsByTagName("label");
				if (labels != null && labels.length > 0){
					for(var i=0; i<labels.length; i++){
						if (labels[i].htmlFor == this.id){
							labels[i].id = (labels[i].htmlFor + "label");
							this._connectEvents(labels[i]);
							dojo.widget.wai.setAttr(this.domNode, "waiState", "labelledby", labels[i].id);
							break;
						}
					}
				}
			}
			this._connectEvents(this.domNode);
			// this is needed here for IE
			this.inputNode.checked=this.checked;
			this._register();
		
			if (this.listened) {
				var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
				this.listenArkeiaParent(t);
			}

            this.imageNode.style.styleFloat = 'none';

			// dojo.debug(this + " created");
		},

		onArkeiaInfoData: function(message) {
			if (this.valueField && message.data) {
				if (this.trueValue == '') {
					if (((typeof(message.data[this.valueField]) == 'boolean') && message.data[this.valueField])
					|| ((typeof(message.data[this.valueField]) == 'number') && (message.data[this.valueField] == 1))
					|| ((typeof(message.data[this.valueField]) == 'string') && (message.data[this.valueField] == '1'))) {
						this.setValue(true);
					} else {
						this.setValue(false);
                    }
				} else {
					if (message.data[this.valueField] == this.trueValue) {
                        this.setValue(true);
                    } else {
                        this.setValue(false);
                    }
				}
			}
		},
        
        hideElements: function(bool){
	    var hide = dojo.json.evalJson(this.hideOnTrue);

            if (hide instanceof Array) {
                for (var i = 0; i < hide.length; i++) {
		    var hideId = document.getElementById(hide[i]);
		    
		    if (hideId) {
			    hideId.style.display = (bool) ? 'none' : '';
			    dojo.debug(this + ((bool) ? ' hide ' : ' show ') + hide[i]);
		    }
                }
            }
	    else {
		    if (hide) {
			    var hideId = document.getElementById(hide);
			    if (hideId) {
				    hideId.style.display = (bool) ? 'none' : '';
			    }
		    }
	    }
        },

        showElements: function(bool){
	    var show = dojo.json.evalJson(this.showOnTrue);

            if (show instanceof Array) {
                for (var i = 0; i < show.length; i++) {
		    var showId = document.getElementById(show[i]);
		    
		    if (showId) {
			    showId.style.display = (bool) ? '' : 'none';
			    dojo.debug(this + ((bool) ? ' show ' : ' hide ') + show[i]);
		    }
                }
            }
	    else {
		    if (show) {
			    var showId = document.getElementById(show);
			    if (showId) {
				    showId.style.display = (bool) ? '' : 'none';
			    }
		    }
	    }
        },

// DOJO c'est genial, mais comme ca couille, on surcharge cette methode afin de forcer la taille des checkbox a 16 et le positionnement du clip !!!
		_setValue: function(/*Boolean*/ bool){
			// summary:
			//	sets checkbox to given value
			//	set state of hidden checkbox node to correspond to given value.
			//	also set CSS class string according to checked/unchecked and disabled/enabled state

            if(bool && this.hideOnTrue != '[]') {
                this.hideElements(bool);
            }

            if(bool && this.showOnTrue != '[]') {
                this.showElements(bool);
            }

			this.checked = bool;
			this.inputNode.checked = this.checked;
			if(this.disabled){
				this.inputNode.setAttribute("disabled",true);
			}else{
				this.inputNode.removeAttribute("disabled");
			}
			dojo.widget.wai.setAttr(this.domNode, "waiState", "checked", this.checked);

			// show the right sprite, depending on state of checkbox
			if(this.imageLoaded){
				this.width = 16;
				this.height = 16;
				var left = (this.checked ? 0 : this.width ) + (this.disabled ? this.width*2 : (this.hover ? this.width*4 : 0 ));
				var s = this.imageNode.style;
				s.marginLeft = -1 * ((arkeia.isIE) ? (26 + left) : left) + "px";
				s.marginTop = -1 * this._topOffset + "px";
				// clip is specified as rect(top right bottom left)
				//dojo.debug(this + left + ' = ' + this.width);
				var clip = "rect(" + this._topOffset + "px, " + (left+this.width) + "px, " + 
					(this._topOffset+this.height) + "px, " + left + "px)";
				s.clip =  clip;
			}
		},

		enable:function(){
			this.disabled = false;
			this.inputNode.removeAttribute("disabled");
		        this.setValue(this.checked);
		},

		disable: function(){
			this.disabled = true;
			this.inputNode.setAttribute("disabled",true);
		        this.setValue(this.checked);
		}

	}
);



dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaRadioButton",
	arkeia.widget.ArkeiaCheckbox,
	{
		// summary
		//	Same as an HTML radio button, but with fancy styling

		_type: "radio",
        hideOnTrue: '[]',
        showOnTrue: '[]',
        fromClick: false,
        doClick: false,

                onValueChanged: function(/*String*/ value){
                        // summary: callback when value changes, for user to attach to                                               
                },

		_onClick: function(/*Event*/ e){
			if(!this.disabled && !this.checked){
                this.fromClick = true;
				this.setValue(true);
			        this.onValueChanged(this.value);
			}
			e.stopPropagation();
			this.onClick();
		},

		setValue: function(/*boolean*/ bool){
			this._setValue(bool);

            if(bool && this.doClick) {
                if(!this.fromClick) {
                    this.onValueChanged();
                } else {
                    this.fromClick = false;
                }
            }

            if(bool && this.hideOnTrue != '[]') {
                this.hideElements(bool);
            }

            if(bool && this.showOnTrue != '[]') {
                this.showElements(bool);
            }

			// if turning this widget on, then turn others in same group off
			if(bool){
				dojo.lang.forEach(this._groups[this.name], function(widget){
					if(widget != this){
						widget._setValue(false);
					}
				}, this);
			}
		},

		onImageLoad: function(){
			// position to second row of sprites (the radio buttons)
			this._topOffset = this.imageNode.height/2;
			dojo.widget.Checkbox.prototype.onImageLoad.call(this);
		}
	}
);

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaRadioButtonWithList",
	arkeia.widget.ArkeiaRadioButton,
	{
        listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaListSelect"],
        listspecialactionontrue: '',

        onArkeiaListSelect: function(message) {

            this.onArkeiaInfoData(message, true);

        },

		onArkeiaInfoData: function(message, fromlist) {
			if (this.valueField && message.data) {
				if (this.trueValue == '') {
					if (((typeof(message.data[this.valueField]) == 'boolean') && message.data[this.valueField])
					|| ((typeof(message.data[this.valueField]) == 'number') && (message.data[this.valueField] == 1))
					|| ((typeof(message.data[this.valueField]) == 'string') && (message.data[this.valueField] == '1'))) {
						this.setValue(true);
                        if(typeof fromlist != 'undefined' && fromlist && this.listspecialactionontrue != '') {
                            eval(this.listspecialactionontrue);
                        }
					} else {
						this.setValue(false);
                    }
				} else {
					if (message.data[this.valueField] == this.trueValue) {
                        this.setValue(true);
                        if(typeof fromlist != 'undefined' && fromlist && this.listspecialactionontrue != '') {
                            eval(this.listspecialactionontrue);
                        }
                    } else {
                        this.setValue(false);
                    }
				}
			}
		}

	}
);