dojo.provide("arkeia.widget.ArkeiaCheckboxList");
dojo.require("dojo.widget.HtmlWidget");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaCheckboxList",

    // renderer
    "html",

    // superclass
    dojo.widget.HtmlWidget,

    // init function
    function(){
    },

    // properties and methods
    {
        widgetsInTemplate: true,
        action: "jsonListServer",
        baseUrl: "",
        controller: "server",
        valueField: "",
        listened: "",
        values: false, 
        _myname: "ArkeiaCheckboxList",
        templateString: '<div id="CheckBoxListContent" dojoAttachPoint="CheckBoxListContent"></div>',

        populate: function(_this, data){
            dojo.debug(_this + " populate data("+data.length+") : "+dojo.json.serialize(data));
            var content = '';
            for (var key in data)
              {
                content += '<div><span id="check_'+data[key]+'" value="'+data[key]+'"></span> '+data[key]+'</div>';
              }

            dojo.debug(_this + " populate set content : "+content);


            _this.CheckBoxListContent.innerHTML = content;

            allchecked = false;
            for (var j in _this.values)
            if (_this.values[j] == '*')
                allchecked = true;

            var i = 0;
            for (var key in data)
              {
                ischecked = false;

                if (allchecked)
                    ischecked = true;
                else if (_this.values)
                    for (var j in _this.values)
                        if (_this.values[j] == data[key])
                            ischecked = true;
		  
                dojo.widget.createWidget("arkeia:ArkeiaCheckbox",{checked: ischecked, name: 'NODE_'+i, value: data[key]},dojo.byId("check_"+data[key]));
                i++;
              }
            dojo.debug(_this + " populate Finish");
            return;
        },
        clearTable: function(_this) {
            dojo.debug(_this + " clearTable");
            _this.CheckBoxListContent.innerHTML = '';
        },
        reload: function(callback) {
            this.dataProvider.loadRemoteData(this,callback,null);
        },
        initialize: function(args, frag) {
            var source = this.getFragNodeRef(frag);
            dojo.debug(this + " Initialize");
            dojo.debug(this + " Initialize getval: " + source.innerHTML);
            if (source.innerHTML != '')
                this.values = dojo.json.evalJson(source.innerHTML);
            else
                this.values = false;
            dojo.debug(this + " values " +dojo.json.serialize(this.values));
            this.dataUrl = this.baseUrl + "/" + this.controller + "/" + this.action;
            dojo.debug(this + " dataUrl: " + this.dataUrl);
            if (!source.dataUrl) source.dataUrl = this.dataUrl;
            var dpClass = arkeia.widget.ArkeiaDataProvider;
            this.dataProvider = new dpClass(source);
            dojo.debug(this + " End of Initialize");
        },
        postCreate: function() {
            dojo.debug(this + " postCreate");
            this.reload(this.populate);
            dojo.debug(this + "End of postCreate");
        }
    }
);
