dojo.provide("arkeia.widget.ArkeiaComboBox");
dojo.require("dojo.widget.ComboBox");
dojo.require("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaComboBox",

    // superclass
    [arkeia.widget.ArkeiaListener, dojo.widget.ComboBox],

    // member variables/functions
    {
        valueField: "",
        value: '',
        valueDisplay: '',
        selectFirst: false,
        selectLast: false,
	disabled: false,
	listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaListSelect"],
	appid: '',
	realDataUrl: '',
	setValueWithName: false,
	getListFromLitener: false,
        doCheckBox: '',
        setDisplay: '',
        setDisplayType: 'block',

        initialize: function() {
            dojo.debug(this + " Initialize with value: "+this.value+" dataUrl: "+this.dataUrl);
	    
            this.listenedArkeiaParents=[];
            if (this.disabled){
                this.disable();
            }

	    dojo.debug(this + " Initialized");
        },
 
        reload: function() {
            this.mySetValue('');
            if(typeof this.lastmessage != 'undefined') {
                if (this.dataUrl != '' || this.realDataUrl != '') {
                    if (this.realDataUrl != '') {
                        if(typeof this.lastmessage.appid != 'undefined') {
                            this.dataProvider.realDataUrl = this.realDataUrl + '?APPLIANCE_GUID=' + this.lastmessage.appid;
                        } else {
                            this.dataProvider.realDataUrl = this.realDataUrl;
                        }
                        this.dataProvider._getData(this.dataProvider.realDataUrl);
                    } else {
                        if(typeof this.lastmessage.appid != 'undefined') {
                            this.dataProvider.dataUrl = this.dataUrl + '?APPLIANCE_GUID=' + this.lastmessage.appid;
                        } else {
                            this.dataProvider.dataUrl = this.dataUrl;
                        }
                        this.dataProvider._getData(this.dataProvider.dataUrl);
                    }
                    var _dataProvider = this.dataProvider;
                    var _this = this;
                    this.dataProvider.setData = function (pdata)
                                    {
                                            _dataProvider._data = pdata;
                                            globalCache.put_cache(_dataProvider, _this, pdata);
                                            if(pdata.length > 0 && _this.setDisplay != '') {
                                                    document.getElementById(_this.setDisplay).style.display = _this.setDisplayType;
                                            }
                                            _this.onArkeiaInfoLoaded();
                                            _this.onArkeiaInfoData(_this.lastmessage, true);
                                    };

                }
            }
        },
 
        postCreate: function() {
	    if (this.listened) {
	        var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
	        this.listenArkeiaParent(t);
	    }

            var s = dojo.widget.html.stabile.getState(this.widgetId);
            if (s){
                this.setState(s);
            }
            this.dataProvider.searchLimit = 512; /* nombre de choix affiche au maximum */

	    if (this.dataUrl != '' || this.realDataUrl != '') {
		this.dataProvider.dataUrl = this.dataUrl;
		if (this.realDataUrl != '') {
		    this.dataProvider.realDataUrl = this.realDataUrl;
		    if (!this.listened) {
			if (data = globalCache.get_cache_from_provider(this.dataProvider)) {
			    this.dataProvider._data = data;
			/*this.dataProvider.setData(data);*/
			} else {
			    this.dataProvider._getData(this.dataProvider.realDataUrl);
			}
		    }
		    
		}
		var _dataProvider = this.dataProvider;
		var _this = this;
		this.dataProvider.setData = function (pdata)
                        {
                                _this.lastmessage = pdata;
                                _dataProvider._data = pdata;
                                globalCache.put_cache(_dataProvider, _this, pdata);
                                if(pdata.length > 0 && _this.setDisplay != '') {
                                        document.getElementById(_this.setDisplay).style.display = _this.setDisplayType;
                                }
                                _this.onArkeiaInfoLoaded();
                        };
	    }

	    if (!this.initWithoutSetValue) {
		if (this.value == '' && (this.selectFirst || this.selectLast)) {
		    this.mySetValue('');
		} else if (this.value != '') {
		    if (this.valueDisplay != '') {
			dojo.debug(this + " Initialize with value["+this.value+"] = "+this.valueDisplay);
			this.setAllValues(this.valueDisplay, this.value);
		    } else {
			this.mySetValue(this.value);
		    }
		} else {
	     	    this.setAllValues("", "");
	    	    dojo.debug(this + " Initialize without default value");
		}
	    }

	    dojo.debug(this + " created");
        },


	onArkeiaListSelect: function(message) {
	    this.onArkeiaInfoData(message);
	},

	onArkeiaInfoData: function(message, nocache) {
	    /* DEBUG
	    dojo.debug("valueField:"+this.valueField);
	    dojo.debug("message.data[valueFiled]:"+message.data[this.valueField]);
	    dojo.debug("message:"+dojo.json.serialize(message));
	    dojo.debug("message.appid:"+message.appid);
	    dojo.debug("this.appid:"+this.appid);
	    */
	    if (this.valueField && message.data) {
            this.lastmessage = message;
            this.valueDisplay = '';
            this.value = '';
		if ((this.realDataUrl != '' || this.dataUrl != '') && this.appid != message.appid) {
		    this.appid = message.appid;
		    this.dataProvider.appid = message.appid;
		    this.dataProvider.realDataUrl = this.realDataUrl;
		    this.dataProvider._data = [];
			
		    if (typeof nocache == 'undefined' && (data = globalCache.get_cache_from_provider(this.dataProvider))) {
			this.dataProvider._data = data;
			/*this.dataProvider.setData(data);*/
		    }
		    else {
			if (this.realDataUrl != '')
			    this.dataProvider._getData(this.realDataUrl+'?APPLIANCE_GUID='+message.appid);
			else
			    this.dataProvider._getData(this.dataUrl+'?APPLIANCE_GUID='+message.appid);
		    }
		} else {
		    if (this.getListFromLitener && this.realDataUrl == '' && this.dataUrl == '' && this.listened) {
			newdata = [];
			list = message.data[this.valueField];
			for (i in list) {
			    newdata.push([list[i], list[i]]);
			}
			this.dataProvider._data = newdata;
		    }
		}
		if ((!this.getListFromLitener || this.realDataUrl != '' || this.dataUrl != ''))
		    this.mySetValue(message.data[this.valueField]);

            if(this.doCheckBox != '' && dojo.widget.byId(this.doCheckBox) && this.valueDisplay != '') {
                dojo.widget.byId(this.doCheckBox).setValue(true);
            }

	    }

	},

    onArkeiaInfoLoaded: function() {

    },

        /* bugfix: overload bugged method in dojo combobox.
        Selection event was based on label change not on value changes */
		_checkValueChanged: function(){ 
			this._arrowIdle();
			var value = this.getSelectedValue(); 
			if (this._prevValue != value){ 
				this._prevValue = value; 
				// only change state and value if a new value is set 
				dojo.widget.html.stabile.setState(this.widgetId, this.getState(), true); 
				this.onValueChanged(value); 
			} 
		},

/*
		enable:function(){
			this.disabled = false;
			this.textbox.removeAttribute("disabled");
		},

		disable: function(){
			this.disabled = true;
			this.textbox.setAttribute("disabled",true);
		},
*/

	getSelectedValue: function(){
            return this.comboBoxSelectionValue.value;
        },


       mySetValue: function(value) {
	   this.tmpvalue = value;
       this.oldValue = this.getSelectedValue(); 
	   dojo.debug(this + " looking for " + value + ' in dataProvider');
           if (!this.dataProvider._data.length) {
	       dojo.debug(this + " mySetValue wait data");
	       var _this = this;
               setTimeout(function (){
                       _this.mySetValue(_this.tmpvalue);
               }, 1000);
	       return ;
           }
	   dojo.debug(this + " looking for " + value + ' in dataProvider');
	   if (value == '') {
            this.valueDisplay = '';
	       if (this.selectFirst) {
		   this.valueDisplay = this.dataProvider._data[0][0];
		   this.value = this.dataProvider._data[0][1];
	       } else if (this.selectLast) {
		   this.valueDisplay = this.dataProvider._data[this.dataProvider._data.length - 1][0];
		   this.value = this.dataProvider._data[this.dataProvider._data.length - 1][1];
	       }
	   } else {
	       idx = this.setValueWithName ? 0 : 1;

               for (i = 0; this.dataProvider._data[i] != undefined; i++) {
		   var elm;
		   elm = this.dataProvider._data[i];
		   if (elm[idx] == value) {
                       this.valueDisplay = elm[0];
                       this.value = elm[1];
                       break ;
		   }
	       }
	   }
	   dojo.debug(this + " mySetValue with value["+this.value+"] = "+this.valueDisplay);

	   this.setAllValues(this.valueDisplay, this.value);
       }
    }
);
