dojo.provide("arkeia.widget.ArkeiaDataProvider");

dojo.declare("arkeia.widget.ArkeiaDataProvider", null, function(options) {
    this.dataUrl = options.dataUrl;
    this.getNextUrl = options.getNext;
    this.nextActionUrl = options.nextAction;
    this.abortUrl = options.abortUrl;
    this._inFlight = false;
    this._lastRequest = null;
    this._isAlive = true;
    this.getNextTimeOut = 200;
    this._displayMessage = true;
    this.onLoadError = null;
    this.startRequest = false;
},{
    _sendRequest: function(obj, callback, params, url, sync) {
        var _this = this;
        var _obj = obj;
        //dojo.debug(this + " ArkeiaDataProvider url:" + url);
        //dojo.debug(this + " ArkeiaDataProvider getNextUrl:" + this.getNextUrl);
        //dojo.debug(this + "                params : " + dojo.json.serialize(params));
        _this._inFlight = true;
    this.fromCache = false;

    if (this.startRequest && (cache = globalCache.get_cache_from_provider(_this, params))) {
        this.startRequest = false;
        _this._inFlight = false;
        this.fromCache = true;
        var _cache = cache;
        /* Timeout for load dojo object */
        if (callback) {
        setTimeout(function() {callback(_obj, _cache, 'all')}, 500);
        }
    } else {
        this.startRequest = false;
            var request = this._lastRequest = dojo.io.bind({
        method: 'POST',
        url: url,
        content: params,
        mimetype: "text/json",
        error: function(type, data, evt) {
            _this._inFlight = false;
                    //dojo.debug(this + "sendRequest error: type: " +type + ",data: "+dojo.json.serialize(data)+",url: "+this.url);
        },
        load:function (type, data, evt) {
            _this._inFlight = false;
                    if (sync || request == _this._lastRequest) {
                        if (callback) callback(_obj, data);
            }
        }
            });
    }
    },
    loadRemoteData: function(obj, callback, params) {
        var _obj = obj;
        var _this = this;
        var _params = params;

        //dojo.debug(this + " loadRemoteData: "+this.dataUrl);

        var returnResult= function(_this, data) {
        if (!_this.fromCache) {
        globalCache.clean_cache_from_provider(_this, _params);
        globalCache.put_cache(_this, _obj, data);
        }
        callback(_obj, data);
    }

    this.startRequest = true;
        this._sendRequest(_this, returnResult, params, this.dataUrl, false);

        //this._sendRequest(obj, callback, params, this.dataUrl, false);
    },
    loadSynchroData: function(obj, callback, params) {
        //dojo.debug(this + " loadSynchroData: "+this.dataUrl);
        this._sendRequest(obj, callback, params, this.dataUrl, true);
    },
    sendData: function(obj, callback, params) {
        //dojo.debug(this + " sendData: "+this.dataUrl);
        this._sendRequest(obj, callback, params, this.dataUrl, false);
    },

    _loadNext: function(_this, callback, params) {
        //dojo.debug(_this + " in loadNext");
        if (!this._isAlive) {
            //dojo.debug(this + " DataProvider is dead");
            if (_this.abortUrl) this._sendRequest(_this, null, params, _this.abortUrl, false);
            return;
        }
        this._sendRequest(_this, callback, params, _this.getNextUrl, true);
        //dojo.debug(_this + " end of  loadNext");
    },

    nextAction: function(obj, callback, params) {
        //dojo.debug("ArkeiaDataProvider nextAction");
        this._sendRequest(obj, callback, params, this.nextActionUrl, false);
    },

    getNext: function(obj, callback, params) {
        //dojo.debug(this + "ArkeiaDataProvider getNext : " + this.getNextUrl);
        this._sendRequest(obj, callback, params, this.getNextUrl, false);
    },
    destroy: function(){
        //dojo.debug(this + " DataProvider destroy");
        this._isAlive = false;
    },
    setDisplayMessage: function(displayMessage)
    {
        this._displayMessage = displayMessage;
    },

    /* loadMultipleResult:
       callback will be caled for each appliance with a message containing :
       {data, data2, appid, appliance_name, last}
       data is param2, data2 is param3.
    */
    loadMultipleResult: function(obj, callback, params) {
        var _obj = obj;
        var _this = this;
	var _params = params;
        var returnResult= function(_this, data, cache) {
            //dojo.debug(_obj + " loadMultipleResult returnResult " + _this.dataUrl);
            //DEBUG dojo.debug(_obj + " data : " + dojo.json.serialize(data));
            var do_get_next = false;
            var sessnum = 1;
            var transnum = 1;
            if (data['VIEW']) {
                callback(_obj, {VIEW:data['VIEW']});
                return;
            }
            var param2 = new Array;
            var param3 = null;

            if (cache != undefined && cache == 'all') {
		var i = 1;
		for(var _appid in data) {
		    //dojo.debug(_obj + " loadMultipleResult returnResult cache for : " + _appid);
		    var newdata = {};
		    newdata[_appid] = data[_appid];
		    
		    function calltimeout(_this, newdata, i) {
			setTimeout(function() {returnResult(_this, newdata, 'one')}, 100 * i);
		    }
		    calltimeout(_this, newdata, i);
		    i++;
		}
		return ;
            }

            for(var appid in data) {
                //dojo.debug(_obj + " loadMultipleResult returnResult appid: " + appid);
                var nb_msg = data[appid]['STATUS'].length;
                var appliance_name = data[appid]['APPLIANCE_NAME'];
                var last_status = 0;
                var last_message = 0;
                var last_last = 0;
                if (nb_msg > 0) {
                    for (var x=0; x < nb_msg; x++) {
                        last_last = data[appid]['LAST'][x]; 
                        sessnum = data[appid]['sessnum'][x];
                        transnum = data[appid]['transnum'][x];
                        last_status = data[appid]['STATUS'][x];
                        last_message = data[appid]['MESSAGE'][x];
                        if (!_this._isAlive) continue;
                        if (last_status != "12") {
			    if (data[appid]['ASK_USER']) {
				_obj.askUserAfterTransaction = true;
			    }
			    if (data[appid]['LICENSE_ERROR']) {
				alert(clean_DSP_MSG(last_message));
				arkeia.layout.display_result('license/nolicenseadd');
				return ;
                            } else if (data[appid]['FORCE_ALERT']) {
				alert(clean_DSP_MSG(last_message));
			    } else if (data[appid]['FORCE_RECONNECT']) {
				alert(arkeia.lang.getMsg('logon_expire'));
				dojo.widget.byId('logoutForm').containerNode.action = '/login/logout';
				dojo.widget.byId('logoutForm').submit();
				return ;
			    } else if (_this._displayMessage) {
				display_message(last_message);
			    }
                        }
                        if (last_status == '0' || last_status == 3) {
                            if (!_this.fromCache) {
                                //dojo.debug(_obj + " loadMultipleResult returnResult clean_cache");
                                globalCache.clean_cache_from_provider(
                                                      _this, _params);
                                globalCache.put_cache(_this, _obj, data);
                            }
                            if (data[appid]['PARAM2'][x] != undefined) {
                                param2 = data[appid]['PARAM2'][x];
                            }
                            if (data[appid]['PARAM3'][x] != undefined) {
                                param3 = data[appid]['PARAM3'][x];
                            }

                            callback(_obj, {data:param2, data2: param3, appid: appid, appliance_name: appliance_name, status: last_status, message: last_message, last:last_last});
                        } else if (last_status != "12") {
                            callback(_obj, {appid: appid, appliance_name: appliance_name, status: last_status, message: last_message, last:last_last});
                        } else if (_this.onLoadError) {
                            _this.onLoadError(_obj);
                        }
                    }
                } else { // one answer
                    //dojo.debug(_obj + " loadMultipleResult returnResult error: data is not an array");
                }
                if (last_last == 0) do_get_next = true;
            }
            // In this version, the very last last means something!
            if (last_last != 0 || cache != undefined) {
                do_get_next = false;
            }
            else do_get_next = true;
            if (last_status == "12" && last_message == "2") do_get_next = true;

            if (do_get_next) {
                var params = {};
                params["sessnum"] = sessnum;
                params["transnum"] = transnum;
                setTimeout(function() {_this._loadNext(_this, returnResult, params)}, _this.getNextTimeOut);
            }
            //dojo.debug(_obj + " end of loadMultipleResult returnResult for " + _this.dataUrl);

        };
	this.startRequest = true;
        this._sendRequest(_this, returnResult, params, this.dataUrl, false);
    }

});

