dojo.provide("arkeia.widget.ArkeiaDropdownDate");
dojo.require("dojo.widget.DropdownDatePicker");
dojo.require("arkeia.widget.ArkeiaListener");

dojo.widget.defineWidget(
// class
	"arkeia.widget.ArkeiaDropdownDate",

// superclass
	[arkeia.widget.ArkeiaListener, dojo.widget.DropdownDatePicker],
		
// member variables/functions
	{
		valueField: "",
		disabled: false,
		listenArkeiaParentEvents: ["arkeiaInfoData"],

		templateString: '<div style="white-space:nowrap; height:20px;"><nobr><input type="hidden" name="" value="" dojoAttachPoint="valueNode" /><input name="" type="text" value="" style="vertical-align:middle;" dojoAttachPoint="inputNode" autocomplete="off" /><img src="${this.iconURL}" alt="${this.iconAlt}" dojoAttachEvent="onclick:onIconClick" dojoAttachPoint="buttonNode" style="float: left !important; position:relative; left:90px; top:-18px; vertical-align:middle; cursor:pointer; cursor:hand" /></nobr></div>',

		fillInTemplate: function(args, frag){
			// summary: see dojo.widget.DomWidget
			dojo.widget.DropdownDatePicker.superclass.fillInTemplate.call(this, args, frag);
			//attributes to be passed on to DatePicker
			var dpArgs = {widgetContainerId: this.widgetId, lang: this.lang, value: this.value,
				startDate: this.startDate, endDate: this.endDate, displayWeeks: this.displayWeeks,
				weekStartsOn: this.weekStartsOn, adjustWeeks: this.adjustWeeks, staticDisplay: this.staticDisplay};

			//build the args for DatePicker based on the public attributes of DropdownDatePicker
			this.datePicker = dojo.widget.createWidget("arkeia:ArkeiaDatePicker", dpArgs, this.containerNode, "child");
			dojo.event.connect(this.datePicker, "onValueChanged", this, "_updateText");
			dojo.event.connect(this.inputNode, "onChange", this, "_updateText");

			if(this.value){
				this._updateText();
			}
			this.containerNode.explodeClassName = "calendarBodyContainer";
			this.valueNode.name=this.name;
		},

		initialize: function() {
			dojo.debug(this + " Initialize");
			this.listenedArkeiaParents=[];
			if (this.disabled)
				this.disable();
			dojo.debug(this + " Initialized");
		},

		postCreate: function(args, frag) {
			if (this.listened) {
				var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
				this.listenArkeiaParent(t);
			}
			if(
					((dojo.render.html.capable) && (dojo.render.html.ie)) &&
					(arkeia.layout.IsIE8Browser() && !arkeia.layout.IsIE8emuIE7Browser())
				) {
				this.buttonNode.style.left = '120px';
				this.buttonNode.style.top = '0px';
			}
			dojo.debug(this + " created");
		},

		onArkeiaInfoData: function(message) {
			if (this.valueField && message.data) {
				this.value = message.data[this.valueField];
				this.setDate(this.value);
			}
		},

		enable:function(){
			this.disabled = false;
			this.textbox.removeAttribute("disabled");
		},

		disable: function(){
			this.disabled = true;
			this.textbox.setAttribute("disabled",true);
		}
	}
);
