dojo.provide("arkeia.widget.ArkeiaInfo");
dojo.require("arkeia.widget.ArkeiaListener");
dojo.require("arkeia.widget.ArkeiaDataProvider");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaInfo",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this.eventNames={};
        this._data =[];
        this._lastId = null;
    },

    // properties and methods
    {
        ArkeiaInfoClass: "ArkeiaInfo",
        _myname: "arkeiaInfo",
        listenArkeiaParentEvents: ["arkeiaListSelect"],
        eventNamesDefault: {
            arkeiaInfoData: "arkeiaInfoData",
            beforeLoad: "beforeLoad",
	    afterLoad: "afterLoad"
        },
        listened: "",
        getNext: "",
        isContainer: true,
        widgetsInTemplate: true,
        //action: 'jsonGetResultOne',
        action: 'jsonGetOne',
        stopWhenErrorStatus: false,
        controller: "",
        baseUrl: "",
        valueField: "",
        screenNumber: 1,
        debugMode: false,
        templatePath: dojo.uri.moduleUri("arkeia/widget", "ArkeiaInfo.html"),
        templateCssPath: dojo.uri.moduleUri("arkeia/widget", "ArkeiaInfo.css"),
        value: "",
        timer: 0,
        msgmode: false,
        params: [],
        multipleSelect: false,
        displayMessage: true,
	initWithDataProvider: false,

        getLastMessage: function(id) {
	    if (id === undefined)
		id = this._lastId;
            var o = this._data[id];
            return(o);
        },

        newDataInfo: function(_this, data, appid) {
            dojo.debug(_this + /*" newDataInfo : " + dojo.json.serialize(data) +*/" appid "+dojo.json.serialize(appid)); 
            if (data['local'] != undefined) {
                data = data['local'];
            }
            _this._data[_this._lastId] = data;
            var eventName = _this.eventNames.arkeiaInfoData;
            dojo.event.topic.publish(eventName, { data: data, appid: appid });
            dojo.debug(_this + " published " + eventName);
            dojo.debug(_this + " newDataInfo Finish");

            if (!_this.debugMode) {
                return;
            }
            // Debug Mode: show all values

            while (_this.innerDiv.childNodes.length > 0) {
                _this.innerDiv.removeChild(_this.innerDiv.childNodes[0]);
            }
            if (!data) {
                _this.innerDiv.style.display = "none";
            } else {
                _this.recursiveFillDebugTable(_this, _this.innerDiv, data);
            }
            return;
        },

	callWhenNewResult: function(message){
	},

        newResult: function(_this, message) {
	    //DEBUG dojo.debug(_this + ' newResult message: ' + dojo.json.serialize(message));

            if (message.data) {
                if (message.data2) message.data['PARAM3'] = message.data2;
                _this.newDataInfo(_this, message.data, message.appid);
            } 

            if (_this.stopWhenErrorStatus == true && message['status'] != '0') {
                dojo.debug(_this + " newResult stop refresh status != 0");
                dojo.event.topic.publish(_this.eventNames.arkeiaInfoData, {});
                dojo.event.topic.publish(_this.eventNames.afterLoad, {});
                return ;
            }

	    _this.callWhenNewResult(message);

            if (_this.timer > 0) {
                _this.timeoutId = setTimeout(function (){
                    _this.reload(_this.value);
                }, _this.timer);
            }
        },


        reload: function(id) {
            this.keepId = id;
            dojo.event.topic.publish(this.eventNames.beforeLoad, {});
            this._lastId = id; // the callback function will always be called for the last request
            if (this.msgmode) {
                dojo.debug(this + " msgmode Id:"+id);
                this.dataProvider.loadMultipleResult(this,this.newResult,this.params);
            } else {
                this.dataProvider.loadRemoteData(this,this.populateData,this.params);
            }
        },

        reloaddata: function() {
            this.reload(this.keepId);
        },

	addWhenDestroy: function(){
	},

	addWhenInitialize: function() {
	},

	afterWidgetCreate: function(){
        },

        /**
         * publish destruction event so that any listeners should stop listening
         */
        destroy: function(){
            if (this.timeoutId) clearTimeout(this.timeoutId);
            this.timer = 0;
            if (this.dataProvider) this.dataProvider.destroy();
            dojo.event.topic.publish(this.widgetId + "/arkeiaParentDestroy", { source: this } );
	    this.addWhenDestroy();
            return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },
        initialize: function() {
            this.params = {};
            this.dataUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
            this.getNext = this.baseUrl + "/" + this.controller +"/jsonGetNextResult";
            if (!this.msgmode) dojo.debug(this + "is not in msgmode");
            for(var name in this.eventNamesDefault) {
                if (dojo.lang.isUndefined(this.eventNames[name])) {
                    this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
                }
            }
	    this.addWhenInitialize();
        },

        postCreate: function(args, frag) {

            var source = this.getFragNodeRef(frag);
            if (!source.dataUrl) source.dataUrl = this.dataUrl;
            if (!source.getNext) source.getNext = this.getNext;
            var dpClass = arkeia.widget.ArkeiaDataProvider;
            this.dataProvider = new dpClass(source);
            this.dataProvider.setDisplayMessage(this.displayMessage);

	    if (this.initWithDataProvider) {
		this.reload(0);
	    }

            if (this.listened) {
                var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                this.listenArkeiaParent(t);
            }

            if (this.value != "") {
                dojo.debug(this + " Set initial value: " + this.value);
                this.setId(this.value, null, null);
            }
	    this.afterWidgetCreate();
        },
        setId:function(id, appid, data) {

// On vire le cache !!!
            if (0 == 1) {
//          if (this._data[id]) {
// si l'objet est deja en cache. alors on déclanche simple le message arkeiaInfoData qui stipule que les données sont présentes.
                var eventName = this.eventNames.arkeiaInfoData;
                dojo.event.topic.publish(eventName, { data: this._data[id], appid: appid });
            } else {
// sinon on recharge l'objet.
// this.params sont les paramètres de la callback

                if (dojo.lang.isString(id)) {
                    this.params[this.valueField] = id;
                } else {
                    /* Si la multiselection n'est pas permit on vide tout 
                     * et on envois l'array pour les evenements  */
                    if (!this.multipleSelect) {
                        var eventName = this.eventNames.arkeiaInfoData;
                        var params = {};
                        params[this.valueField] = id;
			//DEBUG dojo.debug(this + ' et oui id = ' + dojo.json.serialize(id) + ' valueField : ' + this.valueField + ' params : ' + dojo.json.serialize(params));
                        dojo.event.topic.publish(eventName, { data: false, idlist: params, datas: data});
                        return ;
                    }
                    /* si le resultat est un array on envois le parametre 
                     * this.valueField+'_datatype' = 'json_array' et on 
                     * envois le tableau de valeur encode en json 
                     * utilise pour les statistics de bande avec un ArkeiaList
                     * en multiselect.
                     */
                    this.params[this.valueField+'_datatype'] = 'json_array';
                    this.params[this.valueField] = dojo.json.serialize(id);
                }
                dojo.debug(this + " setId "+ this.valueField +"=" + id);
                this.reload(id);
            }
        },

	callWhenOnArkeiaListSelect:  function(message) {
	    //DEBUG dojo.debug(this + 'callWhenOnArkeiaListSelect');
	},

        onArkeiaListSelect: function(message) {
            var tblock, level, c1, c2;
            var isIE = ((dojo.render.html.capable) && (dojo.render.html.ie));
	    //DEBUG dojo.debug('onArkeiaListSelect: screenNumber: '+this.screenNumber+' message:'+dojo.json.serialize(message));

	    this.callWhenOnArkeiaListSelect(message);

            if (this.screenNumber > 1) {
                tblock = message.id.split('@');
                level = tblock[2];
                dojo.debug(this + ' level = ' + level);
                if (level == "0") {
/*
                    var container1 = dojo.widget.byId("Screen1");
                    container1.show();
                    var container2 = dojo.widget.byId("Screen2");
                    container2.hide();
*/
                    container1 = dojo.byId("XClient1");
                    container1.style.display = '';
                    container2 = dojo.byId("XClient2");
                    container2.style.display = 'none';
                } else {
/*
                    var container1 = dojo.widget.byId("Screen2");
                    container1.show();
                    var container2 = dojo.widget.byId("Screen1");
                    container2.hide();
*/
                    container1 = dojo.byId("XClient2");
                    container1.style.display = '';
                    container2 = dojo.byId("XClient1");
                    container2.style.display = 'none';
                }
                if (container1.style.left == -2000 || container1.style.left == '-2000px') {
                    container1.style.left = (isIE) ? 0 : '0px';
                }
                if (container2.style.left == -2000 || container2.style.left == '-2000px') {
                    container2.style.left = (isIE) ? 0 : '0px';
                }
            }
            /*
            dojo.debug(this + " onArkeiaListSelect with message=" + dojo.json.serialize(message));
            dojo.debug(this + " onArkeiaListSelect with id=" + message.id);
            dojo.debug(this + " onArkeiaListSelect with appid=" + message.appid);
            */
            this.setId(message.id, message.appid, message.data);
        },

        // Debug function: display all data
        recursiveFillDebugTable: function(_this, node, data) {
            dojo.debug(_this + " recursiveFillDebugTable entering");
            var table = document.createElement("table");
            table.width = "100%";
            dojo.html.addClass(table,"ArkeiaInfo");
            var mkrow = function(prop, val, label) {
                var row = document.createElement("tr");
                var cell = document.createElement("td")
                dojo.html.addClass(cell,"prop");
                cell.innerHTML=label;
                row.appendChild(cell);
                cell = document.createElement("td")
                if (prop == "item") {
                    _this.recursiveFillDebugTable(_this, cell, val);
                } else {
                    cell.innerHTML=val;
                }
                dojo.html.addClass(cell,"val");
                row.appendChild(cell);
                table.appendChild(row);
            };
            for (var prop in data) {
                if (prop == "__className") continue;
                if (prop == "item" && data[prop].length > 0) {
                    for (var i=0; i < data[prop].length; i++) {
                        mkrow(prop, data[prop][i], prop + " " +i);
                    }
                } else {
                    mkrow(prop, data[prop], prop);
                }
            }
            node.appendChild(table);
            dojo.debug(_this + " recursiveFillDebugTable end");
            return;
        }

    }
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.InfoText",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this._data =[];
    },

    // properties and methods
{
    value: "",
    caption: "",

    action: "",
    controller: "",
    baseUrl: "",
    conditionedTrans: "false",
    optionField: "",
    oldStyleDisplay: "",
    dataUrl: "",
/* itemSelectName et itemSelectValue sont utilise si les donnes sont sous forme de tableau de tableau et on selection le sous tableau qui contien le couple itemSelectName => itemSelectValue utilise pour les stats des tapes */
    itemSelectName: "",
    itemSelectValue: "",
    newID: "",
    newController: "",
    newAction: "",

    unitValue: '',
    valueField: "",
    realValueField: "",
    valueTypeField: "",
    defaultValue: "",
    _myname: "InfoText",
    listenArkeiaParentEvents: ["arkeiaInfoData","arkeiaListSelect"],
    templateString: 
        '<tr dojoAttachPoint="row" class="infoText">'
        + '<td dojoAttachPoint="caption" class="infoTextLabel" valign="top">${this.caption}</td>'
        + '<td dojoAttachPoint="tdvalue" class="infoTextValue">${this.value}</td>'
        + '</tr>',
    displayHidden: function() 
    {
	var styleElem = this.row.style ? this.row.style : this.row;

        styleElem.visibility = 'hidden';
        styleElem.display = 'none';
    },
    displayShow: function() 
    {
	var isIE = ((dojo.render.html.capable) && (dojo.render.html.ie));
	var styleElem = this.row.style ? this.row.style : this.row;

        styleElem.visibility = 'visible';
	if (isIE && this._myname == "InfoText") {
	    styleElem.display = 'block';
	} else {
	    styleElem.display = 'table-row';
	}
    },
    initialize: function() 
    {
        var isIE = ((dojo.render.html.capable) && (dojo.render.html.ie));
        if (isIE && this._myname == "InfoText") {
            tmpCaption = document.createElement('div');
            dojo.html.setClass(tmpCaption, 'infoTextLabel');
            tmpCaption.innerHTML = this.caption.innerHTML;
            this.tdvalue = document.createElement('div');
            dojo.html.setClass(this.tdvalue, 'infoTextValue');
            this.tdvalue.innerHTML = this.value;
            tmpElem = document.createElement('div');
            dojo.html.setClass(tmpElem, 'infoText');
            tmpElem.appendChild(tmpCaption);
            tmpElem.appendChild(this.tdvalue);
            this.domNode = tmpElem;
	    this.row = tmpElem;
        }
        if (this._myname == "InfoText") {
            unitValue = arkwui_lang_get_msg('bkp_showbkp_speed_KB_s');
	}
        if (this.controller != '' && this.action != '') {
            this.params = {};
            this.dataUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
        }
        this.listenedArkeiaParents = [];
        for(var name in this.eventNamesDefault) {
            if (dojo.lang.isUndefined(this.eventNames[name])) {
                this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
            }
        }
    },

    postCreate: function(args, frag) 
    {
        var source = this.getFragNodeRef(frag);

        if (this.listened) {
	    this.changeListened(this.listened);
        }

        if (!source.dataUrl) source.dataUrl = this.dataUrl;
        var dpClass = arkeia.widget.ArkeiaDataProvider;
        this.dataProvider = new dpClass(source);

    },

    changeListened: function(listened) {
	this.listened = listened;
	var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
        this.listenArkeiaParent(t);

    },

    changeid2name: function(_this, data) 
    {
        if(_this.conditionedTrans == 'true') {

            switch (_this.listened) {
                case 'driveinfo':
                    if(data['NAME'] == null) {
                        _this.tdvalue.innerHTML = arkwui_lang_get_msg('drv_status_unknown_tpid')+': '+_this.tdvalue.innerHTML;
                        return;
                    }
                break;
            }

        }

        _this._data[_this._lastId] = data;
        _this.tdvalue.innerHTML = data['NAME'];
    },

    onArkeiaListSelect: function(message) 
    {
        //dojo.debug(this + " onArkeiaListSelect with message=" + dojo.json.serialize(message));
        dojo.debug(this + " onArkeiaListSelect with id=" + dojo.json.serialize(message.id));
        dojo.debug(this + " onArkeiaListSelect with appid=" + dojo.json.serialize(message.appid));
        this.onArkeiaInfoData(message);
    },

    onArkeiaInfoData: function(message) 
    {
        //DEBUG dojo.debug(this + ' onArkeiaInfoData '+this.valueField+' message' + dojo.json.serialize(message));
        /* Change Arkeia Object ID to NAME */

        if(this.conditionedTrans == 'true') {
            switch (this.listened) {
                case 'driveinfo':
                    if (this.valueField == 'TPID') {
                        if(typeof this.dataUrlBKP == 'undefined') {
                            this.dataUrlBKP = this.dataUrl;
                            this.dataUrl = '';
                        }
                        if (message.data['STATUS'] == 'F' && message.data['TPID'] != '0') {
                            this.dataUrl = this.dataUrlBKP;
                            //this.tdvalue.innerHTML = arkwui_lang_get_msg('drv_status_tpid') + message.data['TPID'];
                        } else {
                            this.dataUrl = '';
                        }
                    }
                break ;
            }
        }

        if (this.dataUrl != "" && message.data) {
            var id = message.data[this.valueField];
            var val = id;
            var comp_id = id;
            var comp_field = this.realValueField != '' ? this.realValueField : this.valueField;

            if (message.appid) {
                comp_id = message.appid + "_" + id;
                comp_field = "APPID_" + comp_field;
            }

            if (this._data[comp_id]) { // cached
                val = this._data[comp_id]['NAME'];
            } else { // not cached, load it
                this.params[comp_field] = comp_id;
                this._lastId = comp_id;
		var _this = this;
                this.dataProvider.loadRemoteData(_this, this.changeid2name, this.params);
            }
            this.tdvalue.innerHTML = val;
            return ;
        }
        this._setInfoData(message);
    },

    _setInfoData: function(message) {
        if (!message.data && this.conditionedTrans == 'false') {
            this.tdvalue.innerHTML = ' ';
            return ;
        }


        /* standard case */
        if (this.valueField && message.data) {
            this.value = message.data[this.valueField];
        }
        switch (this.listened) {
	case 'bkponeactive': {
	    typelist = {GENERAL_INFO_rst: 'rst', GENERAL_INFO_bkp: 'bkp', GENERAL_INFO_d2d2t: 'd2d2t'};

	    if (typelist[this.valueField] != unitValue && (type = typelist[this.valueField])) {
		this.tdvalue.innerHTML = 'Server : '+message.data['NODE'] + ' ' +
		    '#drives: '+message.data['NB_DRV'] + ' ' +
		    '#flows: '+message.data['NB_FLOW'] + ' ';
		if (type == 'bkp') {
		    this.tdvalue.innerHTML += 'Savepack: '+message.data['SKID'] + ' ';
		}
		if (type != 'rst') {
		    this.tdvalue.innerHTML += 'Drivepack: '+message.data['DKID'] + ' ';
		    this.tdvalue.innerHTML += 'Pool: '+message.data['PLID'] + ' ';
		}
		if (message.data['BK_INFO'] != undefined && message.data['BK_INFO'] != '') {
		    this.tdvalue.innerHTML += 'Info: '+message.data['BK_INFO'] + ' ';
		}
		break ;
	    }
	}
        case 'ndmpsavepacktrees':
        	if (this.value == undefined && this.defaultValue != undefined) {
        		this.value = this.defaultValue;
        		this.tdvalue.innerHTML = this.value;
        	}
        	else {
        		//this.caption.innerHTML = this.caption;
        		if (this.value == undefined) this.tdvalue.innerHTML = "";
        		else this.tdvalue.innerHTML = this.value;

        	}
        	break;
        case 'bkpflows':
        case 'bkpdrives':
        case 'bkpstatinfo': {
            if ((this.valueField == 'BK_DSK_SIZ' || this.valueField == 'BK_PHY_SIZ'
                || this.valueField == 'BK_DSK_AVG' || this.valueField == 'BK_DSK_INS' 
                || this.valueField == 'BK_PHY_AVG' || this.valueField == 'BK_PHY_INS'
                || this.valueField == 'BK_TIME') && message.data[this.valueField] == undefined) {
                valueField = this.valueField.substring(1);
                this.value = message.data[valueField];
            }
            if (this.valueField == 'FLOW_DSK_SIZ' || this.valueField == 'FLOW_PHY_SIZ' 
                || this.valueField == 'DRV_DSK_SIZ' || this.valueField == 'DRV_PHY_SIZ' 
                || this.valueField == 'BK_DSK_SIZ' || this.valueField == 'BK_PHY_SIZ') {
                	if (this.valueTypeField != '') {
	                		if (message.data[this.valueTypeField]['FLOW_PHY_SIZ'])
		                		this.tdvalue.innerHTML = message.data[this.valueTypeField]['FLOW_PHY_SIZ']+' MB';
        	        		else 
								this.tdvalue.innerHTML = message.data[this.valueTypeField][1]['FLOW_PHY_SIZ']+' MB';
                	}
                	else
                		this.tdvalue.innerHTML = this.value+' MB';
                break ;
            }

            if (this.valueField == 'FLOW_COMPRESS' || this.valueField == 'DRV_COMPRESS') {
                precision = 1000;
                ratio = false;
                if (this.valueField == 'FLOW_COMPRESS')
                    if (parseInt(message.data['FLOW_PHY_SIZ']))
                        ratio = parseInt((message.data['FLOW_DSK_SIZ'] * precision) / message.data['FLOW_PHY_SIZ']);
                if (this.valueField == 'DRV_COMPRESS')
                    if (parseInt(message.data['DRV_PHY_SIZ']))
                        ratio = parseInt((message.data['DRV_DSK_SIZ'] * precision) / message.data['DRV_PHY_SIZ']);

                this.tdvalue.innerHTML = (!ratio ? '' : parseInt(ratio / precision) + '.' + parseInt(ratio % precision));
                break ;
            }
			
			if (this.valueField == 'FLOW_INFO' || this.valueField == 'FLOW_CUR_SEG') {
				if (this.valueTypeField != '') {
	                if (message.data[this.valueTypeField][this.valueField])
		            	this.tdvalue.innerHTML = message.data[this.valueTypeField][this.valueField];
        	        else
						this.tdvalue.innerHTML = message.data[this.valueTypeField][1][this.valueField];
                }
                else
                	this.tdvalue.innerHTML = this.value;
                break;
			}
			
            if (this.valueField == 'BK_DSK_AVG' || this.valueField == 'BK_DSK_INS' 
                || this.valueField == 'BK_PHY_AVG' || this.valueField == 'BK_PHY_INS'
                || this.valueField == 'FLOW_DSK_AVG' || this.valueField == 'FLOW_DSK_INS'
                || this.valueField == 'FLOW_PHY_AVG' || this.valueField == 'FLOW_PHY_INS'
                || this.valueField == 'DRV_DSK_AVG' || this.valueField == 'DRV_DSK_INS'
                || this.valueField == 'DRV_PHY_AVG' || this.valueField == 'DRV_PHY_INS') {
                    var convertval;
                if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_KB_s'))
                    convertval = this.value * 1024 / 60;
                else if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_MB_s'))
                    convertval = this.value / 60;
                else if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_MB_min'))
                    convertval = this.value;
                else if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_MB_h'))
                    convertval = this.value * 60;
                this.tdvalue.innerHTML = parseInt(convertval) + ' ' + this.unitValue;
                break ;
            }

            // DRV_ASK 
            if (this.valueField == 'BK_TIME') { // initialise DRV_ASK when BK_TIME propertie was recieved
                if (message.data['item'] != undefined) {
                    var DRV_ASK = new Array();
                    if (message.data['item']['DRV_NUM'] != undefined) {
                        if (message.data['item']['DRV_ASK'] != undefined)
                            DRV_ASK.push(message.data.item);
                    } else for (i in message.data['item']) {
                        if (message.data['item'][i]['DRV_NUM'] != undefined && message.data['item'][i]['DRV_ASK'] != undefined) {
                            DRV_ASK.push(message.data['item'][i]); 
                        }
                    }

                    if (DRV_ASK.length) {
			change_visibility('drv_ask', 1, 'block', true);
                        drv_ask_list = new Array();
                        for (i in DRV_ASK) {
                            drv_ask_list.push([DRV_ASK[i]['DRV_NAME']+': '+DRV_ASK[i]['DRV_INFO'], DRV_ASK[i]['DRV_ASK']]);
                        }
                        combo = dojo.widget.byId('DrvAskForm_DRV_ASK');
                        if (combo) {
                            if (!combo.dataProvider._data.length) {
                                combo.dataProvider.setData(drv_ask_list);
                                combo.setAllValues(drv_ask_list[0][0], drv_ask_list[0][1]);
                            } else {
                                if (dojo.json.serialize(combo.dataProvider._data) != dojo.json.serialize(drv_ask_list))
                                    combo.dataProvider.setData(drv_ask_list);
                            }
                        }
                    } else {
			change_visibility('drv_ask', 0, 'none', true);
                    }

                }
            }

            if (this.valueField == 'BK_TIME' || this.valueField == 'BK_TIME' || this.valueField == 'FLOW_TIME' || this.valueField == 'DRV_TIME') {
                usage_h = parseInt(this.value / 3600);
                usage_m = parseInt(this.value % 3600);
                usage_s = parseInt(usage_m % 60);
                usage_m = parseInt(usage_m / 60);
                this.tdvalue.innerHTML = (usage_h < 10 ? '0' : '') + usage_h + "h " + (usage_m < 10 ? '0' : '') + usage_m + "m " + (usage_s < 10 ? '0' : '') + usage_s + 's';
                break;
            }
        }
        case 'savepacktrees': {
            if (this.valueField == 'TYPE') {
                if (this.value == undefined) {
		    if (message.data['SKID'] == undefined)
			this.tdvalue.innerHTML = 'TREE';
		    else
			this.tdvalue.innerHTML = 'SAVEPACK';
                } else
                    this.tdvalue.innerHTML = this.value
                break ;
            }
            if (this.valueField == 'CHAIN') {
                if (this.value == undefined)
                    this.tdvalue.innerHTML = '0';
                else
                    this.tdvalue.innerHTML = this.value
                break ;
            }
            if (this.valueField == 'PRIORITY') {
                if (this.value == undefined)
                    this.tdvalue.innerHTML = '50';
                else
                    this.tdvalue.innerHTML = this.value
                break ;
            }
            if (this.valueField == 'FAMILY') {
                if (this.value == undefined)
                    this.tdvalue.innerHTML = '0';
                else
                    this.tdvalue.innerHTML = this.value
                break ;
            }
        }
        case 'savepackinfo': {
            if (this.valueField == 's_cryp') {
                crypt_info = new Array;
                crypt_info['SPK_OPTION'] = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                crypt_info['NO_CRYPT']   = arkwui_lang_get_msg('spk_crypt_NO_CRYPT');
                crypt_info['ANY_CRYPT']  = arkwui_lang_get_msg('spk_crypt_ANY_CRYPT');
                crypt_info['DES_CRYPT']  = arkwui_lang_get_msg('spk_crypt_DES_CRYPT');
                crypt_info['FISH_CRYPT'] = arkwui_lang_get_msg('spk_crypt_FISH_CRYPT');
                if (this.value == undefined) {
                    if (this.listened == 'savepacktrees') {
                        this.value = 'SPK_OPTION';
                    } else {
                        this.value = 'NO_CRYPT';
                    }
                }
                this.tdvalue.innerHTML = crypt_info[this.value];
                break ;
            }
            if (this.valueField == 's_cpres') {
                cpres_info = new Array;
                cpres_info['SPK_OPTION']     = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                cpres_info['ANY_COMPRESS']   = arkwui_lang_get_msg('spk_comp_ANY_COMPRESS');
                cpres_info['LZ1_COMPRESS']   = arkwui_lang_get_msg('spk_comp_LZ1_COMPRESS');
                cpres_info['LZ3_3_COMPRESS'] = arkwui_lang_get_msg('spk_comp_LZ3_3_COMPRESS');
                cpres_info['NO_COMPRESS']    = arkwui_lang_get_msg('spk_comp_NO_COMPRESS');
 
                if (this.value == undefined) {
                    if (this.listened == 'savepacktrees') {
                        this.value = 'SPK_OPTION';
                    } else {
                        this.value = 'ANY_COMPRESS';
                    }
                }
                this.tdvalue.innerHTML = cpres_info[this.value];
                break ;
            }
            if (this.valueField == 's_allowedfs') {
                allowedfs_info = new Array;
                allowedfs_info['SPK_OPTION']     = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                allowedfs_info['NORMAL_FS']      = arkwui_lang_get_msg('spk_allowedfs_NORMAL_FS');
                allowedfs_info['ALL_FS']         = arkwui_lang_get_msg('spk_allowedfs_ALL_FS');
                allowedfs_info['ALL_EXCEPT_NFS'] = arkwui_lang_get_msg('spk_allowedfs_ALL_EXCEPT_NFS');
                if (this.value == undefined) {
                    if (this.listened == 'savepacktrees') {
                        this.value = 'SPK_OPTION';
                    } else {
                        this.value = 'NORMAL_FS';
                    }
                }
                this.tdvalue.innerHTML = allowedfs_info[this.value];
                break ;
            }
            if ((this.valueField == 'DO_CMD_BEFORE' && message.data['CMD_BEFORE'] == undefined) ||
                (this.valueField == 'DO_CMD_AFTER' && message.data['CMD_AFTER'] == undefined) ||
                ((this.valueField == 'CMD_BEFORE' || this.valueField == 'CMD_AFTER') && this.value == undefined)) {
                this.tdvalue.innerHTML = '<em>'+arkwui_lang_get_msg('spk_cmd_no_set')+'</em>';
                break ;
            }
            if (this.valueField == 'DO_CMD_BEFORE' || this.valueField == 'DO_CMD_AFTER') {
                this.tdvalue.innerHTML = (this.value == undefined ? arkwui_lang_get_msg('No') : arkwui_lang_get_msg('Yes'));
                break ;
            }
            if (this.valueField == 's_folln' || this.valueField == 'u_ratim' || this.valueField == 'u_posixacl' || this.valueField == 'RECOVERY'
            	|| this.valueField == 'u_xattr') {
                if (this.listened == 'savepacktrees' && this.value == undefined) {
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                } else {
                    this.tdvalue.innerHTML = (this.value == undefined || this.value == 0 ? arkwui_lang_get_msg('No') : arkwui_lang_get_msg('Yes'));
                }
                break ;
            }
            if (this.valueField == 'FOLLOWFS') {
                if (this.listened == 'savepacktrees' && this.value == undefined){
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                } else {
                    this.tdvalue.innerHTML = (this.value == undefined || this.value == 1 ? arkwui_lang_get_msg('Yes') : arkwui_lang_get_msg('No'));
                }
                break ;
            }
            if (this.valueField == 'MEDIA_SERVER' && this.value == undefined) {
                if (this.listened == 'savepacktrees')
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                else
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('Default');
                break ;
            }
            if (this.valueField == 'MAX_RETRY' && this.value == undefined) {
                if (this.listened == 'savepacktrees' && this.value == undefined)
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('spk_infotree_as_spk_option');
                else
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('Default');
                break ;
            }
        }
        case 'driveinfo': {
            if (this.valueField == 'USAGE_TIME') {
                usage_h = parseInt(this.value / 3600);
                usage_m = parseInt(this.value % 3600);
                usage_s = parseInt(usage_m % 60);
                usage_m = parseInt(usage_m / 60);
                this.tdvalue.innerHTML = usage_h + "h " + usage_m + "m " + usage_s + 's';
                break;
            }
            if (this.valueField == 'DRV_DENY') {
                this.tdvalue.innerHTML = '';
                if (!(this.value & 1)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_read') + ' ';
                if (!(this.value & 2)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_write') + ' ';
                if (!(this.value & 4)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_clean') + ' ';
                if (!(this.value & 8)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_delete');
                if (this.tdvalue.innerHTML == '') this.tdvalue.innerHTML = arkwui_lang_get_msg('right_none');
                break ;
            }
            if (this.valueField == 'TPID') {
                if (message.data['STATUS'] == 'E') {
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('drv_status_empty');
                } else if (message.data['STATUS'] == 'F' && this.value != '0') {
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('drv_status_tpid') + message.data['TPID'];
                } else {
                    this.tdvalue.innerHTML = arkwui_lang_get_msg('drv_status_unknown');
                }
                break ;
            }
	    if (this.valueField == 'DRV_TYPE') {
		if (this.value == 'FILE') {
		    dojo.widget.byId('infoText_MEDIA_SERVER').displayHidden();
		    dojo.widget.byId('infoText_REWIND_DEV').displayHidden();
		} else {
		    dojo.widget.byId('infoText_MEDIA_SERVER').displayShow();
		    dojo.widget.byId('infoText_REWIND_DEV').displayShow();
		}
	    }
        }
        case 'tapeinfo': {
            if (this.valueField == 'VOLTAG') {
                if (message.data['TP_TYPE'] == 'FILE') {
					this.tdvalue.innerHTML = '';					
				} else {
					this.tdvalue.innerHTML = message.data['VOLTAG'];
				}
                break ;
            }
            if (this.valueField == 'PATH') {
                if (message.data['TP_TYPE'] == 'FILE') {
					this.tdvalue.innerHTML = message.data['VOLTAG'];
				} else {
					this.tdvalue.innerHTML = '';					
				}
                break ;
            }
            if (this.valueField == 'ST_CONTENT') {
                tape_status_info = new Array;
                tape_status_info['TPSTC_NEW']      = arkwui_lang_get_msg('tp_TPSTC_NEW');
                tape_status_info['TPSTC_LABELED']  = arkwui_lang_get_msg('tp_TPSTC_LABELED');
                tape_status_info['TPSTC_INUSE']    = arkwui_lang_get_msg('tp_TPSTC_INUSE');
                tape_status_info['TPSTC_FULL']     = arkwui_lang_get_msg('tp_TPSTC_FULL');
                tape_status_info['TPSTC_DAMAGED']  = arkwui_lang_get_msg('tp_TPSTC_DAMAGED');
                tape_status_info['TPSTC_RECYCLED'] = arkwui_lang_get_msg('tp_TPSTC_RECYCLED');
                if (this.value == undefined)
                    this.value = 'TPSTC_NEW';
                this.tdvalue.innerHTML = tape_status_info[this.value];
                break ;
            }
            if (this.valueField == 'ST_ACCESS') {
                tape_status_info = new Array;
                tape_status_info['TPSTC_NEW']     = arkwui_lang_get_msg('tp_TPSTC_NEW');
                tape_status_info['TPSTA_MANUAL']  = arkwui_lang_get_msg('tp_form_st_access_manual');
                tape_status_info['TPSTA_AUTOM']   = arkwui_lang_get_msg('tp_form_st_access_autom');
                tape_status_info['TPSTA_ONLINE']  = arkwui_lang_get_msg('tp_form_st_access_online');
                tape_status_info['TPSTA_DAMAGED'] = arkwui_lang_get_msg('tp_form_st_access_damaged');
                tape_status_info['TPSTA_SECURED'] = arkwui_lang_get_msg('tp_form_st_access_secured');
                if (this.value == undefined)
                    this.value = 'TPSTC_NEW';
                this.tdvalue.innerHTML = tape_status_info[this.value];
                break ;
            }
            if (this.valueField == 'RDATE' || this.valueField == 'LAST_WRITTEN' || this.valueField == 'DUP_DATE' || this.valueField == 'VERIFY_DATE' || this.valueField == 'CREATION_DATE') {
                if (this.value != '' && this.value)
                   this.tdvalue.innerHTML = transformUtimeToStr(this.value, (arkeia.lang.id == 'en')?4:2);
                else
                    this.tdvalue.innerHTML = ' ';
                break ;
            }
            if (this.valueField == 'RECYCLE_IN') {
                tape_recycle_in_info = new Array;
                tape_recycle_in_info[0] = arkwui_lang_get_msg('tp_form_recycle_in_0');
                tape_recycle_in_info[1] = arkwui_lang_get_msg('tp_form_recycle_in_1');
                if (this.value == undefined)
                    this.value = 0;
                this.tdvalue.innerHTML = tape_recycle_in_info[this.value];
                break ;
            }
            if (this.valueField == 'RECYCLE_MODE') {
                tape_recycle_mode_info = new Array;
                tape_recycle_mode_info[0] = arkwui_lang_get_msg('tp_form_recycle_mode_0');
                tape_recycle_mode_info[1] = arkwui_lang_get_msg('tp_form_recycle_mode_1');
                if (this.value == undefined)
                    this.value = 0;
                this.tdvalue.innerHTML = tape_recycle_mode_info[this.value];
                break ;
            }
            if (this.valueField == 'ST_DENY') {
                this.tdvalue.innerHTML = '';
                if (!(this.value & 1)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_read') + ' ';
                if (!(this.value & 2)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_write') + ' ';
                if (!(this.value & 4)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_recycle') + ' ';
                if (!(this.value & 8)) this.tdvalue.innerHTML += arkwui_lang_get_msg('right_delete');
                if (this.tdvalue.innerHTML == '') this.tdvalue.innerHTML = arkwui_lang_get_msg('right_none');
                break ;
            }
        }
        case 'd2d2tinfo': {
            if (this.valueField == 'NEW_TAPE') {
                tp_policy_info = new Array;
                tp_policy_info[0] = arkwui_lang_get_msg('bkp_form_strategy_0');
                tp_policy_info[1] = arkwui_lang_get_msg('bkp_form_strategy_1');
                if (this.value == undefined)
                    this.value = 0;
                this.tdvalue.innerHTML = tp_policy_info[this.value];
                break ;
            }
            if (this.valueField == 'RET_TIME') {
                unit_info = new Array;
                unit_info['D'] = arkwui_lang_get_msg('bkp_form_timeunit_D');
                unit_info['W'] = arkwui_lang_get_msg('bkp_form_timeunit_W');
                unit_info['M'] = arkwui_lang_get_msg('bkp_form_timeunit_M');
                unit_info['Y'] = arkwui_lang_get_msg('bkp_form_timeunit_Y');
                if (message.data['RET_TIME_UNIT'] == undefined)
                    unit = 'D';
                else
                    unit = message.data['RET_TIME_UNIT'];
                this.tdvalue.innerHTML = this.value + ' ' + unit_info[unit];
                break ;
            }
            if (this.valueField == 'DO_EMAIL') {
                do_email_info = new Array;
                do_email_info[1] = arkwui_lang_get_msg('bkp_form_parall_use_email');
                do_email_info[0] = arkwui_lang_get_msg('bkp_form_parall_dont_use_email');
                if (this.value == undefined)
                    this.value = 0;
                this.tdvalue.innerHTML = do_email_info[this.value];
                break ;
            }
        }
        case 'clientlist': {
            if (this.valueField == 'VNAME' || this.valueField == 'PORT' || this.valueField == 'INETADDR' || this.valueField == 'HOSTNAME') {
                var disabled = '';
                if(this.valueField == 'HOSTNAME') {
                    disabled = ' disabled="disabled"';
                }
                this.tdvalue.innerHTML = '<input type="text" value="' + (this.value === undefined ? '' : this.value) + '" name="' + this.valueField + '"'+disabled+' />';
                break ;
            }
        }
        case 'clientinfo': {
	    if (this.valueField == 'SERVNAME' || 
		this.valueField == 'SERVPORT' || 
		this.valueField == 'PORT_NUMBER' || 
		this.valueField == 'VIRTUAL_HOSTNAME' || 
		this.valueField == 'NLP_HOSTFILE' || 
		this.valueField == 'NLP_HOSTNAME' || 
		this.valueField == 'ARKEIADLOGLEVEL' || 
		this.valueField == 'MAX_LOGSIZE') {
		    this.tdvalue.innerHTML = '<input type="text" value="' + (this.value === undefined ? '' : this.value) + '" name="' + this.valueField + '" />';
		    break ;
		} 
	}
        case 'drivepackinfo': {
            if (this.valueField == 'NB_DRIVES' && this.value == 0) {
                this.tdvalue.innerHTML = arkwui_lang_get_msg('All');
                break ;
            }
        }
	case 'vtlinfo': {
	    if (this.valueField == 'D2T_COND_VAL') {
		if (message.data['D2T_AUTO'] == '1') {
		    this.tdvalue.innerHTML = arkwui_lang_get_msg('vtl_info_condition_'+message.data['D2T_COND_TYPE']) + ' ';
		    switch (message.data['D2T_COND_TYPE']) {
			case 'USED_GT':
			case 'AVAIL_LT': {
			    var reg = new RegExp("[\%]","g");
			    this.tdvalue.innerHTML += '<strong>'+this.value;
			    if (!this.value.match(reg))
				this.tdvalue.innerHTML += ' MB'+'</strong>';
			    break ;
			}
			case 'TIME_IS': {
			    var reg = new RegExp("([0-9]{4})([0-9]{2})([0-9]{2})T([0-9]{2})([0-9]{2})([0-9]{2})");
			    this.tdvalue.innerHTML += '<strong>'+this.value.replace(reg, "$3/$2/$1 $4:$5:$6")+'</strong>';
			    break ;
			}
		    }
		    
		    this.tdvalue.innerHTML += '<br/>'+arkwui_lang_get_msg('vtl_form_sentence_part_1')+' ';
		    
		    if (message.data['D2T_WHICH_BKP'] == '1')
			this.tdvalue.innerHTML += '<strong>'+arkwui_lang_get_msg('vtl_arkwhichbkp_oldest')+'</strong>';
		    else
			this.tdvalue.innerHTML += '<strong>'+arkwui_lang_get_msg('vtl_arkwhichbkp_next_to_exp')+'</strong>';
		    
		    this.tdvalue.innerHTML += ' '+arkwui_lang_get_msg('vtl_form_sentence_part_2')+' ';
		    
		    
		    if (message.data['D2T_DELETE_BKP'] == '0')
			this.tdvalue.innerHTML += '<strong>'+arkwui_lang_get_msg('vtl_form_D2T_DELETE_BKP_nodelete')+'</strong>';
		    else
			this.tdvalue.innerHTML += '<strong>'+arkwui_lang_get_msg('vtl_form_D2T_DELETE_BKP_delete')+'</strong>';
		    
		    this.tdvalue.innerHTML += ' '+arkwui_lang_get_msg('vtl_form_sentence_part_3')+' ';
		    
		    var reg = new RegExp("[\%]","g");
		    this.tdvalue.innerHTML += '<strong>'+message.data['D2T_SIZE_AFTER']+'</strong>';
		    if (!message.data['D2T_SIZE_AFTER'].match(reg))
			this.tdvalue.innerHTML += ' MB';
		    break ;
		} else {
		    this.tdvalue.innerHTML = ' ';
		    break ;
		}
	    }
	    if (this.valueField == 'D2T_SETUP_ID' && this.value == undefined) {
		this.tdvalue.innerHTML = ' ';
		break ;
	    }
	    if (this.valueField == 'D2T_WHICH_BKP') {
                wbkp_info = new Array;
                wbkp_info[1] = arkwui_lang_get_msg('vtl_arkwhichbkp_oldest');
                wbkp_info[2] = arkwui_lang_get_msg('vtl_arkwhichbkp_next_to_exp');
		if (this.value == undefined)
		    this.tdvalue.innerHTML = ' ';
		else
                    this.tdvalue.innerHTML = wbkp_info[this.value];
		break ;
	    }
            if (this.valueField == 'D2T_AUTO') {
                this.tdvalue.innerHTML = (this.value == undefined || this.value == '0' ? arkwui_lang_get_msg('No') : arkwui_lang_get_msg('Yes'));
                break ;
            }
            if (this.valueField == 'D2T_DELETE_BKP') {
		if (message.data['D2T_AUTO'] == '1') {
                    this.tdvalue.innerHTML = (this.value == undefined || this.value == '0' ? arkwui_lang_get_msg('No') : arkwui_lang_get_msg('Yes'));
                    break ;
		} else {
		    this.tdvalue.innerHTML = ' ';
		    break ;
		}
	    }
	}
	case 'cptinfolist':
	{
            if (this.valueField == 'TYPE') {
		switch (this.value) {
		    case 'S':
		    case 'L':
		        this.tdvalue.innerHTML = arkwui_lang_get_msg('rst_cptlistone_type_' + this.value);
			if (message.data['LINK'] != undefined && message.data['LINK'] != '')
			    this.tdvalue.innerHTML += ' ' + arkwui_lang_get_msg('rst_cptlistone_type_link_to') + ' ' +message.data['LINK'];
		        break ;
		    case 'h':
		    case 'd':
		    case 'v':
		    case 'f':
		    case 'o':
		    case 'a':
  		        this.tdvalue.innerHTML = arkwui_lang_get_msg('rst_cptlistone_type_' + this.value);
 		        break
		    default :
		        this.tdvalue.innerHTML = arkwui_lang_get_msg('rst_cptlistone_type_unknown');
		        break ;
		}
		break ;
	    }
            if (this.valueField == 'FSIZE') {
		if (!this.value)
		    this.tdvalue.innerHTML = ' ';
		else
		    this.tdvalue.innerHTML = parseInt(this.value,16);
		break ;
	    }
            if (this.valueField == 'LABEL') {
		if (!this.value)
		    this.tdvalue.innerHTML = ' ';
		else
		    this.tdvalue.innerHTML = '<div>'+this.value+' <strong>'+arkwui_lang_get_msg('rst_cptlistone_from_seg')+'</strong> '+message.data['SEGSTART']+' <strong>'+arkwui_lang_get_msg('rst_cptlistone_to_seg')+'</strong> '+message.data['SEGEND']+'</div>';
		var labelid = 1;
		while (message.data['LABEL'+labelid] != undefined) {
		    this.tdvalue.innerHTML += '<div>'+message.data['LABEL'+labelid]+' <strong>'+arkwui_lang_get_msg('rst_cptlistone_from_seg')+'</strong> '+message.data['SEGSTART'+labelid]+' <strong>'+arkwui_lang_get_msg('rst_cptlistone_to_seg')+'</strong> '+message.data['SEGEND'+labelid]+'</div>';
		    labelid++;
		}
		break ;
	    }
            if (this.valueField == 'MDATE') {
                if (this.value != '' && this.value)
                   this.tdvalue.innerHTML = transformUtimeToStr(this.value, (arkeia.lang.id == 'en')?4:2);
                else
                    this.tdvalue.innerHTML = ' ';
                break ;
            }

	}
        case 'jrnlbkp_reportmessage':
	{
	    if (this.valueField == 'BRUT') {
		this.tdvalue.innerHTML = '<pre>'+message.data['BRUT']+'</pre>';
		break ;
	    }
	}
        case 'jrnl_reportmessagev2':
	{
	    if (this.valueField == 'BRUT') {
		this.tdvalue.innerHTML = '<pre>'+message.data['item'][0]['BRUT']+'</pre>';
		break ;
	    }
	}
	case 'schedulerrepinfo':
	{
	    if (this.valueField == 'item') {
		checkboxRepWholeVTL = dojo.widget.byId('schedulerform3_REPLICATE_WHOLE_VTL');
		if (!checkboxRepWholeVTL) {
                    dojo.debug(this + ' widget "schedulerform3_REPLICATE_WHOLE_VTL" not found');
		} else {
		    this.tdvalue.innerHTML = dojo.json.serialize(message.data['item']);
		    spkidlist = message.data['item'];
		    if (spkidlist[0]) {
			checkboxRepWholeVTL.setValue(false);
			checkboxRepWholeVTL.onClick(false);
		    } else  {
			checkboxRepWholeVTL.setValue(true);
			checkboxRepWholeVTL.onClick(true);
		    }
		    spklist = dojo.widget.byId('savepacklist');
		    if (!spklist) {
			dojo.debug(this + ' widget "savepacklist" not found');
		    } else {
			spklist.innertable.rowSelected = {};
			for (spkid in message.data['item']) {
			    if (message.data['item'][spkid])
				spklist.innertable.rowSelected['local_' + message.data['item'][spkid]['SPKID']] = 'local_' + message.data['item'][spkid]['SPKID'];
			}
			spklist.innertable.renderSelections();
		    }
		}
		break ;
	    }
	}
    case 'libinfo': {
        if(this.valueField == 'LIB_TYPE' && this.value == 'TAPE_AUTOMATION') {
            this.row.style.display = 'none';
            break;
        }
    }
        default: {
            switch (this.valueField) {
            case 'COMMENT': {
                this.tdvalue.innerHTML = ((this.value == '' || this.value == undefined) ? '<em>'+arkwui_lang_get_msg('Comment_not_set')+'</em>' : this.value);
                break;
            }
            case 'OWNER': {
                this.tdvalue.innerHTML = ((this.value == '' || this.value == undefined) ? '<em>'+arkwui_lang_get_msg('Owner_not_set')+'</em>' : this.value);
                break;
            }
	    case 'PASSWORD':
	    case 'PASSWD': {
                this.tdvalue.innerHTML = '<em>';
		i = this.value.length;
		while (i) {
			this.tdvalue.innerHTML += '*';
		        i--;
		}
		this.tdvalue.innerHTML += '</em>';
                break;
            }
            default: {
                if (this.valueTypeField != '') {
                    innerHTML = ' ';
                    if (message.data[this.valueTypeField] != undefined && 
                        message.data[this.valueTypeField][this.valueField] != undefined) {
                        innerHTML = message.data[this.valueTypeField][this.valueField];
                    } else if (this.itemSelectName == '' &&
                               message.data[this.valueTypeField] != undefined &&
                               message.data[this.valueTypeField][0] != undefined &&
                               message.data[this.valueTypeField][0][this.valueField] != undefined) {
                        innerHTML = message.data[this.valueTypeField][0][this.valueField];
                    } else if (this.itemSelectName != '' && 
                               message.data[this.valueTypeField] != undefined &&
                               message.data[this.valueTypeField][0] != undefined) {
                    	var ok = false;
                    	var found = false;
                        for (i in message.data[this.valueTypeField]) {
                            if (message.data[this.valueTypeField][i][this.itemSelectName] == this.itemSelectValue) {
                            	ok = true;
                            	if (message.data[this.valueTypeField][i][this.valueField] != undefined)
                                	var found = message.data[this.valueTypeField][i][this.valueField];
                        	}
                        }
                        if (found != false) {
                        	innerHTML = found;
                        }
                        if (ok == true && found == false && this.newID != '') {
                        	for (i in message.data[this.valueTypeField]) {
                        		if (message.data[this.valueTypeField][i][this.newID] != undefined) {
	                        			innerHTML = message.data[this.valueTypeField][i][this.newID];
                        		}
                        	}
                        }
                    }
                } else {
                    innerHTML = this.value;
                }

                if (this.optionField == 'not_undefined' && innerHTML == undefined) {
                    if (this.row.style.display != 'none') {
                        this.oldStyleDisplay = this.row.style.display;
                    }
                    this.row.style.display = 'none';
                } else {
                    this.row.style.display = this.oldStyleDisplay;
                    this.tdvalue.innerHTML = (innerHTML == undefined ? ' ' : innerHTML);
                }
            }
            }
        }
        }
    }
}
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.InfoTextWithTable",

    // renderer
    "html",

    // superclass
    arkeia.widget.InfoText,

    // init function
    function(){
        this._data =[];
    },

    // properties and methods
{

    templateString: 
            '<table style="width: 100%;" cellspacing="0" cellpadding="0">'
        + '<tr dojoAttachPoint="row" class="infoText">'
        + '<td dojoAttachPoint="caption" class="infoTextLabel" valign="top">${this.caption}</td>'
        + '<td dojoAttachPoint="tdvalue" class="infoTextValue">${this.value}</td>'
        + '</tr>'
        + '</table>',

    initialize: function() 
    {
        if (this._myname == "InfoText") {
            unitValue = arkwui_lang_get_msg('bkp_showbkp_speed_KB_s');
	}
        if (this.controller != '' && this.action != '') {
            this.params = {};
            this.dataUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
        }
        this.listenedArkeiaParents = [];
        for(var name in this.eventNamesDefault) {
            if (dojo.lang.isUndefined(this.eventNames[name])) {
                this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
            }
        }
    }

});

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.InfoVMBar",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this._data =[];
    },

    // properties and methods
{
    value: "",
    baseUrl: "",
    itemSelectName: "",
    itemSelectValue: "",
    valueTypeField: "",
    imgSrcPath: 'images/Artichow/',
    imgSrcFile: 'repbar',
    imgMode: '',
    imgHeight: '300',
    imgLegend: '',
    controller:'',
    action: '',
    edgefortExpandDisk: false,		

    _myname: "InfoVMBar",

    listenArkeiaParentEvents: ["arkeiaInfoData","arkeiaListSelect"],

    /*templateString: '<tr dojoAttachPoint="row" class="" style="overflow: visible;">'+
                    '<td dojoAttachPoint="tdvalue" class="" style="height: ${this.imgHeight}px; overflow: visible;">${this.value}</td>'+
                    '</tr>',*/

        templateString: '<div dojoAttachPoint="tdvalue">${this.value}</div>',

    initialize: function() 
    {
        var isIE = ((dojo.render.html.capable) && (dojo.render.html.ie));
        if (isIE) {
            this.tdvalue = document.createElement('div');
            dojo.html.setStyleAttributes(this.tdvalue, 'height: '+this.imgHeight+'px; overflow: visible;');
            this.tdvalue.innerHTML = this.value;
            //tmpElem = document.createElement('div');
            //dojo.html.setStyleAttributes(tmpElem, 'overflow: visible;');
            //tmpElem.appendChild(this.tdvalue);
            this.domNode = this.tdvalue;
            //this.row = tmpElem;
        }
        this.listenedArkeiaParents = [];
        for(var name in this.eventNamesDefault) {
            if (dojo.lang.isUndefined(this.eventNames[name])) {
                this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
            }
        }
    },

    postCreate: function(args, frag) 
    {
        var source = this.getFragNodeRef(frag);

        if (this.listened) {
            var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
            this.listenArkeiaParent(t);
        }

        if (!source.dataUrl) source.dataUrl = this.dataUrl;
        var dpClass = arkeia.widget.ArkeiaDataProvider;
        this.dataProvider = new dpClass(source);

    },

    onArkeiaListSelect: function(message) 
    {
        this.onArkeiaInfoData(message);
    },

    onArkeiaInfoData: function(message) 
    {
        this._setInfoData(message);
    },

    _setInfoData: function(message) {

        if (!message.data) {
            this.tdvalue.innerHTML = ' ';
            return ;
        }

        if(message.data['item']['DEV_SIZE']) {

            var k = 0;
            var units = new Array;

            units[0] = arkwui_lang_get_msg('unit_KB');
            units[1] = arkwui_lang_get_msg('unit_MB');
            units[2] = arkwui_lang_get_msg('unit_GB');
            units[3] = arkwui_lang_get_msg('unit_TB');
            units[4] = arkwui_lang_get_msg('unit_PB');
            units[5] = arkwui_lang_get_msg('unit_EB');

            message.data['item']['DEV_SIZE'] = parseInt(message.data['item']['DEV_SIZE']);

            if(message.data['item']['DEV_SIZE'] > 0) {

                message.data['item']['DEV_SIZE_T'] = message.data['item']['DEV_SIZE'];

                while(message.data['item']['DEV_SIZE_T'] > 1024) {

                    message.data['item']['DEV_SIZE_T'] /= 1024;
                    k++;

                }

                message.data['item']['DEV_SIZE_T'] = (Math.round(message.data['item']['DEV_SIZE_T'] * 100) / 100);
                message.data['item']['DEV_SIZE_T_unit'] = units[k];

            } else {

                message.data['item']['DEV_SIZE_T'] = 0;
                message.data['item']['DEV_SIZE_T_unit'] = units[k];

            }

            message.data['item']['USED_SIZE'] = parseInt(message.data['item']['USED_SIZE']);

            k = 0;

            if(message.data['item']['USED_SIZE'] > 0) {

                message.data['item']['USED_SIZE_T'] = message.data['item']['USED_SIZE'];

                while(message.data['item']['USED_SIZE_T'] > 1024) {

                    message.data['item']['USED_SIZE_T'] /= 1024;
                    k++;

                }

                message.data['item']['USED_SIZE_T'] = (Math.round(message.data['item']['USED_SIZE_T'] * 100) / 100);
                message.data['item']['USED_SIZE_T_unit'] = units[k];

            } else {

                message.data['item']['USED_SIZE_T'] = 0;
                message.data['item']['USED_SIZE_T_unit'] = units[k];

            }

            var percent = 0;

            if(message.data['item']['USED_SIZE'] > 0 && message.data['item']['DEV_SIZE'] > 0) {

                percent = (message.data['item']['USED_SIZE'] * 100) / message.data['item']['DEV_SIZE'];

                if(percent < 100) {

                    percent = (Math.round(percent * 100) / 100);

                }

            }

	    if (this.edgefortExpandDisk == true) {
		    this.tdvalue.innerHTML += arkwui_lang_get_msg('app_expanddisk_header');
	    }
	    else {
		    this.tdvalue.innerHTML += arkwui_lang_get_msg('app_vmlist_header');
	    }

            this.tdvalue.innerHTML += '<br />';
            this.tdvalue.innerHTML += '<span style="font-weight: bold;">'+arkwui_lang_get_msg('app_vmlist_space_used')+'</span>: '+message.data['item']['USED_SIZE_T']+message.data['item']['USED_SIZE_T_unit']+', <span style="font-weight: bold;">'+arkwui_lang_get_msg('app_vmlist_space_total')+'</span>: '+message.data['item']['DEV_SIZE_T']+message.data['item']['DEV_SIZE_T_unit']+'<br />';
            this.tdvalue.innerHTML += '<br />';
            this.tdvalue.innerHTML += '<div style="height: 30px; width: 500px; background: transparent url(\''+baseurl+'/' + this.imgSrcPath + this.imgSrcFile + '.php?cat=vm&total=100&used='+((message.data['item']['USED_SIZE'] * 100) / message.data['item']['DEV_SIZE']) + '&prevenCache='+ new Date().valueOf() +'\') no-repeat; text-align: center; padding-top: 6px; font-size: 13px; color: black; font-weight: bold;">'+percent+'%</div>';

            if(typeof message.data['item']['NEED_RESIZE'] != 'undefined') {

                this.tdvalue.innerHTML += '<br />';

                this.tdvalue.innerHTML += '<div id="buttonct"><button id="expander" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('app_vmlist_act_expand')+'</button></div>';

                dojo.event.connect(dojo.byId('expander'), 'onclick', this, 'doExpand');

            }

        } else {

        }

    },

    _launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {

        var source = new Object;
        var DpClass = arkeia.widget.ArkeiaDataProvider;

        source.dataUrl = dataUrl;
        source.getNext = getNext;
        source.abortUrl = abortUrl;

        obj.dataProvider = new DpClass(source);
        obj.dataProvider.loadMultipleResult(obj, callback, null);

        obj.dataProvider.onLoadError = obj.onLoadError;

    },

    onLoadError: function() {
    
    },

    doExpand: function() {

        var _this = this;

	if (this.edgefortExpandDisk == true) {
		var dataUrl = this.baseUrl + '/' + this.controller + '/' + this.action + '?ARRAYID=0';
	}
	else {
		var dataUrl = this.baseUrl + '/' + this.controller + '/' + this.action + '?DISKID=1';
	}
        var getNext = this.baseUrl + '/' + this.controller + '/jsonGetNextResult';
        var abortUrl = this.baseUrl + '/' + this.controller + '/jsonAbortTrans';

        this._launchtrans(_this, this.catchExpand, dataUrl, getNext, abortUrl);

    },

    onRestart: function(obj, result) {

        document.location.href = result;

    },

    catchExpand: function(obj, result) {

        if(result) {

            if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                //getNext
            } else {

                var reg = new RegExp("^(....\/..\/..) (..:..:..) (.).{8} [^ ]*\: (.*)$", "g");

                if(result.message.replace(reg, '$3') != 'E') {

                    if(confirm(result.message.replace(reg, '$4'))) {

                        var dataUrl = obj.baseUrl+'/login/doLogoutrestartNow';
                        var getNext = obj.baseUrl + '/login/jsonGetNextResult';
                        var abortUrl = this.baseUrl + '/login/jsonAbortTrans';
                        obj._launchtrans(obj, obj.onRestart, dataUrl, getNext, abortUrl);
                        document.location.reload();

                    }

                }

            }

        }

    }

}
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.InfoImage",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this._data =[];
    },

    // properties and methods
{
    value: "",
    dataUrl: "",
    itemSelectName: "",
    itemSelectValue: "",
    valueTypeField: "",
    imgSrcPath: 'images/Artichow/',
    imgSrcFile: 'pie',
    imgCategory: '',
    imgMode: '',
    imgHeight: '170',
    imgLegend: '',

    _myname: "InfoImage",

    listenArkeiaParentEvents: ["arkeiaInfoData","arkeiaListSelect"],

    templateString: '<tr dojoAttachPoint="row" class="" style="overflow: visible;">'+
                    '<td dojoAttachPoint="tdvalue" class="" style="height: ${this.imgHeight}px; overflow: visible;">${this.value}</td>'+
                    '</tr>',

    initialize: function() 
    {
        var isIE = ((dojo.render.html.capable) && (dojo.render.html.ie));
        if (isIE) {
            this.tdvalue = document.createElement('div');
            //dojo.html.setClass(this.tdvalue, 'infoImageValue');
            dojo.html.setStyleAttributes(this.tdvalue, 'height: '+this.imgHeight+'px; overflow: visible;');
            this.tdvalue.innerHTML = this.value;
            tmpElem = document.createElement('div');
            //dojo.html.setClass(tmpElem, 'infoText');
            dojo.html.setStyleAttributes(tmpElem, 'overflow: visible;');
            tmpElem.appendChild(this.tdvalue);
            this.domNode = tmpElem;
	    this.row = tmpElem;
        }
        this.listenedArkeiaParents = [];
        for(var name in this.eventNamesDefault) {
            if (dojo.lang.isUndefined(this.eventNames[name])) {
                this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
            }
        }
    },

    postCreate: function(args, frag) 
    {
        var source = this.getFragNodeRef(frag);

        if (this.listened) {
            var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
            this.listenArkeiaParent(t);
        }

        if (!source.dataUrl) source.dataUrl = this.dataUrl;
        var dpClass = arkeia.widget.ArkeiaDataProvider;
        this.dataProvider = new dpClass(source);

    },

    onArkeiaListSelect: function(message) 
    {
        this.onArkeiaInfoData(message);
    },

    onArkeiaInfoData: function(message) 
    {
        this._setInfoData(message);
    },

    _setInfoData: function(message) {

        if (!message.data) {
            this.tdvalue.innerHTML = ' ';
            return ;
        }

        var innerHTML = '';
        var imgLegend = '';
        var j = 0;

        innerHTML += 'cat=' + this.imgCategory;

        for (i in message.data) {

            innerHTML += '&tpids[]='+message.data[i]['TPID'];
            j++;

        }

        if(j > 0) {

            if(this.imgLegend != '') {

                imgLegend = '<img src="'+baseurl+'/'+this.imgSrcPath+this.imgLegend+'" style="position: absolute; z-index: 2; border: 0px; right: 0px;" alt="" />';

            }

            this.tdvalue.innerHTML = (innerHTML == undefined) ? ' ' : imgLegend + '<img src="'+baseurl+'/' + this.imgSrcPath + this.imgSrcFile + '.php?'+innerHTML + '&prevenCache='+ new Date().valueOf() +'" style="border: 0px; overflow: visible;" />';

        } else {

            this.tdvalue.innerHTML = '';

        }

    }

}
);

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.InfoLoader",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
    },

    // properties and methods
{
    baseUrl: "",
    listenArkeiaParentEvents: ["arkeiaInfoData","beforeLoad", "afterLoad"],
    templateString: '<div class="ArkeiaInfoLoader" id="${this.widgetId}"></div>',

    initialize: function() {
        this.listenedArkeiaParents = [];
        var imgsrc=this.baseUrl + "/images/ajax-loader.gif";
        this.domNode.innerHTML='<img src="' + imgsrc + '"/>';
        this.domNode.style.visibility = "hidden";
    },
    postCreate: function(args, frag) {
        if (this.listened) {
            var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
            this.listenArkeiaParent(t);
        }
    },
    onArkeiaInfoData: function(message) {
        this.onAfterLoad(message);
    },
    onAfterLoad: function(message) {
        this.domNode.style.visibility = "hidden";
    },
    onBeforeLoad: function(message) {
        this.domNode.style.visibility = "visible";
    }
}
);


dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.InfoTextList",

    // renderer
    "html",

    // superclass
    arkeia.widget.InfoText,

    // init function
    function(){
        this._data =[];
    },

    // properties and methods
{
    _myname: "InfoTextList",
    templateString: 
        '<div class="infoTextList">'
        + '<div dojoAttachPoint="caption" class="infoTextLabel" valign="top">${this.caption}</div>'
        + '<div dojoAttachPoint="tdvalue" class="infoTextValue">${this.value}</div>'
        + '</div>',

    initialize: function() 
    {
        if (this.controller != '' && this.action != '') {
            this.params = {};
            this.dataUrl = this.baseUrl + "/" + this.controller +"/" + this.action;
        }
        this.listenedArkeiaParents = [];
        for(var name in this.eventNamesDefault) {
            if (dojo.lang.isUndefined(this.eventNames[name])) {
                this.eventNames[name] = this.widgetId+"/"+this.eventNamesDefault[name];
            }
        }
    },

    destroy: function()
    {
        //DEBUG dojo.debug(this + " destroy");
        this.tdvalue.innerHTML = ' ';
        dojo.event.topic.publish(this.widgetId + '/arkeiaParentDestroy', {source: this});
    },

    _setInfoData: function(message) 
    {
        if (!message.data) {
            this.tdvalue.innerHTML = ' ';
            return ;
        }
	innerHTML = message.data[this.valueTypeField][0][this.valueField];
	this.tdvalue.innerHTML = innerHTML;	
	this.afterSetOrAddData(this);
    },

    afterSetOrAddData: function(_this) {
    }
}
);

