dojo.provide("arkeia.widget.ArkeiaList");
dojo.require("arkeia.widget.ArkeiaListener");
dojo.require("arkeia.widget.ArkeiaDataProvider");
dojo.require("arkeia.widget.ArkeiaFilteringTable");
dojo.require("arkeia.widget.ArkeiaInfo");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaList",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this.eventNames={};
    },

    // properties and methods
    {
        widgetsInTemplate: true,
        action: "jsonGetAll",
        baseUrl: arkeia.baseUrl,
        controller: "",
        valueId: "",
        valueField: "",
        timer: 0,
        getNext: "",
        msgmode: false,
        listened: "",
        rowSelected: false,
        itemName: "item",
        isEmpty: true,
        _myname: "arkeialist",
        columns: "[ { field: 'NAME', label: 'Name'}, ]",
        cssStyle: 'ArkeiaList',
        scrollDown: false,
        isConvertible: true,
        initWithoutSelect: false,
        printIfEmpty: '',
	printByDefault: '',
        cols: [
            { field: "NAME", label: "Name"}
        ],
        sortDesc: false,
        sortAsc: false,
        noSort: false,
        customSort: "",
        sortField: "",
        multipleSelectCheckbox: false,
        multipleSelect: false,
        templatePath: dojo.uri.moduleUri('arkeia/widget', 'ArkeiaList.html'),
        templateCssPath: '',// css is in /style/ directory dojo.uri.moduleUri('arkeia/widget', 'ArkeiaList.css'),
        listeners: [],
        idx_select: -1,
        checkPresentInList: false,
        listenAndAction: false,
        newDataListSimplified: false,
        params: null,
        actionQueryVarName: '',
        actionQueryVarValue: '',
        keepCallback: null, 
        keepMsgmode: null, 
        keepParams: null,
        eventNamesDefault: {
            arkeiaListSelect: "arkeiaListSelect",
            arkeiaListDeselect: "arkeiaListDeselect",
            beforeLoad: "beforeLoad",
            afterLoad: "afterLoad"
        },
        listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaAddData", "arkeiaListSelect"],
        _converterData: null,
        dataByAppliance: false,
        alternateRows: false,
        noSelection: false,
	autoLoad: true,
	callAfterSelect: '',
	valueIdFromTransformData: false,
        rowRefreshSelected: false,

        transformData: function(_this, data) {
             // transform data for printing
            return data;
        },

        getActionQuery: function() {
            query = {};
            query[this.actionQueryVarName] = this.actionQueryVarValue;
            return query;
        },

        afterSetOrAddData: function(_this, data, from) {
             //DEBUG dojo.debug(_this + " afterSetOrAddData");
             // call after data change
        },

        populateTable: function(_this, data, noTransformData) {
            //DEBUG dojo.debug(_this + " populateTable ");
            //DEBUG dojo.debug(_this + " populateTable " + dojo.json.serialize(data));
            //DEBUG var start = new Date();
            if (data) {
                _this._gotData = true;
            }
	    if (noTransformData == undefined && _this.transformData) {
                data = _this.transformData(_this, data);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " populateTable time transformData : " + (stop.getTime() - start.getTime())); 
            //_this.clearTable(_this);
            if (data) {
                _this.innertable.store.setData(data);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " populateTable time set data : " + (stop.getTime() - start.getTime())); 
            _this.afterSetOrAddData(_this, data, 'populateTable');
            dojo.event.topic.publish(_this.eventNames.afterLoad, {});
            _this.ajaxloader.onAfterLoad({});
            if (data.length && !_this.msgmode) {
                _this.selectFirst(_this);
            }
            //DEBUG dojo.debug(_this + ' populateTable before timer data:' + data);
            if ((_this.timer > 0) && data) {
                //DEBUG dojo.debug(_this + ' populateTable set timer ' + _this.timer + ' params: ' + dojo.json.serialize(_this.params));
                _this.timeoutId = setTimeout(
                    function () {
                        _this.reload(_this.populateTable, _this.msgmode, _this.params);
                    },
                    _this.timer
                );
            }

            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " populateTable finish : " + (stop.getTime() - start.getTime())); 
            _this.afterLoad(_this);
            return;
        },

        renderTable: function(_this) {
            // this function acts like render() in FilteringTable.
            // It is used for debug.
            var b;
            var rows = [];
            var tbody = {};
            var emptyRowIdx = -1;
            var i = 0;
            var action = '';
            if (!_this.innertable.isInitialized) {
                dojo.debug(_this + " innertable is not initialized");
                _this.innertable.init();
                dojo.debug(_this + " innertable init done");
                if (!b) {
                    dojo.debug(_this + " innertable before prefill");
                    _this.innertable.prefill();
                    dojo.debug(_this + " innertable after prefill");
                    return;
                }
            }
            tbody = _this.innertable.domNode.tBodies[0];
            dojo.debug(_this + "renderTable before push");
            for (i = 0; i < tbody.rows.length; i +=1) {
                rows.push(tbody.rows[i]);
            }
            dojo.debug(_this + "renderTable after push, rows.length: " + rows.length);
            for (i = 0; i < rows.length; i += 1) {
                tbody.appendChild(rows[i]);
                action = _this.innertable.isRowSelected(tbody.rows[i]) ? "addClass" : "removeClass";
                dojo.html[action](tbody.rows[i], _this.innertable.rowSelectedClass);
            }
            dojo.debug(_this + "renderTable after appendchild");
       },

        clearTable: function(_this) {
            dojo.debug(_this + " clearTable");
            _this._gotData = false;
            _this.innertable.store.clearData();
  	    _this.innertable.resetSelections();
	    _this.rowSelected = false;
        },

        getSelectIdx: function(_this) {
            var idx = 0;
            var data;
            //DEBUG dojo.debug(_this + " getSelectIdx rowSelected "+dojo.json.serialize(_this.innertable.rowSelected));
            for (idx in _this.innertable.rowSelected) {
                return _this.innertable.rowSelected[idx];
            }
            return -1;
            // following old code never executed
            data = _this.innertable.store.get();
            for(idx = 0; idx < data.length; idx += 1) {
                if (data[idx].isSelected) {
                    return idx;
                }
            }
        },

        reloadSelectByIdx: function(_this, idx) {
            dojo.debug(_this + ' reloadSelectByIdx idx: ' + idx);
            if (idx !== -1) {
                _this.innertable.resetSelections();
                if (_this.innertable.inTableByValue(idx)) {
                    _this.innertable.toggleSelectionByValue(idx);
                } else {
                    _this.rowSelected = false;
                    _this.selectFirst(_this);
                }
                _this.innertable.renderSelections();
            }
        },

        selectFirst: function(_this) {
            var first_value;
            dojo.debug(this + 'Selectfirst, isEmpty:'+_this.isEmpty+' this.innertable.valueField:' +_this.innertable.valueField);
            if (!_this.initWithoutSelect && !_this.noSelection) {
                if (!_this.isEmpty) {
                    if (_this.innertable.domNode 
                      && _this._gotData && (!_this.rowSelected || _this.rowRefreshSelected)
                      && _this.innertable.domNode.tBodies 
                      && _this.innertable.domNode.tBodies[0] 
                      && _this.innertable.domNode.tBodies[0].rows 
                      && _this.innertable.domNode.tBodies[0].rows[0]
                    ) {
                        if(typeof _this.rowRefreshSelected == 'boolean') {
                            first_value = _this.innertable.domNode.tBodies[0].rows[0].getAttribute('value');
                        } else {
                            first_value = _this.rowRefreshSelected;
                        }
                        //DEBUG dojo.debug(this + 'Selectfirst, first_value:'+first_value);
                        _this.innertable.resetSelections();
                        _this.innertable.renderSelections();
                        _this.innertable.toggleSelectionByValue(first_value);
                        _this.innertable.rowSelected[first_value] = first_value;
                        _this.innertable.renderSelections();
                        _this.rowSelected = true;
                        _this.innertable.callAfterSelect(_this.innertable.domNode.tBodies[0].rows[0]);
                    }
                }
            }
        },

        addData: function(_this, data){
            dojo.debug(_this + " addData");
            //DEBUG dojo.debug(_this + " data: " + dojo.json.serialize(data));
            if (data) {
                _this._gotData = true;
                if (_this.transformData) {
                    data = _this.transformData(_this, data);
                }
                if (data) {
                    _this.innertable.store.addData(data);
                }
                _this.afterSetOrAddData(_this, data, 'addData');
            }
        },

        addDataRange: function(_this, data, message){
            dojo.debug(_this + " addDataRange");
            //DEBUG dojo.debug(_this + " dataRange: " + dojo.json.serialize(data));
            //DEBUG var start = new Date();
            if (data) {
                _this._gotData = true;
                if (_this.transformData) {
                    data = _this.transformData(_this, data);
                }
                //DEBUG var start = new Date();
                if (data) {
                    _this.innertable.store.addDataRange(data);
                }
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(_this + " addDataRange before render exectime: " + (stop.getTime() - start.getTime()));
                if (message.last) {
                    _this.innertable.render();
                }
                _this.afterSetOrAddData(_this, data, 'addDataRange');
            }
            //DEBUG dojo.debug(_this + " addDataRange Finish exectime: " + (stop.getTime() - start.getTime()));
        },

        reloadChangeParams: function(_this, params) {
            // function for modify params before reload data
            return params;
        },

        reloaddata: function(_this) {
            dojo.debug(_this + ' reloaddata ');
            //DEBUG dojo.debug(_this + ' reloaddata ' + _this.keepCallback + ', ' + _this.keepMsgmode + ', ' + _this.keepParams);
            if (_this.keepCallback !== null) {
                _this.reload(_this.keepCallback, _this.keepMsgmode, _this.keepParams);
            }
        },

        reload: function(callback, msgmode, params) {
            var _this = this;
            this.keepCallback = callback;
            this.keepMsgmode = msgmode;
            this.keepParams = params;
            params = this.reloadChangeParams(_this, params);
            dojo.event.topic.publish(this.eventNames.beforeLoad, {});
            this.ajaxloader.onBeforeLoad({});
            if (msgmode) {
                dojo.debug(this + ' reload in msgmode' + this.keepMsgmode);
                this.isEmpty = true;
                this.idx_select = this.getSelectIdx(_this);
                this.dataProvider.loadMultipleResult(_this, this.newResult, params);
            } else {
                dojo.debug(this + " reload");
                this.dataProvider.loadRemoteData(_this, callback, params);
            }
        },

        afterLoad: function(_this) {},

        onLoadError: function(_this) {
            _this.ajaxloader.onAfterLoad({});
        },

        newResult: function(_this, message) {
            dojo.debug(_this + ' newResult appid:' + message.appid + ' appname:' + message.appliance_name);
            if (message.data !== undefined) {
                _this.newDataList(_this, message.data, message.appid, message.appliance_name, false, message);
            }
            if (message.last) {
                dojo.debug(_this + " newResult last message");
                dojo.event.topic.publish(_this.eventNames.afterLoad, {});
                _this.ajaxloader.onAfterLoad({});
                _this.selectFirst(_this);
                _this.afterLoad(_this);
            } else {
                dojo.debug(_this + " newResult not last message: "+message.last/* message:"+dojo.json.serialize(message)*/); 
            }
        },

        setConverterData: function(_this, data) {
            dojo.debug(_this + " setConverterData");
            _this._converterData["local"] = data;
            return;
        },

        setResultConverterData: function(_this, message) {
            var appid = message.appid;
            var mdata = message.data;
            //DEBUG dojo.debug(this + " setResultConverterData message: "+dojo.json.serialize(message));
            if (!appid) {
                appid = 'local';
            }
            if (mdata) {
                _this._converterData[appid] = mdata;
                mdata = _this.convertData(_this, _this._data_to_convert[appid], appid);
                if (mdata) {
                    _this._data_to_convert[appid] = null;
                    _this.populateTable(_this, mdata);
                }
            }
        },

        newDataList: function(_this, mdata, appid, appliance_name, fromArkeiaInfo, message) {
            var present = false;
            var i = 0;
            var data;
            var realdata;
            var objDiv = {};
            //DEBUG var start = new Date();
            //DEBUG dojo.debug(_this + " newDataList mdata: "+dojo.json.serialize(mdata)+' itemName:'+_this.itemName+' appid:'+appid+' isEmpty: '+_this.isEmpty+' idx_select: '+_this.idx_select);
            if (_this.newDataListSimplified) {
                _this.populateTable(_this, mdata);
                return;
            }
            if (mdata.local) {
                mdata = mdata.local;
            }
            if (_this.isEmpty) {
                if (_this.checkPresentInList) {
                    for (i in mdata[_this.itemName]) {
                        if (i == _this.valueId) {
                            present = true;
                        } else {
                            for (j in mdata[_this.itemName][i]) {
                                if (j == _this.valueId) {
                                    present = true;
                                }
                            }
                        }
                    }
                } else {
                    present = true;
                }
                dojo.debug(this + ' empty ? present: "' + present + '", itemName: "' + _this.itemName /*+ '", mdata: ' + dojo.json.serialize(mdata)*/);
                if (!present || mdata == '' || (mdata[_this.itemName] == undefined && !_this.dataByAppliance) /*|| !mdata[_this.itemName]*/) {
		    dojo.debug(_this + " no mdata, clear table end return ");
		    _this.clearTable(_this);
		    _this.isEmpty = true;
		    if (_this.printIfEmpty != '') {
                        data = dojo.json.evalJson(_this.printIfEmpty);
                        dojo.debug(this + ' empty: Fill table with "' + _this.printIfEmpty + '"');
			_this.populateTable(_this, data);
		    }
		    return;
                } else {
                    _this.clearTable(_this);
                }
            }
            _this.isEmpty = false;
            data = [];
            if (_this.dataByAppliance && (mdata.ERROR != undefined || mdata.NOLOG != undefined)) {
                realdata = mdata;
            } else {
                if (mdata == '' 
                  || mdata[_this.itemName] == undefined
                  || !mdata[_this.itemName]
                ) {
                    return;
                }
                if (mdata[_this.itemName][0] != undefined 
                  && mdata[_this.itemName][0].item != undefined
                  && mdata[_this.itemName][0].item.length > 0
                ) {
                    realdata = mdata[_this.itemName][0]['item'];
                } else {
                    if (mdata[_this.itemName] != undefined 
                      && mdata[_this.itemName].item != undefined 
                      && mdata[_this.itemName].item.length > 0
                    ) {
                        realdata = mdata[_this.itemName].item;
                    } else {
                        if (mdata[_this.itemName].length > 0) {
                            realdata = mdata[_this.itemName];
                        } else {
                            if (mdata[_this.itemName][_this.valueId]) {
                                realdata = [
                                    mdata[_this.itemName]
                                ];
                            } else if (mdata[_this.itemName][0] == undefined) {
				realdata = [mdata[_this.itemName]];
			    }
                        }
                    }
                }
            }
            if (_this.dataByAppliance) {
                data.push({CONTENT: realdata});
            } else if (realdata != undefined) {
                for (i = 0; i < realdata.length; i += 1) {
                    if (realdata[i][_this.valueId] || _this.valueIdFromTransformData) {
                        data.push(realdata[i]);
                    }
                }
            }
            if (appid && _this.msgmode) {
                for (i = 0; i < data.length; i += 1) {
                    data[i][_this.valueField] = appid + '_' + data[i][_this.valueId];
                    data[i].APPLIANCE_GUID = appid;
                    // DEBUG dojo.debug(_this + " valueField:"+ data[i][_this.valueField]);
                    if (appliance_name) {
                        data[i].APPLIANCE_NAME = appliance_name;
                    }
                }
            }
            data = _this.convertData(_this, data, appid);
            if (appid && appid != 'local' && _this.msgmode) {
                if (data) {
                    dojo.debug(_this + " add Data for "+appid + " : " +(appliance_name?appliance_name:"unknown"));
                    if (fromArkeiaInfo) {
                        _this.populateTable(_this, data);
                    } else {
                        _this.addDataRange(_this, data, message);
                    }
                }
            } else if (data) {
                _this.populateTable(_this, data);
            }
            _this.reloadSelectByIdx(_this, _this.idx_select);
            if (_this.scrollDown) {
                dojo.debug(_this + " scroll down");
                objDiv = _this.innertable.domNode.tBodies[0];
                objDiv.scrollTop = objDiv.scrollHeight;
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " newDataList Finish exectime: " + (stop.getTime() - start.getTime()));
        },

        convertData: function(_this, data, appid) {
            var params = null;
            var i = 0;
            var x = 0;
            var val;
            //DEBUG var start = new Date();
            dojo.debug(_this + " convertData appid: "+appid);
            //DEBUG dojo.debug(_this + " convertData: "+dojo.json.serialize(data));
            if (_this._converterData == null) {
                return data; // no conversion
            }
            if (!appid) {
                appid = 'local';
            }
            if (!_this._converterData[appid]) {
                // Don't have _converterData for this appid.
                // We have to load it...
                if (appid != 'local') {
                    params = {};
                    params.APPLIANCE_GUID = appid;
                }
                _this._data_to_convert[appid] = data;
                _this.dataProvider.loadMultipleResult(_this, _this.setResultConverterData, params);
                return null; // return null
            }
            dojo.debug(_this + " converting data");
            for (i = 0; i < data.length; i += 1) {
                for (x = 0; x < _this.cols.length; x += 1) {
                    if (data[i][_this.cols[x].field]) {
                        continue;
                    }
                    val = _this._converterData[appid][data[i][_this.valueId]];
                    if (val) {
                        data[i][_this.cols[x].field] = val;
                    }
                }
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " convertData Finish exectime: " + (stop.getTime() - start.getTime()));
            return data;
        },

        onArkeiaListSelect: function(message) {
            var _this = this;
            //DEBUG dojo.debug(this + " onArkeiaListSelect got message "+dojo.json.serialize(message));
            this.params = message.data;
            if (this.dataProvider == undefined) {
                this.newDataList(_this,message.data,message.appid,0, true, message);
            } else {
                this.reload(this.populateTable, this.msgmode, message.data);
            }
        },

        onArkeiaInfoData: function(message) {
            //DEBUG dojo.debug(this + " onArkeiaInfoData got message "+dojo.json.serialize(message));
            var _this = this;
            this.isEmpty = true;
            if (!message.data) {
                dojo.debug(this + " onArkeiaInfoData got message with no data");
                this.clearTable(this);
            } else {
                this.params = message.data;
                if (this.listenAndAction) {
                    this.reload(this.populateTable, this.msgmode, message.data);
                } else {
                    this.newDataList(_this,message.data,message.appid,0, true, message);
                }
                this.selectFirst(_this);
            }
        },

        onArkeiaAddData: function(message) {
            //DEBUG dojo.debug(this + " onArkeiaAddData got message "+this._msgnum+ ":"+dojo.json.serialize(message));
            var _this = this;
            var objDiv = {};
            if (message.data) {
                message.data.NUM = ++(this._msgnum);
                this.addData(_this, message.data);
                if (_this.scrollDown) {
                    objDiv = _this.innertable.domNode.tBodies[0];
                    objDiv.scrollTop = objDiv.scrollHeight;
                }
            }
        },

        /**
         * publish destruction event so that any listeners should stop listening
         */
        destroy: function() {
            dojo.debug(this + " destroy");
            if (this.timeoutId) {
                clearTimeout(this.timeoutId);
            }
            this.timer = 0;
            dojo.event.topic.publish(this.widgetId + '/arkeiaParentDestroy', {source: this});
            if (this.dataProvider) {
                this.dataProvider.destroy();
            }
            return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },

        initialize: function(args, frag) {
            var name;
            var source = this.getFragNodeRef(frag);
            var DpClass = arkeia.widget.ArkeiaDataProvider;
            // Adjust event names
            this._converterData = null;
            this._gotData = false;
            this._msgnum = 0;
            if (this.msgmode) {
                this.valueField = 'APPID_' + this.valueId;
            } else {
                this.valueId = this.valueField;
            }
            if (this.noSelection) {
                delete this.eventNamesDefault.arkeiaListSelect;
                delete this.eventNamesDefault.arkeiaListDeselect;
            }
            if (this.multipleSelectCheckbox) {
                this.multiselcontener.style.display = 'block';
                this.multiseltext.innerHTML = ': ' + arkeia.lang.getMsg('Multi_selection');
            }
            this.listenedArkeiaParents = [];
            for (name in this.eventNamesDefault) {
                if (this.eventNames[name] === undefined) {
                    this.eventNames[name] = this.widgetId + '/' + this.eventNamesDefault[name];
                }
            }
            this.dataUrl = '';
            if (this.controller) {
                this.dataUrl = this.baseUrl + '/' + this.controller + '/' + this.action;
                if (this.actionQueryVarName != '' && this.actionQueryVarValue != '') {
                    this.dataUrl += '?' + this.actionQueryVarName + '=' + this.actionQueryVarValue;
                }
                if (this.getNext == '') {
                    this.getNext = this.baseUrl + '/' + this.controller + '/jsonGetNextResult';
                }
                this.abortUrl = this.baseUrl + '/' + this.controller + '/jsonAbortTrans';
                if (!source.dataUrl) {
                    source.dataUrl = this.dataUrl;
                }
                if (!source.getNext) {
                    source.getNext = this.getNext;
                }
                if (!source.abortUrl) {
                    source.abortUrl = this.abortUrl;
                }
                this.dataProvider = new DpClass(source);
                this.dataProvider.onLoadError = this.onLoadError;
            }
        },

        postCreate: function() {
            var _this = this;
            var toListen = {};
            dojo.event.connect(this.innertable, 'onDataToggle',this, 'dataSelected');
            if (this.columns) {
                this.setColumns(dojo.json.evalJson(this.columns));
            }
            this.clearTable(this);
            // Declare itself to listeners.
            dojo.lang.forEach(
                this.listeners,
                function(elem) {
                    var toListen = {};
                    dojo.debug(_this + "got one listener");
                    toListen = dojo.lang.isString(elem) ? dojo.widget.byId(elem) : elem;
                    // To activate to prevent fatal error when sure that it doesn't provide new bugs
                    //if (!toListen) {
                    //    dojo.debug(_this + ' widget "' + toListen + '" not found. Can\'t listen');
                    //} else {
                        toListen.listenArkeiaParent(_this);
                    //}
                }
            );
            if (this.multipleSelect) {
                this.changeMultipleSelect(this, true);
            }
            if (this.listened) {
                toListen = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                // To activate to prevent fatal error when sure that it doesn't provide new bugs
                //if (!toListen) {
                //    dojo.debug(this + ' widget "' + toListen + '" not found. Can\'t listenArkeiaParent');
                //} else {
                    this.listenArkeiaParent(toListen);
                //}
                if (this.dataUrl !== '' && this.isConvertible) {
                    this._converterData = [];
                    this._data_to_convert = [];
                    if (!this.msgmode) {
                        this.reload(this.setConverterData, false, null);
                    } 
                }
            } else if (this.dataUrl !== '' && this.autoLoad) {
                this.reload(this.populateTable, this.msgmode, null);
            } else if (!this.autoLoad) {
                if (_this.printByDefault != '') {
                    data = dojo.json.evalJson(_this.printByDefault);
                    dojo.debug(this + ' empty: Fill table with "' + _this.printByDefault + '"');
		    _this.populateTable(_this, data, true);
                }

	    }
	    this.afterWidgetCreate();
        },

	afterWidgetCreate: function () {
	},

        changeMultipleSelect: function (_this, val) {
            _this.multipleSelect = val;
            if (_this.multipleSelect) {
                idx_select = _this.getSelectIdx(_this);
                _this.innertable.resetSelections();
                _this.rowSelected = false;
                _this.innertable.renderSelections();
                _this.innertable.multiple = true;
                _this.reloadSelectByIdx(_this, idx_select);
            } else {
                _this.innertable.resetSelections();
                _this.rowSelected = false;
                _this.innertable.renderSelections();
                _this.innertable.multiple = false;
                _this.selectFirst(_this);
            }
        },

        setColumns: function(cols) {
            var x = 0;
            //DEBUG dojo.debug(this + ' Setcolumns');
            this.cols = cols;
            if (this.sortDesc) {
                this.innertable.sortInformation[0].direction = 1;
            }
            if (this.sortAsc) {
                this.innertable.sortInformation[0].direction = 0;
            }
            if (this.multipleSelect) {
                this.innertable.multiple = true;
            }
            if (this.noSort) {
                this.innertable.maxSortable = 0;
                this.innertable.noSort = true;
            }
            for (x = 0; x < this.cols.length; x += 1) {
                this.innertable.columns.push(
                this.innertable.createMetaData(this.cols[x]));
            }
        },

        getSelectedData: function() {
            dojo.debug(this + " getSelectedData");
            return this.innertable.getSelectedData();
        },

        dataSelected: function() {
            dojo.debug(this + " dataSelected");
            var data = this.getSelectedData();
            var eventName = '';
            var list_id = [];
            var list_appid = [];
            var i;
            //DEBUG dojo.debug(this + " dataSelected data : " + dojo.json.serialize(data));
            if ((data && !dojo.lang.isArray(data)) || (dojo.lang.isArray(data) && (data.length || this.multipleSelect))) {
                this.rowSelected = true;
                eventName = this.eventNames.arkeiaListSelect;
                if (this.multipleSelect) {
                    for (i in data) {
                        list_id[i] = data[i][this.valueField];
                        list_appid[i] = data[i].APPLIANCE_GUID;
                    }
                    dojo.event.topic.publish(eventName, { id: list_id, appid: list_appid, data: data });
                    dojo.debug(this + " published "+eventName+" for multiselect " + dojo.json.serialize(list_id) /*+ ' data: '+ dojo.json.serialize(data)*/);
                } else {
                    dojo.event.topic.publish(eventName, { id: data[this.valueField], appid: data['APPLIANCE_GUID'], data: data });
                    dojo.debug(this + " published "+eventName+" for " + this.valueField /*+ " data:" + data[this.valueField] + ' data: '+ dojo.json.serialize(data)*/);
                }
            }
            if(this.rowRefreshSelected && this.innertable.clicked) {
                this.innertable.clicked = false;
                for(var idx in this.innertable.rowSelected) {
                    this.rowRefreshSelected = idx;
                }
            }
        }

    }
);



dojo.widget.defineWidget(
    'arkeia.widget.ArkeiaTable',

    dojo.widget.HtmlWidget, 

    function() {
        this.store = new dojo.collections.Store();
        this.valueField = 'Id';
        this.multiple = false;
        this.rowSelected = {};
        this.sortInformation = [
            {
                index:0,
                direction:0
            }
        ];
        this.maxSortable = 1;
        this.isInitialized = false;
        this.columns = [];
        // CSS definitions
        this.headClass = '';
        this.tbodyClass = '';
        this.headerClass = '';
        this.headerUpClass = 'selectedUp';
        this.headerDownClass = 'selectedDown';
        this.rowClass = '';
        this.rowAlternateClass = 'alt';
        this.rowSelectedClass = 'selected';
        this.columnSelected = 'sorted-column';

        this.clicked = false;
    },

    {
        //  dojo widget properties

        isContainer: false,
        templatePath: null,
        templateCssPath: null,
        sortColumn: '',
        sortInfo: {},
        rowSelected: {},
        alternateRows: false,
	noSort: false,
    customSort: "",

        //  methods.

        toggleSelection: function (obj) {
            //  summary
            //  Flips the selection state of passed obj.
            //DEBUG dojo.debug(this + " toggleSelection obj: " + dojo.json.serialize(obj));
            //DEBUG dojo.debug(this + " toggleSelection rowSelected: " + dojo.json.serialize(this.rowSelected));
            var key;
            if (obj == null) {
                return ;
            }
            key = obj[this.valueField];
            if (this.rowSelected[key] != undefined || this.rowSelected[key]) {
                delete this.rowSelected[key];
            } else {
                this.rowSelected[key] = key;
            }
            //DEBUG dojo.debug(this + " toggleSelection key: " + key);
            //DEBUG dojo.debug(this + " toggleSelection rowSelected: " + dojo.json.serialize(this.rowSelected));
            this.onDataToggle(obj);
        },

        toggleSelectionByIndex: function(idx) {
            //DEBUG dojo.debug(this + " toggleSelectionByIndex idx: " + idx);
            //  summary
            //  Flips the selection state of object at index idx.
            this.toggleSelection(this.store.getDataByIndex(idx));
        },

        toggleSelectionByValue: function(val) {
            //DEBUG dojo.debug(this + " toggleSelectionByValue val:"+val);
            //      summary
            //      Flips the selection state of object represented by val.
            this.toggleSelection(this.store.getDataByKey(val));
        },

        inTableByValue: function(val) {
            if (this.store.getDataByKey(val)) {
                return true;
            }
            return false;
        },

        toggleSelectionByRow: function(/*HTMLTableRow*/row){
            //DEBUG dojo.debug(this + " toggleSelectionByRow");
            //  summary
            //  Flips the selection state of object represented by row.
            this.toggleSelection(this.getDataByRow(row));
        },

        onDataToggle: function(/* object */obj){ 
            //DEBUG dojo.debug(this + " onDataToggle");
            //  summary
            //  Stub for onDataToggle event.
        },

        selectNone: function() {
            this.resetSelections();
            this.renderSelections();
        },

    selectReverse: function() {
        //DEBUG dojo.debug(this + " selectReverse");
        var i = 0;
        var rows = this.domNode.tBodies[0].rows;
        for (i; i < rows.length -1; i += 1) {
            key = rows[i].getAttribute("value");
            if (this.rowSelected[key] != undefined || this.rowSelected[key]) {
                delete this.rowSelected[key];
            } else {
                this.rowSelected[key] = key;
            }
        }
        this.renderSelections();
        //DEBUG dojo.debug(this + " selectReverse end");
    },

        selectAll: function(){
            //DEBUG dojo.debug(this + " selectAll");
            var i = 0;
            var rows = this.domNode.tBodies[0].rows;
            for (i; i < rows.length - 1; i += 1) {
                key = rows[i].getAttribute('value');
                this.rowSelected[key] = key;
            }
            this.renderSelections();
            //DEBUG dojo.debug(this + " selectAll end");
        },

        renderSelections: function() {
            //DEBUG var start = new Date();
            //DEBUG dojo.debug(this + " renderSelections rowSelected : " + dojo.json.serialize(this.rowSelected));
            //  summary
            //  Render all selected objects using CSS.
            var i = 0;
            var action = '';
            var rows = this.domNode.tBodies[0].rows;
            for (i; i < rows.length; i += 1) {
                action = (this.rowSelected[rows[i].getAttribute('value')]) ? 'addClass' : 'removeClass';
                dojo.html[action](rows[i], this.rowSelectedClass);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " renderSelections exectime: " + (stop.getSeconds() - start.getSeconds()));
        },

        resetSelections: function() {
            //DEBUG dojo.debug(this + " resetSelections");
            //  summary
            //  Unselects all data objects.
            this.rowSelected = {};
        },

        //  parsing functions, from HTML to metadata/SimpleStore
        _meta: {
            field: null,
            format: null,
            filterer: null,
            noSort: false,
            sortType: 'String',
            dataType: String,
            sortFunction: null,
            filterFunction: null,
            label: null,
            align: 'left',
            valign: 'top',
            getField: function() { 
                return this.field || this.label;
            },
            getType: function() { 
                return this.dataType; 
            }
        },

        createMetaData: function(obj){
            //DEBUG dojo.debug(this + " createMetaData");
            //  summary
            //  Take a JSON-type structure and make it into a ducktyped metadata object.
            var p;
            for(p in this._meta){
                //  rudimentary mixin
                if(!obj[p]){
                    obj[p] = this._meta[p];
                }
            }
            if(!obj.label){
                obj.label = obj.field;
            }
            if(!obj.filterFunction){
                obj.filterFunction = this._defaultFilter;
            }
            //DEBUG dojo.debug(this + " createMetaData end");
            return obj; //  object
        },

        getSelectedData: function(){
            //DEBUG dojo.debug(this + " getSelectedData");
            //  summary
            //  returns all objects that are selected.
            var a = [];
            var key;
            for (key in this.rowSelected) {
                //dojo.debug(this + " getSelectedData key : " + dojo.json.serialize(key));
                data = this.store.getByKey(key);
                //dojo.debug(this + " getSelectedData data : " + dojo.json.serialize(data));
                a.push(data.src);
            }
            //DEBUG dojo.debug(this + " getSelectedData return : " + dojo.json.serialize(a));
            if (this.multiple) {
                return a;       //  array
            } else {
                return a.shift();   //  object
            }
        },

        init: function() {
            //DEBUG dojo.debug(this + " init");
            //DEBUG var start = new Date();
            //  summary
            //  initializes the table of data
            var thead = {};
            var tbody = {};
            var row = {};
            var cell = {};
            var cellTag = 'td';
            var i = 0;
            var j = 0;
            var idx = 0;
            var data;
            var headers = [];
            var dir;
            var newClass = '';
            this.isInitialized = false;
            //  if there is no thead, create it now.
            thead = this.domNode.getElementsByTagName('thead')[0];
            if (thead.getElementsByTagName('tr').length == 0) {
                //  render the column code.
                row = document.createElement('tr');
                for (i = 0; i < this.columns.length; i += 1) {
                    cell = document.createElement('td');
                    cell.setAttribute('align', this.columns[i].align);
                    cell.setAttribute('valign', this.columns[i].valign);
                    cell.setAttribute('width', this.columns[i].width);
                    dojo.html.disableSelection(cell);
                    cell.innerHTML = this.columns[i].label;
                    row.appendChild(cell);
                    //  attach the events.
                    if (!this.columns[i].noSort) {
                        dojo.event.connect(cell, "onclick", this, "onSort");
                    }
                }
                dojo.html.prependChild(row, thead);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 1: " + (stop.getTime() - start.getTime()));
            if (this.store.get().length === 0) {
                return false;
            }
            idx = this.domNode.tBodies[0].rows.length;
            if(!idx || idx === 0 || this.domNode.tBodies[0].rows[0].getAttribute('emptyRow') == 'true') {
                idx = 0;
                tbody = this.domNode.tBodies[0];
                while (tbody.childNodes.length > 0) {
                    tbody.removeChild(tbody.childNodes[0]);
                }
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(this + " init 1.1: " + (stop.getTime() - start.getTime()));
                data = this.store.get();
                for (i = 0; i < data.length; i += 1){
                    if(data[i].key == null) {
                        data[i].key = idx;
                    }
                    row = this.createRow(data[i]);
                    tbody.appendChild(row);
                    idx += 1;
                }
                // *-- makes ff3 happy with lists
                if(this.widgetId != 'GlobalMessages_table') { //Cause some troubles in job screen
                    row = document.createElement('tr');
                    row.setAttribute('class', 'alternateRow');
                    row.setAttribute('style', 'height: auto; background-color: transparent; cursor: default; line-height: 0px; font-size: 1px;');
                    row.setAttribute('emptyRow', 'true');
                    row.setAttribute('value', idx+1); //this blank lin need to be the last so in ordered list we set a big value
                    for (j = 0; j < this.columns.length; j += 1) {
                        cell = document.createElement('td');
                        cell.setAttribute('style', 'cursor: default;');
                        cell.innerHTML = '&nbsp;';
                        dojo.html.disableSelection(cell);
                        row.appendChild(cell);
                    }
                    tbody.appendChild(row);
                }
                // * -- makes ff3 happy with lists
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(this + " init 1.2: " + (stop.getTime() - start.getTime()));
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 2: " + (stop.getTime() - start.getTime()));
            //  add empty rows
            if (this.minRows > 0 && idx < this.minRows) {
                idx = this.minRows - idx;
                for (i = 0; i < idx; i += 1) {
                    row = document.createElement('tr');
                    row.setAttribute('emptyRow', 'true');
                    for (j = 0; j < this.columns.length; j += 1) {
                        cell = document.createElement('td');
                        cell.innerHTML = '&nbsp;';
                        row.appendChild(cell);
                    }
                    tbody.appendChild(row);
                }
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 3: " + (stop.getTime() - start.getTime()));
            //  last but not least, show any columns that have sorting already on them.
            row = this.domNode.getElementsByTagName('thead')[0].rows[0];
            if (row.getElementsByTagName(cellTag).length == 0){
                cellTag = 'th';
            } 
            headers = row.getElementsByTagName(cellTag);
            for (i = 0; i < headers.length; i += 1){
                dojo.html.setClass(headers[i], this.headerClass);
            }
            for (i = 0; i < this.sortInformation.length; i += 1) {
                idx = this.sortInformation[i].index;
                dir = (~this.sortInformation[i].direction)&1;
                newClass = (dir == 0) ? this.headerDownClass : this.headerUpClass;
                dojo.html.setClass(headers[idx], newClass);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 4: " + (stop.getTime() - start.getTime()));
            this.isInitialized = true;
            return true;
        },

        //  widget lifetime handlers
        initialize: function() { 
            //  summary
            //  Initializes the widget.
            var self = this;
            //  connect up binding listeners here.
            dojo.event.connect(
                this.store, 
                'onSetData',
                function() {
                    //DEBUG dojo.debug(this + " onSetData");
                    var tbody = {};
                    self.store.forEach(
                        function(element) {
                            element.isSelected = false;
                        }
                    );
                    self.isInitialized = false;
                    self.sortInfo = {};
                    tbody = self.domNode.tBodies[0];
                    if (tbody) {
                        while (tbody.childNodes.length > 0) {
                            tbody.removeChild(tbody.childNodes[0]);
                        }
                    }
                    self.render();
                }
            );
            dojo.event.connect(
                this.store,
                'onClearData',
                function() {
                    //DEBUG dojo.debug(this + " onClearData");
                    self.isInitialized = false;
                    self.sortInfo = {};
                    self.render();
                }
            );
            dojo.event.connect(
                this.store,
                'onAddData',
                function (addedObject) {
                    //DEBUG dojo.debug(this + " onAddData");
                    var row = self.createRow(addedObject);
                    self.domNode.tBodies[0].appendChild(row);
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onUpdateData',
                function (updatedObject) {
                    //DEBUG dojo.debug(this + " onUpdateData");
                    var oldRow = self.getRow(self.store.getDataByKey(updatedObject[self.store.keyField]));
                    var newRow = self.createRow(updatedObject);
                    self.domNode.tBodies[0].replaceChild(newRow, oldRow);
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onAddDataRange', 
                function (arr) {
                    //DEBUG dojo.debug(this + " onAddDataRange");
                    //DEBUG var start = new Date();
                    var i = 0;
                    var row = {};
                    for (i; i < arr.length; i += 1) {
                        arr[i].isSelected = false;
                        row = self.createRow(arr[i]);
                        self.domNode.tBodies[0].appendChild(row);
                        //DEBUG var stop = new Date();
                        //DEBUG dojo.debug(this + " onaddDataRange "+i+" exectime: " + (stop.getSeconds() - start.getSeconds()));
                    };
                    //DEBUG var stop = new Date();
                    //DEBUG dojo.debug(this + " onaddDataRange after appendchild exectime: " + (stop.getSeconds() - start.getSeconds()));
                    //self.render(); Render in ArkieaList widget after recieved all appliance data
                    //DEBUG var stop = new Date();
                    //DEBUG dojo.debug(this + " onaddDataRange after render exectime: " + (stop.getSeconds() - start.getSeconds()));
                }
            );
            dojo.event.connect(
                this.store, 
                'onUpdateDataRange', 
                function (arr) {
                    //DEBUG dojo.debug(this + " onUpdateDataRange");
                    var old = {};
                    var row = {};
                    var i = 0;
                    for (i; i < arr.length; i += 1) {
                        old = self.getRow(self.store.getDataByKey(arr[i][self.store.keyField]));
                        row = self.createRow(arr[i]);
                        self.domNode.tBodies[0].replaceChild(row, old);
                    };
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onRemoveData',
                function (removedObject) {
                    //DEBUG dojo.debug(this + " onRemoveData");
                    var i = 0;
                    var rows = self.domNode.tBodies[0].rows;
                    for (i = 0; i < rows.length; i += 1) {
                        if (self.getDataByRow(rows[i]) == removedObject.src) {
                            rows[i].parentNode.removeChild(rows[i]);
                            break;
                        }
                    }
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onUpdateField', 
                function (obj, fieldPath, val) {
                    //DEBUG dojo.debug(this + " onUpdateField");
                    var row = self.getRow(obj);
                    var idx = self.getColumnIndex(fieldPath);
                    if (idx > -1 && row && row.cells && row.cells[idx] && self.columns[idx]) {
                        self.fillCell(row.cells[idx], self.columns[idx], val);
                    }
                }
            );
        },

        postCreate: function(){
            //DEBUG dojo.debug(this + " postCreate");
            //  summary
            //  finish widget initialization.
            var thead = {};
            var header = 'td';
            var tbody = {};
            var i = 0;
            this.store.keyField = this.valueField;
            if (this.domNode) {
                //  start by making sure domNode is a table element;
                if (this.domNode.nodeName.toLowerCase() != "table") {
                }
                //  see if there is columns set up already
                if (this.domNode.getElementsByTagName("thead")[0]) {
                    thead = this.domNode.getElementsByTagName('thead')[0];
                    if (this.headClass.length > 0) {
                        dojo.html.setClass(thead, this.headClass);
                    }
                    dojo.html.disableSelection(this.domNode);
                    this.parseMetadata(head);
                    if (thead.getElementsByTagName(header).length == 0) {
                        header = 'th';
                    }
                    headers = thead.getElementsByTagName(header);
                    for (i = 0; i < headers.length; i += 1) {
                        if (!this.columns[i].noSort) {
                            dojo.event.connect(headers[i], 'onclick', this, 'onSort');
                        }
                    }
                } else {
                    this.domNode.appendChild(document.createElement('thead'));
                }
                // if the table doesn't have a tbody already, add one and grab a reference to it
                if (this.domNode.tBodies.length < 1) {
                    tbody = document.createElement('tbody');
                    this.domNode.appendChild(tbody);
                } else {
                    tbody = this.domNode.tBodies[0];
                }
                if (this.tbodyClass.length > 0){
                    dojo.html.setClass(tbody, this.tbodyClass);
                }
                dojo.event.connect(tbody, 'onclick', this, 'onSelect');
                this.parseData(tbody);
            }
        },

        parseData: function(/* HTMLTableBody */tbody){
            //DEBUG dojo.debug(this + " parseData");
            //  summary
            //  Parse HTML data into native JSON structure for the store.
            var i = 0;
            var self = this;
            var arr;
            if (tbody.rows.length == 0 && this.columns.length == 0) {
                //DEBUG dojo.debug(this + " parseData nothing");
                return; //  there's no data, ignore me.
            }
            //  create a data constructor based on what we've got for the fields.
            this["__selected__"] = [];
            arr = this.store.getFromHtml(
                this.columns,
                tbody,
                function (obj, row) {
                    if (obj[self.valueField] === undefined || obj[self.valueField] === null) {
                        obj[self.valueField] = dojo.html.getAttribute(row, "value");
                    }
                    if (dojo.html.getAttribute(row, "selected")=="true") {
                        self["__selected__"].push(obj);
                    }
                }
            );
            this.store.setData(arr, true);
            this.render();
            for (i = 0; i < this["__selected__"].length; i += 1) {
                this.select(this["__selected__"][i]);
            }
            this.renderSelections();
            delete this["__selected__"];
            //  say that we are already initialized so that we don't kill anything
            this.isInitialized = true;
        },

        render: function(){
            //  summary
            //  Renders the actual table data.
            //DEBUG var start = new Date();
            var b;
            var rows = [];
            var tbody = {};
            var body_rows = [];
            var length = 0;
            var i = 0;
            var emptyRowIdx = -1;
            var sortFunction;
            var action = '';
            if (!this.isInitialized) {
                b = this.init();
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(this + " render -1 exectime: " + (stop.getTime() - start.getTime()));
                if (!b) {
                    this.prefill();
                    return;
                }
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 0 exectime: " + (stop.getTime() - start.getTime()));
            //  do the sort
            tbody = this.domNode.tBodies[0];
            body_rows = tbody.rows;
            length = body_rows.length;
            for (i = 0; i < length; i += 1) {
                rows[i] = body_rows[i];
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 1 exectime: " + (stop.getTime() - start.getTime()));
            //  build the sorting function, and do the sorting.
            sortFunction = this.createSorter(this.sortInformation);
            if (sortFunction){
                rows.sort(sortFunction);
            }

            if(this.customSort != "") {
                eval('rows.sort('+this.customSort+');');
            }

            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 2 after sort exectime: " + (stop.getTime() - start.getTime()));
            //  append the rows without killing them, this should help with the HTML problems.
            for (i = 0; i < rows.length; i += 1) {
                //dojo.html[(this.isRowSelected(body_rows[i])?"addClass":"removeClass")](body_rows[i], this.rowSelectedClass);
                if (this.alternateRows) {
                    action = (i % 2 == 1) ? 'addClass' : 'removeClass';
                    dojo.html[action](rows[i], this.rowAlternateClass);
                }
                tbody.appendChild(rows[i]);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 3 exectime: " + (stop.getTime() - start.getTime()));
        },

        prefill: function() {
            //DEBUG dojo.debug(this + " prefill");
            //  summary
            //  if there's no data in the table, then prefill it with this.minRows.
            var tbody = this.domNode.tBodies[0];
            var row = {};
            var cell = {};
            var i = 0;
            var j = 0;
            var action = '';
            this.isInitialized = false;
            while (tbody.childNodes.length > 0) {
                tbody.removeChild(tbody.childNodes[0]);
            }
            if (this.minRows > 0) {
                for (i = 0; i < this.minRows; i += 1) {
                    row = document.createElement('tr');
                    if (this.alternateRows) {
                        action = (i % 2 == 1) ? 'addClass' : 'removeClass';
                        dojo.html[action](row, this.rowAlternateClass);
                    }
                    row.setAttribute('emptyRow', 'true');
                    for (j = 0; j < this.columns.length; j += 1) {
                        cell = document.createElement('td');
                        cell.innerHTML = "&nbsp;";
                        row.appendChild(cell);
                    }
                    tbody.appendChild(row);
                }
            }
        },

        //  rendering
        createRow: function(/* object */obj){
            //DEBUG dojo.debug(this + " createRow");
            //  summary
            //  Create an HTML row based on the passed object
            var row = document.createElement('tr');
            var cell = {};
            var field;
            var val = '';
            var rowsortinfo = {};
            var j = 0;
            row.innerHTML = '';
            dojo.html.disableSelection(row);
            if (obj.key != null) {
                row.setAttribute('value', obj.key);
            }
            for (j = 0; j < this.columns.length; j += 1) {
                cell = document.createElement("td");
                cell.setAttribute("align", this.columns[j].align);
                cell.setAttribute("valign", this.columns[j].valign);
		cell.setAttribute("class", "col"+j);
                dojo.html.disableSelection(cell);
                field = this.columns[j].getField();
                val = obj.src[field];
                if (val === undefined) {
                    val = '';
                }
                if (this.columns[j].sortType == "String") {
                    cell.innerHTML = val;
                } else {
                    this.fillCell(cell, this.columns[j], val);
                }
                row.appendChild(cell);
                rowsortinfo[field] = val;
            }
            if (this.sortColumn != '') {
                rowsortinfo[this.sortColumn] = obj.src[this.sortColumn];
            }

            this.sortInfo[obj.key] = rowsortinfo;
            return row; //  HTMLTableRow
        },

        fillCell: function(/* HTMLTableCell */cell, /* object */meta, /* object */val) {
            //DEBUG dojo.debug(this + " fillCell");
            //  summary
            //  Fill the passed cell with value, based on the passed meta object.
            var format;
            var n = '';
            if (meta.sortType == "__markup__") {
                cell.innerHTML=val;
            } else {
                if (meta.getType() == Date) {
                    val = new Date(val);
                    if (!isNaN(val)) {
                        format = (meta.format) ? meta.format : this.defaultDateFormat;
                        cell.innerHTML = dojo.date.strftime(val, format);
                    } else {
                        cell.innerHTML = val;
                    }
                } else if ("Number number int Integer float Float".indexOf(meta.sortType)>-1) {
                    //  TODO: number formatting
                    if (val.length == 0) {
                        val = '0';
                    }
                    n = parseFloat(val, 10) + '';
                    //  TODO: numeric formatting + rounding :)
                    if (n.indexOf(".") > -1) {
                        n = dojo.math.round(parseFloat(val, 10), 2);
                    }
                    cell.innerHTML = n;
                } else {
                    cell.innerHTML = val;
                }
            }
        },

        createSorter: function(/* array */info){
            //DEBUG dojo.debug(this + " createSorter");
            //  summary
            //  creates a custom function to be used for sorting.
            var self = this;
            var sortFunctions = [];   //  our function stack.
            var sortFunction;
            var current = 0;
            var max = 0;
            var direction;

	    if (this.noSort) {
		return false;
	    }
            function createSortFunction (fieldIndex, dir) {
                var meta = self.columns[fieldIndex];
                var field;
                var sortFunction;
                if (self.sortColumn != '') {
                    field = self.sortColumn;
                } else {
                    field = meta.getField();
                }
                sortFunction = function(rowA, rowB) {
                    var rowValue = {
                        A: rowA.getAttribute('value'),
                        B: rowB.getAttribute('value')
                    }
                    var a = (self.sortInfo[rowValue.A]) ? self.sortInfo[rowValue.A][field] : 0;
                    var b = (self.sortInfo[rowValue.B]) ? self.sortInfo[rowValue.B][field] : 0;
                    //DEBUG dojo.debug('sort field: '+field+', A: '+a+', B: '+b);
                    var wdir = dir;
                    var ret = 0;;
                    if (meta.sortFunction != null) {
                        ret = meta.sortFunction(a, b);
                    } else {
                        if (meta.sortType == 'int') {
                            a = parseInt(a);
                            b = parseInt(b);
                            if (a > b) {
                                ret = 1;
                            } else if (a < b) {
                                ret = -1;
                            }
                        } else {
                            if (a > b) {
                                ret = 1;
                            } else if (a < b) {
                                ret = -1;
                            }
                        }
                    }
                    return wdir * ret;
                }
                return sortFunction;
            };
            max = Math.min(info.length, this.maxSortable, this.columns.length);
            while (current < max) {
                direction = (info[current].direction == 0) ? 1 : -1;
                sortFunctions.push(
                    createSortFunction(info[current].index, direction)
                );
                current += 1;
            }
            sortFunction = function (rowA, rowB) {
                var idx = 0;
                var ret;
                while (idx < sortFunctions.length) {
                    ret = sortFunctions[idx++](rowA, rowB);
                    if (ret != 0) {
                        return ret;
                    }
                }
                //  if we got here then we must be equal.
                return 0;
            };  //  function
            return sortFunction;
        },

        isRowSelected: function(/* HTMLTableRow */row) {
            //DEBUG dojo.debug(this + " isRowSelected");
            //  summary
            //  Returns if the passed row is selected.
            return (this.rowSelected[row.getAttribute('value')] !== undefined ? true : false);
        },

        select: function(/*object*/ obj) {
            //      summary
            //      selects the passed object.
            var key = obj[this.valueField];
            this.rowSelected[key] = key;
            this.onDataSelect(obj);
        },

        onDataSelect: function(/* object */obj){ 
            //  summary
            //  Stub for onDataSelect event.
        },

        selectByRow: function(row) {
            //DEBUG dojo.debug(this + " selectByRow");
            this.select(this.getDataByRow(row));
        },

        //  custom data access.
        getByRow: function(/*HTMLTableRow*/row) {
            //DEBUG dojo.debug(this + " getByRow");
            //  summary
            //  Returns the data object based on the passed row.
            return this.store.getByKey(dojo.html.getAttribute(row, 'value'));   //  object
        },

        getDataByRow: function(/*HTMLTableRow*/row){
            //DEBUG dojo.debug(this + " getDataByRow");
            //  summary
            //  Returns the source data object based on the passed row.
            return this.store.getDataByKey(dojo.html.getAttribute(row, 'value')); // object
        },

        getDataByKey: function(key){
            return this.store.getDataByKey(key);
        },

        //  standard events
        onSelect: function(/* HTMLEvent */e){
            //DEBUG dojo.debug(this + " onSelected");
            //  summary
            //  Handles the onclick event of any element.
            var row = dojo.html.getParentByType(e.target, 'tr');
            this.clicked = true;
            var tbody = {};
            var startRow = {};
            var rows = [];
            var i = 0;
            var doSelect = false;
            if (dojo.html.hasAttribute(row, 'emptyRow')) {
                return;
            }
            tbody = dojo.html.getParentByType(row, 'tbody');
            if (this.multiple) {
                if (e.shiftKey) {
                    rows = tbody.rows;
                    for (i = 0; i < rows.length; i += 1) {
                        if (rows[i] == row) {
                            break;
                        }
                        if (this.isRowSelected(rows[i])) {
                            startRow = rows[i];
                        }
                    }
                    if (!startRow) {
                        startRow = row;
                        for (; i < rows.length; i += 1) {
                            if (this.isRowSelected(rows[i])) {
                                row = rows[i];
                                break;
                            }
                        }
                    }
                    this.resetSelections();
                    if (startRow == row) {
                        this.toggleSelectionByRow(row);
                    } else {
                        for(i = 0; i < rows.length; i += 1) {
                            if (rows[i] == startRow) {
                                doSelect = true;
                            }
                            if (doSelect) {
                                this.selectByRow(rows[i]);
                                this.onDataToggle(rows[i]);
                            }
                            if (rows[i] == row) {
                                doSelect = false;
                            }
                        }
                    }
                } else {
                    this.toggleSelectionByRow(row);
                }
            } else {
                this.resetSelections();
                this.toggleSelectionByRow(row);
            }
            this.renderSelections();
            if (!this.multiple) {
		this.callAfterSelect(row);
	    }
        },

	callAfterSelect: function(row) {
	},

        onSort: function(/* HTMLEvent */e){
            //  summary
            //  Sort the table based on the column selected.
            var oldIndex = this.sortIndex;
            var oldDirection = this.sortDirection;
            var source = e.target;
            var row = dojo.html.getParentByType(source, 'tr');
            var cellTag = 'td';
            if (row.getElementsByTagName(cellTag).length == 0){
                cellTag = 'th';
            }
            var headers = row.getElementsByTagName(cellTag);
            var header = dojo.html.getParentByType(source, cellTag);
            var i = 0;
            var idx;
            var dir;
            var newClass = '';
            for (i = 0; i < headers.length; i += 1) {
                dojo.html.setClass(headers[i], this.headerClass);
                if (headers[i] == header) {
                    if (this.sortInformation[0].index != i) {
                        this.sortInformation.unshift(
                            {
                                index: i,
                                direction: 0
                            }
                        );
                    } else {
                        this.sortInformation[0] = {
                            index: i,
                            direction: (~this.sortInformation[0].direction)&1
                        };
                    }
                }
            }
            this.sortInformation.length = Math.min(this.sortInformation.length, this.maxSortable);
            for (i = 0; i < this.sortInformation.length; i += 1) {
                idx = this.sortInformation[i].index;
                dir = (~this.sortInformation[i].direction)&1;
                newClass = (dir == 0) ? this.headerDownClass : this.headerUpClass;
                dojo.html.setClass(headers[idx], newClass);
            }
            this.render();
        }

    }
);
