dojo.provide("arkeia.widget.ArkeiaModalFloatingPane");
dojo.require("dojo.widget.FloatingPane");

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaModalFloatingPane",
	[dojo.widget.FloatingPane, dojo.widget.ModalDialogBase],
	{
		// summary
		//	A modal floating window.
		//	This widget is similar to the Dialog widget, but the window, unlike the Dialog, can be moved.
		//	Must specify size (like style="width: 500px; height: 500px;"),

		windowState: "minimized",
		displayCloseAction: true,
        closeIsHide: true,
		postCreate: function(){
			this.domNode.style.display="none";
			arkeia.widget.ArkeiaModalFloatingPane.superclass.postCreate.apply(this, arguments);
		},
		show: function(){
			this.showModalDialog();
			arkeia.widget.ArkeiaModalFloatingPane.superclass.show.apply(this, arguments);
			//place the background div under this modal pane
			this.bg.style.zIndex = this.domNode.style.zIndex-1;
		},
		hide: function(){
			this.hideModalDialog();
			arkeia.widget.ArkeiaModalFloatingPane.superclass.hide.apply(this, arguments);
		},
		closeWindow: function(){
            if(this.closeIsHide) {
                this.hide();
            } else {
			    this.hide();
			    arkeia.widget.ArkeiaModalFloatingPane.superclass.closeWindow.apply(this, arguments);
            }
		},

        restoreWindow: function() {

            if(this.showState) {
            
            }

        }

	}
);

dojo.widget.defineWidget(
	"arkeia.widget.ArkeiaFloatingPane",
	[dojo.widget.FloatingPane],
	{
		windowState: "minimized",
		displayCloseAction: true,
        closeIsHide: true,

		closeWindow: function(){
            if(this.closeIsHide) {
                arkeia.widget.ArkeiaFloatingPane.superclass.minimizeWindow.apply(this, arguments);
            } else {
			    arkeia.widget.ArkeiaFloatingPane.superclass.closeWindow.apply(this, arguments);
            }
		}

	}
);

