dojo.provide("arkeia.widget.ArkeiaNavigator");

dojo.require("dojo.widget.TreeV3");
dojo.require("dojo.widget.TreeNodeV3");
dojo.require("dojo.widget.TreeBasicControllerV3");
dojo.require("dojo.widget.TreeSelectorV3");
dojo.require("dojo.widget.TreeToggleOnSelect");
dojo.require("dojo.widget.TreeExpandToNodeOnSelect");
dojo.require("dojo.widget.TreeExtension");


dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaNavTreeSelector",

    // renderer
    "html",

    // superclass
    dojo.widget.TreeSelectorV3,

    //init function
    function(){
        this.eventNames = {};
        this.listenedTrees = {};
        this.selectedNodes = [];
        this.lastClicked = {};
    },

    //properties and methods
    {
        type: '',
        idInfoBoxPath: '',

        onTreeClick: function(event) {		

            var node = this.domElement2TreeNode(event.target);

            var Click = event.target.tagName;

            if (!node) {
                return;
            }
            
            this._catchClick(node, Click);
            
            var checkLabelClick = function(domElement) {
                return domElement === node.labelNode;
            }
            
            if (this.checkPathCondition(event.target, checkLabelClick)) {
                this.processNode(node, event);			
            }
            
            
        },

        _catchClick: function(node, Click) {

            if(Click == 'INPUT' || Click == 'SPAN' || Click == 'IMG') {

                if(Click == 'SPAN' || Click == 'IMG') {

                    if(document.createEvent) {
                        var evObj = document.createEvent('MouseEvents');
                        evObj.initMouseEvent( 'click', true, true, window, 0, 0, 0, 0, 0, false, false, true, false, 0, null );
                        node.expandNode.dispatchEvent(evObj);
                    } else if(document.createEventObject) {
                        node.expandNode.fireEvent('onclick');
                    }

                }

                return;
            }

            var Reg = new RegExp('@');

            if(icon_manager && node.widgetId && !Reg.test(node.widgetId)) {

                icon_manager.historyManager(node);

            }

            // Show path info and load file list
            var success = true;
            var byId = {
                filelist: {},
                path: {},
                controller: {}
            };

            if (this.type != 'clientexclusion') {
                byId.filelist = dojo.widget.byId('navrightbox_' + this.type);
                if (!byId.filelist) {
                            dojo.debug(this + 'select() widget "navrightbox_' + this.type + '" not found');
                            return false;
                }

                byId.filelist.objectId = node.widgetId;

                for(i in node){
                    if(i == 'actionsDisabled' || i == 'tryLazyInit' || i == 'nodeDocType' || i == 'object' || i == 'title' || i == 'isFolder' || i == 'isExpanded' || i == 'state') {
                            eval('byId.filelist.'+i+' = node.'+i+';');
                    }
                }
            }

            // show path infos
            if (this.idInfoBoxPath == '') {
                if (this.type != 'clientexclusion') {
                    this.idInfoBoxPath = 'nav3_adressbox';
                } else {
                    this.idInfoBoxPath = 'navrightboxpath_' + this.type;
                }
            }

            byId.path = dojo.byId(this.idInfoBoxPath);

            if (!byId.path) {
                dojo.debug(this + ' div "' + this.idInfoBoxPath + '" not found');
            } else {
                if(!node.fullTitle) {
                    node.fullTitle = 'Root';
                }
                value = node.fullTitle;
                /*if (node.objectId != undefined && node.objectId != '') {
                    reg = new RegExp("^" + node.objectId + "(.*)$", "g");
                    value = value.replace(reg, "$1");
                }*/
                if (this.type != 'clientexclusion') {
                            byId.path.value = value;
                } else {
                    byId.path.value = value;
                }
            }

            // load file list
            byId.controller = dojo.widget.byId('controllerightbox');

            if (this.type != 'clientexclusion') {
                if (!byId.controller) {
                            dojo.debug(this + 'select() widget "controllerightbox" not found');
                            success = false;
                } else {
                    byId.controller.loadRemote(byId.filelist, false);
                }
            }
            return success;
        }
    }
);


/*
dojo.widget.defineWidget(
        // widget name and class
        "arkeia.widget.ArkeiaNavTree",

        // renderer
        "html",

        // superclass
        dojo.widget.TreeV3,

        //init function
        function () {},

        //properties and methods
        {}

);


dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaNavTreeNode",

    // renderer
    "html",

    // superclass
    dojo.widget.TreeNodeV3,

    //init function
    function () {},

    //properties and methods
    {}

);
*/


dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaNavTreeCheckbox",

    "html",

    [dojo.widget.TreeExtension],

    function(){
        this.eventNames = {};
        this.listenedTrees = {};
        this.selectedNodes = [];
        this.lastClicked = {};
    },

    {
        templateCssPath: '', //dojo.uri.moduleUri("arkeia/widget", "ArkeiaNavTreeCheckbox.css"),
        myformid : '',
        type: '',
	checkbox: true,
        listenTreeEvents: ["afterChangeTree", "afterSetFolder", "afterUnsetFolder", "beforeNodeDestroy"],

        listenNodeFilter: function(node) {
            return node instanceof dojo.widget.Widget
        },

        onBeforeNodeDestroy: function(node) {
            dojo.debug(this + ' unListenNode');
            if (node.checkboxNode) {
                node.contentNode.removeChild(node.checkboxNode);
                node.checkboxNode.onclick = null;
                delete node.checkboxNode;
            }
            this.unlistenTree(node, false);
            this.destroy();
        },

        listenNode: function(node) {
            var _this = node;
            var byId = {};
            var list = [];
            var elem;
            var reg = {
                isSubElement: null
            };
            var success = true;
            var checked = false;
            var disabled = false;
            var formid = this.myformid;
            var type = this.type;
            //DEBUG dojo.debug(this + ' listenNode(' + node.widgetId + ')');
            if (!node.checkboxNode && node.widgetId !== 'Root') {
		if (this.checkbox) {
                    byId.form = dojo.widget.byId(this.myformid);
                    if (!byId.form) {
			dojo.debug(this + ' form "' + this.myformid + '" not found');
			success = false;
                    } else {
			list = dojo.json.evalJson(byId.form.getValues().listtrees);
                    }
                    if (list) {
                        //DEBUG dojo.debug(this + ' list = ' + dojo.json.serialize(list));
			for (elem in list) {
                            reg.isSubElement = new RegExp('^' + list[elem].FULLNAME + '[/!:]', 'g');
                            if (list[elem].FULLNAME === node.widgetId) {
				checked = true;
                            } else if (node.widgetId.match(reg.isSubElement)) {
				checked = true;
				disabled = true;
                            }
			}
                    }
                    // create the checkbox
                    node.checkboxNode = document.createElement('input');
                    node.checkboxNode.setAttribute('type', 'checkbox');
                    if (checked) {
			if (arkeia.isIE) {
                            node.checkboxNode.setAttribute('defaultChecked', 'defaultChecked');
			} else {
                            node.checkboxNode.setAttribute('checked', 'checked');
			}
                    }
                    if (disabled) {
			node.checkboxNode.setAttribute('disabled', 'disabled');
                    }
                    node.checkboxNode.style.marginRight = '5px';
                    node.contentNode.appendChild(node.checkboxNode);
                    // move the label after the checkbox
                    node.contentNode.appendChild(node.labelNode);
                    node.checkboxNode.onclick = function () {
			arkeia.navigator.updateSelection(formid, node, type, this.checked);
                    };
		} else {
		    node.checkboxNode = document.createElement('span');
		}
	    }
            return success;
        },

        onAfterChangeTree: function(message) {
            dojo.debug(this + 'onAfterChangeTree()');
            if (!message.oldTree || (message.oldTree.widgetId && !this.listenedTrees[message.oldTree.widgetId])) {
                // moving from old tree to our tree
                if (!message.node) {
                    dojo.debug(this + 'onAfterChangeTree() message.node not found' + dojo.json.serialize(message));
                } else {
                    this.processDescendants(message.node, this.listenNodeFilter, this.listenNode);
                }
            }
        }

    }
);
