dojo.provide('arkeia.widget.ArkeiaRadioGroup');
dojo.require('dojo.widget.RadioGroup');
dojo.require('arkeia.widget.ArkeiaListener');

dojo.widget.defineWidget(
    // class
    'arkeia.widget.ArkeiaRadioGroup',

    // superclass
    [arkeia.widget.ArkeiaListener, dojo.widget.RadioGroup],

    // init function
    function () {
        this.tDisplay = [];
        this.tSetDisplay = [];
    },

    // member properties & methods
    {
        valueField: '',
        disabled: false,
        listChoice: '',
        initChoice: '',
        useBR: '',
        useBidouille: '0',
        innerinput: null,
        specificDisplay: '',
        listenArkeiaParentEvents: ['arkeiaInfoData'],
        templatePath: dojo.uri.moduleUri('arkeia/widget', 'ArkeiaRadioGroup.html'),

        initialize: function () {
            dojo.debug(this + " Initialize");
            this.listenedArkeiaParents = [];
            if (this.disabled) {
                this.disable();
            }
            dojo.debug(this + " Initialized");
        },

        postCreate: function (args, frag) {
            var tChoice = dojo.json.evalJson(this.listChoice);
            var c, key, desc, tDisp, id, li, t, node;
            for (c = 0 ; c < tChoice.length ; c += 1) {
                key = tChoice[c][0];
                desc = tChoice[c][1];
                tDisp = tChoice[c][2];
                this.tDisplay[this.tDisplay.length] = key;
                if (tDisp) {
                    this.tSetDisplay[key] = tDisp;
                }
                id = this.widgetId + '_' + key;
                var li = document.createElement('li');
                li.id = id;
                li.setAttribute('contentId', key);
                if (this.useBR === '1') {
                    li.setAttribute('float', 'none');
                }
                li.appendChild(document.createTextNode(desc));
                this.add(li);
            }
            this._parseStructure();
            dojo.html.addClass(this.domNode, this.groupCssClass);
            
            dojo.event.browser.addListener(
                this.domNode, 
                "onclick", 
                dojo.lang.hitch(this, "onSelect")
            );
            dojo.event.browser.addListener(
                this.domNode, 
                "onClick", 
                dojo.lang.hitch(this, "onSelect")
            );
            
            if (this.selectedItem) {
                this._selectItem(this.selectedItem);
            }
            if (this.listened) {
                t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                this.listenArkeiaParent(t);
            } else {
                if (this.initChoice !== '') {
                    id = this.widgetId + '_' + this.initChoice;
                    node = dojo.byId(id);
                    if (node) {
                        this._selectItem(node);
                    }
                }
            }
            //dojo.debug(this + " created");
        },

        onArkeiaInfoData: function (message) {
            var newIdSelected, newNodeSelected;
//            alert(this.valueField);
//            debug(message.data);
//            alert(message.data[this.valueField])
            if (this.valueField && message.data) {
                if (message.data[this.valueField]) {
                    newIdSelected = this.widgetId + '_' + message.data[this.valueField];
                } else {
                    newIdSelected = this.widgetId + '_' + this.initChoice;
                }
                newNodeSelected = dojo.byId(newIdSelected);
                if (newNodeSelected) {
                    this._selectItem(newNodeSelected);
                }
            }
        },

        enable: function () {
//            this.disabled = false;
//            this.textbox.removeAttribute("disabled");
        },

        disable: function () {
//            this.disabled = true;
//            this.textbox.setAttribute('disabled', 'disabled');
        },

        changeValue: function(_this, value) {
            dojo.debug(this + ' changeValue ');
        },

        onSelect: function (e) {
            var oe = e.target;
            var tagName = oe.tagName;
            var id, tOn, l, lookfor, obj, objStyle, disp, d;
            
            while ((oe.parentNode) && (tagName !== 'LI') && (tagName !== 'li')) {
                oe = oe.parentNode;
                tagName = oe.tagName;
            }
            id = oe.id;
            newvalue = id.substr(this.widgetId.length + 1, 32);
            oldvalue = this.value;
            this.value = newvalue;
            if (this.innerinput) {
                this.innerinput.value = this.value;
            }
            if (oldvalue != undefined && oldvalue != newvalue) {
                var _this = this;
                this.changeValue(_this, newvalue);
            }
            if (this.useBidouille === '1') {
                tOn = [];
                if (this.tSetDisplay[this.value]) {
                    for (l = 0 ; l < this.tSetDisplay[this.value].length ; l += 1) {
                        lookfor = this.tSetDisplay[this.value][l];
                        obj = dojo.byId('xtbl_' + lookfor);
                        if (obj) {
                            objStyle = obj.style ? obj.style : obj;
                            disp = objStyle.display;
                            if (disp === 'none') {
                                objStyle.display = 'block';
                            }
                            dojo.debug(this + ' ON ' + lookfor);
                            tOn[lookfor] = 1;
                        }
                    }
                } else {
                    obj = dojo.byId('xtbl_' + this.value);
                    if (obj) {
                        objStyle = obj.style ? obj.style : obj;
                        disp = objStyle.display;
                        if (disp === 'none') {
                            objStyle.display = 'block';
                        }
                        dojo.debug(this + ' ON ' + this.value);
                        tOn[this.value] = 1;
                    }
                }
                for (d = 0; d < this.tDisplay.length ; d += 1) {
                    if (this.tSetDisplay[this.tDisplay[d]]) {
                        for (l = 0 ; l < this.tSetDisplay[this.tDisplay[d]].length ; l += 1) {
                            lookfor = this.tSetDisplay[this.tDisplay[d]][l];
                            if (tOn[lookfor] !== 1) {
                                obj = dojo.byId('xtbl_' + lookfor);
                                if (obj) {
                                    objStyle = obj.style ? obj.style : obj;
                                    disp = objStyle.display;
                                    if (disp !== 'none') {
                                        objStyle.display = 'none';
                                    }
                                    dojo.debug(this + ' OFF ' + lookfor);
                                    tOn[lookfor] = 1;
                                }
                            }
                        }
                    } else {
                        lookfor = this.tDisplay[d];
                        if (tOn[lookfor] !== 1) {
                            obj = dojo.byId('xtbl_' + lookfor);
                            if (obj) {
                                objStyle = obj.style ? obj.style : obj;
                                disp = objStyle.display;
                                if (disp !== 'none') {
                                    objStyle.display = 'none';
                                }
                                dojo.debug(this + ' OFF ' + lookfor);
                                tOn[lookfor] = 1;
                            }
                        }
                    }
                }
            }
        }

    }
);
