dojo.provide("arkeia.widget.ArkeiaRepList");
dojo.require("arkeia.widget.ArkeiaListener");
dojo.require("arkeia.widget.ArkeiaDataProvider");
dojo.require("arkeia.widget.ArkeiaFilteringTable");
dojo.require("arkeia.widget.ArkeiaInfo");

dojo.widget.defineWidget(
    // widget name and class
    "arkeia.widget.ArkeiaRepList",

    // renderer
    "html",

    // superclass
    arkeia.widget.ArkeiaListener,

    // init function
    function(){
        this.eventNames={};
    },

    // properties and methods
    {
        widgetsInTemplate: true,
        action: "jsonGetAll",
        subaction: '',
        baseUrl: arkeia.baseUrl,
        controller: "",
        valueId: "",
        valueField: "",
        timer: 0,
        getNext: "",
        msgmode: false,
        listened: "",
        rowSelected: false,
        itemName: "item",
        isEmpty: true,
        _myname: "arkeiareplist",
        columns: "[ { field: 'NAME', label: 'Name'}, ]",
        cssStyle: 'ArkeiaList',
        scrollDown: false,
        isConvertible: true,
        initWithoutSelect: false,
        printIfEmpty: '',
        printByDefault: '',
        cols: [
            { field: "NAME", label: "Name"}
        ],
        sortDesc: false,
        noSort: false,
        sortField: "",
        templatePath: dojo.uri.moduleUri('arkeia/widget', 'templates/ArkeiaRepList.html'),
        templateCssPath: '',// css is in /style/ directory dojo.uri.moduleUri('arkeia/widget', 'ArkeiaList.css'),
        listeners: [],
        idx_select: -1,
        checkPresentInList: false,
        listenAndAction: false,
        newDataListSimplified: false,
        params: null,
        actionQueryVarName: '',
        actionQueryVarValue: '',
        keepCallback: null, 
        keepMsgmode: null, 
        keepParams: null,
        eventNamesDefault: {
            arkeiaListSelect: "arkeiaListSelect",
            arkeiaListDeselect: "arkeiaListDeselect",
            beforeLoad: "beforeLoad",
            afterLoad: "afterLoad"
        },
        listenArkeiaParentEvents: ["arkeiaInfoData", "arkeiaAddData", "arkeiaListSelect"],
        _converterData: null,
        dataByAppliance: false,
        alternateRows: false,
        noSelection: false,
        autoLoad: true,
        callAfterSelect: '',
        valueIdFromTransformData: false,

        transformData: function(_this, data) {
             // transform data for printing
            return data;
        },

        getActionQuery: function() {
            query = {};
            query[this.actionQueryVarName] = this.actionQueryVarValue;
            return query;
        },

        afterSetOrAddData: function(_this, data) {
             //DEBUG dojo.debug(_this + " afterSetOrAddData");
             // call after data change
        },

        populateTable: function(_this, data, noTransformData) {
            //DEBUG dojo.debug(_this + " populateTable ");
            //DEBUG dojo.debug(_this + " populateTable " + dojo.json.serialize(data));
            //DEBUG var start = new Date();
            if (data) {
                _this._gotData = true;
            }
	    if (noTransformData == undefined && _this.transformData) {
                data = _this.transformData(_this, data);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " populateTable time transformData : " + (stop.getTime() - start.getTime())); 
            //_this.clearTable(_this);
            if (data) {
                _this.innertable.store.setData(data);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " populateTable time set data : " + (stop.getTime() - start.getTime())); 
            _this.afterSetOrAddData(_this, data);
            dojo.event.topic.publish(_this.eventNames.afterLoad, {});
            _this.ajaxloader.onAfterLoad({});
            if (data.length && !_this.msgmode) {
                _this.selectFirst(_this);
            }
            //DEBUG dojo.debug(_this + ' populateTable before timer data:' + data);
            if ((_this.timer > 0) && data) {
                //DEBUG dojo.debug(_this + ' populateTable set timer ' + _this.timer + ' params: ' + dojo.json.serialize(_this.params));
                _this.timeoutId = setTimeout(
                    function () {
                        _this.reload(_this.populateTable, _this.msgmode, _this.params);
                    },
                    _this.timer
                );
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " populateTable finish : " + (stop.getTime() - start.getTime())); 
            _this.afterLoad(_this);
            return;
        },

        renderTable: function(_this) {
            // this function acts like render() in FilteringTable.
            // It is used for debug.
            var b;
            var rows = [];
            var tbody = {};
            var emptyRowIdx = -1;
            var i = 0;
            var action = '';
            if (!_this.innertable.isInitialized) {
                dojo.debug(_this + " innertable is not initialized");
                _this.innertable.init();
                dojo.debug(_this + " innertable init done");
                if (!b) {
                    dojo.debug(_this + " innertable before prefill");
                    _this.innertable.prefill();
                    dojo.debug(_this + " innertable after prefill");
                    return;
                }
            }
            tbody = _this.innertable.domNode.tBodies[0];
            dojo.debug(_this + "renderTable before push");
            for (i = 0; i < tbody.rows.length; i +=1) {
                rows.push(tbody.rows[i]);
            }
            dojo.debug(_this + "renderTable after push, rows.length: " + rows.length);
            for (i = 0; i < rows.length; i += 1) {
                tbody.appendChild(rows[i]);
                action = _this.innertable.isRowSelected(tbody.rows[i]) ? "addClass" : "removeClass";
                dojo.html[action](tbody.rows[i], _this.innertable.rowSelectedClass);
            }
            dojo.debug(_this + "renderTable after appendchild");
       },

        clearTable: function(_this) {
            dojo.debug(_this + " clearTable");
            _this._gotData = false;
            _this.innertable.store.clearData();
  	    _this.innertable.resetSelections();
	    _this.rowSelected = false;
        },

        getSelectIdx: function(_this) {
            var idx = 0;
            var data;
            //DEBUG dojo.debug(_this + " getSelectIdx rowSelected "+dojo.json.serialize(_this.innertable.rowSelected));
            for (idx in _this.innertable.rowSelected) {
                return _this.innertable.rowSelected[idx];
            }
            return -1;
            // following old code never executed
            data = _this.innertable.store.get();
            for(idx = 0; idx < data.length; idx += 1) {
                if (data[idx].isSelected) {
                    return idx;
                }
            }
        },

        reloadSelectByIdx: function(_this, idx) {
            dojo.debug(_this + ' reloadSelectByIdx idx: ' + idx);
            if (idx !== -1) {
                _this.innertable.resetSelections();
                if (_this.innertable.inTableByValue(idx)) {
                    _this.innertable.toggleSelectionByValue(idx);
                } else {
                    _this.rowSelected = false;
                    _this.selectFirst(_this);
                }
                _this.innertable.renderSelections();
            }
        },

        selectFirst: function(_this) {
            var first_value;
            dojo.debug(this + 'Selectfirst, isEmpty:'+_this.isEmpty+' this.innertable.valueField:' +_this.innertable.valueField);
            if (!_this.initWithoutSelect && !_this.noSelection) {
                if (!_this.isEmpty) {
                    if (_this.innertable.domNode 
                      && _this._gotData && !_this.rowSelected
                      && _this.innertable.domNode.tBodies 
                      && _this.innertable.domNode.tBodies[0] 
                      && _this.innertable.domNode.tBodies[0].rows 
                      && _this.innertable.domNode.tBodies[0].rows[0]
                    ) {
                        first_value = _this.innertable.domNode.tBodies[0].rows[0].getAttribute('value');
                        //DEBUG dojo.debug(this + 'Selectfirst, first_value:'+first_value);
                        _this.innertable.toggleSelectionByValue(first_value);
			_this.innertable.callAfterSelect(_this.innertable.domNode.tBodies[0].rows[0]);
                    }
                    _this.innertable.renderSelections();
                    this.rowSelected = true;
                }
            }
        },

        addData: function(_this, data){
            dojo.debug(_this + " addData");
            //DEBUG dojo.debug(_this + " data: " + dojo.json.serialize(data));
            if (data) {
                _this._gotData = true;
                if (_this.transformData) {
                    data = _this.transformData(_this, data);
                }
                if (data) {
                    _this.innertable.store.addData(data);
                }
                _this.afterSetOrAddData(_this, data);
            }
        },

        addDataRange: function(_this, data, message){
            dojo.debug(_this + " addDataRange");
            //DEBUG dojo.debug(_this + " dataRange: " + dojo.json.serialize(data));
            //DEBUG var start = new Date();
            if (data) {
                _this._gotData = true;
                if (_this.transformData) {
                    data = _this.transformData(_this, data);
                }
                //DEBUG var start = new Date();
                if (data) {
                    _this.innertable.store.addDataRange(data);
                }
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(_this + " addDataRange before render exectime: " + (stop.getTime() - start.getTime()));
                if (message.last) {
                    _this.innertable.render();
                }
                _this.afterSetOrAddData(_this, data);
            }
            //DEBUG dojo.debug(_this + " addDataRange Finish exectime: " + (stop.getTime() - start.getTime()));
        },

        reloadChangeParams: function(_this, params) {
            // function for modify params before reload data
            return params;
        },

        reloaddata: function(_this) {
            dojo.debug(_this + ' reloaddata ');
            //DEBUG dojo.debug(_this + ' reloaddata ' + _this.keepCallback + ', ' + _this.keepMsgmode + ', ' + _this.keepParams);
            if (_this.keepCallback !== null) {
                _this.reload(_this.keepCallback, _this.keepMsgmode, _this.keepParams);
            }
        },

        reload: function(callback, msgmode, params) {
            var _this = this;
            this.keepCallback = callback;
            this.keepMsgmode = msgmode;
            this.keepParams = params;
            params = this.reloadChangeParams(_this, params);
            dojo.event.topic.publish(this.eventNames.beforeLoad, {});
            this.ajaxloader.onBeforeLoad({});
            if (msgmode) {
                dojo.debug(this + ' reload in msgmode' + this.keepMsgmode);
                this.isEmpty = true;
                this.idx_select = this.getSelectIdx(_this);
                this.dataProvider.loadMultipleResult(_this, this.newResult, params);
            } else {
                dojo.debug(this + " reload");
                this.dataProvider.loadRemoteData(_this, callback, params);
            }
        },

        afterLoad: function(_this) {},

        onLoadError: function(_this) {
            _this.ajaxloader.onAfterLoad({});
        },

        newResult: function(_this, message) {
            dojo.debug(_this + ' newResult appid:' + message.appid + ' appname:' + message.appliance_name);
            if (message.data !== undefined) {
                _this.newDataList(_this, message.data, message.appid, message.appliance_name, false, message);
            }
            if (message.last) {
                dojo.debug(_this + " newResult last message");
                dojo.event.topic.publish(_this.eventNames.afterLoad, {});
                _this.ajaxloader.onAfterLoad({});
                _this.selectFirst(_this);
                _this.afterLoad(_this);
            } else {
                dojo.debug(_this + " newResult not last message: "+message.last/* message:"+dojo.json.serialize(message)*/); 
            }
        },

        setConverterData: function(_this, data) {
            dojo.debug(_this + " setConverterData");
            _this._converterData["local"] = data;
            return;
        },

        setResultConverterData: function(_this, message) {
            var appid = message.appid;
            var mdata = message.data;
            //DEBUG dojo.debug(this + " setResultConverterData message: "+dojo.json.serialize(message));
            if (!appid) {
                appid = 'local';
            }
            if (mdata) {
                _this._converterData[appid] = mdata;
                mdata = _this.convertData(_this, _this._data_to_convert[appid], appid);
                if (mdata) {
                    _this._data_to_convert[appid] = null;
                    _this.populateTable(_this, mdata);
                }
            }
        },

        newDataList: function(_this, mdata, appid, appliance_name, fromArkeiaInfo, message) {
            var present = false;
            var i = 0;
            var data;
            var realdata;
            var objDiv = {};
            //DEBUG var start = new Date();
            //DEBUG dojo.debug(_this + " newDataList mdata: "+dojo.json.serialize(mdata)+' itemName:'+_this.itemName+' appid:'+appid+' isEmpty: '+_this.isEmpty+' idx_select: '+_this.idx_select);
            if (_this.newDataListSimplified) {
                _this.populateTable(_this, mdata);
                return;
            }
            if (mdata.local) {
                mdata = mdata.local;
            }
            if (_this.isEmpty) {
                if (_this.checkPresentInList) {
                    for (i in mdata[_this.itemName]) {
                        if (i == _this.valueId) {
                            present = true;
                        } else {
                            for (j in mdata[_this.itemName][i]) {
                                if (j == _this.valueId) {
                                    present = true;
                                }
                            }
                        }
                    }
                } else {
                    present = true;
                }
                dojo.debug(this + ' empty ? present: "' + present + '", itemName: "' + _this.itemName /*+ '", mdata: ' + dojo.json.serialize(mdata)*/);
                if (!present || mdata == '' || (mdata[_this.itemName] == undefined && !_this.dataByAppliance) /*|| !mdata[_this.itemName]*/) {
		    dojo.debug(_this + " no mdata, clear table end return ");
		    _this.clearTable(_this);
		    _this.isEmpty = true;
		    if (_this.printIfEmpty != '') {
                        data = dojo.json.evalJson(_this.printIfEmpty);
                        dojo.debug(this + ' empty: Fill table with "' + _this.printIfEmpty + '"');
			_this.populateTable(_this, data);
		    }
		    return;
                } else {
                    _this.clearTable(_this);
                }
            }
            _this.isEmpty = false;
            data = [];
            if (_this.dataByAppliance && (mdata.ERROR != undefined || mdata.NOLOG != undefined)) {
                realdata = mdata;
            } else {
                if (mdata == '' 
                  || mdata[_this.itemName] == undefined
                  || !mdata[_this.itemName]
                ) {
                    return;
                }
                if (mdata[_this.itemName][0] != undefined 
                  && mdata[_this.itemName][0].item != undefined
                  && mdata[_this.itemName][0].item.length > 0
                ) {
                    realdata = mdata[_this.itemName][0]['item'];
                } else {
                    if (mdata[_this.itemName] != undefined 
                      && mdata[_this.itemName].item != undefined 
                      && mdata[_this.itemName].item.length > 0
                    ) {
                        realdata = mdata[_this.itemName].item;
                    } else {
                        if (mdata[_this.itemName].length > 0) {
                            realdata = mdata[_this.itemName];
                        } else {
                            if (mdata[_this.itemName][_this.valueId]) {
                                realdata = [
                                    mdata[_this.itemName]
                                ];
                            } else if (mdata[_this.itemName][0] == undefined) {
				realdata = [mdata[_this.itemName]];
			    }
                        }
                    }
                }
            }
            if (_this.dataByAppliance) {
                data.push({CONTENT: realdata});
            } else if (realdata != undefined) {
                for (i = 0; i < realdata.length; i += 1) {
                    if (realdata[i][_this.valueId] || _this.valueIdFromTransformData) {
                        data.push(realdata[i]);
                    }
                }
            }
            if (appid && _this.msgmode) {
                for (i = 0; i < data.length; i += 1) {
                    data[i][_this.valueField] = appid + '_' + data[i][_this.valueId];
                    data[i].APPLIANCE_GUID = appid;
                    // DEBUG dojo.debug(_this + " valueField:"+ data[i][_this.valueField]);
                    if (appliance_name) {
                        data[i].APPLIANCE_NAME = appliance_name;
                    }
                }
            }
            data = _this.convertData(_this, data, appid);
            if (appid && appid != 'local' && _this.msgmode) {
                if (data) {
                    dojo.debug(_this + " add Data for "+appid + " : " +(appliance_name?appliance_name:"unknown"));
                    if (fromArkeiaInfo) {
                        _this.populateTable(_this, data);
                    } else {
                        _this.addDataRange(_this, data, message);
                    }
                }
            } else if (data) {
                _this.populateTable(_this, data);
            }
            _this.reloadSelectByIdx(_this, _this.idx_select);
            if (_this.scrollDown) {
                dojo.debug(_this + " scroll down");
                objDiv = _this.innertable.domNode.tBodies[0];
                objDiv.scrollTop = objDiv.scrollHeight;
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " newDataList Finish exectime: " + (stop.getTime() - start.getTime()));
        },

        convertData: function(_this, data, appid) {
            var params = null;
            var i = 0;
            var x = 0;
            var val;
            //DEBUG var start = new Date();
            dojo.debug(_this + " convertData appid: "+appid);
            //DEBUG dojo.debug(_this + " convertData: "+dojo.json.serialize(data));
            if (_this._converterData == null) {
                return data; // no conversion
            }
            if (!appid) {
                appid = 'local';
            }
            if (!_this._converterData[appid]) {
                // Don't have _converterData for this appid.
                // We have to load it...
                if (appid != 'local') {
                    params = {};
                    params.APPLIANCE_GUID = appid;
                }
                _this._data_to_convert[appid] = data;
                _this.dataProvider.loadMultipleResult(_this, _this.setResultConverterData, params);
                return null; // return null
            }
            dojo.debug(_this + " converting data");
            for (i = 0; i < data.length; i += 1) {
                for (x = 0; x < _this.cols.length; x += 1) {
                    if (data[i][_this.cols[x].field]) {
                        continue;
                    }
                    val = _this._converterData[appid][data[i][_this.valueId]];
                    if (val) {
                        data[i][_this.cols[x].field] = val;
                    }
                }
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(_this + " convertData Finish exectime: " + (stop.getTime() - start.getTime()));
            return data;
        },

        onArkeiaListSelect: function(message) {
            var _this = this;
            //DEBUG dojo.debug(this + " onArkeiaListSelect got message "+dojo.json.serialize(message));
            this.params = message.data;
            if (this.dataProvider == undefined) {
                this.newDataList(_this,message.data,message.appid,0, true, message);
            } else {
                this.reload(this.populateTable, this.msgmode, message.data);
            }
        },

        onArkeiaInfoData: function(message) {
            //DEBUG dojo.debug(this + " onArkeiaInfoData got message "+dojo.json.serialize(message));
            var _this = this;
            this.isEmpty = true;
            if (!message.data) {
                dojo.debug(this + " onArkeiaInfoData got message with no data");
                this.clearTable(this);
            } else {
                this.params = message.data;
                if (this.listenAndAction) {
                    this.reload(this.populateTable, this.msgmode, message.data);
                } else {
                    this.newDataList(_this,message.data,message.appid,0, true, message);
                }
                this.selectFirst(_this);
            }
        },

        onArkeiaAddData: function(message) {
            //DEBUG dojo.debug(this + " onArkeiaAddData got message "+this._msgnum+ ":"+dojo.json.serialize(message));
            var _this = this;
            var objDiv = {};
            if (message.data) {
                message.data.NUM = ++(this._msgnum);
                this.addData(_this, message.data);
                if (_this.scrollDown) {
                    objDiv = _this.innertable.domNode.tBodies[0];
                    objDiv.scrollTop = objDiv.scrollHeight;
                }
            }
        },

        /**
         * publish destruction event so that any listeners should stop listening
         */
        destroy: function() {
            dojo.debug(this + " destroy");
            if (this.timeoutId) {
                clearTimeout(this.timeoutId);
            }
            this.timer = 0;
            dojo.event.topic.publish(this.widgetId + '/arkeiaParentDestroy', {source: this});
            if (this.dataProvider) {
                this.dataProvider.destroy();
            }
            return dojo.widget.HtmlWidget.prototype.destroy.apply(this, arguments);
        },

        initialize: function(args, frag) {
            var name;
            var source = this.getFragNodeRef(frag);
            var DpClass = arkeia.widget.ArkeiaDataProvider;
            // Adjust event names
            this._converterData = null;
            this._gotData = false;
            this._msgnum = 0;
            if (this.msgmode) {
                this.valueField = 'APPID_' + this.valueId;
            } else {
                this.valueId = this.valueField;
            }
            if (this.noSelection) {
                delete this.eventNamesDefault.arkeiaListSelect;
                delete this.eventNamesDefault.arkeiaListDeselect;
            }
            this.listenedArkeiaParents = [];
            for (name in this.eventNamesDefault) {
                if (this.eventNames[name] === undefined) {
                    this.eventNames[name] = this.widgetId + '/' + this.eventNamesDefault[name];
                }
            }
            this.dataUrl = '';
            if (this.controller) {
                this.dataUrl = this.baseUrl + '/' + this.controller + '/' + this.action;
                if (this.actionQueryVarName != '' && this.actionQueryVarValue != '') {
                    this.dataUrl += '?' + this.actionQueryVarName + '=' + this.actionQueryVarValue;
                }
                if (this.getNext == '') {
                    this.getNext = this.baseUrl + '/' + this.controller + '/jsonGetNextResult';
                }
                this.abortUrl = this.baseUrl + '/' + this.controller + '/jsonAbortTrans';
                if (!source.dataUrl) {
                    source.dataUrl = this.dataUrl;
                }
                if (!source.getNext) {
                    source.getNext = this.getNext;
                }
                if (!source.abortUrl) {
                    source.abortUrl = this.abortUrl;
                }
                this.dataProvider = new DpClass(source);
                this.dataProvider.onLoadError = this.onLoadError;
            }
        },

        postCreate: function() {
            var _this = this;
            var toListen = {};
            dojo.event.connect(this.innertable, 'onDataToggle',this, 'dataSelected');
            if (this.columns) {
                this.setColumns(dojo.json.evalJson(this.columns));
            }
            this.clearTable(this);
            // Declare itself to listeners.
            dojo.lang.forEach(
                this.listeners,
                function(elem) {
                    var toListen = {};
                    dojo.debug(_this + "got one listener");
                    toListen = dojo.lang.isString(elem) ? dojo.widget.byId(elem) : elem;
                    // To activate to prevent fatal error when sure that it doesn't provide new bugs
                    //if (!toListen) {
                    //    dojo.debug(_this + ' widget "' + toListen + '" not found. Can\'t listen');
                    //} else {
                        toListen.listenArkeiaParent(_this);
                    //}
                }
            );
            if (this.listened) {
                toListen = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                // To activate to prevent fatal error when sure that it doesn't provide new bugs
                //if (!toListen) {
                //    dojo.debug(this + ' widget "' + toListen + '" not found. Can\'t listenArkeiaParent');
                //} else {
                    this.listenArkeiaParent(toListen);
                //}
                if (this.dataUrl !== '' && this.isConvertible) {
                    this._converterData = [];
                    this._data_to_convert = [];
                    if (!this.msgmode) {
                        this.reload(this.setConverterData, false, null);
                    } 
                }
            } else if (this.dataUrl !== '' && this.autoLoad) {
                this.reload(this.populateTable, this.msgmode, null);
            } else if (!this.autoLoad) {
                if (_this.printByDefault != '') {
                    data = dojo.json.evalJson(_this.printByDefault);
                    dojo.debug(this + ' empty: Fill table with "' + _this.printByDefault + '"');
		    _this.populateTable(_this, data, true);
                }

	    }
        },

        setColumns: function(cols) {
            var x = 0;
            //DEBUG dojo.debug(this + ' Setcolumns');
            this.cols = cols;
            if (this.sortDesc) {
                this.innertable.sortInformation[0].direction = 1;
            }
            if (this.noSort) {
                this.innertable.maxSortable = 0;
                this.innertable.noSort = true;
            }
            for (x = 0; x < this.cols.length; x += 1) {
                this.innertable.columns.push(
                this.innertable.createMetaData(this.cols[x]));
            }
        },

        getSelectedData: function() {
            dojo.debug(this + " getSelectedData");
            return this.innertable.getSelectedData();
        },

        dataSelected: function() {
            dojo.debug(this + " dataSelected");
            var data = this.getSelectedData();
            var eventName = '';
            var list_id = [];
            var list_appid = [];
            var i;
            //DEBUG dojo.debug(this + " dataSelected data : " + dojo.json.serialize(data));
            if ((data && !dojo.lang.isArray(data)) || (dojo.lang.isArray(data) && data.length)) {
                this.rowSelected = true;
                eventName = this.eventNames.arkeiaListSelect;
                dojo.event.topic.publish(eventName, { id: data[this.valueField], appid: data['APPLIANCE_GUID'], data: data });
                dojo.debug(this + " published "+eventName+" for " + this.valueField /*+ " data:" + data[this.valueField] + ' data: '+ dojo.json.serialize(data)*/);
            }
        }

    }
);

dojo.widget.defineWidget(
    'arkeia.widget.ArkeiaRepTable',

    dojo.widget.HtmlWidget, 

    function() {
        this.store = new dojo.collections.Store();
        this.valueField = 'Id';
        this.rowSelected = {};
        this.sortInformation = [
            {
                index:0,
                direction:0
            }
        ];
        this.maxSortable = 1;
        this.isInitialized = false;
        this.columns = [];
        // CSS definitions
        this.headClass = '';
        this.tbodyClass = '';
        this.headerClass = '';
        this.headerUpClass = 'selectedUp';
        this.headerDownClass = 'selectedDown';
        this.rowClass = '';
        this.rowAlternateClass = 'alt';
        this.rowSelectedClass = 'selected';
        this.columnSelected = 'sorted-column';
        this.baseUrl = arkeia.baseUrl;
        this.controller = '';
        this.action = '';
        this.getNext = '';
    },

    {
        //  dojo widget properties

        isContainer: false,
        templatePath: null,
        templateCssPath: null,
        sortColumn: '',
        sortInfo: {},
        rowSelected: {},
        alternateRows: false,
        noSort: false,

        //  methods.

        toggleSelection: function (obj) {
            //  summary
            //  Flips the selection state of passed obj.
            //DEBUG dojo.debug(this + " toggleSelection obj: " + dojo.json.serialize(obj));
            //DEBUG dojo.debug(this + " toggleSelection rowSelected: " + dojo.json.serialize(this.rowSelected));
            var key;
            if (obj == null) {
                return ;
            }
            key = obj[this.valueField];
            if (this.rowSelected[key] != undefined || this.rowSelected[key]) {
                delete this.rowSelected[key];
            } else {
                this.rowSelected[key] = key;
            }
            //DEBUG dojo.debug(this + " toggleSelection key: " + key);
            //DEBUG dojo.debug(this + " toggleSelection rowSelected: " + dojo.json.serialize(this.rowSelected));
            this.onDataToggle(obj);
        },

        toggleSelectionByIndex: function(idx) {
            //DEBUG dojo.debug(this + " toggleSelectionByIndex idx: " + idx);
            //  summary
            //  Flips the selection state of object at index idx.
            this.toggleSelection(this.store.getDataByIndex(idx));
        },

        toggleSelectionByValue: function(val) {
            //DEBUG dojo.debug(this + " toggleSelectionByValue val:"+val);
            //      summary
            //      Flips the selection state of object represented by val.
            this.toggleSelection(this.store.getDataByKey(val));
        },

        inTableByValue: function(val) {
            if (this.store.getDataByKey(val)) {
                return true;
            }
            return false;
        },

        toggleSelectionByRow: function(/*HTMLTableRow*/row){
            //DEBUG dojo.debug(this + " toggleSelectionByRow");
            //  summary
            //  Flips the selection state of object represented by row.
            this.toggleSelection(this.getDataByRow(row));
        },

        onDataToggle: function(/* object */obj){ 
            //DEBUG dojo.debug(this + " onDataToggle");
            //  summary
            //  Stub for onDataToggle event.
        },

        selectNone: function() {
            this.resetSelections();
            this.renderSelections();
        },

    selectReverse: function() {
        //DEBUG dojo.debug(this + " selectReverse");
        var i = 0;
        var rows = this.domNode.tBodies[0].rows;
        for (i; i < rows.length - 1; i += 1) {
            key = rows[i].getAttribute("value");
            if (this.rowSelected[key] != undefined || this.rowSelected[key]) {
                delete this.rowSelected[key];
            } else {
                this.rowSelected[key] = key;
            }
        }
        this.renderSelections();
        //DEBUG dojo.debug(this + " selectReverse end");
    },

        selectAll: function(){
            //DEBUG dojo.debug(this + " selectAll");
            var i = 0;
            var rows = this.domNode.tBodies[0].rows;
            for (i; i < rows.length - 1; i += 1) {
                key = rows[i].getAttribute('value');
                this.rowSelected[key] = key;
            }
            this.renderSelections();
            //DEBUG dojo.debug(this + " selectAll end");
        },

        renderSelections: function() {
            //DEBUG var start = new Date();
            //DEBUG dojo.debug(this + " renderSelections rowSelected : " + dojo.json.serialize(this.rowSelected));
            //  summary
            //  Render all selected objects using CSS.
            var i = 0;
            var action = '';
            var rows = this.domNode.tBodies[0].rows;
            for (i; i < rows.length; i += 1) {
                action = (this.rowSelected[rows[i].getAttribute('value')]) ? 'addClass' : 'removeClass';
                dojo.html[action](rows[i], this.rowSelectedClass);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " renderSelections exectime: " + (stop.getSeconds() - start.getSeconds()));
        },

        resetSelections: function() {
            //DEBUG dojo.debug(this + " resetSelections");
            //  summary
            //  Unselects all data objects.
            this.rowSelected = {};
        },

        //  parsing functions, from HTML to metadata/SimpleStore
        _meta: {
            field: null,
            format: null,
            filterer: null,
            noSort: false,
            sortType: 'String',
            dataType: String,
            sortFunction: null,
            filterFunction: null,
            label: null,
            align: 'left',
            valign: 'top',
            getField: function() { 
                return this.field || this.label;
            },
            getType: function() { 
                return this.dataType; 
            }
        },

        createMetaData: function(obj){
            //DEBUG dojo.debug(this + " createMetaData");
            //  summary
            //  Take a JSON-type structure and make it into a ducktyped metadata object.
            var p;
            for(p in this._meta){
                //  rudimentary mixin
                if(!obj[p]){
                    obj[p] = this._meta[p];
                }
            }
            if(!obj.label){
                obj.label = obj.field;
            }
            if(!obj.filterFunction){
                obj.filterFunction = this._defaultFilter;
            }
            //DEBUG dojo.debug(this + " createMetaData end");
            return obj; //  object
        },

        getSelectedData: function(){
            //DEBUG dojo.debug(this + " getSelectedData");
            //  summary
            //  returns all objects that are selected.
            var a = [];
            var key;
            for (key in this.rowSelected) {
                //dojo.debug(this + " getSelectedData key : " + dojo.json.serialize(key));
                data = this.store.getByKey(key);
                //dojo.debug(this + " getSelectedData data : " + dojo.json.serialize(data));
                a.push(data.src);
            }
            //DEBUG dojo.debug(this + " getSelectedData return : " + dojo.json.serialize(a));
            return a.shift();   //  object
        },

        init: function() {
            //DEBUG dojo.debug(this + " init");
            //DEBUG var start = new Date();
            //  summary
            //  initializes the table of data
            var thead = {};
            var tbody = {};
            var row = {};
            var cell = {};
            var cellTag = 'td';
            var i = 0;
            var j = 0;
            var idx = 0;
            var data;
            var headers = [];
            var dir;
            var newClass = '';
            this.isInitialized = false;

            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 1: " + (stop.getTime() - start.getTime()));
            if (this.store.get().length === 0) {
                return false;
            }
            idx = this.domNode.tBodies[0].rows.length;
            if(!idx || idx === 0 || this.domNode.tBodies[0].rows[0].getAttribute('emptyRow') == 'true') {
                idx = 0;
                tbody = this.domNode.tBodies[0];
                while (tbody.childNodes.length > 0) {
                    tbody.removeChild(tbody.childNodes[0]);
                }
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(this + " init 1.1: " + (stop.getTime() - start.getTime()));
                data = this.store.get();
                for (i = 0; i < data.length; i += 1){
                    if(data[i].key == null) {
                        data[i].key = idx;
                    }
                    row = this.createRow(data[i]);
                    tbody.appendChild(row);
                    idx += 1;
                }
                // *-- makes ff3 happy with lists
                if(this.widgetId != 'GlobalMessages_table') { //Cause some troubles in job screen
                    row = document.createElement('tr');
                    row.setAttribute('class', 'alternateRow');
                    row.setAttribute('style', 'height: auto; background-color: transparent; cursor: default; line-height: 0px; font-size: 1px;');
                    row.setAttribute('emptyRow', 'true');
                    row.setAttribute('value', idx+1); //this blank lin need to be the last so in ordered list we set a big value
                    for (j = 0; j < this.columns.length; j += 1) {
                        cell = document.createElement('td');
                        cell.setAttribute('style', 'cursor: default;');
                        cell.innerHTML = '&nbsp;';
                        dojo.html.disableSelection(cell);
                        row.appendChild(cell);
                    }
                    tbody.appendChild(row);
                }
                // * -- makes ff3 happy with lists
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(this + " init 1.2: " + (stop.getTime() - start.getTime()));
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 2: " + (stop.getTime() - start.getTime()));
            //  add empty rows
            if (this.minRows > 0 && idx < this.minRows) {
                idx = this.minRows - idx;
                for (i = 0; i < idx; i += 1) {
                    row = document.createElement('tr');
                    row.setAttribute('emptyRow', 'true');
                    for (j = 0; j < this.columns.length; j += 1) {
                        cell = document.createElement('td');
                        cell.innerHTML = '&nbsp;';
                        row.appendChild(cell);
                    }
                    tbody.appendChild(row);
                }
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 3: " + (stop.getTime() - start.getTime()));
            //  last but not least, show any columns that have sorting already on them.
            row = this.domNode.getElementsByTagName('thead')[0].rows[0];
            if (row.getElementsByTagName(cellTag).length == 0){
                cellTag = 'th';
            } 
            headers = row.getElementsByTagName(cellTag);
            for (i = 0; i < headers.length; i += 1){
                dojo.html.setClass(headers[i], this.headerClass);
            }
            for (i = 0; i < this.sortInformation.length; i += 1) {
                idx = this.sortInformation[i].index;
                dir = (~this.sortInformation[i].direction)&1;
                newClass = (dir == 0) ? this.headerDownClass : this.headerUpClass;
                dojo.html.setClass(headers[idx], newClass);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " init 4: " + (stop.getTime() - start.getTime()));
            this.isInitialized = true;
            return true;
        },

        //  widget lifetime handlers
        initialize: function() { 
            //  summary
            //  Initializes the widget.
            var self = this;
            //  connect up binding listeners here.
            dojo.event.connect(
                this.store, 
                'onSetData',
                function() {
                    //DEBUG dojo.debug(this + " onSetData");
                    var tbody = {};
                    self.store.forEach(
                        function(element) {
                            element.isSelected = false;
                        }
                    );
                    self.isInitialized = false;
                    self.sortInfo = {};
                    tbody = self.domNode.tBodies[0];
                    if (tbody) {
                        while (tbody.childNodes.length > 0) {
                            tbody.removeChild(tbody.childNodes[0]);
                        }
                    }
                    self.render();
                }
            );
            dojo.event.connect(
                this.store,
                'onClearData',
                function() {
                    //DEBUG dojo.debug(this + " onClearData");
                    self.isInitialized = false;
                    self.sortInfo = {};
                    self.render();
                }
            );
            dojo.event.connect(
                this.store,
                'onAddData',
                function (addedObject) {
                    //DEBUG dojo.debug(this + " onAddData");
                    var row = self.createRow(addedObject);
                    self.domNode.tBodies[0].appendChild(row);
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onUpdateData',
                function (updatedObject) {
                    //DEBUG dojo.debug(this + " onUpdateData");
                    var oldRow = self.getRow(self.store.getDataByKey(updatedObject[self.store.keyField]));
                    var newRow = self.createRow(updatedObject);
                    self.domNode.tBodies[0].replaceChild(newRow, oldRow);
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onAddDataRange', 
                function (arr) {
                    //DEBUG dojo.debug(this + " onAddDataRange");
                    //DEBUG var start = new Date();
                    var i = 0;
                    var row = {};
                    for (i; i < arr.length; i += 1) {
                        arr[i].isSelected = false;
                        row = self.createRow(arr[i]);
                        self.domNode.tBodies[0].appendChild(row);
                        //DEBUG var stop = new Date();
                        //DEBUG dojo.debug(this + " onaddDataRange "+i+" exectime: " + (stop.getSeconds() - start.getSeconds()));
                    };
                    //DEBUG var stop = new Date();
                    //DEBUG dojo.debug(this + " onaddDataRange after appendchild exectime: " + (stop.getSeconds() - start.getSeconds()));
                    //self.render(); Render in ArkieaList widget after recieved all appliance data
                    //DEBUG var stop = new Date();
                    //DEBUG dojo.debug(this + " onaddDataRange after render exectime: " + (stop.getSeconds() - start.getSeconds()));
                }
            );
            dojo.event.connect(
                this.store, 
                'onUpdateDataRange', 
                function (arr) {
                    //DEBUG dojo.debug(this + " onUpdateDataRange");
                    var old = {};
                    var row = {};
                    var i = 0;
                    for (i; i < arr.length; i += 1) {
                        old = self.getRow(self.store.getDataByKey(arr[i][self.store.keyField]));
                        row = self.createRow(arr[i]);
                        self.domNode.tBodies[0].replaceChild(row, old);
                    };
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onRemoveData',
                function (removedObject) {
                    //DEBUG dojo.debug(this + " onRemoveData");
                    var i = 0;
                    var rows = self.domNode.tBodies[0].rows;
                    for (i = 0; i < rows.length; i += 1) {
                        if (self.getDataByRow(rows[i]) == removedObject.src) {
                            rows[i].parentNode.removeChild(rows[i]);
                            break;
                        }
                    }
                    self.render();
                }
            );
            dojo.event.connect(
                this.store, 
                'onUpdateField', 
                function (obj, fieldPath, val) {
                    //DEBUG dojo.debug(this + " onUpdateField");
                    var row = self.getRow(obj);
                    var idx = self.getColumnIndex(fieldPath);
                    if (idx > -1 && row && row.cells && row.cells[idx] && self.columns[idx]) {
                        self.fillCell(row.cells[idx], self.columns[idx], val);
                    }
                }
            );
        },

        postCreate: function(){
            //DEBUG dojo.debug(this + " postCreate");
            //  summary
            //  finish widget initialization.
            var thead = {};
            var header = 'td';
            var tbody = {};
            var i = 0;
            this.store.keyField = this.valueField;
            if (this.domNode) {
                //  start by making sure domNode is a table element;
                if (this.domNode.nodeName.toLowerCase() != "table") {
                }
                //  see if there is columns set up already
                if (this.domNode.getElementsByTagName("thead")[0]) {
                    thead = this.domNode.getElementsByTagName('thead')[0];
                    if (this.headClass.length > 0) {
                        dojo.html.setClass(thead, this.headClass);
                    }
                    dojo.html.disableSelection(this.domNode);
                    this.parseMetadata(head);
                    if (thead.getElementsByTagName(header).length == 0) {
                        header = 'th';
                    }
                    headers = thead.getElementsByTagName(header);
                    for (i = 0; i < headers.length; i += 1) {
                        if (!this.columns[i].noSort) {
                            dojo.event.connect(headers[i], 'onclick', this, 'onSort');
                        }
                    }
                } else {
                    this.domNode.appendChild(document.createElement('thead'));
                }
                // if the table doesn't have a tbody already, add one and grab a reference to it
                if (this.domNode.tBodies.length < 1) {
                    tbody = document.createElement('tbody');
                    this.domNode.appendChild(tbody);
                } else {
                    tbody = this.domNode.tBodies[0];
                }
                if (this.tbodyClass.length > 0){
                    dojo.html.setClass(tbody, this.tbodyClass);
                }
                dojo.event.connect(tbody, 'onclick', this, 'onSelect');
                this.parseData(tbody);
            }
        },

        parseData: function(/* HTMLTableBody */tbody){
            //DEBUG dojo.debug(this + " parseData");
            //  summary
            //  Parse HTML data into native JSON structure for the store.
            var i = 0;
            var self = this;
            var arr;
            if (tbody.rows.length == 0 && this.columns.length == 0) {
                //DEBUG dojo.debug(this + " parseData nothing");
                return; //  there's no data, ignore me.
            }
            //  create a data constructor based on what we've got for the fields.
            this["__selected__"] = [];
            arr = this.store.getFromHtml(
                this.columns,
                tbody,
                function (obj, row) {
                    if (obj[self.valueField] === undefined || obj[self.valueField] === null) {
                        obj[self.valueField] = dojo.html.getAttribute(row, "value");
                    }
                    if (dojo.html.getAttribute(row, "selected")=="true") {
                        self["__selected__"].push(obj);
                    }
                }
            );
            this.store.setData(arr, true);
            this.render();
            for (i = 0; i < this["__selected__"].length; i += 1) {
                this.select(this["__selected__"][i]);
            }
            this.renderSelections();
            delete this["__selected__"];
            //  say that we are already initialized so that we don't kill anything
            this.isInitialized = true;
        },

        render: function(){
            //  summary
            //  Renders the actual table data.
            //DEBUG var start = new Date();
            var b;
            var rows = [];
            var tbody = {};
            var body_rows = [];
            var length = 0;
            var i = 0;
            var emptyRowIdx = -1;
            var sortFunction;
            var action = '';
            if (!this.isInitialized) {
                b = this.init();
                //DEBUG var stop = new Date();
                //DEBUG dojo.debug(this + " render -1 exectime: " + (stop.getTime() - start.getTime()));
                if (!b) {
                    this.prefill();
                    return;
                }
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 0 exectime: " + (stop.getTime() - start.getTime()));
            //  do the sort
            tbody = this.domNode.tBodies[0];
            body_rows = tbody.rows;
            length = body_rows.length;
            for (i = 0; i < length; i += 1) {
                rows[i] = body_rows[i];
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 1 exectime: " + (stop.getTime() - start.getTime()));
            //  build the sorting function, and do the sorting.
            sortFunction = this.createSorter(this.sortInformation);
            if (sortFunction){
                rows.sort(sortFunction);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 2 after sort exectime: " + (stop.getTime() - start.getTime()));
            //  append the rows without killing them, this should help with the HTML problems.
            for (i = 0; i < rows.length; i += 1) {
                //dojo.html[(this.isRowSelected(body_rows[i])?"addClass":"removeClass")](body_rows[i], this.rowSelectedClass);
                if (this.alternateRows) {
                    action = (i % 2 == 1) ? 'addClass' : 'removeClass';
                    dojo.html[action](rows[i], this.rowAlternateClass);
                }
                tbody.appendChild(rows[i]);
            }
            //DEBUG var stop = new Date();
            //DEBUG dojo.debug(this + " render 3 exectime: " + (stop.getTime() - start.getTime()));
        },

        prefill: function() {
            //DEBUG dojo.debug(this + " prefill");
            //  summary
            //  if there's no data in the table, then prefill it with this.minRows.
            var tbody = this.domNode.tBodies[0];
            var row = {};
            var cell = {};
            var i = 0;
            var j = 0;
            var action = '';
            this.isInitialized = false;
            while (tbody.childNodes.length > 0) {
                tbody.removeChild(tbody.childNodes[0]);
            }
            if (this.minRows > 0) {
                for (i = 0; i < this.minRows; i += 1) {
                    row = document.createElement('tr');
                    if (this.alternateRows) {
                        action = (i % 2 == 1) ? 'addClass' : 'removeClass';
                        dojo.html[action](row, this.rowAlternateClass);
                    }
                    row.setAttribute('emptyRow', 'true');
                    for (j = 0; j < this.columns.length; j += 1) {
                        cell = document.createElement('td');
                        cell.innerHTML = "&nbsp;";
                        row.appendChild(cell);
                    }
                    tbody.appendChild(row);
                }
            }
        },

        _launchtrans: function(obj, callback, dataUrl, getNext, abortUrl) {

            var source = new Object;
            var DpClass = arkeia.widget.ArkeiaDataProvider;

            source.dataUrl = dataUrl;
            source.getNext = getNext;
            source.abortUrl = abortUrl;

            obj.dataProvider = new DpClass(source);
            obj.dataProvider.loadMultipleResult(obj, callback, null);

            obj.dataProvider.onLoadError = obj.obj.onLoadError;

        },

        _createRowAction: function(id) {

            var vtls = document.getElementById('vtls_'+id);
            var img = document.getElementById('img_'+id);

            if(vtls.style.display == 'none') {

                if(document.LISTTYPE == 'ct') {
                    this.obj = document.DCIDS[id].object;
                }

                if(document.LISTTYPE == 'ac') {
                    this.obj = document.MODULE_IDS[id].object;
                }

                this.obj.id = id;

                if (this.obj.controller) {

                    if(document.LISTTYPE == 'ct') {

                        this.obj.dataUrl = this.obj.baseUrl + '/' + this.obj.controller + '/' + this.obj.action + '?DCID=' + id;

                    }

                    if(document.LISTTYPE == 'ac') {

                        this.obj.dataUrl = this.obj.baseUrl + '/' + this.obj.controller + '/' + this.obj.action + '?MODULE_ID=' + id;

                    }

                    if (this.obj.getNext == '') {
                        this.obj.getNext = this.obj.baseUrl + '/' + this.obj.controller + '/jsonGetNextResult';
                    }

                    this.obj.abortUrl = this.obj.baseUrl + '/' + this.obj.controller + '/jsonAbortTrans';

                    this._launchtrans(this.obj, this.obj.createRowData, this.obj.dataUrl, this.obj.getNext, this.obj.abortUrl);

                }

                vtls.style.display='block';
                document.getElementById('refreshbutton_'+id).style.display = 'inline';
                img.src=''+baseurl+'/images/arrow-expanded.gif';

            } else {

                vtls.style.display='none';
                document.getElementById('refreshbutton_'+id).style.display = 'none';
                img.src=''+baseurl+'/images/arrow-collapsed.gif';

            }

        },

        _createRowVTL: function(obj_id, i, data, content, modal) {

            var k = 0;
            var units = new Array;

            units[0] = arkwui_lang_get_msg('unit_B');
            units[1] = arkwui_lang_get_msg('unit_KB');
            units[2] = arkwui_lang_get_msg('unit_MB');
            units[3] = arkwui_lang_get_msg('unit_GB');
            units[4] = arkwui_lang_get_msg('unit_TB');
            units[5] = arkwui_lang_get_msg('unit_PB');
            units[6] = arkwui_lang_get_msg('unit_EB');

            var html = '';
            var id = 'bkps_'+obj_id+'_'+data[i].VTLID;
            var img_id = 'img_bkps_'+obj_id+'_'+data[i].VTLID;

            k = 0;

            if(data[i].CAPACITY > 0) {

                data[i].CAPACITY_T = data[i].CAPACITY;

                while(data[i].CAPACITY_T > 1024) {

                    data[i].CAPACITY_T /= 1024;
                    k++;

                }

                data[i].CAPACITY_T = (Math.round(data[i].CAPACITY_T * 100) / 100);

            } else {

                data[i].CAPACITY_T = 0;

            }

            data[i].CAPACITY_T += ' '+units[k];

            k = 0;

            if(data[i].SIZE > 0) {

                data[i].SIZE_T = data[i].SIZE;

                while(data[i].SIZE_T > 1024) {

                    data[i].SIZE_T /= 1024;
                    k++;

                }

                data[i].SIZE_T = (Math.round(data[i].SIZE_T * 100) / 100);

            } else {

                data[i].SIZE_T = 0;

            }

            data[i].SIZE_T += ' '+units[k];

            k = 0;

            if(data[i].SIZE_REP > 0) {

                data[i].SIZE_REP_T = data[i].SIZE_REP;

                while(data[i].SIZE_REP_T > 1024) {

                    data[i].SIZE_REP_T /= 1024;
                    k++;

                }

                data[i].SIZE_REP_T = (Math.round(data[i].SIZE_REP_T * 100) / 100);

            } else {

                data[i].SIZE_REP_T = 0;

            }

            data[i].SIZE_REP_T += ' '+units[k];

            k = 0;

            if(data[i].SIZE_REC > 0) {

                data[i].SIZE_REC_T = data[i].SIZE_REC;

                while(data[i].SIZE_REC_T > 1024) {

                    data[i].SIZE_REC_T /= 1024;
                    k++;

                }

                data[i].SIZE_REC_T = (Math.round(data[i].SIZE_REC_T * 100) / 100);

            } else {

                data[i].SIZE_REC_T = 0;

            }

            data[i].SIZE_REC_T += ' '+units[k];

            html += '<div class="schwizard" style="float: none; padding-left: 20px; padding-right: 20px; padding-top: 5px; padding-bottom: 5px;">';
            html += '<fieldset>';
            html += '<legend>';

            if(modal == 0 && content != '') {

                html += '<img id="'+img_id+'" src="'+baseurl+'/images/arrow-collapsed.gif" alt="" style="float: none; vertical align: middle; cursor: pointer;" onclick="';
                html += 'if(document.getElementById(\''+id+'\').style.display == \'none\') {';
                html += 'document.getElementById(\''+id+'\').style.display = \'block\';';
                html += 'document.getElementById(\''+img_id+'\').src = \''+baseurl+'/images/arrow-expanded.gif\';';
                html += '} else {';
                html += 'document.getElementById(\''+id+'\').style.display = \'none\';';
                html += 'document.getElementById(\''+img_id+'\').src = \''+baseurl+'/images/arrow-collapsed.gif\';';
                html += '}';
                html += '"><span style="cursor: pointer;" onclick="';
                html += 'if(document.getElementById(\''+id+'\').style.display == \'none\') {';
                html += 'document.getElementById(\''+id+'\').style.display = \'block\';';
                html += 'document.getElementById(\''+img_id+'\').src = \''+baseurl+'/images/arrow-expanded.gif\';';
                html += '} else {';
                html += 'document.getElementById(\''+id+'\').style.display = \'none\';';
                html += 'document.getElementById(\''+img_id+'\').src = \''+baseurl+'/images/arrow-collapsed.gif\';';
                html += '}';
                html += '">';

            } else {

                html += '<span>';

            }

            html += data[i].NAME+'</span>&nbsp;&nbsp;';
            html += '<span style="font-size: smaller;">('+data[i].CAPACITY_T+')</span>&nbsp;&nbsp;';

            if(modal == 0) {

                html += '<img src="'+baseurl+'/images/loupe_16x16.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_details')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                if(document.LISTTYPE == 'ct') {

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'det\', \''+obj_id+'\', '+i+');';

                }

                if(document.LISTTYPE == 'ac') {

                    html += 'document.MODULE_IDS[\''+obj_id+'\'].object._createRowModal(\'det\', \''+obj_id+'\', '+i+');';

                }

                html += '">';

                if(typeof data[i].ALLOW_REP != 'undefined' && document.LISTTYPE == 'ct') {

                    html += '<img src="'+baseurl+'/images/arrow_rep_16x16.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_replication')+'" style="float: none; vertical-align: bottom;cursor: pointer;" onclick="';

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'rep\', \''+obj_id+'\', '+i+');';

                    html += '">';

                }

                if(typeof data[i].ALLOW_RECO != 'undefined' && document.LISTTYPE == 'ct') {

                    html += '<img src="'+baseurl+'/images/arrow_reco_16x16.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_recover')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'rec\', \''+obj_id+'\', '+i+');';

                    html += '">';

                }

                if(typeof data[i].ALLOW_BUILD_VTL != 'undefined' && document.LISTTYPE == 'ct') {

                    html += '<img src="'+baseurl+'/images/arrow_build_vtl_16x16.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_build_vtl')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'build\', \''+obj_id+'\', '+i+');';

                    html += '">';

                }

                if(typeof data[i].ALLOW_DELETE != 'undefined') {

                    html += '<img src="'+baseurl+'/images/arrow_delete_16x16.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_delete')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    if(document.LISTTYPE == 'ct') {

                        html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'del\', \''+obj_id+'\', '+i+');';

                    }

                    if(document.LISTTYPE == 'ac') {

                        html += 'document.MODULE_IDS[\''+obj_id+'\'].object._createRowModal(\'del\', \''+obj_id+'\', '+i+');';

                    }

                    html += '">';

                }

                if(typeof data[i].ALLOW_REINDEX != 'undefined') {

                    html += '<img src="'+baseurl+'/images/arrow_integrate_16x16.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_integration')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    if(document.LISTTYPE == 'ct') {

                        html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'int\', \''+obj_id+'\', '+i+');';

                    }

                    if(document.LISTTYPE == 'ac') {

                        html += 'document.MODULE_IDS[\''+obj_id+'\'].object._createRowModal(\'int\', \''+obj_id+'\', '+i+');';

                    }

                    html += '">';

                }

            }

            html += '</legend>';
            html += '<div style="padding-left: 10px; padding-right: 10px; padding-top: 5px; padding-bottom: 5px; line-height: 20px;">';
            html += '<table style="height: 20px; border: none; padding: 0px; overflow: visible;">';
            html += '<tbody style="height: 20px; padding: 0px; overflow: visible;">';
            html += '<tr>';
            html += '<td style="height: 20px; padding: 0px; padding-bottom: 5px; overflow: visible; vertical-align: middle; font-size: smaller; font-weight: bold; line-height: 20px;">';

            if(document.LISTTYPE == 'ct') {

                html += '<span style="color: '+REPLISTCOLORS['blue']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_size')+data[i].SIZE_T+'</span>, ';
                html += '<span style="color: '+REPLISTCOLORS['red']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_replicated_size')+data[i].SIZE_REP_T+'</span>';

                if(data[i].SIZE_REC > 0) {

                    html += ', <span style="color: '+REPLISTCOLORS['green']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_recovered_size')+data[i].SIZE_REC_T+'</span>';

                }

            }

            if(document.LISTTYPE == 'ac') {

                html += '<span style="color: '+REPLISTCOLORS['red']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_available_data_size')+data[i].SIZE_REP_T+'</span>';

                if(data[i].SIZE > 0) {

                    html += ', <span style="color: '+REPLISTCOLORS['blue']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_reindexed_size')+data[i].SIZE_T+'</span>';

                }

            }

            html += '<br>';

            if(modal == 0) {

                html += '<img src="'+baseurl+'/images/Artichow/repbar.php?cat=vtl&modal=0&cap='+data[i].CAPACITY_P+'&size='+data[i].SIZE_P+'&sizerep='+data[i].SIZE_REP_P+'&sizerec='+data[i].SIZE_REC_P+'" alt="" style="float: none; vertical-align: middle;">';

            } else {

                if(modal == 1) {

                    var maxsize = 0;

                    if(parseInt(data[i].CAPACITY) >= parseInt(data[i].SIZE_REP)) {

                        maxsize = data[i].CAPACITY;

                    } else {

                        maxsize = data[i].SIZE_REP;

                    }

                    html += '<img src="'+baseurl+'/images/Artichow/repbar.php?cat=vtl&modal=1&cap='+((data[i].CAPACITY * 100) / maxsize)+'&size='+((data[i].SIZE * 100) / maxsize)+'&sizerep='+((data[i].SIZE_REP * 100) / maxsize)+'&sizerec='+((data[i].SIZE_REC * 100) / maxsize)+'" alt="" style="float: none; vertical-align: middle;">';

                }

            }

            html += '</td>';
            html += '</tr>';
            html += '</tbody>';
            html += '</table>';

            if(modal == 0) {

                html += '<div id="'+id+'" style="display: none;">';

            } else {

                html += '<div>';

            }

            html += content;

            html += '</div>';
            html += '</div>';
            html += '</fieldset>';
            html += '</div>';

            return html;

        },

        _createRowBKP: function(obj_id, i, j, data, modal) {

            var k = 0;
            var units = new Array;

            units[0] = arkwui_lang_get_msg('unit_B');
            units[1] = arkwui_lang_get_msg('unit_KB');
            units[2] = arkwui_lang_get_msg('unit_MB');
            units[3] = arkwui_lang_get_msg('unit_GB');
            units[4] = arkwui_lang_get_msg('unit_TB');
            units[5] = arkwui_lang_get_msg('unit_PB');
            units[6] = arkwui_lang_get_msg('unit_EB');

            var html = '';

            k = 0;

            if(data[i].item[j].SIZE > 0) {

                data[i].item[j].SIZE_T = data[i].item[j].SIZE;

                while(data[i].item[j].SIZE_T > 1024) {

                    data[i].item[j].SIZE_T /= 1024;
                    k++;

                }

                data[i].item[j].SIZE_T = (Math.round(data[i].item[j].SIZE_T * 100) / 100);

            } else {

                data[i].item[j].SIZE_T = 0;

            }

            data[i].item[j].SIZE_T += ' '+units[k];

            k = 0;

            if(data[i].item[j].SIZE_REP > 0) {

                data[i].item[j].SIZE_REP_T = data[i].item[j].SIZE_REP;

                while(data[i].item[j].SIZE_REP_T > 1024) {

                    data[i].item[j].SIZE_REP_T /= 1024;
                    k++;

                }

                data[i].item[j].SIZE_REP_T = (Math.round(data[i].item[j].SIZE_REP_T * 100) / 100);

            } else {

                data[i].item[j].SIZE_REP_T = 0;

            }

            data[i].item[j].SIZE_REP_T += ' '+units[k];

            if(modal == 0) {

                html += '<hr style="background-color: #ffffff; border: 1px #d3e0ef dashed; line-height: 1px; font-size: 1px;" />';

            }

            if(modal == 0) {

                html += '<div style="padding: 0px;">';

            } else {

                html += '<div style="padding: 10px;">';

            }

            html += '<span style="color:#C66B29; font-weight:bold; font-size: smaller;">'+data[i].item[j].BACKUP_NAME+'</span>&nbsp;&nbsp;';

            if(modal == 0) {

                html += '<img src="'+baseurl+'/images/loupe_12x12.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_details')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                if(document.LISTTYPE == 'ct') {

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'det\', \''+obj_id+'\', '+i+', '+j+');';

                }

                if(document.LISTTYPE == 'ac') {

                    html += 'document.MODULE_IDS[\''+obj_id+'\'].object._createRowModal(\'det\', \''+obj_id+'\', '+i+', '+j+');';

                }

                html += '">';

                if(typeof data[i].item[j].ALLOW_REP != 'undefined' && document.LISTTYPE == 'ct') {

                    html += '<img src="'+baseurl+'/images/arrow_rep_12x12.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_replication')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'rep\', \''+obj_id+'\', '+i+', '+j+');';

                    html += '">';

                }

                if(typeof data[i].item[j].ALLOW_RECO != 'undefined' && document.LISTTYPE == 'ct') {

                    html += '<img src="'+baseurl+'/images/arrow_reco_12x12.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_recover')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'rec\', \''+obj_id+'\', '+i+', '+j+');';

                    html += '">';

                }

                if(typeof data[i].item[j].ALLOW_DELETE != 'undefined') {

                    html += '<img src="'+baseurl+'/images/arrow_delete_12x12.gif" alt="" title="'+arkwui_lang_get_msg('replication_button_do_delete')+'" style="float: none; vertical-align: bottom; cursor: pointer;" onclick="';

                    if(document.LISTTYPE == 'ct') {

                        html += 'document.DCIDS[\''+obj_id+'\'].object._createRowModal(\'del\', \''+obj_id+'\', '+i+', '+j+');';

                    }

                    if(document.LISTTYPE == 'ac') {

                        html += 'document.MODULE_IDS[\''+obj_id+'\'].object._createRowModal(\'del\', \''+obj_id+'\', '+i+', '+j+');';

                    }

                    html += '">';

                }

            }

            html += '<br>';
            html += '<table style="height: 18px; border: none; padding: 0px; overflow: visible; line-height: 18px;">';
            html += '<tbody style="height: 18px; padding: 0px; overflow: visible; line-height: 18px;">';
            html += '<tr>';
            html += '<td style="height: 18px; padding: 0px; padding-bottom: 5px; overflow: visible; vertical-align: middle; font-size: smaller; font-weight: bold; line-height: 18px;">';

            if(document.LISTTYPE == 'ct') {

                html += '<span style="color: '+REPLISTCOLORS['blue']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_local_size')+data[i].item[j].SIZE_T+'</span>, ';
                html += '<span style="color: '+REPLISTCOLORS['red']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_remote_size')+data[i].item[j].SIZE_REP_T+'</span>';

            }

            if(document.LISTTYPE == 'ac') {

                html += '<span style="color: '+REPLISTCOLORS['red']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_available_data_size')+data[i].item[j].SIZE_REP_T+'</span>';

                if(data[i].item[j].SIZE > 0) {
                    html += ', <span style="color: '+REPLISTCOLORS['blue']+'; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_reindexed_size')+data[i].item[j].SIZE_T+'</span>';
                }

            }

            html += '<br>';

            if(modal ==0) {

                html += '<img src="'+baseurl+'/images/Artichow/repbar.php?cat=bkp&modal=0&size='+data[i].item[j].SIZE_P+'&sizerep='+data[i].item[j].SIZE_REP_P+'" alt="" style="float: none; vertical-align: middle;">';

            } else {

                if(modal == 1) {

                    var maxsize = 0;

                    if(parseInt(data[i].CAPACITY) >= parseInt(data[i].SIZE_REP)) {

                        maxsize = data[i].CAPACITY;

                    } else {

                        maxsize = data[i].SIZE_REP;

                    }

                    html += '<img src="'+baseurl+'/images/Artichow/repbar.php?cat=bkp&modal=1&size='+((data[i].item[j].SIZE * 100) / maxsize)+'&sizerep='+((data[i].item[j].SIZE_REP * 100) / maxsize)+'" alt="" style="float: none; vertical-align: middle;">';

                } else {

                    var maxsize = 0;

                    if(data[i].item[j].SIZE > maxsize) { maxsize = data[i].item[j].SIZE; }
                    if(data[i].item[j].SIZE_REP > maxsize) { maxsize = data[i].item[j].SIZE_REP; }

                    html += '<img src="'+baseurl+'/images/Artichow/repbar.php?cat=bkp&modal=1&size='+((data[i].item[j].SIZE * 100) / maxsize)+'&sizerep='+((data[i].item[j].SIZE_REP * 100) / maxsize)+'" alt="" style="float: none; vertical-align: middle;">';

                }

            }

            html += '</td>';
            html += '</tr>';
            html += '</tbody>';
            html += '</table>';
            html += '</div>';

            return html;

        },

        _createRowModalWin: function() {

            dojo.widget.byId('RepModalWindow').show();

        },

        _createRowModal: function(type, obj_id, i, j) {

            switch(type) {

                case 'det':

                    dojo.widget.byId('RepModalWindow').titleBarText.innerHTML = arkwui_lang_get_msg('replication_button_do_details');

                    if(document.LISTTYPE == 'ct') {

                        document.DCIDS[obj_id].object._createRowModalWin();
                        result = document.DCIDS[obj_id].lastresult;

                    }

                    if(document.LISTTYPE == 'ac') {

                        document.MODULE_IDS[obj_id].object._createRowModalWin();
                        result = document.MODULE_IDS[obj_id].lastresult;

                    }

                    var html = '';

                    if(typeof j == 'undefined') {

                        var bkps = '';

                        if(typeof result.data[i].item != 'undefined') {

                            for(j=0; j<result.data[i].item.length; j++) {

                                if(typeof result.data[i].item[j].BKSID != 'undefined') {

                                    if(document.LISTTYPE == 'ct') {

                                        bkps += document.DCIDS[obj_id].object._createRowBKP(obj_id, i, j, result.data, 1);

                                    }

                                    if(document.LISTTYPE == 'ac') {

                                        bkps += document.MODULE_IDS[obj_id].object._createRowBKP(obj_id, i, j, result.data, 1);

                                    }

                                }

                            }

                        }

                        if(document.LISTTYPE == 'ct') {

                            html += document.DCIDS[obj_id].object._createRowVTL(obj_id, i, result.data, bkps, 1);

                        }

                        if(document.LISTTYPE == 'ac') {

                            html += document.MODULE_IDS[obj_id].object._createRowVTL(obj_id, i, result.data, bkps, 1);

                        }

                    } else {

                        if(document.LISTTYPE == 'ct') {

                            html += document.DCIDS[obj_id].object._createRowBKP(obj_id, i, j, result.data, 2);

                        }

                        if(document.LISTTYPE == 'ac') {

                            html += document.MODULE_IDS[obj_id].object._createRowBKP(obj_id, i, j, result.data, 2);

                        }

                    }

                    html += '<div style="text-align: center;"><button id="hider" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('Close')+'</button></div>';

                    document.getElementById('RepModalContent').innerHTML = html;

                    dojo.event.connect(dojo.byId('hider'), 'onclick', dojo.widget.byId('RepModalWindow'), 'hide');

                break;

                case 'rep':

                    if(document.LISTTYPE == 'ct') {

                        if(document.DCIDS[obj_id].vmbi) {

                            document.DCIDS[obj_id].vmbi = false;

                        }

                        if(document.DCIDS[obj_id].vmba) {

                            document.DCIDS[obj_id].vmba = false;

                        }

                        if(document.DCIDS[obj_id].its) {

                            document.DCIDS[obj_id].its = false;

                        }

                        document.DCIDS[obj_id].object.popup = 'rep';

                        document.DCIDS[obj_id].object.resetswitchmail();
                        document.DCIDS[obj_id].object.resetswitchretention();

                        dojo.widget.byId('RepModalWindow').titleBarText.innerHTML = arkwui_lang_get_msg('replication_button_do_replication');

                        result = document.DCIDS[obj_id].lastresult;
                        var basepath = document.DCIDS[obj_id].object.baseUrl + '/' + document.DCIDS[obj_id].object.controller;

                        if(typeof j == 'undefined') {

                            var dataUrl = basepath + '/jsonLaunchReplication?DCID='+obj_id+'&VTLID='+result.data[i].VTLID;
                            var vtlName= result.data[i].NAME;

                        } else {

                            var dataUrl = basepath + '/jsonLaunchReplication?DCID='+obj_id+'&VTLID='+result.data[i].VTLID+'&BKSID='+result.data[i].item[j].BKSID;
                            var vtlName= result.data[i].NAME;
                            var backupName = result.data[i].item[j].BACKUP_NAME;

                        }

                        var getNext = basepath + '/jsonGetNextResult';
                        var abortUrl = basepath + '/jsonAbortTrans';

                        document.DCIDS[obj_id].object._createRowModalWin();

                        var html = '';

                        html += '<div style="text-align: left; padding-left: 10px; padding-top: 10px;">';

                        var trans = new Array();

                        if(typeof j != 'undefined') {

                            var subtrans = new Array();
                            subtrans['backupname'] = backupName;
                            trans['backup'] = arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_replication_header_backup'), subtrans);

                        } else {

                            trans['backup'] = '';

                        }

                        trans['vtlname'] = vtlName;

                        html += arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_replication_header'), trans);

                        html += '<div class="schwizard" style="float: none; padding-left: 0px; padding-right: 10px; padding-top: 10px; padding-bottom: 10px;">';
                        html += '<fieldset style="text-align: center;">';
                        html += '<table style="width: 100%;">';

                        html += '<tr>';
                        html += '<td style="width: 100%; text-align: left; padding-left: 30%;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_replication_header_domail');
                        html += '<span class="iecheckboxcontainer" id="RepModalContentDoEmail" style="vertical-align: text-bottom;"></span>';
                        html += '</td>';
                        html += '</tr>';

                        html += '<tr>';
                        html += '<td style="width: 100%; text-align: left;  padding-left: 30%;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_replication_header_doret');
                        html += '<span class="iecheckboxcontainer" id="RepModalContentDoRetention" style="vertical-align: text-bottom;"></span>';
                        html += '</td>';
                        html += '</tr>';

                        html += '<tr>';
                        html += '<td id="RepModalContentDoRetentionBox" style="width: 100%; text-align: left;  padding-left: 35%; display: none;">';
                        html += arkwui_lang_get_msg('bkp_inter_form_valid_for')+': ';
                        html += '<input class="subvalue" style="width:5%" type="text" name="RET_TIME" id="RET_TIME" dojoType="arkeia:ArkeiaTextbox" value="30" />';
                        html += '&nbsp;&nbsp;';
                        html += '<select style="width: 20%;" name="RET_TIME_UNIT" id="RET_TIME_UNIT" dojoType="arkeia:ArkeiaComboBox" onValueChanged="verifForm" autoComplete="true" mode="local" forceValidOption="true" selectFirst="true"> ';
                        html += '<option value="D">'+arkwui_lang_get_msg('bkp_form_timeunit_D')+'</option>';
                        html += '<option value="W">'+arkwui_lang_get_msg('bkp_form_timeunit_W')+'</option>';
                        html += '<option value="M">'+arkwui_lang_get_msg('bkp_form_timeunit_M')+'</option>';
                        html += '<option value="Y">'+arkwui_lang_get_msg('bkp_form_timeunit_Y')+'</option>';
                        html += '</select>';
                        html += '</td>';
                        html += '</tr>';

                        html += '</table>';

                        html += '<div style="text-align: center; padding-top: 10px; padding-bottom: 10px">';
                        html += '<button type="button" class="dojoButtonContents dojoButton ArkButton" onclick="';
                        html += 'var prefix = \'\';';
                        html += 'var reterror = false;';
                        html += 'if(typeof document.DCIDS[\''+obj_id+'\'].object.reperet != \'undefined\' && document.DCIDS[\''+obj_id+'\'].object.reperet == 1) { ';
                        html += 'if(document.getElementById(\'RET_TIME\').value == \'\'){';
                        html += 'reterror = true;';
                        html += '} else {';
                        html += 'prefix += \'&RET_TIME=\'+document.getElementById(\'RET_TIME\').value+\'&RET_TIME_UNIT=\'+document.getElementById(\'RET_TIME_UNIT\').options[document.getElementById(\'RET_TIME_UNIT\').selectedIndex].value;';
                        html += '}';
                        html += '}';
                        html += 'if(!reterror){ '
                        html += 'if(typeof document.DCIDS[\''+obj_id+'\'].object.repemail == \'undefined\' || document.DCIDS[\''+obj_id+'\'].object.repemail == 0) { ';
                        html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\'+prefix, \''+getNext+'\', \''+abortUrl+'\');';
                        html += 'this.disabled=\'disabled\';';
                        html += '} else {';
                        html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'&DO_EMAIL=1\'+prefix, \''+getNext+'\', \''+abortUrl+'\');';
                        html += 'this.disabled=\'disabled\';';
                        html += '}';
                        html += '} else {';
                        html += 'alert(arkwui_lang_get_msg(\'replication_error_value_require_RET_TIME\'));';
                        html += '}';
                        html += '">'+arkwui_lang_get_msg('replication_listing_popup_replication_header_start_replication')+'</button>';
                        html += '&nbsp;';
                        html += '<button id="hider" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('replication_listing_popup_replication_header_close')+'</button>';
                        html += '</div>';

                        html += '</fieldset>';
                        html += '</div>';
                        html += '</div>';

                        html += '<div id="RepModalMessage" style="border-top: 1px #C76E28 solid; position: absolute; left: 1%; height: 70px; width: 98%; bottom: 0px; overflow: auto; font-size: smaller;"></div>';

                        html += '<div id="RepModalJobContent" style="text-align: center; display: none; padding-top: 10px; padding-bottom: 10px;">';
                        html += '<div id="RepModalJobContentInf" style="text-align: center; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_popup_replication_header_job_is_running')+'</div>';
                        html += '<div class="schwizard" style="float: none; padding-left: 10px; padding-right: 10px; padding-top: 0px; padding-bottom: 0px;">';
                        html += '<fieldset><legend>'+arkwui_lang_get_msg('replication_listing_popup_replication_job_title')+'</legend>';
                        html += '<table style="width: 100%;">';
                        html += '<tr class="infoText">';
                        html += '<td class="infoTextLabel" style="width: 30%; text-align: right;">'+arkwui_lang_get_msg('bkp_showbkp_info_net_speed_ins')+'</td>';
                        html += '<td id="RepModalJobContentIns" style="width: 70%;"></td>';
                        html += '</tr>';
                        html += '<tr class="infoText">';
                        html += '<td class="infoTextLabel" style="width: 30%; text-align: right;">'+arkwui_lang_get_msg('bkp_showbkp_info_net_speed_avg')+'</td>';
                        html += '<td id="RepModalJobContentAvg" style="width: 70%;"></td>';
                        html += '</tr>';
                        html += '<tr class="infoText">';
                        html += '<td colspan="2"><table id="RepModalJobContentSiz" class="tablesize" style="width: 100%;"></table></td>';
                        html += '</tr>';
                        html += '</table>';
                        html += '</fieldset>';
                        html += '</div>';
                        html += '</div>';

                        document.getElementById('RepModalContent').innerHTML = html;

                        vdeArgs = {widgetId: 'DO_EMAIL', name: 'DO_EMAIL', id: 'DO_EMAIL', type: 'checkbox', value: '1'};
                        dojo.widget.createWidget('arkeia:ArkeiaCheckbox', vdeArgs, document.getElementById('RepModalContentDoEmail'), 'child');

                        vdeArgs2 = {widgetId: 'DO_RETENTION', name: 'DO_RETENTION', id: 'DO_RETENTION', type: 'checkbox', value: '1'};
                        dojo.widget.createWidget('arkeia:ArkeiaCheckbox', vdeArgs2, document.getElementById('RepModalContentDoRetention'), 'child');

                        dojo.event.connect(dojo.byId('DO_EMAIL'), 'onclick', this, 'dorepjobswitchmail');

                        dojo.event.connect(dojo.byId('DO_RETENTION'), 'onclick', this, 'dorepjobswitchretention');

                        dojo.event.connect(dojo.byId('hider'), 'onclick', this, 'popupHide');
                    }

                break;

                case 'rec':

					if(document.LISTTYPE == 'ct') {

                        if(document.DCIDS[obj_id].vmbi) {

                            document.DCIDS[obj_id].vmbi = false;

                        }

                        if(document.DCIDS[obj_id].vmba) {

                            document.DCIDS[obj_id].vmba = false;

                        }

                        if(document.DCIDS[obj_id].its) {

                            document.DCIDS[obj_id].its = false;

                        }

                        document.DCIDS[obj_id].object.popup = 'rec';

                        document.DCIDS[obj_id].object.resetswitchmail();
                        document.DCIDS[obj_id].object.resetswitchretention();

                        dojo.widget.byId('RepModalWindow').titleBarText.innerHTML = arkwui_lang_get_msg('replication_button_do_recover');

                        result = document.DCIDS[obj_id].lastresult;
                        var basepath = document.DCIDS[obj_id].object.baseUrl + '/' + document.DCIDS[obj_id].object.controller;

                        if(typeof j == 'undefined') {

                            var dataUrl = basepath + '/jsonLaunchRecover?DCID='+obj_id+'&VTLID='+result.data[i].VTLID;
                            var vtlName= result.data[i].NAME;

                        } else {

                            var dataUrl = basepath + '/jsonLaunchRecover?DCID='+obj_id+'&VTLID='+result.data[i].VTLID+'&BKSID='+result.data[i].item[j].BKSID;
                            var vtlName= result.data[i].NAME;
                            var backupName = result.data[i].item[j].BACKUP_NAME;

                        }

                        var getNext = basepath + '/jsonGetNextResult';
                        var abortUrl = basepath + '/jsonAbortTrans';

                        document.DCIDS[obj_id].object._createRowModalWin();

                        var html = '';

                        html += '<div style="text-align: left; padding-left: 10px; padding-top: 10px;">';

                        var trans = new Array();

                        if(typeof j != 'undefined') {

                            var subtrans = new Array();
                            subtrans['backupname'] = backupName;
                            trans['backup'] = arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_recover_header_backup'), subtrans);

                        } else {

                            trans['backup'] = '';

                        }

                        trans['vtlname'] = vtlName;

                        html += arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_recover_header'), trans);

                        html += '<div class="schwizard" style="float: none; padding-left: 0px; padding-right: 10px; padding-top: 10px; padding-bottom: 10px;">';
                        html += '<fieldset>';
                        html += '<table style="width: 100%;">';
                        html += '<tr>';
                        html += '<td style="width: 100%; text-align: center;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_recover_header_domail');
                        html += '<span class="iecheckboxcontainer" id="RepModalContentDoEmail" style="vertical-align: text-bottom;"></span>';
                        html += '</td>';
                        html += '</tr>';
                        html += '</table>';
                        html += '<div style="text-align: center; padding-top: 10px; padding-bottom: 10px">';
                        html += '<button type="button" class="dojoButtonContents dojoButton ArkButton" onclick="';

                        html += 'if(typeof document.DCIDS[\''+obj_id+'\'].object.repemail == \'undefined\' || document.DCIDS[\''+obj_id+'\'].object.repemail == 0) { ';
                        html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\', \''+getNext+'\', \''+abortUrl+'\');';
                        html += '} else {';
                        html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'&DO_EMAIL=1\', \''+getNext+'\', \''+abortUrl+'\');';
                        html += '}';

                        html += 'this.disabled=\'disabled\';';
                        html += '">'+arkwui_lang_get_msg('replication_listing_popup_recover_header_start_recover')+'</button>';
                        html += '&nbsp;';
                        html += '<button id="hider" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('replication_listing_popup_recover_header_close')+'</button>';
                        html += '</div>';
                        html += '</fieldset>';
                        html += '</div>';
                        html += '</div>';

                        html += '<div id="RepModalMessage" style="border-top: 1px #C76E28 solid; position: absolute; left: 1%; height: 70px; width: 98%; bottom: 0px; overflow: auto; font-size: smaller;"></div>';

                        html += '<div id="RepModalJobContent" style="text-align: center; display: none; padding-top: 10px; padding-bottom: 10px;">';
                        html += '<div id="RepModalJobContentInf" style="text-align: center; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_popup_recover_header_job_is_running')+'</div>';
                        html += '<div class="schwizard" style="float: none; padding-left: 10px; padding-right: 10px; padding-top: 0px; padding-bottom: 0px;">';
                        html += '<fieldset><legend>'+arkwui_lang_get_msg('replication_listing_popup_recover_job_title')+'</legend>';
                        html += '<table style="width: 100%;">';
                        html += '<tr class="infoText">';
                        html += '<td class="infoTextLabel" style="width: 30%; text-align: right;">'+arkwui_lang_get_msg('bkp_showbkp_info_net_speed_ins')+'</td>';
                        html += '<td id="RepModalJobContentIns" style="width: 70%;"></td>';
                        html += '</tr>';
                        html += '<tr class="infoText">';
                        html += '<td class="infoTextLabel" style="width: 30%; text-align: right;">'+arkwui_lang_get_msg('bkp_showbkp_info_net_speed_avg')+'</td>';
                        html += '<td id="RepModalJobContentAvg" style="width: 70%;"></td>';
                        html += '</tr>';
                        html += '<tr class="infoText">';
                        html += '<td colspan="2"><table id="RepModalJobContentSiz" class="tablesize" style="width: 100%;"></table></td>';
                        html += '</tr>';
                        html += '</table>';
                        html += '</fieldset>';
                        html += '</div>';
                        html += '</div>';

                        document.getElementById('RepModalContent').innerHTML = html;

                        vdeArgs = {widgetId: 'DO_EMAIL', name: 'DO_EMAIL', id: 'DO_EMAIL', type: 'checkbox', value: '1'};
                        dojo.widget.createWidget('arkeia:ArkeiaCheckbox', vdeArgs, document.getElementById('RepModalContentDoEmail'), 'child');

                        dojo.event.connect(dojo.byId('DO_EMAIL'), 'onclick', this, 'dorepjobswitchmail');
                        dojo.event.connect(dojo.byId('hider'), 'onclick', this, 'popupHide');

                    }

                break;

                case 'int':

                    dojo.widget.byId('RepModalWindow').titleBarText.innerHTML = arkwui_lang_get_msg('replication_button_do_integration');

                    if(document.LISTTYPE == 'ct') {

                        if(document.DCIDS[obj_id].its) {

                            document.DCIDS[obj_id].its = false;

                        }

                        document.DCIDS[obj_id].object.popup = 'int';

                        document.DCIDS[obj_id].object.resetswitchmail();
                        document.DCIDS[obj_id].object.resetswitchretention();

                        document.DCIDS[obj_id].object._createRowModalWin();
                        result = document.DCIDS[obj_id].lastresult;

                        var basepath = document.DCIDS[obj_id].object.baseUrl + '/' + document.DCIDS[obj_id].object.controller;

                    }

                    if(document.LISTTYPE == 'ac') {

                        if(document.MODULE_IDS[obj_id].its) {

                            document.MODULE_IDS[obj_id].its = false;

                        }

                        document.MODULE_IDS[obj_id].object.popup = 'int';

                        document.MODULE_IDS[obj_id].object.resetswitchmail();
                        document.MODULE_IDS[obj_id].object.resetswitchretention();

                        document.MODULE_IDS[obj_id].object._createRowModalWin();
                        result = document.MODULE_IDS[obj_id].lastresult;

                        var basepath = document.MODULE_IDS[obj_id].object.baseUrl + '/' + document.MODULE_IDS[obj_id].object.controller;

                    }

                    var dataUrl = basepath + '/jsonLaunchIntegration';
                    var getNext = basepath + '/jsonGetNextResult';
                    var abortUrl = basepath + '/jsonAbortTrans';

                    var vtlName= result.data[i].NAME;

                    var srcvtlName= result.data[i].NAME;

                    var html = '';

                    html += '<div style="text-align: left; padding-left: 10px; padding-top: 10px;">';

                    var trans = new Array();

                    trans['vtlname'] = vtlName;

                    if(document.LISTTYPE == 'ac') {

                        html += arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_integration_ac_header'), trans);

                    }

                    if(document.LISTTYPE == 'ct') {

                        html += arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_integration_ct_header'), trans);

                    }

                    html += '<div class="schwizard" style="float: none; padding-left: 0px; padding-right: 10px; padding-top: 10px; padding-bottom: 10px;">';
                    html += '<fieldset>';
                    html += '<table style="width: 100%;">';
                    html += '<tr>';
                    html += '<td style="width: 50%; text-align: right; padding-right: 5px;">';
                    html += arkwui_lang_get_msg('replication_listing_popup_integration_header_domail');
                    html += '</td>';
                    html += '<td style="width: 50%; text-align: left; padding-left: 5px;">';
                    html += '<div class="iecheckboxcontainer" id="RepModalContentDoEmail"></div>';
                    html += '</td>';
                    html += '</tr>';

                    if(document.LISTTYPE == 'ac') {

                        html += '<tr>';
                        html += '<td style="width: 50%; text-align: right; padding-right: 5px;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_integration_header_vtlname');
                        html += '</td>';
                        html += '<td style="width: 50%; text-align: left; padding-left: 5px;">';
                        html += '<input type="text" id="SRC_VTL_NAME" value="'+srcvtlName+'"';

                        if(typeof result.data[i].IS_REINDEXED != 'undefined') {

                            html += ' disabled="disabled"';

                        }

                        html += ' />';
                        html += '</td>';
                        html += '</tr>';

                    }

                    html += '</table>';
                    html += '<div style="text-align: center; padding-top: 10px; padding-bottom: 10px">';
                    html += '<button type="button" class="dojoButtonContents dojoButton ArkButton" onclick="';

                    html += 'if(';
                    html += 'document.LISTTYPE == \'ac\' && ';
                    html += 'document.getElementById(\'SRC_VTL_NAME\').value == \'\'';
                    html += ') {';

                    html += 'var errorStr = \'\';';

                    html += 'if(document.getElementById(\'SRC_VTL_NAME\').value == \'\') errorStr += \''+arkwui_lang_get_msg('replication_listing_popup_integration_error_vtlname')+'\';';

                    html += 'alert(errorStr);';

                    html += '} else {';

                    if(document.LISTTYPE == 'ct') {

                        html += 'var appendix = \'?\';';

                        html += 'appendix += \'VTLID='+result.data[i].VTLID+'&CT=1\';';

                        html += 'if(typeof document.DCIDS[\''+obj_id+'\'].object.repemail != \'undefined\' && document.DCIDS[\''+obj_id+'\'].object.repemail == 1) { ';
                        html += 'appendix += \'&DO_EMAIL=1\';';
                        html += '}'

                        html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\'+appendix, \''+getNext+'\', \''+abortUrl+'\');';

                    }

                    if(document.LISTTYPE == 'ac') {

                        html += 'var appendix = \'?\';';

                        if(typeof result.data[i].IS_REINDEXED != 'undefined') {

                            html += 'appendix += \'VTLID='+result.data[i].REAL_VTLID+'&IS_REINDEXED=1\';';

                        } else {

                            html += 'appendix += \'MODULE_ID='+obj_id+'&VTLID='+result.data[i].VTLID+'&VTLNAME='+result.data[i].NAME+'\';';

                            html += 'if(document.getElementById(\'SRC_VTL_NAME\').value != \'\') appendix += \'&SRC_VTL_NAME=\'+document.getElementById(\'SRC_VTL_NAME\').value;';

                        }

                        html += 'if(typeof document.MODULE_IDS[\''+obj_id+'\'].object.repemail != \'undefined\' && document.MODULE_IDS[\''+obj_id+'\'].object.repemail == 1) { ';
                        html += 'appendix += \'&DO_EMAIL=1\';';
                        html += '}'

                        html += 'document.MODULE_IDS[\''+obj_id+'\'].object._launchtrans(document.MODULE_IDS[\''+obj_id+'\'].object, document.MODULE_IDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\'+appendix, \''+getNext+'\', \''+abortUrl+'\');';

                    }

                    html += 'this.disabled=\'disabled\';';
                    html += '}';
                    html += '">'+arkwui_lang_get_msg('replication_listing_popup_integration_header_start_integration')+'</button>';
                    html += '&nbsp;';
                    html += '<button id="hider" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('replication_listing_popup_integration_header_close')+'</button>';
                    html += '</div>';
                    html += '</fieldset>';
                    html += '</div>';
                    html += '</div>';

                    html += '<div id="RepModalMessage" style="border-top: 1px #C76E28 solid; position: absolute; left: 1%; height: 70px; width: 98%; bottom: 0px; overflow: auto; font-size: smaller;"></div>';

                    html += '<div id="RepModalJobContent" style="text-align: center; display: none; padding-top: 10px; padding-bottom: 10px;">';
                    html += '<div id="RepModalJobContentInf" style="text-align: center; font-weight: bold;">'+arkwui_lang_get_msg('replication_listing_popup_integration_header_job_is_running')+'</div>';
                    html += '<div class="schwizard" style="float: none; padding-left: 10px; padding-right: 10px; padding-top: 0px; padding-bottom: 0px;">';
                    html += '<fieldset><legend>'+arkwui_lang_get_msg('replication_listing_popup_integration_job_reindexed_size')+'</legend>';
                    html += '<table style="width: 100%;">';
                    html += '<tr class="infoText">';
                    html += '<td colspan="2"><table id="RepModalJobContentSiz" class="tablesize" style="width: 100%;"></table></td>';
                    html += '</tr>';
                    html += '</table>';
                    html += '</fieldset>';
                    html += '</div>';
                    html += '</div>';

                    document.getElementById('RepModalContent').innerHTML = html;

                    vdeArgs = {widgetId: 'DO_EMAIL', name: 'DO_EMAIL', id: 'DO_EMAIL', type: 'checkbox', value: '1'};
                    dojo.widget.createWidget('arkeia:ArkeiaCheckbox', vdeArgs, document.getElementById('RepModalContentDoEmail'), 'child');

                    dojo.event.connect(dojo.byId('DO_EMAIL'), 'onclick', this, 'dorepjobswitchmail');
                    dojo.event.connect(dojo.byId('hider'), 'onclick', this, 'popupHide');

                break;

                case 'build':

                    if(document.LISTTYPE == 'ct') {

                        var is_shared = false;

                        if(typeof document.DCIDS[obj_id].shared != 'undefined') {
                        
                            is_shared = true;

                        }

                        dojo.widget.byId('RepModalWindow').titleBarText.innerHTML = arkwui_lang_get_msg('replication_button_do_build_vtl');

                        document.DCIDS[obj_id].object.popup = 'build';

                        document.DCIDS[obj_id].object._createRowModalWin();
                        result = document.DCIDS[obj_id].lastresult;

                        var basepath = document.DCIDS[obj_id].object.baseUrl + '/' + document.DCIDS[obj_id].object.controller;

                        var dataUrl = basepath + '/jsonLaunchVtlCreation';
                        var getNext = basepath + '/jsonGetNextResult';
                        var abortUrl = basepath + '/jsonAbortTrans';

                        var vtlName= result.data[i].NAME;

                        var srcvtlName= result.data[i].NAME;
                        var srcvtlCapacity = 0;

                        if(result.data[i].CAPACITY > 0) {

                            srcvtlCapacity = (result.data[i].CAPACITY / 1024) / 1024;

                        } else {

                            srcvtlCapacity = '';

                        }

                        var html = '';

                        html += '<div style="text-align: left; padding-left: 10px; padding-top: 10px;">';

                        var trans = new Array();

                        trans['vtlname'] = vtlName;

                        html += arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_build_header'), trans);

                        html += '<div class="schwizard" style="float: none; padding-left: 0px; padding-right: 10px; padding-top: 10px; padding-bottom: 10px;">';
                        html += '<fieldset>';
                        html += '<table style="width: 100%;">';

                        html += '<tr>';
                        html += '<td style="width: 50%; text-align: right; padding-right: 5px;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_build_header_vtlname');
                        html += '</td>';
                        html += '<td style="width: 50%; text-align: left; padding-left: 5px;">';
                        html += '<input type="text" id="SRC_VTL_NAME" value="'+srcvtlName+'"';
                        html += ' />';
                        html += '</td>';
                        html += '</tr>';

                        html += '<tr>';
                        html += '<td style="width: 50%; text-align: right; padding-right: 5px;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_build_header_vtlcapacity');
                        html += '</td>';
                        html += '<td style="width: 50%; text-align: left; padding-left: 5px;">';
                        html += '<input type="text" id="SRC_VTL_CAPACITY" value="'+srcvtlCapacity+'"';
                        html += ' />';
                        html += '</td>';
                        html += '</tr>';

                        html += '<tr>';
                        html += '<td style="width: 50%; text-align: right; padding-right: 5px;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_build_header_mediaserver');
                        html += '</td>';
                        html += '<td style="width: 50%; text-align: left; padding-left: 5px;" id="RepModalContentMediaServer">';

                        html += '</td>';
                        html += '</tr>';

                        html += '<tr>';
                        html += '<td style="width: 50%; text-align: right; padding-right: 5px;">';
                        html += arkwui_lang_get_msg('replication_listing_popup_build_header_vtlpath');
                        html += '</td>';
                        html += '<td style="width: 50%; text-align: left; padding-left: 5px;">';
                        html += '<input type="text" id="SRC_VTL_PATH" value=""';
                        html += ' />';
                        html += '</td>';
                        html += '</tr>';

                        html += '</table>';
                        html += '<div style="text-align: center; padding-top: 10px; padding-bottom: 10px">';
                        html += '<button type="button" class="dojoButtonContents dojoButton ArkButton" onclick="';

                        html += 'if(';
                        html += 'document.getElementById(\'SRC_VTL_NAME\').value == \'\' || ';
                        html += 'document.getElementById(\'SRC_VTL_CAPACITY\').value == \'\' || ';
                        html += 'dojo.widget.byId(\'MEDIA_SERVER\').getValue() == \'\' || ';
                        html += 'document.getElementById(\'SRC_VTL_PATH\').value == \'\'';
                        html += ') {';

                        html += 'var errorStr = \'\';';

                        html += 'if(document.getElementById(\'SRC_VTL_NAME\').value == \'\') errorStr += \''+arkwui_lang_get_msg('replication_listing_popup_build_error_vtlname')+'\';';
                        html += 'if(document.getElementById(\'SRC_VTL_CAPACITY\').value == \'\') errorStr += \''+arkwui_lang_get_msg('replication_listing_popup_build_error_vtlcapacity')+'\';';
                        html += 'if(dojo.widget.byId(\'MEDIA_SERVER\').getValue() == \'\') errorStr += \''+arkwui_lang_get_msg('replication_listing_popup_build_error_mediaserver')+'\';';
                        html += 'if(document.getElementById(\'SRC_VTL_PATH\').value == \'\') errorStr += \''+arkwui_lang_get_msg('replication_listing_popup_build_error_vtlpath')+'\';';

                        html += 'alert(errorStr);';

                        html += '} else {';

                        html += 'var appendix = \'?\';';

                        if(is_shared) {

                            html += 'appendix += \'SHARED=1&DCID='+obj_id+'&REMOTE_REPVTLID='+result.data[i].VTLID+'&REMOTE_REPNAME='+result.data[i].NAME+'\';';

                        } else {

                            html += 'appendix += \'REMOTE_REPNAME='+result.data[i].NAME+'&VTLID='+result.data[i].VTLID+'\';';

                        }

                        html += 'appendix += \'&MEDIA_SERVER=\'+dojo.widget.byId(\'MEDIA_SERVER\').getValue();';

                        html += 'if(document.getElementById(\'SRC_VTL_NAME\').value != \'\') appendix += \'&NAME=\'+document.getElementById(\'SRC_VTL_NAME\').value;';
                        html += 'if(document.getElementById(\'SRC_VTL_CAPACITY\').value != \'\') appendix += \'&CAPACITY=\'+document.getElementById(\'SRC_VTL_CAPACITY\').value;';
                        html += 'if(document.getElementById(\'SRC_VTL_PATH\').value != \'\') appendix += \'&PATH=\'+document.getElementById(\'SRC_VTL_PATH\').value;';

                        html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\'+appendix, \''+getNext+'\', \''+abortUrl+'\');';

                        html += '}';

                        html += '">'+arkwui_lang_get_msg('replication_listing_popup_build_header_start_build')+'</button>';
                        html += '&nbsp;';
                        html += '<button id="hider" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('replication_listing_popup_build_header_close')+'</button>';
                        html += '</div>';
                        html += '</fieldset>';
                        html += '</div>';
                        html += '</div>';

                        html += '<div id="RepModalMessage" style="border-top: 1px #C76E28 solid; position: absolute; left: 1%; height: 70px; width: 98%; bottom: 0px; overflow: auto; font-size: smaller;"></div>';

                        document.getElementById('RepModalContent').innerHTML = html;

                        msArgs = {name: 'MEDIA_SERVER', widgetId: 'MEDIA_SERVER', realDataUrl: document.DCIDS[obj_id].object.baseUrl + '/mediaserver/jsonListMediaserver', forceValidOption: 'true', autoComplete: 'true', selectFirst: 'true'};
                        dojo.widget.createWidget('arkeia:ArkeiaComboBox', msArgs, document.getElementById('RepModalContentMediaServer'), 'child');

                        dojo.event.connect(dojo.byId('hider'), 'onclick', this, 'popupHide');

                    }

                break;

                case 'del':

                    dojo.widget.byId('RepModalWindow').titleBarText.innerHTML = arkwui_lang_get_msg('replication_button_do_delete');

                    if(document.LISTTYPE == 'ct') {

                        document.DCIDS[obj_id].object.popup = 'del';

                        document.DCIDS[obj_id].object._createRowModalWin();
                        result = document.DCIDS[obj_id].lastresult;

                        var basepath = document.DCIDS[obj_id].object.baseUrl + '/' + document.DCIDS[obj_id].object.controller;
                    }

                    if(document.LISTTYPE == 'ac') {

                        document.MODULE_IDS[obj_id].object.popup = 'del';

                        document.MODULE_IDS[obj_id].object._createRowModalWin();
                        result = document.MODULE_IDS[obj_id].lastresult;

                        var basepath = document.MODULE_IDS[obj_id].object.baseUrl + '/' + document.MODULE_IDS[obj_id].object.controller;

                    }

                    var dataUrl = basepath + '/jsonLaunchRemove';
                    var getNext = basepath + '/jsonGetNextResult';
                    var abortUrl = basepath + '/jsonAbortTrans';

                    var vtlName= result.data[i].NAME;
                    if(typeof j != 'undefined') {
                        var backupName = result.data[i].item[j].BACKUP_NAME;
                    }

                    var html = '';

                    html += '<div style="text-align: left; padding-left: 10px; padding-top: 10px;">';

                    var trans = new Array();

                    if(typeof j != 'undefined') {

                        var subtrans = new Array();
                        subtrans['backupname'] = backupName;
                        trans['backup'] = arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_delete_header_backup'), subtrans);

                    } else {

                        trans['backup'] = '';

                    }

                    trans['vtlname'] = vtlName;

                    html += arkwui_tpl_get_trans(arkwui_lang_get_msg('replication_listing_popup_delete_header'), trans);

                    html += '<div class="schwizard" style="float: none; padding-left: 0px; padding-right: 10px; padding-top: 10px; padding-bottom: 10px;">';
                    html += '<fieldset>';

                    html += '<div style="text-align: center;">';

                    html += '<button type="button" class="dojoButtonContents dojoButton ArkButton" onclick="';

                    if(document.LISTTYPE == 'ct') {

                        if(typeof j != 'undefined') {

                            html += 'var appendix = \'?\';';

                            html += 'appendix += \'VTLID='+result.data[i].VTLID+'&BKSID='+result.data[i].item[j].BKSID+'\';';

                            html += 'document.DCIDS[\''+obj_id+'\'].object._launchtrans(document.DCIDS[\''+obj_id+'\'].object, document.DCIDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\'+appendix, \''+getNext+'\', \''+abortUrl+'\');';

                        }

                    }

                    if(document.LISTTYPE == 'ac') {

                        html += 'var appendix = \'?\';';

                        html += 'appendix += \'MODULE_ID='+obj_id+'&VTLID='+result.data[i].VTLID+'\';';

                        if(typeof j != 'undefined') {

                            html += 'appendix += \'&BKSID='+result.data[i].item[j].BKSID+'\';';

                        }

                        html += 'document.MODULE_IDS[\''+obj_id+'\'].object._launchtrans(document.MODULE_IDS[\''+obj_id+'\'].object, document.MODULE_IDS[\''+obj_id+'\'].object.createRowModalData, \''+dataUrl+'\'+appendix, \''+getNext+'\', \''+abortUrl+'\');';

                    }

                    html += '">'+arkwui_lang_get_msg('replication_listing_popup_delete_header_yes')+'</button>';

                    html += '<button id="hider" type="button" class="dojoButtonContents dojoButton ArkButton">'+arkwui_lang_get_msg('replication_listing_popup_delete_header_no')+'</button>';
                    html += '</div>';

                    html += '</fieldset>';
                    html += '</div>';
                    html += '</div>';

                    html += '<div id="RepModalMessage" style="border-top: 1px #C76E28 solid; position: absolute; left: 1%; height: 70px; width: 98%; bottom: 0px; overflow: auto; font-size: smaller;"></div>';

                    document.getElementById('RepModalContent').innerHTML = html;

                    dojo.event.connect(dojo.byId('hider'), 'onclick', this, 'popupHide');

                break;

            }

        },

        popupHide: function() {

            dojo.widget.byId('RepModalWindow').hide();

            this.popup = '';
            var id = this.id;

        },

        createRowData: function(obj, result) {

            if(result) {

                if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                    //getNext
                } else {

                    if(document.LISTTYPE == 'ct') {

                        document.DCIDS[obj.id].lastresult = result;

                    }

                    if(document.LISTTYPE == 'ac') {

                        document.MODULE_IDS[obj.id].lastresult = result;

                    }

                    var html = '';

                    if (typeof result.data != 'undefined'
		    		&& result.data.length > 0) {

                        for(i=0; i<result.data.length; i++) {

                            var bkps = '';

                            if(typeof result.data[i].item != 'undefined') {

                                if(typeof result.data[i].item[0] == 'undefined') {

                                    result.data[i].item = new Array(result.data[i].item);

                                }

                                for(j=0; j<result.data[i].item.length; j++) {

                                    if(typeof result.data[i].item[j].BKSID != 'undefined') {

                                        bkps += obj._createRowBKP(obj.id, i, j, result.data, 0);

                                    }

                                }

                            }

                            html += obj._createRowVTL(obj.id, i, result.data, bkps, 0);

                        }

                    } else {

                        if(document.LISTTYPE == 'ct') {
                            html += arkwui_lang_get_msg('replication_connection_nodata');
			}
                        if(document.LISTTYPE == 'ac') {
                            html += arkwui_lang_get_msg('replication_module_nodata');
			}

                    }

                    document.getElementById('vtls_'+obj.id).innerHTML = html;

                }

            }

        },

        resetswitchmail: function() {

            if(typeof this.repemail == 'undefined') {

                this.repemail = 0;

            } else {

                this.repemail = 0;

            }

        },

        dorepjobswitchmail: function() {

            if(typeof this.repemail == 'undefined') {

                this.repemail = 1;

            } else {

                if(this.repemail == 0) {

                    this.repemail = 1;

                } else {

                    this.repemail = 0;

                }

            }

        },

        resetswitchretention: function() {

            if(typeof this.reperet == 'undefined') {

                this.reperet = 0;

            } else {

                this.reperet = 0;

            }

        },

        dorepjobswitchretention: function() {

            if(typeof this.reperet == 'undefined') {

                this.reperet = 1;

            } else {

                if(this.reperet == 0) {

                    this.reperet = 1;

                } else {

                    this.reperet = 0;

                }

            }

            if(this.reperet == 1) {
                document.getElementById('RepModalContentDoRetentionBox').style.display = '';
            } else {
                document.getElementById('RepModalContentDoRetentionBox').style.display = 'none';
            }

        },

        dorepjob: function(obj, jobid, port) {

            var basepath = obj.baseUrl + '/' + obj.controller;

            var dataUrl = basepath + '/jsonStat?ID='+jobid+'&PORT='+port;
            var getNext = basepath + '/jsonGetNextResult';
            var abortUrl = basepath + '/jsonAbortTrans';

            obj._launchtrans(obj, obj.printrepjob, dataUrl, getNext, abortUrl);

        },

        printrepjob: function(obj, result) {

            if(result) {

                if(typeof result.data2 != 'undefined' && typeof result.data2.item != 'undefined') {

                    if(typeof result.data2.item.DSP_MSG != 'undefined') {

                        var msg = result.data2.item.DSP_MSG;
                        var reg = new RegExp("^(....\/..\/..) (..:..:..) (.).{8} [^ ]*\: (.*)$", "g");
                        var replaceString = '<span class="RepModalMessagetype$3"><span class="datetime">$2:</span> <span class="message">$4</span></span>';

                        msg = msg.replace(reg, replaceString);

                        if(document.getElementById('RepModalMessage_'+result.data2.item.NUM) == null) {

                            document.getElementById('RepModalMessage').innerHTML += '<div id="RepModalMessage_'+result.data2.item.NUM+'">' + msg + '</div>';

                        }

                    } else {

                        for(i=0; i<result.data2.item.length; i++) {

                            var msg = result.data2.item[i].DSP_MSG;
                            var reg = new RegExp("^(....\/..\/..) (..:..:..) (.).{8} [^ ]*\: (.*)$", "g");
                            var replaceString = '<span class="RepModalMessagetype$3"><span class="datetime">$2:</span> <span class="message">$4</span></span>';

                            msg = msg.replace(reg, replaceString);

                            if(document.getElementById('RepModalMessage_'+result.data2.item[i].NUM) == null) {

                                document.getElementById('RepModalMessage').innerHTML += '<div id="RepModalMessage_'+result.data2.item[i].NUM+'">' + msg + '</div>';

                            }

                        }

                    }

                }

                if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                    //getNext
                } else {

                    if(document.getElementById('RepModalJobContent').style.display == 'none') {

                        document.getElementById('RepModalJobContent').style.display = 'block';

                    }

                    if(document.LISTTYPE == 'ct') {

                        if(document.DCIDS[obj.id].object.popup == 'rep' || document.DCIDS[obj.id].object.popup == 'rec') {

                            if(typeof document.DCIDS[obj.id].vmbi == 'undefined' || !document.DCIDS[obj.id].vmbi) {

                                document.getElementById('RepModalJobContentIns').innerHTML = '';
                                var vmbiArgs = {widgetId: 'FLOW_PHY_INS_METER', id: 'FLOW_PHY_INS_METER', valueField: 'FLOW_PHY_INS', valueTypeField: 'item', unitValue: arkwui_lang_get_msg('bkp_showbkp_speed_KB_s')};
                                var vmbi = dojo.widget.createWidget('arkeia:ArkeiaViewMeterBar', vmbiArgs, document.getElementById('RepModalJobContentIns'), 'child');

                                document.DCIDS[obj.id].vmbi = vmbi;

                            } else {

                                var vmbi = document.DCIDS[obj.id].vmbi;

                            }

                            if(typeof document.DCIDS[obj.id].vmba == 'undefined' || !document.DCIDS[obj.id].vmba) {

                                document.getElementById('RepModalJobContentAvg').innerHTML = '';
                                var vmbaArgs = {widgetId: 'FLOW_PHY_AVG_METER', id: 'FLOW_PHY_AVG_METER', valueField: 'FLOW_PHY_AVG', valueTypeField: 'item', unitValue: arkwui_lang_get_msg('bkp_showbkp_speed_KB_s')};
                                var vmba = dojo.widget.createWidget('arkeia:ArkeiaViewMeterBar', vmbaArgs, document.getElementById('RepModalJobContentAvg'), 'child');

                                document.DCIDS[obj.id].vmba = vmba;

                            } else {

                                var vmba = document.DCIDS[obj.id].vmba;

                            }

                        }

                        if(typeof document.DCIDS[obj.id].its == 'undefined' || !document.DCIDS[obj.id].its) {

                            document.getElementById('RepModalJobContentSiz').innerHTML = '';
                            var itsArgs = {widgetId: 'FLOW_PHY_SIZ', id: 'FLOW_PHY_SIZ', valueField: 'FLOW_PHY_SIZ', valueTypeField: 'item', caption: arkwui_lang_get_msg('bkp_showbkp_info_bkp_size'), unitValue: arkwui_lang_get_msg('unit_MB'), defaultValue: '0'};
                            var its = dojo.widget.createWidget('arkeia:InfoText', itsArgs, document.getElementById('RepModalJobContentSiz'), 'child');

                            document.DCIDS[obj.id].its = its;

                            document.DCIDS[obj.id].its.tdvalue.innerHTML = document.DCIDS[obj.id].its.defaultValue + document.DCIDS[obj.id].its.unitValue;

                        } else {

                            var its = document.DCIDS[obj.id].its;

                        }

                        if(typeof result.data2 != 'undefined' && typeof obj.popup != 'undefined' && (obj.popup == 'rep' || obj.popup == 'rec' || obj.popup == 'int')) {

                            setTimeout(function () { obj.dorepjob(obj, result.data2.jobid, result.data2.jobport); }, 2000);

                            if(obj.popup == 'rep' || obj.popup == 'rec') {

                                document.DCIDS[obj.id].vmbi.onArkeiaInfoData(result);
                                document.DCIDS[obj.id].vmba.onArkeiaInfoData(result);

                            }

                            document.DCIDS[obj.id].its.onArkeiaInfoData(result);

                            document.DCIDS[obj.id].its.tdvalue.innerHTML += document.DCIDS[obj.id].its.unitValue;

                        } else {

                            document.getElementById('RepModalJobContentInf').innerHTML = arkwui_lang_get_msg('replication_listing_popup_job_completed');
                            document.getElementById('RepModalJobContentInf').style.color = REPLISTCOLORS['red'];

                        }

                    }

                    if(document.LISTTYPE == 'ac') {

                        if(typeof document.MODULE_IDS[obj.id].its == 'undefined' || !document.MODULE_IDS[obj.id].its) {

                            document.getElementById('RepModalJobContentSiz').innerHTML = '';
                            var itsArgs = {widgetId: 'FLOW_PHY_SIZ', id: 'FLOW_PHY_SIZ', valueField: 'FLOW_PHY_SIZ', valueTypeField: 'item', caption: arkwui_lang_get_msg('bkp_showbkp_info_bkp_size'), unitValue: arkwui_lang_get_msg('unit_MB'), defaultValue: '0'};
                            var its = dojo.widget.createWidget('arkeia:InfoText', itsArgs, document.getElementById('RepModalJobContentSiz'), 'child');

                            document.MODULE_IDS[obj.id].its = its;

                            document.MODULE_IDS[obj.id].its.tdvalue.innerHTML = document.MODULE_IDS[obj.id].its.defaultValue + document.MODULE_IDS[obj.id].its.unitValue;

                        } else {

                            var its = document.MODULE_IDS[obj.id].its;

                        }

                        if(typeof result.data2 != 'undefined' && typeof obj.popup != 'undefined' && (obj.popup == 'rep' || obj.popup == 'int')) {

                            setTimeout(function () { obj.dorepjob(obj, result.data2.jobid, result.data2.jobport); }, 2000);

                            document.MODULE_IDS[obj.id].its.onArkeiaInfoData(result);

                            document.MODULE_IDS[obj.id].its.tdvalue.innerHTML += document.MODULE_IDS[obj.id].its.unitValue;

                        } else {

                            document.getElementById('RepModalJobContentInf').innerHTML = arkwui_lang_get_msg('replication_listing_popup_job_completed');
                            document.getElementById('RepModalJobContentInf').style.color = REPLISTCOLORS['red'];

                        }

                    }

                }

            }

        },

        createRowModalData: function(obj, result) {

            if(result) {

                if(typeof result.message != 'undefined') {

                    var msg = result.message;
                    var reg = new RegExp("^(....\/..\/..) (..:..:..) (.).{8} [^ ]*\: (.*)$", "g");
                    var replaceString = '<span class="RepModalMessagetype$3">$2: $4</span>';

                    msg = msg.replace(reg, replaceString);

                    if  (msg.replace(reg, replaceString) != 'E' &&
                            (
                                obj.popup == 'del' ||
                                obj.popup == 'build'
                            )
                        ) {

                        obj.popupHide();
                        document.getElementById('vtls_'+obj.id).style.display = 'none';
                        obj._createRowAction(obj.id);

                    }

                    document.getElementById('RepModalMessage').innerHTML += '<div>' + msg + '</div>';

                }

                if((result.status == 12 && (result.message == 2 || result.message == 3)) || (result.status != 12 && result.last == 0)) {
                    //getNext
                } else {

                    if(typeof result.data == 'string') {

                        obj.dorepjob(obj, result.data, result.data2);

                    }

                }

            }

        },

        //  rendering
        createRow: function(/* object */obj){
            //DEBUG dojo.debug(this + " createRow");
            //  summary
            //  Create an HTML row based on the passed object
            var row = document.createElement('tr');
            var cell = {};
            var field;
            var val = '';
            var html = '';
            var rowsortinfo = {};
            var j = 0;
            var id ='';
            row.innerHTML = '';
            dojo.html.disableSelection(row);
            if (obj.key != null) {
                row.setAttribute('value', obj.key);
            }

            if(typeof document.DCIDS == 'undefined') {
                document.DCIDS = new Array;
            }

            if(typeof document.MODULE_IDS == 'undefined') {
                document.MODULE_IDS = new Array;
            }

            for (j = 0; j < this.columns.length; j += 1) {

                cell = document.createElement("td");
                cell.setAttribute("align", this.columns[j].align);
                cell.setAttribute("valign", this.columns[j].valign);
		        cell.setAttribute("class", "col"+j);
                dojo.html.disableSelection(cell);
                field = this.columns[j].getField();
                val = obj.src[field];
                if (val === undefined) {
                    val = '';
                }

                if(j == 0) {

                    if(typeof obj.src['DCID'] != 'undefined' || typeof obj.src['MODULE_ID'] != 'undefined') {

                        if(typeof obj.src['DCID'] != 'undefined') {

                            document.LISTTYPE = 'ct';

                            id = obj.src['DCID'];

                            if(typeof document.DCIDS[id] == 'undefined') {
                                document.DCIDS[id] = new Object;
                                document.DCIDS[id].object = this;
                                document.DCIDS[id].object.id = id;
                            }

                            if(typeof obj.src['SHARE'] != 'undefined' && obj.src['SHARE'] == 1) {

                                val += ' ('+arkwui_lang_get_msg('replication_listing_shared')+')';
                                document.DCIDS[id].shared = 1;

                            }

                            html += '<div class="schwizard" style="padding-left: 10px; padding-right: 10px; padding-top: 5px; padding-bottom: 5px;">';
                            html += '<fieldset>';
                            html += '<legend style="cursor: pointer;">';
                            html += '<span onclick="document.DCIDS[\''+id+'\'].object._createRowAction(\''+id+'\');">';
                            html += '<img id="img_'+id+'" src="'+baseurl+'/images/arrow-collapsed.gif" alt="" style="float: none; vertical-align: middle;">';
                            html += '<span style="font-size:medium;">'+val+'</span>';
                            html += '</span>';
                            html += '&nbsp;<img id="refreshbutton_'+id+'" src="'+baseurl+'/images/refresh_12x12.png" title="'+arkwui_lang_get_msg('replication_button_do_refresh')+'" onclick="document.getElementById(\'vtls_'+id+'\').style.display=\'none\';document.DCIDS[\''+id+'\'].object._createRowAction(\''+id+'\');" alt="" style="float: none; vertical-align: middle; display: none;">';
                            html += '</legend>';
                            html += '<div id="vtls_'+id+'" style="display: none;">';
                            html += '<span style="padding-left: 30px; padding-top: 30px;"><img src="'+baseurl+'/images/ajax-loader.gif" alt="" style="float: none;"></span>';
                            html += '</div>';
                            html += '</fieldset>';
                            html += '</div>';

                        }

                        if(typeof obj.src['MODULE_ID'] != 'undefined') {

                            document.LISTTYPE = 'ac';

                            id = obj.src['MODULE_ID'];

                            if(typeof document.MODULE_IDS[id] == 'undefined') {
                                document.MODULE_IDS[id] = new Object;
                                document.MODULE_IDS[id].object = this;
                                document.MODULE_IDS[id].object.id = id;
                            }

                            html += '<div class="schwizard" style="padding-left: 10px; padding-right: 10px; padding-top: 5px; padding-bottom: 5px;">';
                            html += '<fieldset>';
                            html += '<legend style="cursor: pointer;">';
                            html += '<span onclick="document.MODULE_IDS[\''+id+'\'].object._createRowAction(\''+id+'\');">';
                            html += '<img id="img_'+id+'" src="'+baseurl+'/images/arrow-collapsed.gif" alt="" style="float: none; vertical-align: middle;">';
                            html += '<span style="font-size:medium;">'+val+'</span>';
                            html += '</span>';
                            html += '&nbsp;<img id="refreshbutton_'+id+'" src="'+baseurl+'/images/refresh_12x12.png" title="'+arkwui_lang_get_msg('replication_button_do_refresh')+'" onclick="document.getElementById(\'vtls_'+id+'\').style.display=\'none\';document.MODULE_IDS[\''+id+'\'].object._createRowAction(\''+id+'\');" alt="" style="float: none; vertical-align: middle; display: none;">';
                            html += '</legend>';
                            html += '<div id="vtls_'+id+'" style="display: none;">';
                            html += '<span style="padding-left: 30px; padding-top: 30px;"><img src="'+baseurl+'/images/ajax-loader.gif" alt="" style="float: none;"></span>';
                            html += '</div>';
                            html += '</fieldset>';
                            html += '</div>';

                        }

                    } else {

                        html = val;

                    }

                } else {

                    html = val;

                }

                if (this.columns[j].sortType == "String") {
                    cell.innerHTML = html;
                } else {
                    this.fillCell(cell, this.columns[j], html);
                }
                row.appendChild(cell);
                rowsortinfo[field] = val;
            }
            if (this.sortColumn != '') {
                rowsortinfo[this.sortColumn] = obj.src[this.sortColumn];
            }

            this.sortInfo[obj.key] = rowsortinfo;
            return row; //  HTMLTableRow
        },

        fillCell: function(/* HTMLTableCell */cell, /* object */meta, /* object */val) {
            //DEBUG dojo.debug(this + " fillCell");
            //  summary
            //  Fill the passed cell with value, based on the passed meta object.
            var format;
            var n = '';
            if (meta.sortType == "__markup__") {
                cell.innerHTML=val;
            } else {
                if (meta.getType() == Date) {
                    val = new Date(val);
                    if (!isNaN(val)) {
                        format = (meta.format) ? meta.format : this.defaultDateFormat;
                        cell.innerHTML = dojo.date.strftime(val, format);
                    } else {
                        cell.innerHTML = val;
                    }
                } else if ("Number number int Integer float Float".indexOf(meta.sortType)>-1) {
                    //  TODO: number formatting
                    if (val.length == 0) {
                        val = '0';
                    }
                    n = parseFloat(val, 10) + '';
                    //  TODO: numeric formatting + rounding :)
                    if (n.indexOf(".") > -1) {
                        n = dojo.math.round(parseFloat(val, 10), 2);
                    }
                    cell.innerHTML = n;
                } else {
                    cell.innerHTML = val;
                }
            }
        },

        createSorter: function(/* array */info){
            //DEBUG dojo.debug(this + " createSorter");
            //  summary
            //  creates a custom function to be used for sorting.
            var self = this;
            var sortFunctions = [];   //  our function stack.
            var sortFunction;
            var current = 0;
            var max = 0;
            var direction;

	    if (this.noSort) {
		return false;
	    }
            function createSortFunction (fieldIndex, dir) {
                var meta = self.columns[fieldIndex];
                var field;
                var sortFunction;
                if (self.sortColumn != '') {
                    field = self.sortColumn;
                } else {
                    field = meta.getField();
                }
                sortFunction = function(rowA, rowB) {
                    var rowValue = {
                        A: rowA.getAttribute('value'),
                        B: rowB.getAttribute('value')
                    }
                    var a = (self.sortInfo[rowValue.A]) ? self.sortInfo[rowValue.A][field] : 0;
                    var b = (self.sortInfo[rowValue.B]) ? self.sortInfo[rowValue.B][field] : 0;
                    //DEBUG dojo.debug('sort field: '+field+', A: '+a+', B: '+b);
                    var wdir = dir;
                    var ret = 0;;
                    if (meta.sortFunction != null) {
                        ret = meta.sortFunction(a, b);
                    } else {
                        if (meta.sortType == 'int') {
                            a = parseInt(a);
                            b = parseInt(b);
                            if (a > b) {
                                ret = 1;
                            } else if (a < b) {
                                ret = -1;
                            }
                        } else {
                            if (a > b) {
                                ret = 1;
                            } else if (a < b) {
                                ret = -1;
                            }
                        }
                    }
                    return wdir * ret;
                }
                return sortFunction;
            };
            max = Math.min(info.length, this.maxSortable, this.columns.length);
            while (current < max) {
                direction = (info[current].direction == 0) ? 1 : -1;
                sortFunctions.push(
                    createSortFunction(info[current].index, direction)
                );
                current += 1;
            }
            sortFunction = function (rowA, rowB) {
                var idx = 0;
                var ret;
                while (idx < sortFunctions.length) {
                    ret = sortFunctions[idx++](rowA, rowB);
                    if (ret != 0) {
                        return ret;
                    }
                }
                //  if we got here then we must be equal.
                return 0;
            };  //  function
            return sortFunction;
        },

        isRowSelected: function(/* HTMLTableRow */row) {
            //DEBUG dojo.debug(this + " isRowSelected");
            //  summary
            //  Returns if the passed row is selected.
            return (this.rowSelected[row.getAttribute('value')] !== undefined ? true : false);
        },

        select: function(/*object*/ obj) {
            //      summary
            //      selects the passed object.
            var key = obj[this.valueField];
            this.rowSelected[key] = key;
            this.onDataSelect(obj);
        },

        onDataSelect: function(/* object */obj){ 
            //  summary
            //  Stub for onDataSelect event.
        },

        selectByRow: function(row) {
            //DEBUG dojo.debug(this + " selectByRow");
            this.select(this.getDataByRow(row));
        },

        //  custom data access.
        getByRow: function(/*HTMLTableRow*/row) {
            //DEBUG dojo.debug(this + " getByRow");
            //  summary
            //  Returns the data object based on the passed row.
            return this.store.getByKey(dojo.html.getAttribute(row, 'value'));   //  object
        },

        getDataByRow: function(/*HTMLTableRow*/row){
            //DEBUG dojo.debug(this + " getDataByRow");
            //  summary
            //  Returns the source data object based on the passed row.
            return this.store.getDataByKey(dojo.html.getAttribute(row, 'value')); // object
        },

        getDataByKey: function(key){
            return this.store.getDataByKey(key);
        },

        //  standard events
        onSelect: function(/* HTMLEvent */e){
            //DEBUG dojo.debug(this + " onSelected");
            //  summary
            //  Handles the onclick event of any element.
            var row = dojo.html.getParentByType(e.target, 'tr');
            var tbody = {};
            var startRow = {};
            var rows = [];
            var i = 0;
            var doSelect = false;
            if (dojo.html.hasAttribute(row, 'emptyRow')) {
                return;
            }
            tbody = dojo.html.getParentByType(row, 'tbody');
            this.resetSelections();
            this.toggleSelectionByRow(row);
            this.renderSelections();
            this.callAfterSelect(row);
        },

	callAfterSelect: function(row) {
	    
	},

        onSort: function(/* HTMLEvent */e){
            //  summary
            //  Sort the table based on the column selected.
            var oldIndex = this.sortIndex;
            var oldDirection = this.sortDirection;
            var source = e.target;
            var row = dojo.html.getParentByType(source, 'tr');
            var cellTag = 'td';
            if (row.getElementsByTagName(cellTag).length == 0){
                cellTag = 'th';
            }
            var headers = row.getElementsByTagName(cellTag);
            var header = dojo.html.getParentByType(source, cellTag);
            var i = 0;
            var idx;
            var dir;
            var newClass = '';
            for (i = 0; i < headers.length; i += 1) {
                dojo.html.setClass(headers[i], this.headerClass);
                if (headers[i] == header) {
                    if (this.sortInformation[0].index != i) {
                        this.sortInformation.unshift(
                            {
                                index: i,
                                direction: 0
                            }
                        );
                    } else {
                        this.sortInformation[0] = {
                            index: i,
                            direction: (~this.sortInformation[0].direction)&1
                        };
                    }
                }
            }
            this.sortInformation.length = Math.min(this.sortInformation.length, this.maxSortable);
            for (i = 0; i < this.sortInformation.length; i += 1) {
                idx = this.sortInformation[i].index;
                dir = (~this.sortInformation[i].direction)&1;
                newClass = (dir == 0) ? this.headerDownClass : this.headerUpClass;
                dojo.html.setClass(headers[idx], newClass);
            }
            this.render();
        }

    }
);

var REPLISTCOLORS = new Array();
REPLISTCOLORS['red'] = '#ff0000';
REPLISTCOLORS['blue'] = '#5984D7';
REPLISTCOLORS['green'] = '#33b107';
