
icon_manager = {

    curPath: '',
    screenType: '',
    multiSel: true,
    fromBase : 32,
    oldBase:  32,
    classState: false,
    detailsStatus: false,
    list: new Array('machine', 'plugin', 'filesystem', 'folder', 'symfolder', 'file', 'symfile'),
    history: new Array(),
    histCurIndex: -1,
    histBrowsing: false,
    noCbox: false,

    initialize: function (screenType) {

        this.curPath = '';
        this.history = new Array();
        this.histCurIndex = -1;
        this.histBrowsing = false;
        this.screenType = screenType;

        var cookie = dojo.io.cookie.getCookie('nav3_sizeswitcher');

        if(cookie) {

            if(cookie != 'det') {

                this.fromBase = cookie;
                this.oldBase = cookie;

            } else {

                this.detailsStatus = true;
                this.fromBase = 16;
                this.oldBase = 32;

            }

        }

    },

    hasClass: function (obj, className) {

        if (typeof obj == 'undefined' || obj==null || !RegExp) {

            return false;

        }

        var result = false;

        if(!(typeof obj.className == 'undefined' || obj.className == '')) {

            var cur = this._explode(' ', obj.className);

            for(var i=0; i<cur.length; i++) {

                if(cur[i] == className) {

                    result = true;
                    break;

                }

            }

        }

        return result;

    },

    _explode: function(delimiter, string) {

        var tmpString = new String(string);
        return tmpString.split(delimiter); 

    },

    _implode: function(delimiter, array) {

        return array.join(delimiter);

    },

    _setClass: function(obj, className) {

        obj.className = className;

    },

    addClass: function(obj, className) {

        if(typeof obj.className != 'undefined' && obj.className != '') {

            var cur = this._explode(' ', obj.className);
            cur.push(className);
            this._setClass(obj, this._implode(' ', cur));

        } else {

            this._setClass(obj, className);

        }

    },

    delClass: function(obj, className) {

        if(typeof obj.className != 'undefined' && obj.className != '') {

            var cur = this._explode(' ', obj.className);
            var tmp = new Array;

            for(var i=0; i<cur.length; i++) {

                if(cur[i] != className) {

                    tmp.push(cur[i]);

                }

                if(tmp.length > 0) {

                    this._setClass(obj, this._implode(' ', tmp));

                } else {

                    this._setClass(obj, '');

                }

            }

        }

    },

    repClass: function(obj, fromClassName, toClassName) {

        if(this.hasClass(obj, fromClassName) && !this.hasClass(obj, toClassName)) {

            this.delClass(obj, fromClassName);
            this.addClass(obj, toClassName);

        }

    },

    repRegexpClass: function(obj, fromClassRegexpName, toClassRegexpName) {

        if(typeof obj.className != 'undefined' && obj.className != '') {

            var cur = this._explode(' ', obj.className);

            for(var i=0; i<cur.length; i++) {

                cur[i] = cur[i].replace(fromClassRegexpName, toClassRegexpName);

            }

            this._setClass(obj, this._implode(' ', cur));

        }

    },

    getElementsWithClassName : function (elementName, className) {
        var allElements = document.getElementsByTagName(elementName);
        var elemColl = new Array();
        var j=0;
        for (var i = 0; i< allElements.length; i++) {
             if (this.hasClass(allElements[i], className)) {
                 elemColl[j] = allElements[i];
                 j++;
             }
        }
        return elemColl;
    },

    fixZIndex: function() {

        var list = this.getElementsWithClassName('span', 'nav3_icon_normal');

        for(var i=0; i<list.length; i++) {

            if(typeof list[i].style.zIndex == 'undefined') {

                list[i].style.zIndex = 1;

            } else {

                list[i].style.zIndex = list[i].style.zIndex + 1;

            }

        }

    },

    _buildOne: function(infos, tree_formid, tree_type, detailsOnly) {

        if(!this.classState) {

            var curClass = 'nav3_normal';
            this.classState = true;

        } else {

            var curClass = 'nav3_alternate';
            this.classState = false;

        }

        if(!this.detailsStatus) {
        
            var curState = 'hide';

        } else {

            var curState = 'show';

        }

        var result = '';

        if(!detailsOnly) {

            result += '<span id="right_'+infos['objectId']+'" fullTitle="'+infos['fullTitle']+'" class="nav3_details-ct-'+curState+' nav3_details-ct-'+curState+'-'+this.fromBase+'x'+this.fromBase+'">';

            result += '<span id="right_selref_'+infos['objectId']+'" type="'+infos['type']+'" class="nav3_icon-main nav3_icon-'+infos['type']+'-'+this.fromBase+'x'+this.fromBase+'-main';

            if(infos['selected']) {

                result += ' nav3_icon-'+infos['type']+'-'+this.fromBase+'x'+this.fromBase+'-main-selected';

            }

            result += '" ondblclick="arkeia.navigator.openSelection(\''+infos['objectId']+'\');">';
            result += '<span class="nav3_ct">';
            result += '<span class="nav3_icon nav3_icon_normal"  onmouseover="icon_manager.repClass(this, \'nav3_icon_normal\', \'nav3_icon_hover\');" onmouseout="if(icon_manager.isclick){ icon_manager.isclick=false; } else{icon_manager.repClass(this, \'nav3_icon_hover\', \'nav3_icon_normal\');};">';
            result += '<input type="checkbox"';

            if(infos['selected']) {

                result += ' onclick="icon_manager.mkSelected(icon_manager.findDomFromCbox(this), \''+infos['type']+'\', \''+tree_formid+'\', \''+this.screenType+'\', \''+infos['objectId']+'\', false);"';

                if(!infos['directselected']) {

                    result += ' disabled="disabled"';

                }

                result += ' checked="checked"';

            } else {

                result += ' onclick="icon_manager.mkSelected(icon_manager.findDomFromCbox(this), \''+infos['type']+'\', \''+tree_formid+'\', \''+this.screenType+'\', \''+infos['objectId']+'\', false);"';

            }

            if(this.noCbox) {
                result += ' style="display: none;"';
            }

            result += ' />';

            result += '</span>';
            result += '<span class="nav3_text nav3_text_normal" onmouseover="icon_manager.repClass(this, \'nav3_text_normal\', \'nav3_text_hover\');" onmouseout="icon_manager.repClass(this, \'nav3_text_hover\', \'nav3_text_normal\');">'+infos['short_text']+'</span>';
            result += '</span>';
            result += '</span>';

            result += '<div class="nav3_details-'+curState+'">';

        } else {

            result += '<span class="nav3_nodetails-ct-hide nav3_nodetails-ct-hide-'+this.fromBase+'x'+this.fromBase+'">';
            result += '<div class="nav3_nodetails-hide">';

        }

        result += '<table class="nav3_details" cellpadding="0" cellspacing="0">';

        if(!detailsOnly) {

            result += '<tr class="'+curClass+'" onmouseover="icon_manager.repClass(this, \''+curClass+'\', \'nav3_hover\');" onmouseout="icon_manager.repClass(this, \'nav3_hover\', \''+curClass+'\');" ondblclick="arkeia.navigator.openSelection(\''+infos['objectId']+'\');">';

        } else {

            result += '<tr class="'+curClass+'" onmouseover="icon_manager.repClass(this, \''+curClass+'\', \'nav3_hover\');" onmouseout="icon_manager.repClass(this, \'nav3_hover\', \''+curClass+'\');">';

        }

        result += '<td style="width: 7%; padding-right: 0px; text-align: right;">';

        if(!detailsOnly) {

            result += '<span class="nav3_icon-main nav3_icon-'+infos['type']+'-'+this.fromBase+'x'+this.fromBase+'-main">';
            result += '<input type="checkbox"';

            if(infos['selected']) {

                result += ' onclick="icon_manager.mkSelected(icon_manager.findDomFromCbox(this, \'det\'), \''+infos['type']+'\', \''+tree_formid+'\', \''+this.screenType+'\', \''+infos['objectId']+'\', false);"';

                if(!infos['directselected']) {

                    result += ' disabled="disabled"';

                }

                result += ' checked="checked"';

            } else {

                result += ' onclick="icon_manager.mkSelected(icon_manager.findDomFromCbox(this, \'det\'), \''+infos['type']+'\', \''+tree_formid+'\', \''+this.screenType+'\', \''+infos['objectId']+'\', false);"';

            }

            if(this.noCbox) {
                result += ' style="display: none;"';
            }

            result += ' />';

        } else {

            result += '<span class="nav3_icon-main nav3_icon-'+infos['type']+'-16x16-main-nodetails">';

        }

        result += '<span class="nav3_icon nav3_icon_normal" onmouseover="icon_manager.repClass(this, \'nav3_icon_normal\', \'nav3_icon_hover\');" onmouseout="icon_manager.repClass(this, \'nav3_icon_hover\', \'nav3_icon_normal\');">&nbsp;</span>';
        result += '</span>';
        result += '</td>';
        result += '<td style="width: 33%; text-align: left;">'+infos['text']+'</td>';
        result += '<td style="width: 10%;">'+infos['rights']+'</td>';
        result += '<td style="width: 10%;">'+infos['ownage']+'</td>';
        result += '<td style="width: 10%;">'+infos['size']+'</td>';
        result += '<td style="width: 30%;">'+infos['date']+'</td>';
        result += '<td>&nbsp;</td>';
        result += '</tr>';
        result += '</table>';
        result += '</div>';
        result += '</span>';

        return result;

    },

    mkone : function(target, infos) {

        document.getElementById(target).innerHTML += this._buildOne(infos);

    },

    mkall : function(target, infos, tree_formid, tree_type, detailsOnly) {

        if(typeof detailsOnly == 'undefined') {

            detailsOnly = false;

        }

        var curSel = arkeia.navigator.getSelection(tree_formid);

        var built = '';

        var allreadyselected = false;
        var reg = false;

        for(var i=0; i<infos.length; i++) {

            allreadyselected = false;
            allreadydirectselected = false;

            for(var j=0; j<curSel.length; j++) {

                reg = new RegExp('^' + curSel[j] + '[/!:]', 'g');

                if(curSel[j] == infos[i]['objectId'] || reg.test(infos[i]['objectId'])) {

                    if(curSel[j] == infos[i]['objectId']) {

                        allreadydirectselected = true;

                    }

                    allreadyselected =true;
                    break;

                }

            }

            if(allreadyselected) {
                infos[i]['selected'] = true;
                if(allreadydirectselected) {
                    infos[i]['directselected'] = true;
                } else {
                    infos[i]['directselected'] = false;
                }
            } else {
                infos[i]['selected'] = false;
                infos[i]['directselected'] = false;
            }

            built += this._buildOne(infos[i], tree_formid, tree_type , detailsOnly);

        }

        if(target == 'ret') {

            return built;

        } else {

            document.getElementById(target).innerHTML += built;

        }

    },

    chkSelected: function(objectId, setChecked) {

        var reg = new RegExp('^' + objectId + '[/!:]', 'g');

        if(this.curPath == objectId || reg.test(this.curPath)) {

            var tmplist = this.getElementsWithClassName('span', 'nav3_icon-main');

            for(var j=0; j<tmplist.length; j++) {

                if(typeof tmplist[j].getAttribute('type') != 'object') {
                    if(!this.hasClass(tmplist[j],  'nav3_icon-'+tmplist[j].getAttribute('type')+'-'+this.fromBase+'x'+this.fromBase+'-main-selected')) {
                        this.mkSelected(tmplist[j], tmplist[j].getAttribute('type'), null, null, null, true, false);
                        var cbox = this.findCboxInDom(tmplist[j]);
                        var detcbox = this.findCboxInDom(tmplist[j], 'det');
                        cbox.disabled = true;
                        detcbox.disabled = true;
                    } else {
                        if(!setChecked) {
                            this.mkSelected(tmplist[j], tmplist[j].getAttribute('type'), null, null, null, true, false);
                        } else {
                            var cbox = this.findCboxInDom(tmplist[j]);
                            var detcbox = this.findCboxInDom(tmplist[j], 'det');
                            cbox.disabled = true;
                            detcbox.disabled = true;
                        }
                    }
                }

            }

        } else {

            var tmpref = document.getElementById('right_selref_'+objectId);

            if(tmpref) {

                this.mkSelected(tmpref, tmpref.getAttribute('type'), null, null, null, true, false);

            }

        }

    },

    findCboxInDom: function(obj, el) {

        var iconDomPath = 'parentNode.childNodes[0].childNodes[0].childNodes[0].childNodes[0]';
        var deticonDomPath = 'parentNode.childNodes[1].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0]';

        var ret = false;

        if(typeof el == 'undefined' || el == 'main') {

            eval('ret = obj.'+iconDomPath+';');
        
        } else {

            eval('ret = obj.'+deticonDomPath+';');

        }

        return ret;

    },

    findDomFromCbox: function(obj, el) {

        var domPath = 'parentNode.parentNode.parentNode.parentNode.childNodes[0]';
        var detDomPath = 'parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.childNodes[0]';

        var ret = false;

        if(typeof el == 'undefined' || el == 'main') {

            eval('ret = obj.'+domPath+';');
        
        } else {

            eval('ret = obj.'+detDomPath+';');

        }

        return ret;

    },

    mkSelected: function(obj, type, tree_formid, tree_type, objectId, noUpdate, detailsOnly) {

        //make selected
        if(!this.hasClass(obj,  'nav3_icon-'+type+'-'+this.fromBase+'x'+this.fromBase+'-main-selected')) {

            if(typeof noUpdate == 'undefined' || !noUpdate) {

                arkeia.navigator.updateSelection(tree_formid, objectId, this.screenType, true);

            }

            var cbox = this.findCboxInDom(obj);

            if(!cbox.checked) {
                cbox.checked = true;
            }

            var detcbox = this.findCboxInDom(obj, 'det');

            if(!detcbox.checked) {
                detcbox.checked = true;
            }

            if(!this.multiSel) {

                for(var i=0; i<this.list.length; i++) {

                    var tmplist = this.getElementsWithClassName('span', 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main-selected');

                    for(var j=0; j<tmplist.length; j++) {
                        this.delClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main-selected');
                    }

                }

            }

            this.addClass(obj, 'nav3_icon-'+type+'-'+this.fromBase+'x'+this.fromBase+'-main-selected');

        //make unselected
        } else {

            if(typeof noUpdate == 'undefined' || !noUpdate) {

                arkeia.navigator.updateSelection(tree_formid, objectId, this.screenType, false);

            }

            var cbox = this.findCboxInDom(obj);

            if(cbox.disabled) {
                cbox.disabled = false;
            }

            if(cbox.checked) {
                cbox.checked = false;
            }

            var detcbox = this.findCboxInDom(obj, 'det');

            if(detcbox.disabled) {
                detcbox.disabled = false;
            }

            if(detcbox.checked) {
                detcbox.checked = false;
            }

            this.delClass(obj, 'nav3_icon-'+type+'-'+this.fromBase+'x'+this.fromBase+'-main-selected');

        }

    },

    changeBase: function (toBase) {

        dojo.io.cookie.setCookie('nav3_sizeswitcher', toBase, 1, arkeia.baseUrl);

        if(toBase == 'det') {

            this.switchDetails();

            return;

        } else {

            if(this.detailsStatus) {

                this.switchDetails();

            }

        }

        if  (
                (this.fromBase == toBase) ||
                (this.fromBase != 32 && this.fromBase != 48 && this.fromBase != 64) ||
                (toBase != 32 && toBase != 48 && toBase != 64)
            ) {

            if(this.fromBase == toBase) {
                
            }

            return;

        }

        for(var i=0; i<this.list.length; i++) {

            var tmplist = this.getElementsWithClassName('span', 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main');

            for(var j=0; j<tmplist.length; j++) {
                this.repClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main', 'nav3_icon-'+this.list[i]+'-'+toBase+'x'+toBase+'-main');
                this.repClass(tmplist[j].parentNode, 'nav3_details-ct-hide-'+this.fromBase+'x'+this.fromBase, 'nav3_details-ct-hide-'+toBase+'x'+toBase) ;

                if(this.hasClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main-selected')) {

                    this.repClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main-selected', 'nav3_icon-'+this.list[i]+'-'+toBase+'x'+toBase+'-main-selected') ;

                }

            }

        }

        this.fromBase = toBase;

    },

    incrBase: function(combo, dir) {

        var cb = document.getElementById(combo);
        var curIndex = cb.selectedIndex;

        if(cb.disabled) {

            return;

        }

        if(typeof dir == 'undefined') {

            if(curIndex+1 < cb.options.length && typeof cb.options[curIndex+1] != 'undefined') {

                cb.options[curIndex+1].selected = 'selected';
                this.changeBase(cb.options[curIndex+1].value);

            } 

        } else {

            if(curIndex-1 >= 0 && typeof cb.options[curIndex-1] != 'undefined') {

                cb.options[curIndex-1].selected = 'selected';
                this.changeBase(cb.options[curIndex-1].value);

            }

        }

    },

    switchDetails: function() {

        if(!this.detailsStatus) {

            var tmplist = this.getElementsWithClassName('span', 'nav3_details-ct-hide');

            for(var j=0; j<tmplist.length; j++) {

                this.repClass(tmplist[j], 'nav3_details-ct-hide', 'nav3_details-ct-show');

            }

            var tmplist = this.getElementsWithClassName('div', 'nav3_details-hide');

            for(var j=0; j<tmplist.length; j++) {

                this.repClass(tmplist[j], 'nav3_details-hide', 'nav3_details-show');

            }

            this.oldBase = this.fromBase;
            var toBase = 16;

            for(var i=0; i<this.list.length; i++) {

                var tmplist = this.getElementsWithClassName('span', 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main');

                for(var j=0; j<tmplist.length; j++) {
                    this.repClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main', 'nav3_icon-'+this.list[i]+'-'+toBase+'x'+toBase+'-main');
                    this.repClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main-selected', 'nav3_icon-'+this.list[i]+'-'+toBase+'x'+toBase+'-main-selected');
                    this.repClass(tmplist[j].parentNode, 'nav3_details-ct-hide-'+this.fromBase+'x'+this.fromBase , 'nav3_details-ct-show-'+toBase+'x'+toBase);
                }

            }

            this.fromBase = toBase;

            this.detailsStatus = true;

        } else {

            var tmplist = this.getElementsWithClassName('span', 'nav3_details-ct-show');

            for(var j=0; j<tmplist.length; j++) {

                this.repClass(tmplist[j], 'nav3_details-ct-show', 'nav3_details-ct-hide');

            }

            var tmplist = this.getElementsWithClassName('div', 'nav3_details-show');

            for(var j=0; j<tmplist.length; j++) {

                this.repClass(tmplist[j], 'nav3_details-show', 'nav3_details-hide');

            }

            var toBase = this.oldBase;

            for(var i=0; i<this.list.length; i++) {

                var tmplist = this.getElementsWithClassName('span', 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main');

                for(var j=0; j<tmplist.length; j++) {
                    this.repClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main', 'nav3_icon-'+this.list[i]+'-'+toBase+'x'+toBase+'-main');
                    this.repClass(tmplist[j], 'nav3_icon-'+this.list[i]+'-'+this.fromBase+'x'+this.fromBase+'-main-selected', 'nav3_icon-'+this.list[i]+'-'+toBase+'x'+toBase+'-main-selected');
                    this.repClass(tmplist[j].parentNode, 'nav3_details-ct-show-'+this.fromBase+'x'+this.fromBase , 'nav3_details-ct-hide-'+toBase+'x'+toBase);
                }

            }

            this.fromBase = toBase;

            this.detailsStatus = false;

        }

    },

    reloadRootNode: function (prefix) {

        if(typeof prefix == 'undefined') {

            prefix = '';

        }

        var node = dojo.widget.byId(prefix+'Root');
        this.reloadNode(node);

    },

    reloadCurrentNode: function () {

        var node = dojo.widget.byId(this.history[this.screenType][this.histCurIndex]);
        this.reloadNode(node);

    },

    loadNode: function(node) {
        this.reloadNode(node);
    },

    reloadNode: function (node) {

        if(!node.fullTitle) {

            node.fullTitle = 'Root';

        }

        var adressbox = dojo.byId('nav3_adressbox');

        if(adressbox) {

            adressbox.value = node.fullTitle;

        }

        dojo.widget.byId('controlleleftbox').loadRemote(node, true);

        this.reloadRightNode(node);

    },

    reloadRightNode: function(node) {

        var rightbox = dojo.widget.byId('navrightbox_'+this.screenType);

        if(rightbox) {

            if(typeof node != 'undefined') {

                rightbox.objectId = node.widgetId;

            }

            dojo.widget.byId('controllerightbox').loadRemote(rightbox, true);

        }

    },

    showPrev: function () {

        dojo.debug('Curindex: ' + this.histCurIndex + ', History: ' + dojo.json.serialize(this.history[this.screenType]));

        if(this.histCurIndex > 0) {

            this.histBrowsing = true;

            dojo.debug('browsing: (idx:' + (this.histCurIndex - 1) + ') ' +this.history[this.screenType][this.histCurIndex - 1]);
            var node = dojo.widget.byId(this.history[this.screenType][this.histCurIndex - 1]);

            if(node.isExpanded) {
                node.collapse();
            }

            this.histCurIndex--;

            this.historyManager(node);

            this.reloadNode(node);

            if(!node.isExpanded) {

                node.expand();

            }

            if(this.histCurIndex == 0) {
                var nav3_histrew = dojo.byId('nav3_histrew');
                if(this.hasClass(nav3_histrew, 'nav3_histrew_normal')) {
                    this.repClass(nav3_histrew, 'nav3_histrew_normal', 'nav3_histrew_disabled');
                }
            }

            if(this.history[this.screenType].length - 1 > this.histCurIndex) {
                var nav3_histfwd = dojo.byId('nav3_histfwd');
                if(this.hasClass(nav3_histfwd, 'nav3_histfwd_disabled')) {
                    this.repClass(nav3_histfwd, 'nav3_histfwd_disabled', 'nav3_histfwd_normal');
                }
            }

        }

    },

    showNext: function () {

        if(this.histCurIndex >= 0 && this.histCurIndex <this.history[this.screenType].length - 1) {

            this.histBrowsing = true;

            dojo.debug('browsing: (idx:' + (this.histCurIndex + 1) + ') ' + this.history[this.screenType][this.histCurIndex + 1]);
            var node = dojo.widget.byId(this.history[this.screenType][this.histCurIndex + 1]);

            if(node.isExpanded) {
                node.collapse();
            }

            this.histCurIndex++;

            this.historyManager(node);

            this.reloadNode(node);

            if(!node.isExpanded) {

                node.expand();

            }

            if(this.histCurIndex >= 0) {
                var nav3_histrew = dojo.byId('nav3_histrew');
                if(this.hasClass(nav3_histrew, 'nav3_histrew_disabled')) {
                    this.repClass(nav3_histrew, 'nav3_histrew_disabled', 'nav3_histrew_normal');
                }
            }

            if(this.history[this.screenType].length - 1 == this.histCurIndex) {
                var nav3_histfwd = dojo.byId('nav3_histfwd');
                if(this.hasClass(nav3_histfwd, 'nav3_histfwd_normal')) {
                    this.repClass(nav3_histfwd, 'nav3_histfwd_normal', 'nav3_histfwd_disabled');
                }
            }

        }

    },

    historyManager: function(node) {

        this.curPath = node.widgetId;

        if(typeof this.history[this.screenType] == 'undefined') {

            this.history[this.screenType] = new Array;

        }

        if(!this.histBrowsing && this.histCurIndex ==this.history[this.screenType].length - 1) {

            dojo.debug('This is a newly opened directory');

            this.history[this.screenType].push(node.widgetId);
            this.histCurIndex++;

            if(this.histCurIndex > 0) {

                var nav3_histrew = dojo.byId('nav3_histrew');
                if(this.hasClass(nav3_histrew, 'nav3_histrew_disabled')) {
                    this.repClass(nav3_histrew, 'nav3_histrew_disabled', 'nav3_histrew_normal');
                }

            }

        } else {

            dojo.debug('This is something happening after a browsing');

            if(this.histBrowsing) {

                dojo.debug('We know it\'s browsing so let\'s not hurt the history');

                this.histBrowsing = false;

            } else {

                dojo.debug('We are opening a new dir from a browsed content so let\'s kill the history after the current index');

                var tmp = new Array();

                for(var i=0; i<this.histCurIndex+1; i++) {

                    tmp.push(this.history[this.screenType][i]);

                }

                this.history[this.screenType] = tmp;

                this.history[this.screenType].push(node.widgetId);
                this.histCurIndex++;

                if(this.histCurIndex > 0) {

                    var nav3_histrew = dojo.byId('nav3_histrew');
                    if(this.hasClass(nav3_histrew, 'nav3_histrew_disabled')) {
                        this.repClass(nav3_histrew, 'nav3_histrew_disabled', 'nav3_histrew_normal');
                    }

                }

                var nav3_histfwd = dojo.byId('nav3_histfwd');
                if(this.hasClass(nav3_histfwd, 'nav3_histfwd_normal')) {
                    this.repClass(nav3_histfwd, 'nav3_histfwd_normal', 'nav3_histfwd_disabled');
                }

            }

        }

    },

    handleKeyUp: function (e) {

        var evt = (e) ? e : window.event;

        this.handleCharUp((evt.charCode)?evt.charCode:evt.keyCode);

    },

    handleKeyDown: function (e) {

        var evt = (e) ? e : window.event;

        if (evt.type == "keydown") {
            this.handleCharDown((evt.charCode)?evt.charCode:evt.keyCode, 'nonchar');
        } else {
            this.handleCharDown((evt.charCode)?evt.charCode:evt.keyCode, 'char'); 
        }

        if (evt.keyCode == 8)  { 
            evt.returnValue = false;
        }

    },

    handleCharDown: function (curchar, source) {

        if(curchar > 0) {

        }

    },

    handleCharUp: function (curchar) {

        if(curchar > 0) {

        }

    }

};

dojo.require("dojo.lang.declare");
dojo.provide("arkeia.widget.ArkeiaSpecTreeWithNode");
dojo.require("dojo.widget.TreeNodeV3");
dojo.provide("arkeia.widget.ArkeiaTreeNodeV3");

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaTreeNodeV3",
	dojo.widget.TreeNodeV3,
{
    fullTitle: '',
    autoload: false,
    hasRight: false,
    tree_type: '',

	initialize: function(args, frag, parent) {
		if (args.isFolder) {
			this.isFolder = true;
		}
		if (this.children.length || this.isFolder) {
			this.setFolder();			
		} else {
			this.viewSetExpand();
		}
		
		for(var i=0; i<this.actionsDisabled.length;i++) {
			this.actionsDisabled[i] = this.actionsDisabled[i].toUpperCase();
		}

        if(this.autoload) {

            this.tree.root_widgetId = this.widgetId;

            if(this.hasRight && icon_manager) {
                icon_manager.initialize(this.tree_type);
            }

            dojo.html.addClass(this.expandNode, 'TreeExpandRoot');
            dojo.html.addClass(this.labelNode, 'TreeContentRoot');
            dojo.html.addClass(this.contentNode, 'TreeContentRoot');

            setTimeout(
                'if(document.createEvent) {'+
                'var evObj = document.createEvent(\'MouseEvents\');'+
                'evObj.initMouseEvent(\'click\', true, true, window, 0, 0, 0, 0, 0, false, false, true, false, 0, null );'+
                'dojo.widget.byId(\''+this.widgetId+'\').expandNode.dispatchEvent(evObj);'+
                '} else if(document.createEventObject) {'+
                'dojo.widget.byId(\''+this.widgetId+'\').expandNode.fireEvent(\'onclick\');'+
                '}',
                1000
            );

        } else {

            if(typeof args.typeIcon != 'undefined' && args.typeIcon == 'machine') {

                dojo.html.addClass(this.domNode, 'TreeNodeRoot');

            }

        }

        this.tree.previous_widgetId = this.widgetId;

		dojo.event.topic.publish(this.tree.eventNames.afterChangeTree, {oldTree:null, newTree:this.tree, node:this} );

	}

});

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaTreeV3",
	dojo.widget.TreeV3,
{

	initialize: function(args){
		
		this.domNode.widgetId = this.widgetId;
		
		for(var i=0; i<this.actionsDisabled.length; i++){
			this.actionsDisabled[i] = this.actionsDisabled[i].toUpperCase();
		}
		
		//dojo.debug(args.defaultChildWidget ? true : false)
		
		if(!args.defaultChildWidget){
			this.defaultChildWidget = arkeia.widget.ArkeiaTreeNodeV3;
		}else{
			this.defaultChildWidget = dojo.getObject(args.defaultChildWidget);
		}
		
		this.adjustEventNames();
		this.adjustDndMode();

		this.makeNodeTemplate();
		this.makeContainerNodeTemplate();
		
		this.containerNode = this.domNode;
		
		dojo.html.setClass(this.domNode, this.classPrefix+"Container");
		dojo.widget.wai.setAttr(this.domNode, "waiRole", "role", "tree");
		
		var _this = this;
			
		//dojo.html.disableSelection(this.domNode)
				
		dojo.lang.forEach(this.listeners,
			function(elem){
				var t = dojo.lang.isString(elem) ? dojo.widget.byId(elem) : elem;
				t.listenTree(_this)				
			}
		);
	}

});

dojo.require("dojo.widget.TabContainer");
dojo.provide("arkeia.widget.ArkeiaTabContainer");

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaTabContainer",
	dojo.widget.TabContainer,
{
	fillInTemplate: function() {
		// create the tab list that will have a tab (a.k.a. tab button) for each tab panel
		this.tablist = dojo.widget.createWidget("arkeia:ArkeiaTabController",
			{
				id: this.widgetId + "_tablist",
				labelPosition: this.labelPosition,
				doLayout: this.doLayout,
				containerId: this.widgetId
			}, this.tablistNode);
		dojo.widget.TabContainer.superclass.fillInTemplate.apply(this, arguments);
	}

});

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaTabController",
	dojo.widget.TabController,
{
    buttonWidget: "arkeia:ArkeiaTabButton"
});

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaTabButton",
	dojo.widget.TabButton,
{

    onClick: function(){
		this.focus();

        if(icon_manager) {

            setTimeout('icon_manager.fixZIndex();', 500);

        }

	}

});

dojo.declare(
	"arkeia.widget.ArkeiaSpecTreeWithNode",
	null,
	function(){ },
{
    noCbox: false,
	/*
	 * dynamic loading-related stuff. 
	 * When an empty folder node appears, it is "UNCHECKED" first,
	 * then after Rpc call it becomes LOADING and, finally LOADED
	 *
	 * tree may be dynamically loaded also
	 */
	loadStates: {
		UNCHECKED: "UNCHECKED",
    	LOADING: "LOADING",
    	LOADED: "LOADED"
	},
	
	state: "UNCHECKED",  // after creation will change to loadStates: "loaded/loading/unchecked"

    //RpcUrl: "", // user can override rpc url for specific nodes

	objectId: "", // the widget represents an object


	// I need this to parse children
	isContainer: true,
	
	lockLevel: 0, // lock ++ unlock --, so nested locking works fine

    tree_formid: '',
    tree_type: '',

	lock: function() {
		this.lockLevel++;
	},
	unlock: function() {
		if (!this.lockLevel) {
			//dojo.debug((new Error()).stack);
			dojo.raise(this.widgetType+" unlock: not locked");
		}
		this.lockLevel--;
	},
	
	
	expandLevel: 0, // expand to level automatically
	loadLevel: 0, // load to level automatically
		
	hasLock: function() {
		return this.lockLevel>0;
	},

	isLocked: function() {
		var node = this;
		while (true) {
			if (node.lockLevel) {
				return true;
			}
			if (!node.parent || node.isTree) {
				break;
			}
			
			node = node.parent;
			
		}

		return false;
	},

	
	flushLock: function() {
		this.lockLevel = 0;
		//this.unMarkLoading();
	},
	
	
	actionIsDisabled: function(action) {
		var disabled = false;

		if (dojo.lang.inArray(this.actionsDisabled, action)) {
			disabled = true;
		}


		//dojo.debug("Check "+this+" "+disabled)
		
		
		if (this.isTreeNode) {
			if (!this.tree.allowAddChildToLeaf && action == this.actions.ADDCHILD && !this.isFolder) {
				disabled = true;
			}
		}
		return disabled;
	},
		
	actionIsDisabledNow: function(action) {
		return this.actionIsDisabled(action) || this.isLocked();
	},
	
	
	/**
	 * childrenArray is array of Widgets or array of Objects
	 * widgets may be both attached and detached
	 *
	 * Use Cases
	 * 1) lots of widgets are packed and passed in.
	 *  - widgets are created
	 *  - widgets have no parent (detached or not attached yet)
	 *
	 * 2) array of widgets and data objects passed in with flag makeWidgetsFromChildren
	 *  - some widgets are not created
	 *  - all objects have no parent
	 *
	 * 3) expand is called with makeWidgetsFromChildren=true
	 *  - some objects need to be turned into widgets
	 *  - some widgets have parent (e.g markup), some widgets and objects do not
	 *
	 *  Will folderize a node as side-effect.
	 */
	setChildren: function(childrenArray) {
		//dojo.profile.start("setChildren "+this);
		//dojo.debug("setChildren in "+this);

        var k = 0;
        var units = new Array;

        units[0] = arkwui_lang_get_msg('unit_B');
        units[1] = arkwui_lang_get_msg('unit_KB');
        units[2] = arkwui_lang_get_msg('unit_MB');
        units[3] = arkwui_lang_get_msg('unit_GB');
        units[4] = arkwui_lang_get_msg('unit_TB');
        units[5] = arkwui_lang_get_msg('unit_PB');
        units[6] = arkwui_lang_get_msg('unit_EB');

		if (childrenArray) {
			this.children = childrenArray;
		}

        var res = new Array();

        this.domNode.removeAttribute('tabindex');

        if(this.children.length == 1 && this.children[0].type == 'E') {

            this.domNode.innerHTML = '<div style="text-align: left; padding-left:20px; height: 50px; line-height: 50px; vertical-align: middle; color: #ff0000;"><img src="'+baseurl+'/images/flag_red.png" style="float: none;" />'+this.children[0].titleRight+'</div>';

            var nodeleft = dojo.widget.byId(this.objectId);

            if(nodeleft) {
                nodeleft.collapse();
                nodeleft.state = nodeleft.loadStates.UNCHECKED;
                node.children = new Array();
            }

            return;

        }

		for(var i=0; i<this.children.length; i++) {

			var child = this.children[i];

            res[i] = new Array();

            if(typeof child.typeIcon != 'undefined') {

                res[i]['type'] = child.typeIcon;

            } else {

                if(typeof child.isFolder != 'undefined') {

                    res[i]['type'] = 'folder';

                } else {

                    res[i]['type'] = 'file';

                }

            }

            res[i]['text'] = child.titleRightLong;
            res[i]['short_text'] = child.titleRight;
            res[i]['objectId'] = child.widgetId;
            res[i]['fullTitle'] = child.fullTitle;
            
            if(typeof child.MODE != 'undefined') {
                if(res[i]['type'] == 'machine') {

                    res[i]['rights'] = '';

                } else {

                    if(res[i]['type'] == 'plugin') {

                        res[i]['rights'] = '';

                    } else {

                        if(res[i]['rights'] == 'filesystem') {

                            res[i]['rights'] = '';

                        } else {

                            res[i]['rights'] = child.MODE;

                        }

                    }

                }
            } else {
                res[i]['rights'] = '';
            }

            if(typeof child.UID != 'undefined' && typeof child.GID != 'undefined') {
                res[i]['ownage'] = child.UID + '/' + child.GID;
            } else {
                res[i]['ownage'] = '';
            }

            if(typeof child.FSIZE != 'undefined') {

		    if(!parseInt(child.FSIZE) != child.FSIZE) {
			child.FSIZE = 0;
		    }

                k=0;

                if(child.FSIZE > 0) {

                    while(child.FSIZE > 1024) {

                        child.FSIZE /= 1024;
                        k++;

                    }

                    child.FSIZE = (Math.round(child.FSIZE * 100) / 100);

                } else {

                    child.FSIZE = 0;

                }

                res[i]['size'] = child.FSIZE + ' ' + units[k];
            } else {
                res[i]['size'] = '';
            }

            if(typeof child.MDATE != 'undefined') {
                res[i]['date'] = child.MDATE;
            } else {
                res[i]['date'] = '';
            }

        }

        icon_manager.noCbox = this.noCbox;
        this.domNode.innerHTML = '';

        this.domNode.innerHTML = icon_manager.mkall('ret', res, this.tree_formid, this.tree_type);

        return;

		
		if (this.isTreeNode && !this.isFolder) {
			//dojo.debug("folder parent "+parent+ " isfolder "+parent.isFolder);
			this.setFolder();
		} else if (this.isTreeNode) {
			this.state = this.loadStates.LOADED;
		}
		
		var hadChildren = this.children.length > 0;
		
        if (hadChildren && childrenArray){
            // perf: most of time setChildren used for empty nodes, so save function call
            this.destroyChildren();
        }
        
		if (childrenArray) {
			this.children = childrenArray;
		}
		


		var hasChildren = this.children.length > 0;
		if (this.isTreeNode && hasChildren != hadChildren) {
			// call only when hasChildren state changes
			this.viewSetHasChildren();
		}
		


		for(var i=0; i<this.children.length; i++) {
			var child = this.children[i];
			
			//dojo.profile.start("setChildren - create "+this);
			
			if (!(child instanceof dojo.widget.Widget)) {
				
				child = this.children[i] = this.tree.createNode(child);
				var childWidgetCreated = true;	
				//dojo.debugShallow(child)
				
				//dojo.debug("setChildren creates node "+child);
			} else {
				var childWidgetCreated = false;
			}
			
			//dojo.profile.end("setChildren - create "+this);

			//dojo.profile.start("setChildren - attach "+this);

			if (!child.parent) { // detached child
				
				//dojo.debug("detached child "+child);
				
				child.parent = this;

				//dojo.profile.start("setChildren - updateTree "+this);
				
				if (this.tree !== child.tree) {				
					child.updateTree(this.tree);
				}
				//dojo.profile.end("setChildren - updateTree "+this);

			
				//dojo.debug("Add layout for "+child);
				child.viewAddLayout();
				this.containerNode.appendChild(child.domNode);
					
				var message = {
					child: child,
					index: i,
					parent: this,
					childWidgetCreated: childWidgetCreated
				};
			
				delete dojo.widget.manager.topWidgets[child.widgetId];
		

				//dojo.profile.start("setChildren - event "+this);
				//dojo.debug("publish "+this.tree.eventNames.afterAddChild)
				dojo.event.topic.publish(this.tree.eventNames.afterAddChild, message);

				//dojo.profile.end("setChildren - event "+this);

			}
			
			if (this.tree.eagerWidgetInstantiation && child.children.length) {
				child.setChildren();				
			}

			//dojo.profile.end("setChildren - attach "+this);

		
		}
		


		//dojo.profile.end("setChildren "+this);
		
	},	
	
	
	doAddChild: function(child, index) {
		return this.addChild(child, index, true);
	},
		
	addChild: function(child, index, dontPublishEvent) {
		if (dojo.lang.isUndefined(index)) {
			index = this.children.length;
		}
		
		//dojo.debug("doAddChild "+index+" called for "+this+" child "+child+" existing children "+(this.children.length ? this.children : "<no children>"));
				
		if (!child.isTreeNode){
			dojo.raise("You can only add TreeNode widgets to a "+this.widgetType+" widget!");
			return;
		}
			
		this.children.splice(index, 0, child);
		child.parent = this;
				
		child.addedTo(this, index, dontPublishEvent);
		
		// taken from DomWidget.registerChild
		// delete from widget list that are notified on resize etc (no parent)
		delete dojo.widget.manager.topWidgets[child.widgetId];
				
	},
	
	 /**
     * does not inform children about resize (skips onShow),
     * because on large trees that's slow
     */
    onShow: function() {        
        this.animationInProgress=false;
    },
    
    onHide: function() {        
        this.animationInProgress=false;
    }
	
});
