dojo.provide("arkeia.widget.ArkeiaSplitContainer");
dojo.require("dojo.widget.SplitContainer");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaSplitContainer",

    // superclass
    dojo.widget.SplitContainer,

    // member variables/functions
    {

        templateCssPath: dojo.uri.moduleUri("arkeia.widget", "ArkeiaSplitContainer.css"),
        widgetId: "generalSplit",
        sizerWidth: 1,

        beginSizing: function(e, i){
            this.paneBefore = this.children[i];
            this.paneAfter = this.children[i+1];

            this.isSizing = true;
            this.sizingSplitter = this.sizers[i];

            if(!this.cover){
                this.cover = dojo.doc().createElement('div');
                this.domNode.appendChild(this.cover);
                var s = this.cover.style;
                s.position='absolute';
                s.zIndex=1;
                s.top=0;
                s.left=0;
                s.width="100%";
                s.height="100%";
            }else{
                this.cover.style.zIndex=1;
            }
            this.sizingSplitter.style.zIndex=2;
            
            this.originPos = dojo.html.getAbsolutePosition(this.children[0].domNode, true, dojo.html.boxSizing.MARGIN_BOX);
            if (this.isHorizontal){
                var client = (e.layerX ? e.layerX : e.offsetX);
                if(typeof client == 'undefined') client = 0; //fixes big badass bug in firefox3
                var screen = e.pageX;
                this.originPos = this.originPos.x;
            }else{
                var client = (e.layerY ? e.layerY : e.offsetY);
                if(typeof client == 'undefined') client = 0; //fixes big badass bug in firefox3
                var screen = e.pageY;
                this.originPos = this.originPos.y;
            }
            this.startPoint = this.lastPoint = screen;
            this.screenToClientOffset = screen - client;
            this.dragOffset = this.lastPoint - this.paneBefore.sizeActual - this.originPos - this.paneBefore.position;

            if (!this.activeSizing){
                this._showSizingLine();
            }

            //
            // attach mouse events
            //

            dojo.event.connect(document.documentElement, "onmousemove", this, "changeSizing");
            dojo.event.connect(document.documentElement, "onmouseup", this, "endSizing");
            dojo.event.browser.stopEvent(e);
        }

    }
);

dojo.widget.defineWidget(
    "arkeia.widget.ArkeiaSplitContainerPanel",
	dojo.widget.SplitContainerPanel,
	{}
);
