dojo.provide("arkeia.widget.ArkeiaViewMeterBar");
dojo.require("dojo.widget.ProgressBar");

dojo.widget.defineWidget(
    // class
    "arkeia.widget.ArkeiaViewMeterBar",

    // superclass
    arkeia.widget.ArkeiaListener,
             
    // member variables/functions
    {
        widgetsInTemplate: true,
        value: 0,
        maxValue: 34,
        unitValue: '',
        valueField: "",
        valueTypeField: "",
        listenArkeiaParentEvents: ["arkeiaInfoData"],
        caption: '',
        listened: false,
        templateString: '<table id="${this.widgetId}"><tr><td><strong dojoAttachPoint="viewmin"></strong></td> <td><div height="20" width="300" dojoAttachPoint="viewmeter" dojoType="ProgressBar" progressValue="0" maxProgressValue="100" hasText="true"></div></td><td><strong dojoAttachPoint="viewmax"></strong></td></tr></table>',

        initialize: function()
        {
            unitValue = arkwui_lang_get_msg('bkp_showbkp_speed_KB_s');
            this.listenedArkeiaParents = [];
        },

        postCreate: function(args, frag)
        {
            if (this.listened) {
                var t = dojo.lang.isString(this.listened) ? dojo.widget.byId(this.listened) : this.listened;
                this.listenArkeiaParent(t);
            }
        },
       
        onArkeiaInfoData: function(message) 
        {
            dojo.debug(this + ' onArkeiaInfoData ViewMeter ' + this.valueField);

	        if (this.valueTypeField != '') {
	        	if (message.data[this.valueTypeField][this.valueField])
			        value = message.data[this.valueTypeField][this.valueField];
			    else
			    	value = message.data[this.valueTypeField][1][this.valueField];
	        } else value = message.data[this.valueField];

	        while (value > this.maxValue)
		        this.maxValue = this.maxValue * 2;
	        if (value != 0 && value * 16 < this.maxValue)
		        this.maxValue = value * 3;

            this.viewmeter.setMaxProgressValue(this.maxValue, true);
            this.viewmeter.setProgressValue(value, true);

	    
	        if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_KB_s')) {
                    convertval = value * 1024 / 60;
                    convertmaxval = this.maxValue * 1024 / 60;
	        } else if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_MB_s')) {
		        convertval = value / 60;
		        convertmaxval = this.maxValue / 60;
	        } else if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_MB_min')) {
		        convertval = value;
		        convertmaxval = this.maxValue;
	        } else if (this.unitValue == arkwui_lang_get_msg('bkp_showbkp_speed_MB_h')) {
		        convertval = value * 60;
		        convertmaxval = this.maxValue * 60;
	        }

	        this.viewmeter._progressPercentValue = parseInt(convertval) + ' ' + this.unitValue;
            this.viewmeter.render();
/* bug #2261
	        this.viewmax.innerHTML = parseInt(convertmaxval) + ' ' + this.unitValue;
	        this.viewmin.innerHTML = 0 + ' ' + this.unitValue;
*/
        }
    }
);
